/*
	description: "Declarations for retrieve mechanism."
	date:		"$Date: 2012-01-06 17:01:04 +0000 (Fri, 06 Jan 2012) $"
	revision:	"$Revision: 88161 $"
	copyright:	"Copyright (c) 1985-2006, Eiffel Software."
	license:	"GPL version 2 see http://www.eiffel.com/licensing/gpl.txt)"
	licensing_options:	"Commercial license is available at http://www.eiffel.com/licensing"
	copying: "[
			This file is part of Eiffel Software's Runtime.
			
			Eiffel Software's Runtime is free software; you can
			redistribute it and/or modify it under the terms of the
			GNU General Public License as published by the Free
			Software Foundation, version 2 of the License
			(available at the URL listed under "license" above).
			
			Eiffel Software's Runtime is distributed in the hope
			that it will be useful,	but WITHOUT ANY WARRANTY;
			without even the implied warranty of MERCHANTABILITY
			or FITNESS FOR A PARTICULAR PURPOSE.
			See the	GNU General Public License for more details.
			
			You should have received a copy of the GNU General Public
			License along with Eiffel Software's Runtime; if not,
			write to the Free Software Foundation, Inc.,
			51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
		]"
	source: "[
			 Eiffel Software
			 356 Storke Road, Goleta, CA 93117 USA
			 Telephone 805-685-1006, Fax 805-685-6869
			 Website http://www.eiffel.com
			 Customer support http://support.eiffel.com
		]"
*/

#ifndef _eif_retrieve_h_
#define _eif_retrieve_h_
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#include <stdio.h>
#include "eif_globals.h"
#include "eif_cecil.h"

#ifdef __cplusplus
extern "C" {
#endif
 
/* Internal representation of the different kinds of storage */
#define BASIC_STORE '\0'
#define GENERAL_STORE '\01'
#define INDEPENDENT_STORE '\02'
/* TODO: Should this be used instead of INDEPENDENT_STORE? */
#define RECOVERABLE_STORE '\03'

/* Setting of `eif_discard_pointer_values' */
RT_LNK void eif_set_discard_pointer_values(EIF_BOOLEAN);

/* Recoverable storable */
RT_LNK void set_mismatch_information_access (EIF_OBJECT, EIF_PROCEDURE, EIF_PROCEDURE, EIF_PROCEDURE);
RT_LNK void class_translation_put (char *new_name, char *old_name);
RT_LNK void class_translation_clear (void);
RT_LNK EIF_INTEGER class_translation_count (void);
RT_LNK char *class_translation_old (EIF_INTEGER i);
RT_LNK char *class_translation_new (EIF_INTEGER i);

/*
 * Eiffel calls
 */
RT_LNK char *eretrieve(EIF_INTEGER file_desc);		/* Retrieve object store in file */
RT_LNK EIF_REFERENCE stream_eretrieve(EIF_POINTER *, EIF_INTEGER, EIF_INTEGER, EIF_INTEGER *);	/* Retrieve object store in stream */
RT_LNK char *portable_retrieve(int (*char_read_function)(char *, int));

#ifdef __cplusplus
}
#endif

#endif

