/*
	description: "[
			User's main entry point.

			This entry point may be defined by the user to do any required
			initializations. For instance, when interfacing with a data base,
			one may wish to run special initialization procedures which have
			to happen BEFORE the program enters in the main creation routine.

			At the time umain() is called, the Eiffel run-time is set up
			properly, but the root object is not created yet.
			]"
	date:		"$Date: 2012-12-14 22:50:31 +0000 (Fri, 14 Dec 2012) $"
	revision:	"$Revision: 90208 $"
	copyright:	"Copyright (c) 1985-2006, Eiffel Software."
	license:	"GPL version 2 see http://www.eiffel.com/licensing/gpl.txt)"
	licensing_options:	"Commercial license is available at http://www.eiffel.com/licensing"
	copying: "[
			This file is part of Eiffel Software's Runtime.
			
			Eiffel Software's Runtime is free software; you can
			redistribute it and/or modify it under the terms of the
			GNU General Public License as published by the Free
			Software Foundation, version 2 of the License
			(available at the URL listed under "license" above).
			
			Eiffel Software's Runtime is distributed in the hope
			that it will be useful,	but WITHOUT ANY WARRANTY;
			without even the implied warranty of MERCHANTABILITY
			or FITNESS FOR A PARTICULAR PURPOSE.
			See the	GNU General Public License for more details.
			
			You should have received a copy of the GNU General Public
			License along with Eiffel Software's Runtime; if not,
			write to the Free Software Foundation, Inc.,
			51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
		]"
	source: "[
			 Eiffel Software
			 356 Storke Road, Goleta, CA 93117 USA
			 Telephone 805-685-1006, Fax 805-685-6869
			 Website http://www.eiffel.com
			 Customer support http://support.eiffel.com
		]"
*/

/*
doc:<file name="umain.c" header="eif_umain.h" version="$Id: umain.c 90208 2012-12-14 22:50:31Z manus $" summary="User's main entry point">
*/

#include "eif_umain.h"

void umain(int argc, EIF_NATIVE_CHAR **argv, EIF_NATIVE_CHAR **envp)
{
	/* Empty by default, but may be overwritten by user */
}

/*
doc:</file>
*/
