note

	description:

		"Warning: Rule declared twice"

	library: "Gobo Eiffel Parse Library"
	copyright: "Copyright (c) 1999-2011, Eric Bezault and others"
	license: "MIT License"
	date: "$Date: 2016-05-06 19:15:38 +0000 (Fri, 06 May 2016) $"
	revision: "$Revision: 98678 $"

class PR_RULE_DECLARED_TWICE_ERROR

inherit

	UT_ERROR

create

	make

feature {NONE} -- Initialization

	make (filename: STRING; line: INTEGER; a_rule: STRING)
			-- Create a new error reporting that `a_rule'
			-- has been declared twice.
		require
			filename_not_void: filename /= Void
			a_rule_not_void: a_rule /= Void
		do
			create parameters.make_filled (empty_string, 1, 3)
			parameters.put (filename, 1)
			parameters.put (line.out, 2)
			parameters.put (a_rule, 3)
		end

feature -- Access

	default_template: STRING = "Warning, %"$1%", line $2: rule $3 declared twice"
			-- Default template used to built the error message

	code: STRING = "PR0012"
			-- Error code

invariant

--	dollar0: $0 = program name
--	dollar1: $1 = filename
--	dollar2: $2 = line number
--	dollar3: $3 = rule name

end
