note
	description: "Common CGI and meta variable names."
	legal: "See notice at end of class."
	status: "See notice at end of class."
	date: "$Date: 2015-06-10 16:48:30 +0000 (Wed, 10 Jun 2015) $"
	revision: "$Revision: 97452 $"

class
	WGI_META_NAMES

feature -- Access

	request_uri: STRING = "REQUEST_URI"

	request_method: STRING = "REQUEST_METHOD"

	query_string: STRING = "QUERY_STRING"

	content_type: STRING = "CONTENT_TYPE"

	content_length: STRING = "CONTENT_LENGTH"

	path_info: STRING = "PATH_INFO"

	path_translated: STRING = "PATH_TRANSLATED"

	http_user_agent: STRING = "HTTP_USER_AGENT"

	http_authorization: STRING = "HTTP_AUTHORIZATION"

	http_host: STRING = "HTTP_HOST"

	http_cookie: STRING = "HTTP_COOKIE"

	http_from: STRING = "HTTP_FROM"

	http_accept: STRING = "HTTP_ACCEPT"

	http_accept_charset: STRING = "HTTP_ACCEPT_CHARSET"

	http_accept_encoding: STRING = "HTTP_ACCEPT_ENCODING"

	http_accept_language: STRING = "HTTP_ACCEPT_LANGUAGE"

	http_connection: STRING = "HTTP_CONNECTION"
	
	http_content_range: STRING = "HTTP_CONTENT_RANGE"

	http_content_encoding: STRING = "HTTP_CONTENT_ENCODING"

	http_expect: STRING = "HTTP_EXPECT"

	http_referer: STRING = "HTTP_REFERER"

	http_transfer_encoding: STRING = "HTTP_TRANSFER_ENCODING"

	http_access_control_request_headers: STRING = "HTTP_ACCESS_CONTROL_REQUEST_HEADERS"

	http_if_match: STRING = "HTTP_IF_MATCH"
	
	http_if_modified_since: STRING = "HTTP_IF_MODIFIED_SINCE"

	http_if_none_match: STRING = "HTTP_IF_NONE_MATCH"

	http_if_range: STRING = "HTTP_IF_RANGE"
	
	http_if_unmodified_since: STRING = "HTTP_IF_UNMODIFIED_SINCE"

	http_last_modified: STRING = "HTTP_LAST_MODIFIED"

	http_range: STRING = "HTTP_RANGE"
	
	gateway_interface: STRING = "GATEWAY_INTERFACE"

	auth_type: STRING = "AUTH_TYPE"

	remote_host: STRING = "REMOTE_HOST"

	remote_addr: STRING = "REMOTE_ADDR"

	remote_ident: STRING = "REMOTE_IDENT"

	remote_user: STRING = "REMOTE_USER"

	script_name: STRING = "SCRIPT_NAME"

	server_name: STRING = "SERVER_NAME"

	server_port: STRING = "SERVER_PORT"

	server_protocol: STRING = "SERVER_PROTOCOL"

	server_software: STRING = "SERVER_SOFTWARE"

feature -- Extra names

	request_time: STRING = "REQUEST_TIME"

	self: STRING = "SELF"

	orig_path_info: STRING = "ORIG_PATH_INFO"

note
	copyright: "2011-2012, Jocelyn Fiat, Javier Velilla, Eiffel Software and others"
	license: "Eiffel Forum License v2 (see http://www.eiffel.com/licensing/forum.txt)"
	source: "[
			Eiffel Software
			5949 Hollister Ave., Goleta, CA 93117 USA
			Telephone 805-685-1006, Fax 805-685-6869
			Website http://www.eiffel.com
			Customer support http://support.eiffel.com
		]"
end
