note

	description:
		"Client root-class for the polling example."
	legal: "See notice at end of class.";

	status: "See notice at end of class.";
	date: "$Date: 2013-02-04 21:27:38 +0000 (Mon, 04 Feb 2013) $";
	revision: "$Revision: 91160 $"

class POLLING_CLIENT

create

	make

feature

	make (argv: ARRAY [STRING])
		local
			soc: detachable NETWORK_DATAGRAM_SOCKET
			ps: MEDIUM_POLLER
			readcomm: DATAGRAM_READER
			writecomm: CLIENT_DATAGRAM_WRITER
		do
			if argv.count /= 3 then
				io.error.putstring ("Usage: ")
				io.error.putstring (argv.item (0))
				io.error.putstring (" hostname portnumber%N")
			else
				create soc.make_targeted (argv.item (1), argv.item (2).to_integer)
				create ps.make_write_only
				create readcomm.make (soc)
				ps.put_read_command (readcomm)
				create writecomm.make (soc)
				ps.put_write_command (writecomm)
				ps.execute (15, 20000)
				ps.make_read_only
				ps.execute (15, 20000)
				soc.close
			end
		rescue
			if soc /= Void and then not soc.is_closed then
				soc.close
			end
		end

note
	copyright:	"Copyright (c) 1984-2006, Eiffel Software and others"
	license:	"Eiffel Forum License v2 (see http://www.eiffel.com/licensing/forum.txt)"
	source: "[
			 Eiffel Software
			 356 Storke Road, Goleta, CA 93117 USA
			 Telephone 805-685-1006, Fax 805-685-6869
			 Website http://www.eiffel.com
			 Customer support http://support.eiffel.com
		]"


end

