note
	description: "[
			XML Event filters that can forward event to 'next' filter

			Note: the original code is from Gobo's XM library (http://www.gobosoft.com/)
			]"
	date: "$Date: 2016-05-10 12:25:18 +0000 (Tue, 10 May 2016) $"
	revision: "$Revision: 98712 $"

class
	XML_CALLBACKS_FILTER

inherit
	XML_CALLBACKS
		undefine
			default_create
		end

	XML_CALLBACKS_SOURCE
		rename
			set_callbacks as set_next
		undefine
			default_create
		end

	XML_FORWARD_CALLBACKS
		-- implementation of default behaviour:
		-- forwarding to 'next' processor in chain
		rename
			callbacks as next,
			set_callbacks as set_next
		end

create
    make_null,
	make_next

feature {NONE} -- Initialization

	make_next (a_next: like next)
			-- Create a new event filter with `a_next' as next filter.
		require
			a_next_not_void: a_next /= Void
		do
			initialize
			set_next (a_next)
		ensure
			next_set: next = a_next
		end

	initialize
			-- Initialize current callbacks filter.
		do
		end		

invariant
	next_not_void: next /= Void

note
	copyright: "Copyright (c) 1984-2016, Eiffel Software and others"
	license: "Eiffel Forum License v2 (see http://www.eiffel.com/licensing/forum.txt)"
	source: "[
			Eiffel Software
			5949 Hollister Ave., Goleta, CA 93117 USA
			Telephone 805-685-1006, Fax 805-685-6869
			Website http://www.eiffel.com
			Customer support http://support.eiffel.com
		]"
end
