note
	description: "[
		Pattern interface for explicit disposable of resources, This interface does not provide GC based disposable.
		
		See the default dual disposable implementation {DISPOSABLE_SAFE}, which implemented {DISPOSABLE_I} and 
		{DISPOSABLE} to provide implicit and explicit disposal.
	]"
	legal: "See notice at end of class."
	status: "See notice at end of class."
	date: "$Date: 2009-03-03 21:00:24 +0000 (Tue, 03 Mar 2009) $"
	revision: "$Revision: 77499 $"

deferred class
	DISPOSABLE_I

inherit
	USABLE_I

feature -- Clean up

	dispose
			-- Action to be executed just before garbage collection
			-- reclaims an object.
		deferred
		end

feature -- Access

	automation: DISPOSABLE_AUTOMATION_I
			-- Access to disposable automation object to automatically dispose of ancillary objects.
		require
			is_interface_usable: is_interface_usable
		deferred
		ensure
			result_attached: Result /= Void
			result_is_interface_usable: Result.is_interface_usable
			result_consistent: Result = automation
		end

;note
	copyright:	"Copyright (c) 1984-2009, Eiffel Software"
	license:	"GPL version 2 (see http://www.eiffel.com/licensing/gpl.txt)"
	licensing_options:	"http://www.eiffel.com/licensing"
	copying: "[
			This file is part of Eiffel Software's Eiffel Development Environment.
			
			Eiffel Software's Eiffel Development Environment is free
			software; you can redistribute it and/or modify it under
			the terms of the GNU General Public License as published
			by the Free Software Foundation, version 2 of the License
			(available at the URL listed under "license" above).
			
			Eiffel Software's Eiffel Development Environment is
			distributed in the hope that it will be useful, but
			WITHOUT ANY WARRANTY; without even the implied warranty
			of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
			See the GNU General Public License for more details.
			
			You should have received a copy of the GNU General Public
			License along with Eiffel Software's Eiffel Development
			Environment; if not, write to the Free Software Foundation,
			Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
		]"
	source: "[
			Eiffel Software
			5949 Hollister Ave., Goleta, CA 93117 USA
			Telephone 805-685-1006, Fax 805-685-6869
			Website http://www.eiffel.com
			Customer support http://support.eiffel.com
		]"

end
