/*
indexing
	description: "C features of EV_GTK_CALLBACK_MARSHAL, see ev_callback_marshal.e."
	date: "$Date: 2024-01-04 18:47:15 +0000 (Thu, 04 Jan 2024) $"
	revision: "$Revision: 107460 $"
	copyright:	"Copyright (c) 1984-2006, Eiffel Software and others"
	license:	"Eiffel Forum License v2 (see http://www.eiffel.com/licensing/forum.txt)"
	source: "[
			 Eiffel Software
			 356 Storke Road, Goleta, CA 93117 USA
			 Telephone 805-685-1006, Fax 805-685-6869
			 Website http://www.eiffel.com
			 Customer support http://support.eiffel.com
		]"
*/

#ifndef _EV_GTK_CALLBACK_MARSHAL_H_INCLUDED_
#define _EV_GTK_CALLBACK_MARSHAL_H_INCLUDED_

#include <ev_gtk.h>


#ifdef EIF_IL_DLL
extern void c_ev_gtk_callback_marshal_init (
			void (*) (EIF_POINTER, EIF_INTEGER, EIF_POINTER, EIF_POINTER), /* marshal */
			void (*) (EIF_POINTER) /* free */
		);
#else
extern void c_ev_gtk_callback_marshal_init (
			EIF_REFERENCE, /*EV_GTK_MARSHAL*/
			void (*) (EIF_REFERENCE, EIF_REFERENCE, EIF_INTEGER, EIF_POINTER, EIF_POINTER)
		);
#endif

extern void c_ev_gtk_callback_marshal_destroy ();

extern int c_ev_gtk_callback_marshal_is_enabled;
extern void c_ev_gtk_callback_marshal_set_is_enabled (int);

#ifdef EIF_IL_DLL
extern guint c_ev_gtk_callback_marshal_signal_connect (gpointer, const gchar*, EIF_POINTER, gboolean);
#else
extern guint c_ev_gtk_callback_marshal_signal_connect (gpointer, const gchar*, EIF_OBJECT, gboolean);
#endif

#ifdef EIF_IL_DLL
extern guint c_ev_gtk_callback_marshal_timeout_connect (gint, EIF_POINTER);
#else
extern guint c_ev_gtk_callback_marshal_timeout_connect (gint, EIF_OBJECT);
#endif

extern void gtk_set_dispatcher_object(EIF_OBJECT _addr_);
#   define cgtk_set_dispatcher_object(_addr_) gtk_set_dispatcher_object(_addr_)
        /* Set `dispatcher' with `eif_adopt (addr)' */

extern void gtk_release_dispatcher_object();

#   define cgtk_release_dispatcher_object gtk_release_dispatcher_object()
        /* Release `dispatcher' object. */

#endif
