/*
indexing
	description: "Class used for assertions checking in ISE runtime."
	date: "$Date: 2007-12-18 01:27:30 +0000 (Tue, 18 Dec 2007) $"
	revision: "$Revision: 71552 $"
	copyright:	"Copyright (c) 1984-2006, Eiffel Software"
	license:	"GPL version 2 see http://www.eiffel.com/licensing/gpl.txt"
	licensing_options:	"http://www.eiffel.com/licensing"
	copying: "[
			This file is part of Eiffel Software's Eiffel Development Environment.
			
			Eiffel Software's Eiffel Development Environment is free
			software; you can redistribute it and/or modify it under
			the terms of the GNU General Public License as published
			by the Free Software Foundation, version 2 of the License
			(available at the URL listed under "license" above).
			
			Eiffel Software's Eiffel Development Environment is
			distributed in the hope that it will be useful,	but
			WITHOUT ANY WARRANTY; without even the implied warranty
			of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
			See the	GNU General Public License for more details.
			
			You should have received a copy of the GNU General Public
			License along with Eiffel Software's Eiffel Development
			Environment; if not, write to the Free Software Foundation,
			Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
		]"
	source: "[
			 Eiffel Software
			 356 Storke Road, Goleta, CA 93117 USA
			 Telephone 805-685-1006, Fax 805-685-6869
			 Website http://www.eiffel.com
			 Customer support http://support.eiffel.com
		]"

*/
	
using System;
using EiffelSoftware.Runtime.CA;

namespace EiffelSoftware.Runtime
{

[EIFFEL_CONSUMABLE_ATTRIBUTE(false)]
[CLSCompliant(false)]
[Serializable]
public class ASSERTIONS	{

	public static void REQUIRE (String msg, bool expression)
		// Throw a precondition violation if `expression' is not true.
	{
		if (!expression) {
            ISE_RUNTIME.raise_precondition(msg);
		}
	}

	public static void ENSURE (String msg, bool expression)
		// Throw a postcondition violation if `expression' is not true.
	{
		if (!expression) {
            ISE_RUNTIME.raise_postcondition(msg);
		}
	}

	public static void CHECK (String msg, bool expression)
		// Throw a check violation if `expression' is not true.
	{
		if (!expression) {
            ISE_RUNTIME.raise_check(msg);
		}
	}

} // class ASSERTIONS

} // namespace
