note
	description: "Represents any serious runtime error that might occur in the storage backend, e.g. a disk failure, out-of-memory, a lost connection etc..."
	author: "Roman Schmocker"
	date: "$Date: 2013-09-27 23:17:24 +0000 (Fri, 27 Sep 2013) $"
	revision: "$Revision: 93026 $"

class
	PS_BACKEND_ERROR

inherit
	PS_ERROR
		redefine
			tag, accept, default_create
		end

feature -- Access

	tag: IMMUTABLE_STRING_32
			-- A short message describing what the current error is
		once
			create Result.make_from_string_8 ("Backend runtime error")
		end

feature {PS_ERROR_VISITOR} -- Visitor pattern

	accept (a_visitor: PS_ERROR_VISITOR)
			-- `accept' function of the visitor pattern
		do
			a_visitor.visit_backend_error (Current)
		end

feature {NONE} -- Initialization

	default_create
			-- Create a new instance of this error
		do
			backend_error_code := -1
			set_description ("A runtime error occurred in the database backend, e.g. a disk failure, out-of-memory, a lost connection...")
		end
end
