note
	description: "[
		An expecption specific to exceptional cases in the SQLite library where input/output devices are
		concerned.
		
		This exception will only be raised in exception circumstances where an error needs to be
		propagated back to the client. Clients should alway check for this exception on critical
		calls.
	]"
	legal: "See notice at end of class."
	status: "See notice at end of class."
	date: "$Date: 2009-09-18 23:48:56 +0000 (Fri, 18 Sep 2009) $"
	revision: "$Revision: 80765 $"

class
	SQLITE_IO_EXCEPTION

inherit
	SQLITE_EXCEPTION
		redefine
			extended_code
		end

create
	make,
	make_with_message

feature -- Access

	extended_code: INTEGER
			-- <Precursor>
			-- See {SQLITE_EXTENDED_IOERR_CODES} for error codes.
		do
			Result := Precursor
		end

note
	copyright: "Copyright (c) 1984-2009, Eiffel Software"
	license: "GPL version 2 (see http://www.eiffel.com/licensing/gpl.txt)"
	licensing_options: "http://www.eiffel.com/licensing"
	copying: "[
			This file is part of Eiffel Software's Eiffel Development Environment.
			
			Eiffel Software's Eiffel Development Environment is free
			software; you can redistribute it and/or modify it under
			the terms of the GNU General Public License as published
			by the Free Software Foundation, version 2 of the License
			(available at the URL listed under "license" above).
			
			Eiffel Software's Eiffel Development Environment is
			distributed in the hope that it will be useful, but
			WITHOUT ANY WARRANTY; without even the implied warranty
			of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
			See the GNU General Public License for more details.
			
			You should have received a copy of the GNU General Public
			License along with Eiffel Software's Eiffel Development
			Environment; if not, write to the Free Software Foundation,
			Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
		]"
	source: "[
			Eiffel Software
			5949 Hollister Ave., Goleta, CA 93117 USA
			Telephone 805-685-1006, Fax 805-685-6869
			Website http://www.eiffel.com
			Customer support http://support.eiffel.com
		]"

end
