note

	description:

		"Eiffel parsers"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 1999-2021, Eric Bezault and others"
	license: "MIT License"
	date: "$Date: 2023-03-09 10:35:58 +0000 (Thu, 09 Mar 2023) $"
	revision: "$Revision: 106643 $"

class ET_EIFFEL_PARSER

inherit

	ET_EIFFEL_PARSER_SKELETON
		undefine
			read_token
		redefine
			system_processor
		end

	ET_EIFFEL_SCANNER
		rename
			make as make_eiffel_scanner
		undefine
			reset, set_syntax_error
		redefine
			system_processor
		end

create

	make


feature {NONE} -- Implementation

	yy_build_parser_tables
			-- Build parser tables.
		do
			yytranslate := yytranslate_template
			yyr1 := yyr1_template
			yytypes1 := yytypes1_template
			yytypes2 := yytypes2_template
			yydefact := yydefact_template
			yydefgoto := yydefgoto_template
			yypact := yypact_template
			yypgoto := yypgoto_template
			yytable := yytable_template
			yycheck := yycheck_template
		end

	yy_create_value_stacks
			-- Create value stacks.
		do
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
			create yyspecial_routines8
			yyvsc8 := yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.make (yyvsc8)
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
			create yyspecial_routines10
			yyvsc10 := yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.make (yyvsc10)
			create yyspecial_routines11
			yyvsc11 := yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.make (yyvsc11)
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
			create yyspecial_routines19
			yyvsc19 := yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.make (yyvsc19)
			create yyspecial_routines20
			yyvsc20 := yyInitial_yyvs_size
			yyvs20 := yyspecial_routines20.make (yyvsc20)
			create yyspecial_routines21
			yyvsc21 := yyInitial_yyvs_size
			yyvs21 := yyspecial_routines21.make (yyvsc21)
			create yyspecial_routines22
			yyvsc22 := yyInitial_yyvs_size
			yyvs22 := yyspecial_routines22.make (yyvsc22)
			create yyspecial_routines23
			yyvsc23 := yyInitial_yyvs_size
			yyvs23 := yyspecial_routines23.make (yyvsc23)
			create yyspecial_routines24
			yyvsc24 := yyInitial_yyvs_size
			yyvs24 := yyspecial_routines24.make (yyvsc24)
			create yyspecial_routines25
			yyvsc25 := yyInitial_yyvs_size
			yyvs25 := yyspecial_routines25.make (yyvsc25)
			create yyspecial_routines26
			yyvsc26 := yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.make (yyvsc26)
			create yyspecial_routines27
			yyvsc27 := yyInitial_yyvs_size
			yyvs27 := yyspecial_routines27.make (yyvsc27)
			create yyspecial_routines28
			yyvsc28 := yyInitial_yyvs_size
			yyvs28 := yyspecial_routines28.make (yyvsc28)
			create yyspecial_routines29
			yyvsc29 := yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.make (yyvsc29)
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
			create yyspecial_routines31
			yyvsc31 := yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.make (yyvsc31)
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
			create yyspecial_routines34
			yyvsc34 := yyInitial_yyvs_size
			yyvs34 := yyspecial_routines34.make (yyvsc34)
			create yyspecial_routines35
			yyvsc35 := yyInitial_yyvs_size
			yyvs35 := yyspecial_routines35.make (yyvsc35)
			create yyspecial_routines36
			yyvsc36 := yyInitial_yyvs_size
			yyvs36 := yyspecial_routines36.make (yyvsc36)
			create yyspecial_routines37
			yyvsc37 := yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.make (yyvsc37)
			create yyspecial_routines38
			yyvsc38 := yyInitial_yyvs_size
			yyvs38 := yyspecial_routines38.make (yyvsc38)
			create yyspecial_routines39
			yyvsc39 := yyInitial_yyvs_size
			yyvs39 := yyspecial_routines39.make (yyvsc39)
			create yyspecial_routines40
			yyvsc40 := yyInitial_yyvs_size
			yyvs40 := yyspecial_routines40.make (yyvsc40)
			create yyspecial_routines41
			yyvsc41 := yyInitial_yyvs_size
			yyvs41 := yyspecial_routines41.make (yyvsc41)
			create yyspecial_routines42
			yyvsc42 := yyInitial_yyvs_size
			yyvs42 := yyspecial_routines42.make (yyvsc42)
			create yyspecial_routines43
			yyvsc43 := yyInitial_yyvs_size
			yyvs43 := yyspecial_routines43.make (yyvsc43)
			create yyspecial_routines44
			yyvsc44 := yyInitial_yyvs_size
			yyvs44 := yyspecial_routines44.make (yyvsc44)
			create yyspecial_routines45
			yyvsc45 := yyInitial_yyvs_size
			yyvs45 := yyspecial_routines45.make (yyvsc45)
			create yyspecial_routines46
			yyvsc46 := yyInitial_yyvs_size
			yyvs46 := yyspecial_routines46.make (yyvsc46)
			create yyspecial_routines47
			yyvsc47 := yyInitial_yyvs_size
			yyvs47 := yyspecial_routines47.make (yyvsc47)
			create yyspecial_routines48
			yyvsc48 := yyInitial_yyvs_size
			yyvs48 := yyspecial_routines48.make (yyvsc48)
			create yyspecial_routines49
			yyvsc49 := yyInitial_yyvs_size
			yyvs49 := yyspecial_routines49.make (yyvsc49)
			create yyspecial_routines50
			yyvsc50 := yyInitial_yyvs_size
			yyvs50 := yyspecial_routines50.make (yyvsc50)
			create yyspecial_routines51
			yyvsc51 := yyInitial_yyvs_size
			yyvs51 := yyspecial_routines51.make (yyvsc51)
			create yyspecial_routines52
			yyvsc52 := yyInitial_yyvs_size
			yyvs52 := yyspecial_routines52.make (yyvsc52)
			create yyspecial_routines53
			yyvsc53 := yyInitial_yyvs_size
			yyvs53 := yyspecial_routines53.make (yyvsc53)
			create yyspecial_routines54
			yyvsc54 := yyInitial_yyvs_size
			yyvs54 := yyspecial_routines54.make (yyvsc54)
			create yyspecial_routines55
			yyvsc55 := yyInitial_yyvs_size
			yyvs55 := yyspecial_routines55.make (yyvsc55)
			create yyspecial_routines56
			yyvsc56 := yyInitial_yyvs_size
			yyvs56 := yyspecial_routines56.make (yyvsc56)
			create yyspecial_routines57
			yyvsc57 := yyInitial_yyvs_size
			yyvs57 := yyspecial_routines57.make (yyvsc57)
			create yyspecial_routines58
			yyvsc58 := yyInitial_yyvs_size
			yyvs58 := yyspecial_routines58.make (yyvsc58)
			create yyspecial_routines59
			yyvsc59 := yyInitial_yyvs_size
			yyvs59 := yyspecial_routines59.make (yyvsc59)
			create yyspecial_routines60
			yyvsc60 := yyInitial_yyvs_size
			yyvs60 := yyspecial_routines60.make (yyvsc60)
			create yyspecial_routines61
			yyvsc61 := yyInitial_yyvs_size
			yyvs61 := yyspecial_routines61.make (yyvsc61)
			create yyspecial_routines62
			yyvsc62 := yyInitial_yyvs_size
			yyvs62 := yyspecial_routines62.make (yyvsc62)
			create yyspecial_routines63
			yyvsc63 := yyInitial_yyvs_size
			yyvs63 := yyspecial_routines63.make (yyvsc63)
			create yyspecial_routines64
			yyvsc64 := yyInitial_yyvs_size
			yyvs64 := yyspecial_routines64.make (yyvsc64)
			create yyspecial_routines65
			yyvsc65 := yyInitial_yyvs_size
			yyvs65 := yyspecial_routines65.make (yyvsc65)
			create yyspecial_routines66
			yyvsc66 := yyInitial_yyvs_size
			yyvs66 := yyspecial_routines66.make (yyvsc66)
			create yyspecial_routines67
			yyvsc67 := yyInitial_yyvs_size
			yyvs67 := yyspecial_routines67.make (yyvsc67)
			create yyspecial_routines68
			yyvsc68 := yyInitial_yyvs_size
			yyvs68 := yyspecial_routines68.make (yyvsc68)
			create yyspecial_routines69
			yyvsc69 := yyInitial_yyvs_size
			yyvs69 := yyspecial_routines69.make (yyvsc69)
			create yyspecial_routines70
			yyvsc70 := yyInitial_yyvs_size
			yyvs70 := yyspecial_routines70.make (yyvsc70)
			create yyspecial_routines71
			yyvsc71 := yyInitial_yyvs_size
			yyvs71 := yyspecial_routines71.make (yyvsc71)
			create yyspecial_routines72
			yyvsc72 := yyInitial_yyvs_size
			yyvs72 := yyspecial_routines72.make (yyvsc72)
			create yyspecial_routines73
			yyvsc73 := yyInitial_yyvs_size
			yyvs73 := yyspecial_routines73.make (yyvsc73)
			create yyspecial_routines74
			yyvsc74 := yyInitial_yyvs_size
			yyvs74 := yyspecial_routines74.make (yyvsc74)
			create yyspecial_routines75
			yyvsc75 := yyInitial_yyvs_size
			yyvs75 := yyspecial_routines75.make (yyvsc75)
			create yyspecial_routines76
			yyvsc76 := yyInitial_yyvs_size
			yyvs76 := yyspecial_routines76.make (yyvsc76)
			create yyspecial_routines77
			yyvsc77 := yyInitial_yyvs_size
			yyvs77 := yyspecial_routines77.make (yyvsc77)
			create yyspecial_routines78
			yyvsc78 := yyInitial_yyvs_size
			yyvs78 := yyspecial_routines78.make (yyvsc78)
			create yyspecial_routines79
			yyvsc79 := yyInitial_yyvs_size
			yyvs79 := yyspecial_routines79.make (yyvsc79)
			create yyspecial_routines80
			yyvsc80 := yyInitial_yyvs_size
			yyvs80 := yyspecial_routines80.make (yyvsc80)
			create yyspecial_routines81
			yyvsc81 := yyInitial_yyvs_size
			yyvs81 := yyspecial_routines81.make (yyvsc81)
			create yyspecial_routines82
			yyvsc82 := yyInitial_yyvs_size
			yyvs82 := yyspecial_routines82.make (yyvsc82)
			create yyspecial_routines83
			yyvsc83 := yyInitial_yyvs_size
			yyvs83 := yyspecial_routines83.make (yyvsc83)
			create yyspecial_routines84
			yyvsc84 := yyInitial_yyvs_size
			yyvs84 := yyspecial_routines84.make (yyvsc84)
			create yyspecial_routines85
			yyvsc85 := yyInitial_yyvs_size
			yyvs85 := yyspecial_routines85.make (yyvsc85)
			create yyspecial_routines86
			yyvsc86 := yyInitial_yyvs_size
			yyvs86 := yyspecial_routines86.make (yyvsc86)
			create yyspecial_routines87
			yyvsc87 := yyInitial_yyvs_size
			yyvs87 := yyspecial_routines87.make (yyvsc87)
			create yyspecial_routines88
			yyvsc88 := yyInitial_yyvs_size
			yyvs88 := yyspecial_routines88.make (yyvsc88)
			create yyspecial_routines89
			yyvsc89 := yyInitial_yyvs_size
			yyvs89 := yyspecial_routines89.make (yyvsc89)
			create yyspecial_routines90
			yyvsc90 := yyInitial_yyvs_size
			yyvs90 := yyspecial_routines90.make (yyvsc90)
			create yyspecial_routines91
			yyvsc91 := yyInitial_yyvs_size
			yyvs91 := yyspecial_routines91.make (yyvsc91)
			create yyspecial_routines92
			yyvsc92 := yyInitial_yyvs_size
			yyvs92 := yyspecial_routines92.make (yyvsc92)
			create yyspecial_routines93
			yyvsc93 := yyInitial_yyvs_size
			yyvs93 := yyspecial_routines93.make (yyvsc93)
			create yyspecial_routines94
			yyvsc94 := yyInitial_yyvs_size
			yyvs94 := yyspecial_routines94.make (yyvsc94)
			create yyspecial_routines95
			yyvsc95 := yyInitial_yyvs_size
			yyvs95 := yyspecial_routines95.make (yyvsc95)
			create yyspecial_routines96
			yyvsc96 := yyInitial_yyvs_size
			yyvs96 := yyspecial_routines96.make (yyvsc96)
			create yyspecial_routines97
			yyvsc97 := yyInitial_yyvs_size
			yyvs97 := yyspecial_routines97.make (yyvsc97)
			create yyspecial_routines98
			yyvsc98 := yyInitial_yyvs_size
			yyvs98 := yyspecial_routines98.make (yyvsc98)
			create yyspecial_routines99
			yyvsc99 := yyInitial_yyvs_size
			yyvs99 := yyspecial_routines99.make (yyvsc99)
			create yyspecial_routines100
			yyvsc100 := yyInitial_yyvs_size
			yyvs100 := yyspecial_routines100.make (yyvsc100)
			create yyspecial_routines101
			yyvsc101 := yyInitial_yyvs_size
			yyvs101 := yyspecial_routines101.make (yyvsc101)
			create yyspecial_routines102
			yyvsc102 := yyInitial_yyvs_size
			yyvs102 := yyspecial_routines102.make (yyvsc102)
			create yyspecial_routines103
			yyvsc103 := yyInitial_yyvs_size
			yyvs103 := yyspecial_routines103.make (yyvsc103)
			create yyspecial_routines104
			yyvsc104 := yyInitial_yyvs_size
			yyvs104 := yyspecial_routines104.make (yyvsc104)
			create yyspecial_routines105
			yyvsc105 := yyInitial_yyvs_size
			yyvs105 := yyspecial_routines105.make (yyvsc105)
			create yyspecial_routines106
			yyvsc106 := yyInitial_yyvs_size
			yyvs106 := yyspecial_routines106.make (yyvsc106)
			create yyspecial_routines107
			yyvsc107 := yyInitial_yyvs_size
			yyvs107 := yyspecial_routines107.make (yyvsc107)
			create yyspecial_routines108
			yyvsc108 := yyInitial_yyvs_size
			yyvs108 := yyspecial_routines108.make (yyvsc108)
			create yyspecial_routines109
			yyvsc109 := yyInitial_yyvs_size
			yyvs109 := yyspecial_routines109.make (yyvsc109)
			create yyspecial_routines110
			yyvsc110 := yyInitial_yyvs_size
			yyvs110 := yyspecial_routines110.make (yyvsc110)
			create yyspecial_routines111
			yyvsc111 := yyInitial_yyvs_size
			yyvs111 := yyspecial_routines111.make (yyvsc111)
			create yyspecial_routines112
			yyvsc112 := yyInitial_yyvs_size
			yyvs112 := yyspecial_routines112.make (yyvsc112)
			create yyspecial_routines113
			yyvsc113 := yyInitial_yyvs_size
			yyvs113 := yyspecial_routines113.make (yyvsc113)
			create yyspecial_routines114
			yyvsc114 := yyInitial_yyvs_size
			yyvs114 := yyspecial_routines114.make (yyvsc114)
			create yyspecial_routines115
			yyvsc115 := yyInitial_yyvs_size
			yyvs115 := yyspecial_routines115.make (yyvsc115)
			create yyspecial_routines116
			yyvsc116 := yyInitial_yyvs_size
			yyvs116 := yyspecial_routines116.make (yyvsc116)
			create yyspecial_routines117
			yyvsc117 := yyInitial_yyvs_size
			yyvs117 := yyspecial_routines117.make (yyvsc117)
			create yyspecial_routines118
			yyvsc118 := yyInitial_yyvs_size
			yyvs118 := yyspecial_routines118.make (yyvsc118)
			create yyspecial_routines119
			yyvsc119 := yyInitial_yyvs_size
			yyvs119 := yyspecial_routines119.make (yyvsc119)
			create yyspecial_routines120
			yyvsc120 := yyInitial_yyvs_size
			yyvs120 := yyspecial_routines120.make (yyvsc120)
			create yyspecial_routines121
			yyvsc121 := yyInitial_yyvs_size
			yyvs121 := yyspecial_routines121.make (yyvsc121)
			create yyspecial_routines122
			yyvsc122 := yyInitial_yyvs_size
			yyvs122 := yyspecial_routines122.make (yyvsc122)
			create yyspecial_routines123
			yyvsc123 := yyInitial_yyvs_size
			yyvs123 := yyspecial_routines123.make (yyvsc123)
			create yyspecial_routines124
			yyvsc124 := yyInitial_yyvs_size
			yyvs124 := yyspecial_routines124.make (yyvsc124)
			create yyspecial_routines125
			yyvsc125 := yyInitial_yyvs_size
			yyvs125 := yyspecial_routines125.make (yyvsc125)
			create yyspecial_routines126
			yyvsc126 := yyInitial_yyvs_size
			yyvs126 := yyspecial_routines126.make (yyvsc126)
			create yyspecial_routines127
			yyvsc127 := yyInitial_yyvs_size
			yyvs127 := yyspecial_routines127.make (yyvsc127)
			create yyspecial_routines128
			yyvsc128 := yyInitial_yyvs_size
			yyvs128 := yyspecial_routines128.make (yyvsc128)
			create yyspecial_routines129
			yyvsc129 := yyInitial_yyvs_size
			yyvs129 := yyspecial_routines129.make (yyvsc129)
			create yyspecial_routines130
			yyvsc130 := yyInitial_yyvs_size
			yyvs130 := yyspecial_routines130.make (yyvsc130)
			create yyspecial_routines131
			yyvsc131 := yyInitial_yyvs_size
			yyvs131 := yyspecial_routines131.make (yyvsc131)
			create yyspecial_routines132
			yyvsc132 := yyInitial_yyvs_size
			yyvs132 := yyspecial_routines132.make (yyvsc132)
			create yyspecial_routines133
			yyvsc133 := yyInitial_yyvs_size
			yyvs133 := yyspecial_routines133.make (yyvsc133)
			create yyspecial_routines134
			yyvsc134 := yyInitial_yyvs_size
			yyvs134 := yyspecial_routines134.make (yyvsc134)
		end

	yy_init_value_stacks
			-- Initialize value stacks.
		do
			yyvsp1 := -1
			yyvsp2 := -1
			yyvsp3 := -1
			yyvsp4 := -1
			yyvsp5 := -1
			yyvsp6 := -1
			yyvsp7 := -1
			yyvsp8 := -1
			yyvsp9 := -1
			yyvsp10 := -1
			yyvsp11 := -1
			yyvsp12 := -1
			yyvsp13 := -1
			yyvsp14 := -1
			yyvsp15 := -1
			yyvsp16 := -1
			yyvsp17 := -1
			yyvsp18 := -1
			yyvsp19 := -1
			yyvsp20 := -1
			yyvsp21 := -1
			yyvsp22 := -1
			yyvsp23 := -1
			yyvsp24 := -1
			yyvsp25 := -1
			yyvsp26 := -1
			yyvsp27 := -1
			yyvsp28 := -1
			yyvsp29 := -1
			yyvsp30 := -1
			yyvsp31 := -1
			yyvsp32 := -1
			yyvsp33 := -1
			yyvsp34 := -1
			yyvsp35 := -1
			yyvsp36 := -1
			yyvsp37 := -1
			yyvsp38 := -1
			yyvsp39 := -1
			yyvsp40 := -1
			yyvsp41 := -1
			yyvsp42 := -1
			yyvsp43 := -1
			yyvsp44 := -1
			yyvsp45 := -1
			yyvsp46 := -1
			yyvsp47 := -1
			yyvsp48 := -1
			yyvsp49 := -1
			yyvsp50 := -1
			yyvsp51 := -1
			yyvsp52 := -1
			yyvsp53 := -1
			yyvsp54 := -1
			yyvsp55 := -1
			yyvsp56 := -1
			yyvsp57 := -1
			yyvsp58 := -1
			yyvsp59 := -1
			yyvsp60 := -1
			yyvsp61 := -1
			yyvsp62 := -1
			yyvsp63 := -1
			yyvsp64 := -1
			yyvsp65 := -1
			yyvsp66 := -1
			yyvsp67 := -1
			yyvsp68 := -1
			yyvsp69 := -1
			yyvsp70 := -1
			yyvsp71 := -1
			yyvsp72 := -1
			yyvsp73 := -1
			yyvsp74 := -1
			yyvsp75 := -1
			yyvsp76 := -1
			yyvsp77 := -1
			yyvsp78 := -1
			yyvsp79 := -1
			yyvsp80 := -1
			yyvsp81 := -1
			yyvsp82 := -1
			yyvsp83 := -1
			yyvsp84 := -1
			yyvsp85 := -1
			yyvsp86 := -1
			yyvsp87 := -1
			yyvsp88 := -1
			yyvsp89 := -1
			yyvsp90 := -1
			yyvsp91 := -1
			yyvsp92 := -1
			yyvsp93 := -1
			yyvsp94 := -1
			yyvsp95 := -1
			yyvsp96 := -1
			yyvsp97 := -1
			yyvsp98 := -1
			yyvsp99 := -1
			yyvsp100 := -1
			yyvsp101 := -1
			yyvsp102 := -1
			yyvsp103 := -1
			yyvsp104 := -1
			yyvsp105 := -1
			yyvsp106 := -1
			yyvsp107 := -1
			yyvsp108 := -1
			yyvsp109 := -1
			yyvsp110 := -1
			yyvsp111 := -1
			yyvsp112 := -1
			yyvsp113 := -1
			yyvsp114 := -1
			yyvsp115 := -1
			yyvsp116 := -1
			yyvsp117 := -1
			yyvsp118 := -1
			yyvsp119 := -1
			yyvsp120 := -1
			yyvsp121 := -1
			yyvsp122 := -1
			yyvsp123 := -1
			yyvsp124 := -1
			yyvsp125 := -1
			yyvsp126 := -1
			yyvsp127 := -1
			yyvsp128 := -1
			yyvsp129 := -1
			yyvsp130 := -1
			yyvsp131 := -1
			yyvsp132 := -1
			yyvsp133 := -1
			yyvsp134 := -1
		end

	yy_clear_value_stacks
			-- Clear objects in semantic value stacks so that
			-- they can be collected by the garbage collector.
		do
			yyvs1.keep_head (0)
			yyvs2.keep_head (0)
			yyvs3.keep_head (0)
			yyvs4.keep_head (0)
			yyvs5.keep_head (0)
			yyvs6.keep_head (0)
			yyvs7.keep_head (0)
			yyvs8.keep_head (0)
			yyvs9.keep_head (0)
			yyvs10.keep_head (0)
			yyvs11.keep_head (0)
			yyvs12.keep_head (0)
			yyvs13.keep_head (0)
			yyvs14.keep_head (0)
			yyvs15.keep_head (0)
			yyvs16.keep_head (0)
			yyvs17.keep_head (0)
			yyvs18.keep_head (0)
			yyvs19.keep_head (0)
			yyvs20.keep_head (0)
			yyvs21.keep_head (0)
			yyvs22.keep_head (0)
			yyvs23.keep_head (0)
			yyvs24.keep_head (0)
			yyvs25.keep_head (0)
			yyvs26.keep_head (0)
			yyvs27.keep_head (0)
			yyvs28.keep_head (0)
			yyvs29.keep_head (0)
			yyvs30.keep_head (0)
			yyvs31.keep_head (0)
			yyvs32.keep_head (0)
			yyvs33.keep_head (0)
			yyvs34.keep_head (0)
			yyvs35.keep_head (0)
			yyvs36.keep_head (0)
			yyvs37.keep_head (0)
			yyvs38.keep_head (0)
			yyvs39.keep_head (0)
			yyvs40.keep_head (0)
			yyvs41.keep_head (0)
			yyvs42.keep_head (0)
			yyvs43.keep_head (0)
			yyvs44.keep_head (0)
			yyvs45.keep_head (0)
			yyvs46.keep_head (0)
			yyvs47.keep_head (0)
			yyvs48.keep_head (0)
			yyvs49.keep_head (0)
			yyvs50.keep_head (0)
			yyvs51.keep_head (0)
			yyvs52.keep_head (0)
			yyvs53.keep_head (0)
			yyvs54.keep_head (0)
			yyvs55.keep_head (0)
			yyvs56.keep_head (0)
			yyvs57.keep_head (0)
			yyvs58.keep_head (0)
			yyvs59.keep_head (0)
			yyvs60.keep_head (0)
			yyvs61.keep_head (0)
			yyvs62.keep_head (0)
			yyvs63.keep_head (0)
			yyvs64.keep_head (0)
			yyvs65.keep_head (0)
			yyvs66.keep_head (0)
			yyvs67.keep_head (0)
			yyvs68.keep_head (0)
			yyvs69.keep_head (0)
			yyvs70.keep_head (0)
			yyvs71.keep_head (0)
			yyvs72.keep_head (0)
			yyvs73.keep_head (0)
			yyvs74.keep_head (0)
			yyvs75.keep_head (0)
			yyvs76.keep_head (0)
			yyvs77.keep_head (0)
			yyvs78.keep_head (0)
			yyvs79.keep_head (0)
			yyvs80.keep_head (0)
			yyvs81.keep_head (0)
			yyvs82.keep_head (0)
			yyvs83.keep_head (0)
			yyvs84.keep_head (0)
			yyvs85.keep_head (0)
			yyvs86.keep_head (0)
			yyvs87.keep_head (0)
			yyvs88.keep_head (0)
			yyvs89.keep_head (0)
			yyvs90.keep_head (0)
			yyvs91.keep_head (0)
			yyvs92.keep_head (0)
			yyvs93.keep_head (0)
			yyvs94.keep_head (0)
			yyvs95.keep_head (0)
			yyvs96.keep_head (0)
			yyvs97.keep_head (0)
			yyvs98.keep_head (0)
			yyvs99.keep_head (0)
			yyvs100.keep_head (0)
			yyvs101.keep_head (0)
			yyvs102.keep_head (0)
			yyvs103.keep_head (0)
			yyvs104.keep_head (0)
			yyvs105.keep_head (0)
			yyvs106.keep_head (0)
			yyvs107.keep_head (0)
			yyvs108.keep_head (0)
			yyvs109.keep_head (0)
			yyvs110.keep_head (0)
			yyvs111.keep_head (0)
			yyvs112.keep_head (0)
			yyvs113.keep_head (0)
			yyvs114.keep_head (0)
			yyvs115.keep_head (0)
			yyvs116.keep_head (0)
			yyvs117.keep_head (0)
			yyvs118.keep_head (0)
			yyvs119.keep_head (0)
			yyvs120.keep_head (0)
			yyvs121.keep_head (0)
			yyvs122.keep_head (0)
			yyvs123.keep_head (0)
			yyvs124.keep_head (0)
			yyvs125.keep_head (0)
			yyvs126.keep_head (0)
			yyvs127.keep_head (0)
			yyvs128.keep_head (0)
			yyvs129.keep_head (0)
			yyvs130.keep_head (0)
			yyvs131.keep_head (0)
			yyvs132.keep_head (0)
			yyvs133.keep_head (0)
			yyvs134.keep_head (0)
		end

	yy_push_last_value (yychar1: INTEGER)
			-- Push semantic value associated with token `last_token'
			-- (with internal id `yychar1') on top of corresponding
			-- value stack.
		do
			inspect yytypes2.item (yychar1)
			when 1 then
				yyvsp1 := yyvsp1 + 1
				if yyvsp1 >= yyvsc1 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs1")
					end
					yyvsc1 := yyvsc1 + yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
				end
				yyspecial_routines1.force (yyvs1, last_detachable_any_value, yyvsp1)
			when 2 then
				yyvsp2 := yyvsp2 + 1
				if yyvsp2 >= yyvsc2 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs2")
					end
					yyvsc2 := yyvsc2 + yyInitial_yyvs_size
					yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
				end
				yyspecial_routines2.force (yyvs2, last_detachable_et_keyword_value, yyvsp2)
			when 3 then
				yyvsp3 := yyvsp3 + 1
				if yyvsp3 >= yyvsc3 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs3")
					end
					yyvsc3 := yyvsc3 + yyInitial_yyvs_size
					yyvs3 := yyspecial_routines3.aliased_resized_area (yyvs3, yyvsc3)
				end
				yyspecial_routines3.force (yyvs3, last_detachable_et_agent_keyword_value, yyvsp3)
			when 4 then
				yyvsp4 := yyvsp4 + 1
				if yyvsp4 >= yyvsc4 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs4")
					end
					yyvsc4 := yyvsc4 + yyInitial_yyvs_size
					yyvs4 := yyspecial_routines4.aliased_resized_area (yyvs4, yyvsc4)
				end
				yyspecial_routines4.force (yyvs4, last_detachable_et_precursor_keyword_value, yyvsp4)
			when 5 then
				yyvsp5 := yyvsp5 + 1
				if yyvsp5 >= yyvsc5 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs5")
					end
					yyvsc5 := yyvsc5 + yyInitial_yyvs_size
					yyvs5 := yyspecial_routines5.aliased_resized_area (yyvs5, yyvsc5)
				end
				yyspecial_routines5.force (yyvs5, last_detachable_et_symbol_value, yyvsp5)
			when 6 then
				yyvsp6 := yyvsp6 + 1
				if yyvsp6 >= yyvsc6 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs6")
					end
					yyvsc6 := yyvsc6 + yyInitial_yyvs_size
					yyvs6 := yyspecial_routines6.aliased_resized_area (yyvs6, yyvsc6)
				end
				yyspecial_routines6.force (yyvs6, last_detachable_et_position_value, yyvsp6)
			when 7 then
				yyvsp7 := yyvsp7 + 1
				if yyvsp7 >= yyvsc7 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs7")
					end
					yyvsc7 := yyvsc7 + yyInitial_yyvs_size
					yyvs7 := yyspecial_routines7.aliased_resized_area (yyvs7, yyvsc7)
				end
				yyspecial_routines7.force (yyvs7, last_detachable_et_boolean_constant_value, yyvsp7)
			when 8 then
				yyvsp8 := yyvsp8 + 1
				if yyvsp8 >= yyvsc8 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs8")
					end
					yyvsc8 := yyvsc8 + yyInitial_yyvs_size
					yyvs8 := yyspecial_routines8.aliased_resized_area (yyvs8, yyvsc8)
				end
				yyspecial_routines8.force (yyvs8, last_detachable_et_break_value, yyvsp8)
			when 9 then
				yyvsp9 := yyvsp9 + 1
				if yyvsp9 >= yyvsc9 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs9")
					end
					yyvsc9 := yyvsc9 + yyInitial_yyvs_size
					yyvs9 := yyspecial_routines9.aliased_resized_area (yyvs9, yyvsc9)
				end
				yyspecial_routines9.force (yyvs9, last_detachable_et_character_constant_value, yyvsp9)
			when 10 then
				yyvsp10 := yyvsp10 + 1
				if yyvsp10 >= yyvsc10 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs10")
					end
					yyvsc10 := yyvsc10 + yyInitial_yyvs_size
					yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
				end
				yyspecial_routines10.force (yyvs10, last_detachable_et_current_value, yyvsp10)
			when 11 then
				yyvsp11 := yyvsp11 + 1
				if yyvsp11 >= yyvsc11 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs11")
					end
					yyvsc11 := yyvsc11 + yyInitial_yyvs_size
					yyvs11 := yyspecial_routines11.aliased_resized_area (yyvs11, yyvsc11)
				end
				yyspecial_routines11.force (yyvs11, last_detachable_et_free_operator_value, yyvsp11)
			when 12 then
				yyvsp12 := yyvsp12 + 1
				if yyvsp12 >= yyvsc12 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs12")
					end
					yyvsc12 := yyvsc12 + yyInitial_yyvs_size
					yyvs12 := yyspecial_routines12.aliased_resized_area (yyvs12, yyvsc12)
				end
				yyspecial_routines12.force (yyvs12, last_detachable_et_identifier_value, yyvsp12)
			when 13 then
				yyvsp13 := yyvsp13 + 1
				if yyvsp13 >= yyvsc13 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs13")
					end
					yyvsc13 := yyvsc13 + yyInitial_yyvs_size
					yyvs13 := yyspecial_routines13.aliased_resized_area (yyvs13, yyvsc13)
				end
				yyspecial_routines13.force (yyvs13, last_detachable_et_integer_constant_value, yyvsp13)
			when 14 then
				yyvsp14 := yyvsp14 + 1
				if yyvsp14 >= yyvsc14 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs14")
					end
					yyvsc14 := yyvsc14 + yyInitial_yyvs_size
					yyvs14 := yyspecial_routines14.aliased_resized_area (yyvs14, yyvsc14)
				end
				yyspecial_routines14.force (yyvs14, last_detachable_et_keyword_operator_value, yyvsp14)
			when 15 then
				yyvsp15 := yyvsp15 + 1
				if yyvsp15 >= yyvsc15 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs15")
					end
					yyvsc15 := yyvsc15 + yyInitial_yyvs_size
					yyvs15 := yyspecial_routines15.aliased_resized_area (yyvs15, yyvsc15)
				end
				yyspecial_routines15.force (yyvs15, last_detachable_et_manifest_string_value, yyvsp15)
			when 16 then
				yyvsp16 := yyvsp16 + 1
				if yyvsp16 >= yyvsc16 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs16")
					end
					yyvsc16 := yyvsc16 + yyInitial_yyvs_size
					yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
				end
				yyspecial_routines16.force (yyvs16, last_detachable_et_real_constant_value, yyvsp16)
			when 17 then
				yyvsp17 := yyvsp17 + 1
				if yyvsp17 >= yyvsc17 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs17")
					end
					yyvsc17 := yyvsc17 + yyInitial_yyvs_size
					yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
				end
				yyspecial_routines17.force (yyvs17, last_detachable_et_result_value, yyvsp17)
			when 18 then
				yyvsp18 := yyvsp18 + 1
				if yyvsp18 >= yyvsc18 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs18")
					end
					yyvsc18 := yyvsc18 + yyInitial_yyvs_size
					yyvs18 := yyspecial_routines18.aliased_resized_area (yyvs18, yyvsc18)
				end
				yyspecial_routines18.force (yyvs18, last_detachable_et_retry_instruction_value, yyvsp18)
			when 19 then
				yyvsp19 := yyvsp19 + 1
				if yyvsp19 >= yyvsc19 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs19")
					end
					yyvsc19 := yyvsc19 + yyInitial_yyvs_size
					yyvs19 := yyspecial_routines19.aliased_resized_area (yyvs19, yyvsc19)
				end
				yyspecial_routines19.force (yyvs19, last_detachable_et_symbol_operator_value, yyvsp19)
			when 20 then
				yyvsp20 := yyvsp20 + 1
				if yyvsp20 >= yyvsc20 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs20")
					end
					yyvsc20 := yyvsc20 + yyInitial_yyvs_size
					yyvs20 := yyspecial_routines20.aliased_resized_area (yyvs20, yyvsc20)
				end
				yyspecial_routines20.force (yyvs20, last_detachable_et_void_value, yyvsp20)
			when 21 then
				yyvsp21 := yyvsp21 + 1
				if yyvsp21 >= yyvsc21 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs21")
					end
					yyvsc21 := yyvsc21 + yyInitial_yyvs_size
					yyvs21 := yyspecial_routines21.aliased_resized_area (yyvs21, yyvsc21)
				end
				yyspecial_routines21.force (yyvs21, last_detachable_et_semicolon_symbol_value, yyvsp21)
			when 22 then
				yyvsp22 := yyvsp22 + 1
				if yyvsp22 >= yyvsc22 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs22")
					end
					yyvsc22 := yyvsc22 + yyInitial_yyvs_size
					yyvs22 := yyspecial_routines22.aliased_resized_area (yyvs22, yyvsc22)
				end
				yyspecial_routines22.force (yyvs22, last_detachable_et_bracket_symbol_value, yyvsp22)
			when 23 then
				yyvsp23 := yyvsp23 + 1
				if yyvsp23 >= yyvsc23 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs23")
					end
					yyvsc23 := yyvsc23 + yyInitial_yyvs_size
					yyvs23 := yyspecial_routines23.aliased_resized_area (yyvs23, yyvsc23)
				end
				yyspecial_routines23.force (yyvs23, last_detachable_et_question_mark_symbol_value, yyvsp23)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: not a token type: ")
					std.error.put_integer (yytypes2.item (yychar1))
					std.error.put_new_line
				end
				abort
			end
		end

	yy_push_error_value
			-- Push semantic value associated with token 'error'
			-- on top of corresponding value stack.
		local
			yyval1: detachable ANY
		do
			yyvsp1 := yyvsp1 + 1
			if yyvsp1 >= yyvsc1 then
				debug ("GEYACC")
					std.error.put_line ("Resize yyvs1")
				end
				yyvsc1 := yyvsc1 + yyInitial_yyvs_size
				yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
			end
			yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
		end

	yy_pop_last_value (yystate: INTEGER)
			-- Pop semantic value from stack when in state `yystate'.
		local
			yy_type_id: INTEGER
		do
			yy_type_id := yytypes1.item (yystate)
			inspect yy_type_id
			when 1 then
				yyvsp1 := yyvsp1 - 1
			when 2 then
				yyvsp2 := yyvsp2 - 1
			when 3 then
				yyvsp3 := yyvsp3 - 1
			when 4 then
				yyvsp4 := yyvsp4 - 1
			when 5 then
				yyvsp5 := yyvsp5 - 1
			when 6 then
				yyvsp6 := yyvsp6 - 1
			when 7 then
				yyvsp7 := yyvsp7 - 1
			when 8 then
				yyvsp8 := yyvsp8 - 1
			when 9 then
				yyvsp9 := yyvsp9 - 1
			when 10 then
				yyvsp10 := yyvsp10 - 1
			when 11 then
				yyvsp11 := yyvsp11 - 1
			when 12 then
				yyvsp12 := yyvsp12 - 1
			when 13 then
				yyvsp13 := yyvsp13 - 1
			when 14 then
				yyvsp14 := yyvsp14 - 1
			when 15 then
				yyvsp15 := yyvsp15 - 1
			when 16 then
				yyvsp16 := yyvsp16 - 1
			when 17 then
				yyvsp17 := yyvsp17 - 1
			when 18 then
				yyvsp18 := yyvsp18 - 1
			when 19 then
				yyvsp19 := yyvsp19 - 1
			when 20 then
				yyvsp20 := yyvsp20 - 1
			when 21 then
				yyvsp21 := yyvsp21 - 1
			when 22 then
				yyvsp22 := yyvsp22 - 1
			when 23 then
				yyvsp23 := yyvsp23 - 1
			when 24 then
				yyvsp24 := yyvsp24 - 1
			when 25 then
				yyvsp25 := yyvsp25 - 1
			when 26 then
				yyvsp26 := yyvsp26 - 1
			when 27 then
				yyvsp27 := yyvsp27 - 1
			when 28 then
				yyvsp28 := yyvsp28 - 1
			when 29 then
				yyvsp29 := yyvsp29 - 1
			when 30 then
				yyvsp30 := yyvsp30 - 1
			when 31 then
				yyvsp31 := yyvsp31 - 1
			when 32 then
				yyvsp32 := yyvsp32 - 1
			when 33 then
				yyvsp33 := yyvsp33 - 1
			when 34 then
				yyvsp34 := yyvsp34 - 1
			when 35 then
				yyvsp35 := yyvsp35 - 1
			when 36 then
				yyvsp36 := yyvsp36 - 1
			when 37 then
				yyvsp37 := yyvsp37 - 1
			when 38 then
				yyvsp38 := yyvsp38 - 1
			when 39 then
				yyvsp39 := yyvsp39 - 1
			when 40 then
				yyvsp40 := yyvsp40 - 1
			when 41 then
				yyvsp41 := yyvsp41 - 1
			when 42 then
				yyvsp42 := yyvsp42 - 1
			when 43 then
				yyvsp43 := yyvsp43 - 1
			when 44 then
				yyvsp44 := yyvsp44 - 1
			when 45 then
				yyvsp45 := yyvsp45 - 1
			when 46 then
				yyvsp46 := yyvsp46 - 1
			when 47 then
				yyvsp47 := yyvsp47 - 1
			when 48 then
				yyvsp48 := yyvsp48 - 1
			when 49 then
				yyvsp49 := yyvsp49 - 1
			when 50 then
				yyvsp50 := yyvsp50 - 1
			when 51 then
				yyvsp51 := yyvsp51 - 1
			when 52 then
				yyvsp52 := yyvsp52 - 1
			when 53 then
				yyvsp53 := yyvsp53 - 1
			when 54 then
				yyvsp54 := yyvsp54 - 1
			when 55 then
				yyvsp55 := yyvsp55 - 1
			when 56 then
				yyvsp56 := yyvsp56 - 1
			when 57 then
				yyvsp57 := yyvsp57 - 1
			when 58 then
				yyvsp58 := yyvsp58 - 1
			when 59 then
				yyvsp59 := yyvsp59 - 1
			when 60 then
				yyvsp60 := yyvsp60 - 1
			when 61 then
				yyvsp61 := yyvsp61 - 1
			when 62 then
				yyvsp62 := yyvsp62 - 1
			when 63 then
				yyvsp63 := yyvsp63 - 1
			when 64 then
				yyvsp64 := yyvsp64 - 1
			when 65 then
				yyvsp65 := yyvsp65 - 1
			when 66 then
				yyvsp66 := yyvsp66 - 1
			when 67 then
				yyvsp67 := yyvsp67 - 1
			when 68 then
				yyvsp68 := yyvsp68 - 1
			when 69 then
				yyvsp69 := yyvsp69 - 1
			when 70 then
				yyvsp70 := yyvsp70 - 1
			when 71 then
				yyvsp71 := yyvsp71 - 1
			when 72 then
				yyvsp72 := yyvsp72 - 1
			when 73 then
				yyvsp73 := yyvsp73 - 1
			when 74 then
				yyvsp74 := yyvsp74 - 1
			when 75 then
				yyvsp75 := yyvsp75 - 1
			when 76 then
				yyvsp76 := yyvsp76 - 1
			when 77 then
				yyvsp77 := yyvsp77 - 1
			when 78 then
				yyvsp78 := yyvsp78 - 1
			when 79 then
				yyvsp79 := yyvsp79 - 1
			when 80 then
				yyvsp80 := yyvsp80 - 1
			when 81 then
				yyvsp81 := yyvsp81 - 1
			when 82 then
				yyvsp82 := yyvsp82 - 1
			when 83 then
				yyvsp83 := yyvsp83 - 1
			when 84 then
				yyvsp84 := yyvsp84 - 1
			when 85 then
				yyvsp85 := yyvsp85 - 1
			when 86 then
				yyvsp86 := yyvsp86 - 1
			when 87 then
				yyvsp87 := yyvsp87 - 1
			when 88 then
				yyvsp88 := yyvsp88 - 1
			when 89 then
				yyvsp89 := yyvsp89 - 1
			when 90 then
				yyvsp90 := yyvsp90 - 1
			when 91 then
				yyvsp91 := yyvsp91 - 1
			when 92 then
				yyvsp92 := yyvsp92 - 1
			when 93 then
				yyvsp93 := yyvsp93 - 1
			when 94 then
				yyvsp94 := yyvsp94 - 1
			when 95 then
				yyvsp95 := yyvsp95 - 1
			when 96 then
				yyvsp96 := yyvsp96 - 1
			when 97 then
				yyvsp97 := yyvsp97 - 1
			when 98 then
				yyvsp98 := yyvsp98 - 1
			when 99 then
				yyvsp99 := yyvsp99 - 1
			when 100 then
				yyvsp100 := yyvsp100 - 1
			when 101 then
				yyvsp101 := yyvsp101 - 1
			when 102 then
				yyvsp102 := yyvsp102 - 1
			when 103 then
				yyvsp103 := yyvsp103 - 1
			when 104 then
				yyvsp104 := yyvsp104 - 1
			when 105 then
				yyvsp105 := yyvsp105 - 1
			when 106 then
				yyvsp106 := yyvsp106 - 1
			when 107 then
				yyvsp107 := yyvsp107 - 1
			when 108 then
				yyvsp108 := yyvsp108 - 1
			when 109 then
				yyvsp109 := yyvsp109 - 1
			when 110 then
				yyvsp110 := yyvsp110 - 1
			when 111 then
				yyvsp111 := yyvsp111 - 1
			when 112 then
				yyvsp112 := yyvsp112 - 1
			when 113 then
				yyvsp113 := yyvsp113 - 1
			when 114 then
				yyvsp114 := yyvsp114 - 1
			when 115 then
				yyvsp115 := yyvsp115 - 1
			when 116 then
				yyvsp116 := yyvsp116 - 1
			when 117 then
				yyvsp117 := yyvsp117 - 1
			when 118 then
				yyvsp118 := yyvsp118 - 1
			when 119 then
				yyvsp119 := yyvsp119 - 1
			when 120 then
				yyvsp120 := yyvsp120 - 1
			when 121 then
				yyvsp121 := yyvsp121 - 1
			when 122 then
				yyvsp122 := yyvsp122 - 1
			when 123 then
				yyvsp123 := yyvsp123 - 1
			when 124 then
				yyvsp124 := yyvsp124 - 1
			when 125 then
				yyvsp125 := yyvsp125 - 1
			when 126 then
				yyvsp126 := yyvsp126 - 1
			when 127 then
				yyvsp127 := yyvsp127 - 1
			when 128 then
				yyvsp128 := yyvsp128 - 1
			when 129 then
				yyvsp129 := yyvsp129 - 1
			when 130 then
				yyvsp130 := yyvsp130 - 1
			when 131 then
				yyvsp131 := yyvsp131 - 1
			when 132 then
				yyvsp132 := yyvsp132 - 1
			when 133 then
				yyvsp133 := yyvsp133 - 1
			when 134 then
				yyvsp134 := yyvsp134 - 1
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown type id: ")
					std.error.put_integer (yy_type_id)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_run_geyacc
			-- You must run geyacc to regenerate this class.
		do
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER)
			-- Execute semantic action.
		do
			if yy_act <= 200 then
				yy_do_action_1_200 (yy_act)
			elseif yy_act <= 400 then
				yy_do_action_201_400 (yy_act)
			elseif yy_act <= 600 then
				yy_do_action_401_600 (yy_act)
			elseif yy_act <= 800 then
				yy_do_action_601_800 (yy_act)
			elseif yy_act <= 1000 then
				yy_do_action_801_1000 (yy_act)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_1_200 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 1 then
					--|#line 255 "et_eiffel_parser.y"
				yy_do_action_1
			when 2 then
					--|#line 259 "et_eiffel_parser.y"
				yy_do_action_2
			when 3 then
					--|#line 267 "et_eiffel_parser.y"
				yy_do_action_3
			when 4 then
					--|#line 276 "et_eiffel_parser.y"
				yy_do_action_4
			when 5 then
					--|#line 277 "et_eiffel_parser.y"
				yy_do_action_5
			when 6 then
					--|#line 277 "et_eiffel_parser.y"
				yy_do_action_6
			when 7 then
					--|#line 288 "et_eiffel_parser.y"
				yy_do_action_7
			when 8 then
					--|#line 296 "et_eiffel_parser.y"
				yy_do_action_8
			when 9 then
					--|#line 301 "et_eiffel_parser.y"
				yy_do_action_9
			when 10 then
					--|#line 303 "et_eiffel_parser.y"
				yy_do_action_10
			when 11 then
					--|#line 303 "et_eiffel_parser.y"
				yy_do_action_11
			when 12 then
					--|#line 314 "et_eiffel_parser.y"
				yy_do_action_12
			when 13 then
					--|#line 316 "et_eiffel_parser.y"
				yy_do_action_13
			when 14 then
					--|#line 316 "et_eiffel_parser.y"
				yy_do_action_14
			when 15 then
					--|#line 329 "et_eiffel_parser.y"
				yy_do_action_15
			when 16 then
					--|#line 331 "et_eiffel_parser.y"
				yy_do_action_16
			when 17 then
					--|#line 335 "et_eiffel_parser.y"
				yy_do_action_17
			when 18 then
					--|#line 346 "et_eiffel_parser.y"
				yy_do_action_18
			when 19 then
					--|#line 346 "et_eiffel_parser.y"
				yy_do_action_19
			when 20 then
					--|#line 355 "et_eiffel_parser.y"
				yy_do_action_20
			when 21 then
					--|#line 355 "et_eiffel_parser.y"
				yy_do_action_21
			when 22 then
					--|#line 366 "et_eiffel_parser.y"
				yy_do_action_22
			when 23 then
					--|#line 373 "et_eiffel_parser.y"
				yy_do_action_23
			when 24 then
					--|#line 379 "et_eiffel_parser.y"
				yy_do_action_24
			when 25 then
					--|#line 383 "et_eiffel_parser.y"
				yy_do_action_25
			when 26 then
					--|#line 394 "et_eiffel_parser.y"
				yy_do_action_26
			when 27 then
					--|#line 406 "et_eiffel_parser.y"
				yy_do_action_27
			when 28 then
					--|#line 406 "et_eiffel_parser.y"
				yy_do_action_28
			when 29 then
					--|#line 415 "et_eiffel_parser.y"
				yy_do_action_29
			when 30 then
					--|#line 415 "et_eiffel_parser.y"
				yy_do_action_30
			when 31 then
					--|#line 426 "et_eiffel_parser.y"
				yy_do_action_31
			when 32 then
					--|#line 433 "et_eiffel_parser.y"
				yy_do_action_32
			when 33 then
					--|#line 437 "et_eiffel_parser.y"
				yy_do_action_33
			when 34 then
					--|#line 443 "et_eiffel_parser.y"
				yy_do_action_34
			when 35 then
					--|#line 445 "et_eiffel_parser.y"
				yy_do_action_35
			when 36 then
					--|#line 450 "et_eiffel_parser.y"
				yy_do_action_36
			when 37 then
					--|#line 461 "et_eiffel_parser.y"
				yy_do_action_37
			when 38 then
					--|#line 470 "et_eiffel_parser.y"
				yy_do_action_38
			when 39 then
					--|#line 472 "et_eiffel_parser.y"
				yy_do_action_39
			when 40 then
					--|#line 474 "et_eiffel_parser.y"
				yy_do_action_40
			when 41 then
					--|#line 476 "et_eiffel_parser.y"
				yy_do_action_41
			when 42 then
					--|#line 478 "et_eiffel_parser.y"
				yy_do_action_42
			when 43 then
					--|#line 480 "et_eiffel_parser.y"
				yy_do_action_43
			when 44 then
					--|#line 482 "et_eiffel_parser.y"
				yy_do_action_44
			when 45 then
					--|#line 484 "et_eiffel_parser.y"
				yy_do_action_45
			when 46 then
					--|#line 488 "et_eiffel_parser.y"
				yy_do_action_46
			when 47 then
					--|#line 499 "et_eiffel_parser.y"
				yy_do_action_47
			when 48 then
					--|#line 511 "et_eiffel_parser.y"
				yy_do_action_48
			when 49 then
					--|#line 524 "et_eiffel_parser.y"
				yy_do_action_49
			when 50 then
					--|#line 537 "et_eiffel_parser.y"
				yy_do_action_50
			when 51 then
					--|#line 552 "et_eiffel_parser.y"
				yy_do_action_51
			when 52 then
					--|#line 554 "et_eiffel_parser.y"
				yy_do_action_52
			when 53 then
					--|#line 558 "et_eiffel_parser.y"
				yy_do_action_53
			when 54 then
					--|#line 560 "et_eiffel_parser.y"
				yy_do_action_54
			when 55 then
					--|#line 566 "et_eiffel_parser.y"
				yy_do_action_55
			when 56 then
					--|#line 570 "et_eiffel_parser.y"
				yy_do_action_56
			when 57 then
					--|#line 576 "et_eiffel_parser.y"
				yy_do_action_57
			when 58 then
					--|#line 576 "et_eiffel_parser.y"
				yy_do_action_58
			when 59 then
					--|#line 590 "et_eiffel_parser.y"
				yy_do_action_59
			when 60 then
					--|#line 601 "et_eiffel_parser.y"
				yy_do_action_60
			when 61 then
					--|#line 610 "et_eiffel_parser.y"
				yy_do_action_61
			when 62 then
					--|#line 619 "et_eiffel_parser.y"
				yy_do_action_62
			when 63 then
					--|#line 621 "et_eiffel_parser.y"
				yy_do_action_63
			when 64 then
					--|#line 623 "et_eiffel_parser.y"
				yy_do_action_64
			when 65 then
					--|#line 625 "et_eiffel_parser.y"
				yy_do_action_65
			when 66 then
					--|#line 627 "et_eiffel_parser.y"
				yy_do_action_66
			when 67 then
					--|#line 629 "et_eiffel_parser.y"
				yy_do_action_67
			when 68 then
					--|#line 631 "et_eiffel_parser.y"
				yy_do_action_68
			when 69 then
					--|#line 633 "et_eiffel_parser.y"
				yy_do_action_69
			when 70 then
					--|#line 635 "et_eiffel_parser.y"
				yy_do_action_70
			when 71 then
					--|#line 639 "et_eiffel_parser.y"
				yy_do_action_71
			when 72 then
					--|#line 646 "et_eiffel_parser.y"
				yy_do_action_72
			when 73 then
					--|#line 655 "et_eiffel_parser.y"
				yy_do_action_73
			when 74 then
					--|#line 655 "et_eiffel_parser.y"
				yy_do_action_74
			when 75 then
					--|#line 668 "et_eiffel_parser.y"
				yy_do_action_75
			when 76 then
					--|#line 679 "et_eiffel_parser.y"
				yy_do_action_76
			when 77 then
					--|#line 688 "et_eiffel_parser.y"
				yy_do_action_77
			when 78 then
					--|#line 697 "et_eiffel_parser.y"
				yy_do_action_78
			when 79 then
					--|#line 699 "et_eiffel_parser.y"
				yy_do_action_79
			when 80 then
					--|#line 699 "et_eiffel_parser.y"
				yy_do_action_80
			when 81 then
					--|#line 712 "et_eiffel_parser.y"
				yy_do_action_81
			when 82 then
					--|#line 723 "et_eiffel_parser.y"
				yy_do_action_82
			when 83 then
					--|#line 732 "et_eiffel_parser.y"
				yy_do_action_83
			when 84 then
					--|#line 741 "et_eiffel_parser.y"
				yy_do_action_84
			when 85 then
					--|#line 743 "et_eiffel_parser.y"
				yy_do_action_85
			when 86 then
					--|#line 747 "et_eiffel_parser.y"
				yy_do_action_86
			when 87 then
					--|#line 749 "et_eiffel_parser.y"
				yy_do_action_87
			when 88 then
					--|#line 749 "et_eiffel_parser.y"
				yy_do_action_88
			when 89 then
					--|#line 762 "et_eiffel_parser.y"
				yy_do_action_89
			when 90 then
					--|#line 774 "et_eiffel_parser.y"
				yy_do_action_90
			when 91 then
					--|#line 782 "et_eiffel_parser.y"
				yy_do_action_91
			when 92 then
					--|#line 791 "et_eiffel_parser.y"
				yy_do_action_92
			when 93 then
					--|#line 793 "et_eiffel_parser.y"
				yy_do_action_93
			when 94 then
					--|#line 795 "et_eiffel_parser.y"
				yy_do_action_94
			when 95 then
					--|#line 797 "et_eiffel_parser.y"
				yy_do_action_95
			when 96 then
					--|#line 799 "et_eiffel_parser.y"
				yy_do_action_96
			when 97 then
					--|#line 801 "et_eiffel_parser.y"
				yy_do_action_97
			when 98 then
					--|#line 803 "et_eiffel_parser.y"
				yy_do_action_98
			when 99 then
					--|#line 805 "et_eiffel_parser.y"
				yy_do_action_99
			when 100 then
					--|#line 807 "et_eiffel_parser.y"
				yy_do_action_100
			when 101 then
					--|#line 809 "et_eiffel_parser.y"
				yy_do_action_101
			when 102 then
					--|#line 811 "et_eiffel_parser.y"
				yy_do_action_102
			when 103 then
					--|#line 813 "et_eiffel_parser.y"
				yy_do_action_103
			when 104 then
					--|#line 815 "et_eiffel_parser.y"
				yy_do_action_104
			when 105 then
					--|#line 817 "et_eiffel_parser.y"
				yy_do_action_105
			when 106 then
					--|#line 819 "et_eiffel_parser.y"
				yy_do_action_106
			when 107 then
					--|#line 821 "et_eiffel_parser.y"
				yy_do_action_107
			when 108 then
					--|#line 823 "et_eiffel_parser.y"
				yy_do_action_108
			when 109 then
					--|#line 825 "et_eiffel_parser.y"
				yy_do_action_109
			when 110 then
					--|#line 827 "et_eiffel_parser.y"
				yy_do_action_110
			when 111 then
					--|#line 829 "et_eiffel_parser.y"
				yy_do_action_111
			when 112 then
					--|#line 831 "et_eiffel_parser.y"
				yy_do_action_112
			when 113 then
					--|#line 833 "et_eiffel_parser.y"
				yy_do_action_113
			when 114 then
					--|#line 837 "et_eiffel_parser.y"
				yy_do_action_114
			when 115 then
					--|#line 839 "et_eiffel_parser.y"
				yy_do_action_115
			when 116 then
					--|#line 841 "et_eiffel_parser.y"
				yy_do_action_116
			when 117 then
					--|#line 843 "et_eiffel_parser.y"
				yy_do_action_117
			when 118 then
					--|#line 845 "et_eiffel_parser.y"
				yy_do_action_118
			when 119 then
					--|#line 847 "et_eiffel_parser.y"
				yy_do_action_119
			when 120 then
					--|#line 849 "et_eiffel_parser.y"
				yy_do_action_120
			when 121 then
					--|#line 851 "et_eiffel_parser.y"
				yy_do_action_121
			when 122 then
					--|#line 853 "et_eiffel_parser.y"
				yy_do_action_122
			when 123 then
					--|#line 855 "et_eiffel_parser.y"
				yy_do_action_123
			when 124 then
					--|#line 857 "et_eiffel_parser.y"
				yy_do_action_124
			when 125 then
					--|#line 859 "et_eiffel_parser.y"
				yy_do_action_125
			when 126 then
					--|#line 861 "et_eiffel_parser.y"
				yy_do_action_126
			when 127 then
					--|#line 863 "et_eiffel_parser.y"
				yy_do_action_127
			when 128 then
					--|#line 865 "et_eiffel_parser.y"
				yy_do_action_128
			when 129 then
					--|#line 867 "et_eiffel_parser.y"
				yy_do_action_129
			when 130 then
					--|#line 869 "et_eiffel_parser.y"
				yy_do_action_130
			when 131 then
					--|#line 871 "et_eiffel_parser.y"
				yy_do_action_131
			when 132 then
					--|#line 873 "et_eiffel_parser.y"
				yy_do_action_132
			when 133 then
					--|#line 875 "et_eiffel_parser.y"
				yy_do_action_133
			when 134 then
					--|#line 877 "et_eiffel_parser.y"
				yy_do_action_134
			when 135 then
					--|#line 879 "et_eiffel_parser.y"
				yy_do_action_135
			when 136 then
					--|#line 883 "et_eiffel_parser.y"
				yy_do_action_136
			when 137 then
					--|#line 885 "et_eiffel_parser.y"
				yy_do_action_137
			when 138 then
					--|#line 889 "et_eiffel_parser.y"
				yy_do_action_138
			when 139 then
					--|#line 892 "et_eiffel_parser.y"
				yy_do_action_139
			when 140 then
					--|#line 900 "et_eiffel_parser.y"
				yy_do_action_140
			when 141 then
					--|#line 911 "et_eiffel_parser.y"
				yy_do_action_141
			when 142 then
					--|#line 916 "et_eiffel_parser.y"
				yy_do_action_142
			when 143 then
					--|#line 923 "et_eiffel_parser.y"
				yy_do_action_143
			when 144 then
					--|#line 932 "et_eiffel_parser.y"
				yy_do_action_144
			when 145 then
					--|#line 934 "et_eiffel_parser.y"
				yy_do_action_145
			when 146 then
					--|#line 938 "et_eiffel_parser.y"
				yy_do_action_146
			when 147 then
					--|#line 941 "et_eiffel_parser.y"
				yy_do_action_147
			when 148 then
					--|#line 947 "et_eiffel_parser.y"
				yy_do_action_148
			when 149 then
					--|#line 955 "et_eiffel_parser.y"
				yy_do_action_149
			when 150 then
					--|#line 960 "et_eiffel_parser.y"
				yy_do_action_150
			when 151 then
					--|#line 965 "et_eiffel_parser.y"
				yy_do_action_151
			when 152 then
					--|#line 970 "et_eiffel_parser.y"
				yy_do_action_152
			when 153 then
					--|#line 983 "et_eiffel_parser.y"
				yy_do_action_153
			when 154 then
					--|#line 992 "et_eiffel_parser.y"
				yy_do_action_154
			when 155 then
					--|#line 1003 "et_eiffel_parser.y"
				yy_do_action_155
			when 156 then
					--|#line 1005 "et_eiffel_parser.y"
				yy_do_action_156
			when 157 then
					--|#line 1011 "et_eiffel_parser.y"
				yy_do_action_157
			when 158 then
					--|#line 1013 "et_eiffel_parser.y"
				yy_do_action_158
			when 159 then
					--|#line 1020 "et_eiffel_parser.y"
				yy_do_action_159
			when 160 then
					--|#line 1031 "et_eiffel_parser.y"
				yy_do_action_160
			when 161 then
					--|#line 1031 "et_eiffel_parser.y"
				yy_do_action_161
			when 162 then
					--|#line 1046 "et_eiffel_parser.y"
				yy_do_action_162
			when 163 then
					--|#line 1053 "et_eiffel_parser.y"
				yy_do_action_163
			when 164 then
					--|#line 1053 "et_eiffel_parser.y"
				yy_do_action_164
			when 165 then
					--|#line 1069 "et_eiffel_parser.y"
				yy_do_action_165
			when 166 then
					--|#line 1076 "et_eiffel_parser.y"
				yy_do_action_166
			when 167 then
					--|#line 1084 "et_eiffel_parser.y"
				yy_do_action_167
			when 168 then
					--|#line 1091 "et_eiffel_parser.y"
				yy_do_action_168
			when 169 then
					--|#line 1098 "et_eiffel_parser.y"
				yy_do_action_169
			when 170 then
					--|#line 1105 "et_eiffel_parser.y"
				yy_do_action_170
			when 171 then
					--|#line 1114 "et_eiffel_parser.y"
				yy_do_action_171
			when 172 then
					--|#line 1121 "et_eiffel_parser.y"
				yy_do_action_172
			when 173 then
					--|#line 1128 "et_eiffel_parser.y"
				yy_do_action_173
			when 174 then
					--|#line 1135 "et_eiffel_parser.y"
				yy_do_action_174
			when 175 then
					--|#line 1144 "et_eiffel_parser.y"
				yy_do_action_175
			when 176 then
					--|#line 1155 "et_eiffel_parser.y"
				yy_do_action_176
			when 177 then
					--|#line 1157 "et_eiffel_parser.y"
				yy_do_action_177
			when 178 then
					--|#line 1157 "et_eiffel_parser.y"
				yy_do_action_178
			when 179 then
					--|#line 1170 "et_eiffel_parser.y"
				yy_do_action_179
			when 180 then
					--|#line 1177 "et_eiffel_parser.y"
				yy_do_action_180
			when 181 then
					--|#line 1186 "et_eiffel_parser.y"
				yy_do_action_181
			when 182 then
					--|#line 1195 "et_eiffel_parser.y"
				yy_do_action_182
			when 183 then
					--|#line 1204 "et_eiffel_parser.y"
				yy_do_action_183
			when 184 then
					--|#line 1215 "et_eiffel_parser.y"
				yy_do_action_184
			when 185 then
					--|#line 1217 "et_eiffel_parser.y"
				yy_do_action_185
			when 186 then
					--|#line 1217 "et_eiffel_parser.y"
				yy_do_action_186
			when 187 then
					--|#line 1230 "et_eiffel_parser.y"
				yy_do_action_187
			when 188 then
					--|#line 1232 "et_eiffel_parser.y"
				yy_do_action_188
			when 189 then
					--|#line 1236 "et_eiffel_parser.y"
				yy_do_action_189
			when 190 then
					--|#line 1247 "et_eiffel_parser.y"
				yy_do_action_190
			when 191 then
					--|#line 1247 "et_eiffel_parser.y"
				yy_do_action_191
			when 192 then
					--|#line 1262 "et_eiffel_parser.y"
				yy_do_action_192
			when 193 then
					--|#line 1266 "et_eiffel_parser.y"
				yy_do_action_193
			when 194 then
					--|#line 1271 "et_eiffel_parser.y"
				yy_do_action_194
			when 195 then
					--|#line 1271 "et_eiffel_parser.y"
				yy_do_action_195
			when 196 then
					--|#line 1281 "et_eiffel_parser.y"
				yy_do_action_196
			when 197 then
					--|#line 1285 "et_eiffel_parser.y"
				yy_do_action_197
			when 198 then
					--|#line 1296 "et_eiffel_parser.y"
				yy_do_action_198
			when 199 then
					--|#line 1304 "et_eiffel_parser.y"
				yy_do_action_199
			when 200 then
					--|#line 1315 "et_eiffel_parser.y"
				yy_do_action_200
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_201_400 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 201 then
					--|#line 1315 "et_eiffel_parser.y"
				yy_do_action_201
			when 202 then
					--|#line 1326 "et_eiffel_parser.y"
				yy_do_action_202
			when 203 then
					--|#line 1330 "et_eiffel_parser.y"
				yy_do_action_203
			when 204 then
					--|#line 1337 "et_eiffel_parser.y"
				yy_do_action_204
			when 205 then
					--|#line 1345 "et_eiffel_parser.y"
				yy_do_action_205
			when 206 then
					--|#line 1352 "et_eiffel_parser.y"
				yy_do_action_206
			when 207 then
					--|#line 1362 "et_eiffel_parser.y"
				yy_do_action_207
			when 208 then
					--|#line 1371 "et_eiffel_parser.y"
				yy_do_action_208
			when 209 then
					--|#line 1381 "et_eiffel_parser.y"
				yy_do_action_209
			when 210 then
					--|#line 1383 "et_eiffel_parser.y"
				yy_do_action_210
			when 211 then
					--|#line 1387 "et_eiffel_parser.y"
				yy_do_action_211
			when 212 then
					--|#line 1398 "et_eiffel_parser.y"
				yy_do_action_212
			when 213 then
					--|#line 1400 "et_eiffel_parser.y"
				yy_do_action_213
			when 214 then
					--|#line 1400 "et_eiffel_parser.y"
				yy_do_action_214
			when 215 then
					--|#line 1413 "et_eiffel_parser.y"
				yy_do_action_215
			when 216 then
					--|#line 1415 "et_eiffel_parser.y"
				yy_do_action_216
			when 217 then
					--|#line 1419 "et_eiffel_parser.y"
				yy_do_action_217
			when 218 then
					--|#line 1421 "et_eiffel_parser.y"
				yy_do_action_218
			when 219 then
					--|#line 1421 "et_eiffel_parser.y"
				yy_do_action_219
			when 220 then
					--|#line 1434 "et_eiffel_parser.y"
				yy_do_action_220
			when 221 then
					--|#line 1436 "et_eiffel_parser.y"
				yy_do_action_221
			when 222 then
					--|#line 1440 "et_eiffel_parser.y"
				yy_do_action_222
			when 223 then
					--|#line 1442 "et_eiffel_parser.y"
				yy_do_action_223
			when 224 then
					--|#line 1442 "et_eiffel_parser.y"
				yy_do_action_224
			when 225 then
					--|#line 1455 "et_eiffel_parser.y"
				yy_do_action_225
			when 226 then
					--|#line 1457 "et_eiffel_parser.y"
				yy_do_action_226
			when 227 then
					--|#line 1461 "et_eiffel_parser.y"
				yy_do_action_227
			when 228 then
					--|#line 1472 "et_eiffel_parser.y"
				yy_do_action_228
			when 229 then
					--|#line 1480 "et_eiffel_parser.y"
				yy_do_action_229
			when 230 then
					--|#line 1489 "et_eiffel_parser.y"
				yy_do_action_230
			when 231 then
					--|#line 1500 "et_eiffel_parser.y"
				yy_do_action_231
			when 232 then
					--|#line 1502 "et_eiffel_parser.y"
				yy_do_action_232
			when 233 then
					--|#line 1509 "et_eiffel_parser.y"
				yy_do_action_233
			when 234 then
					--|#line 1520 "et_eiffel_parser.y"
				yy_do_action_234
			when 235 then
					--|#line 1520 "et_eiffel_parser.y"
				yy_do_action_235
			when 236 then
					--|#line 1535 "et_eiffel_parser.y"
				yy_do_action_236
			when 237 then
					--|#line 1537 "et_eiffel_parser.y"
				yy_do_action_237
			when 238 then
					--|#line 1539 "et_eiffel_parser.y"
				yy_do_action_238
			when 239 then
					--|#line 1539 "et_eiffel_parser.y"
				yy_do_action_239
			when 240 then
					--|#line 1551 "et_eiffel_parser.y"
				yy_do_action_240
			when 241 then
					--|#line 1551 "et_eiffel_parser.y"
				yy_do_action_241
			when 242 then
					--|#line 1563 "et_eiffel_parser.y"
				yy_do_action_242
			when 243 then
					--|#line 1565 "et_eiffel_parser.y"
				yy_do_action_243
			when 244 then
					--|#line 1567 "et_eiffel_parser.y"
				yy_do_action_244
			when 245 then
					--|#line 1567 "et_eiffel_parser.y"
				yy_do_action_245
			when 246 then
					--|#line 1579 "et_eiffel_parser.y"
				yy_do_action_246
			when 247 then
					--|#line 1579 "et_eiffel_parser.y"
				yy_do_action_247
			when 248 then
					--|#line 1593 "et_eiffel_parser.y"
				yy_do_action_248
			when 249 then
					--|#line 1605 "et_eiffel_parser.y"
				yy_do_action_249
			when 250 then
					--|#line 1617 "et_eiffel_parser.y"
				yy_do_action_250
			when 251 then
					--|#line 1626 "et_eiffel_parser.y"
				yy_do_action_251
			when 252 then
					--|#line 1642 "et_eiffel_parser.y"
				yy_do_action_252
			when 253 then
					--|#line 1644 "et_eiffel_parser.y"
				yy_do_action_253
			when 254 then
					--|#line 1648 "et_eiffel_parser.y"
				yy_do_action_254
			when 255 then
					--|#line 1648 "et_eiffel_parser.y"
				yy_do_action_255
			when 256 then
					--|#line 1661 "et_eiffel_parser.y"
				yy_do_action_256
			when 257 then
					--|#line 1668 "et_eiffel_parser.y"
				yy_do_action_257
			when 258 then
					--|#line 1675 "et_eiffel_parser.y"
				yy_do_action_258
			when 259 then
					--|#line 1684 "et_eiffel_parser.y"
				yy_do_action_259
			when 260 then
					--|#line 1693 "et_eiffel_parser.y"
				yy_do_action_260
			when 261 then
					--|#line 1697 "et_eiffel_parser.y"
				yy_do_action_261
			when 262 then
					--|#line 1703 "et_eiffel_parser.y"
				yy_do_action_262
			when 263 then
					--|#line 1705 "et_eiffel_parser.y"
				yy_do_action_263
			when 264 then
					--|#line 1705 "et_eiffel_parser.y"
				yy_do_action_264
			when 265 then
					--|#line 1718 "et_eiffel_parser.y"
				yy_do_action_265
			when 266 then
					--|#line 1729 "et_eiffel_parser.y"
				yy_do_action_266
			when 267 then
					--|#line 1738 "et_eiffel_parser.y"
				yy_do_action_267
			when 268 then
					--|#line 1749 "et_eiffel_parser.y"
				yy_do_action_268
			when 269 then
					--|#line 1754 "et_eiffel_parser.y"
				yy_do_action_269
			when 270 then
					--|#line 1758 "et_eiffel_parser.y"
				yy_do_action_270
			when 271 then
					--|#line 1766 "et_eiffel_parser.y"
				yy_do_action_271
			when 272 then
					--|#line 1773 "et_eiffel_parser.y"
				yy_do_action_272
			when 273 then
					--|#line 1782 "et_eiffel_parser.y"
				yy_do_action_273
			when 274 then
					--|#line 1789 "et_eiffel_parser.y"
				yy_do_action_274
			when 275 then
					--|#line 1798 "et_eiffel_parser.y"
				yy_do_action_275
			when 276 then
					--|#line 1803 "et_eiffel_parser.y"
				yy_do_action_276
			when 277 then
					--|#line 1810 "et_eiffel_parser.y"
				yy_do_action_277
			when 278 then
					--|#line 1811 "et_eiffel_parser.y"
				yy_do_action_278
			when 279 then
					--|#line 1812 "et_eiffel_parser.y"
				yy_do_action_279
			when 280 then
					--|#line 1813 "et_eiffel_parser.y"
				yy_do_action_280
			when 281 then
					--|#line 1818 "et_eiffel_parser.y"
				yy_do_action_281
			when 282 then
					--|#line 1823 "et_eiffel_parser.y"
				yy_do_action_282
			when 283 then
					--|#line 1831 "et_eiffel_parser.y"
				yy_do_action_283
			when 284 then
					--|#line 1836 "et_eiffel_parser.y"
				yy_do_action_284
			when 285 then
					--|#line 1842 "et_eiffel_parser.y"
				yy_do_action_285
			when 286 then
					--|#line 1850 "et_eiffel_parser.y"
				yy_do_action_286
			when 287 then
					--|#line 1861 "et_eiffel_parser.y"
				yy_do_action_287
			when 288 then
					--|#line 1866 "et_eiffel_parser.y"
				yy_do_action_288
			when 289 then
					--|#line 1874 "et_eiffel_parser.y"
				yy_do_action_289
			when 290 then
					--|#line 1879 "et_eiffel_parser.y"
				yy_do_action_290
			when 291 then
					--|#line 1885 "et_eiffel_parser.y"
				yy_do_action_291
			when 292 then
					--|#line 1893 "et_eiffel_parser.y"
				yy_do_action_292
			when 293 then
					--|#line 1904 "et_eiffel_parser.y"
				yy_do_action_293
			when 294 then
					--|#line 1906 "et_eiffel_parser.y"
				yy_do_action_294
			when 295 then
					--|#line 1908 "et_eiffel_parser.y"
				yy_do_action_295
			when 296 then
					--|#line 1912 "et_eiffel_parser.y"
				yy_do_action_296
			when 297 then
					--|#line 1914 "et_eiffel_parser.y"
				yy_do_action_297
			when 298 then
					--|#line 1922 "et_eiffel_parser.y"
				yy_do_action_298
			when 299 then
					--|#line 1924 "et_eiffel_parser.y"
				yy_do_action_299
			when 300 then
					--|#line 1932 "et_eiffel_parser.y"
				yy_do_action_300
			when 301 then
					--|#line 1935 "et_eiffel_parser.y"
				yy_do_action_301
			when 302 then
					--|#line 1944 "et_eiffel_parser.y"
				yy_do_action_302
			when 303 then
					--|#line 1948 "et_eiffel_parser.y"
				yy_do_action_303
			when 304 then
					--|#line 1958 "et_eiffel_parser.y"
				yy_do_action_304
			when 305 then
					--|#line 1961 "et_eiffel_parser.y"
				yy_do_action_305
			when 306 then
					--|#line 1970 "et_eiffel_parser.y"
				yy_do_action_306
			when 307 then
					--|#line 1974 "et_eiffel_parser.y"
				yy_do_action_307
			when 308 then
					--|#line 1984 "et_eiffel_parser.y"
				yy_do_action_308
			when 309 then
					--|#line 1986 "et_eiffel_parser.y"
				yy_do_action_309
			when 310 then
					--|#line 1994 "et_eiffel_parser.y"
				yy_do_action_310
			when 311 then
					--|#line 1997 "et_eiffel_parser.y"
				yy_do_action_311
			when 312 then
					--|#line 2006 "et_eiffel_parser.y"
				yy_do_action_312
			when 313 then
					--|#line 2009 "et_eiffel_parser.y"
				yy_do_action_313
			when 314 then
					--|#line 2018 "et_eiffel_parser.y"
				yy_do_action_314
			when 315 then
					--|#line 2022 "et_eiffel_parser.y"
				yy_do_action_315
			when 316 then
					--|#line 2034 "et_eiffel_parser.y"
				yy_do_action_316
			when 317 then
					--|#line 2037 "et_eiffel_parser.y"
				yy_do_action_317
			when 318 then
					--|#line 2041 "et_eiffel_parser.y"
				yy_do_action_318
			when 319 then
					--|#line 2044 "et_eiffel_parser.y"
				yy_do_action_319
			when 320 then
					--|#line 2048 "et_eiffel_parser.y"
				yy_do_action_320
			when 321 then
					--|#line 2050 "et_eiffel_parser.y"
				yy_do_action_321
			when 322 then
					--|#line 2053 "et_eiffel_parser.y"
				yy_do_action_322
			when 323 then
					--|#line 2056 "et_eiffel_parser.y"
				yy_do_action_323
			when 324 then
					--|#line 2062 "et_eiffel_parser.y"
				yy_do_action_324
			when 325 then
					--|#line 2070 "et_eiffel_parser.y"
				yy_do_action_325
			when 326 then
					--|#line 2074 "et_eiffel_parser.y"
				yy_do_action_326
			when 327 then
					--|#line 2076 "et_eiffel_parser.y"
				yy_do_action_327
			when 328 then
					--|#line 2080 "et_eiffel_parser.y"
				yy_do_action_328
			when 329 then
					--|#line 2082 "et_eiffel_parser.y"
				yy_do_action_329
			when 330 then
					--|#line 2086 "et_eiffel_parser.y"
				yy_do_action_330
			when 331 then
					--|#line 2088 "et_eiffel_parser.y"
				yy_do_action_331
			when 332 then
					--|#line 2094 "et_eiffel_parser.y"
				yy_do_action_332
			when 333 then
					--|#line 2103 "et_eiffel_parser.y"
				yy_do_action_333
			when 334 then
					--|#line 2105 "et_eiffel_parser.y"
				yy_do_action_334
			when 335 then
					--|#line 2117 "et_eiffel_parser.y"
				yy_do_action_335
			when 336 then
					--|#line 2128 "et_eiffel_parser.y"
				yy_do_action_336
			when 337 then
					--|#line 2128 "et_eiffel_parser.y"
				yy_do_action_337
			when 338 then
					--|#line 2143 "et_eiffel_parser.y"
				yy_do_action_338
			when 339 then
					--|#line 2145 "et_eiffel_parser.y"
				yy_do_action_339
			when 340 then
					--|#line 2147 "et_eiffel_parser.y"
				yy_do_action_340
			when 341 then
					--|#line 2149 "et_eiffel_parser.y"
				yy_do_action_341
			when 342 then
					--|#line 2151 "et_eiffel_parser.y"
				yy_do_action_342
			when 343 then
					--|#line 2153 "et_eiffel_parser.y"
				yy_do_action_343
			when 344 then
					--|#line 2155 "et_eiffel_parser.y"
				yy_do_action_344
			when 345 then
					--|#line 2157 "et_eiffel_parser.y"
				yy_do_action_345
			when 346 then
					--|#line 2159 "et_eiffel_parser.y"
				yy_do_action_346
			when 347 then
					--|#line 2161 "et_eiffel_parser.y"
				yy_do_action_347
			when 348 then
					--|#line 2163 "et_eiffel_parser.y"
				yy_do_action_348
			when 349 then
					--|#line 2165 "et_eiffel_parser.y"
				yy_do_action_349
			when 350 then
					--|#line 2167 "et_eiffel_parser.y"
				yy_do_action_350
			when 351 then
					--|#line 2169 "et_eiffel_parser.y"
				yy_do_action_351
			when 352 then
					--|#line 2171 "et_eiffel_parser.y"
				yy_do_action_352
			when 353 then
					--|#line 2173 "et_eiffel_parser.y"
				yy_do_action_353
			when 354 then
					--|#line 2175 "et_eiffel_parser.y"
				yy_do_action_354
			when 355 then
					--|#line 2177 "et_eiffel_parser.y"
				yy_do_action_355
			when 356 then
					--|#line 2179 "et_eiffel_parser.y"
				yy_do_action_356
			when 357 then
					--|#line 2181 "et_eiffel_parser.y"
				yy_do_action_357
			when 358 then
					--|#line 2183 "et_eiffel_parser.y"
				yy_do_action_358
			when 359 then
					--|#line 2185 "et_eiffel_parser.y"
				yy_do_action_359
			when 360 then
					--|#line 2187 "et_eiffel_parser.y"
				yy_do_action_360
			when 361 then
					--|#line 2189 "et_eiffel_parser.y"
				yy_do_action_361
			when 362 then
					--|#line 2191 "et_eiffel_parser.y"
				yy_do_action_362
			when 363 then
					--|#line 2193 "et_eiffel_parser.y"
				yy_do_action_363
			when 364 then
					--|#line 2195 "et_eiffel_parser.y"
				yy_do_action_364
			when 365 then
					--|#line 2197 "et_eiffel_parser.y"
				yy_do_action_365
			when 366 then
					--|#line 2199 "et_eiffel_parser.y"
				yy_do_action_366
			when 367 then
					--|#line 2201 "et_eiffel_parser.y"
				yy_do_action_367
			when 368 then
					--|#line 2205 "et_eiffel_parser.y"
				yy_do_action_368
			when 369 then
					--|#line 2207 "et_eiffel_parser.y"
				yy_do_action_369
			when 370 then
					--|#line 2213 "et_eiffel_parser.y"
				yy_do_action_370
			when 371 then
					--|#line 2220 "et_eiffel_parser.y"
				yy_do_action_371
			when 372 then
					--|#line 2222 "et_eiffel_parser.y"
				yy_do_action_372
			when 373 then
					--|#line 2230 "et_eiffel_parser.y"
				yy_do_action_373
			when 374 then
					--|#line 2241 "et_eiffel_parser.y"
				yy_do_action_374
			when 375 then
					--|#line 2248 "et_eiffel_parser.y"
				yy_do_action_375
			when 376 then
					--|#line 2255 "et_eiffel_parser.y"
				yy_do_action_376
			when 377 then
					--|#line 2265 "et_eiffel_parser.y"
				yy_do_action_377
			when 378 then
					--|#line 2276 "et_eiffel_parser.y"
				yy_do_action_378
			when 379 then
					--|#line 2283 "et_eiffel_parser.y"
				yy_do_action_379
			when 380 then
					--|#line 2292 "et_eiffel_parser.y"
				yy_do_action_380
			when 381 then
					--|#line 2301 "et_eiffel_parser.y"
				yy_do_action_381
			when 382 then
					--|#line 2310 "et_eiffel_parser.y"
				yy_do_action_382
			when 383 then
					--|#line 2319 "et_eiffel_parser.y"
				yy_do_action_383
			when 384 then
					--|#line 2330 "et_eiffel_parser.y"
				yy_do_action_384
			when 385 then
					--|#line 2332 "et_eiffel_parser.y"
				yy_do_action_385
			when 386 then
					--|#line 2334 "et_eiffel_parser.y"
				yy_do_action_386
			when 387 then
					--|#line 2334 "et_eiffel_parser.y"
				yy_do_action_387
			when 388 then
					--|#line 2347 "et_eiffel_parser.y"
				yy_do_action_388
			when 389 then
					--|#line 2354 "et_eiffel_parser.y"
				yy_do_action_389
			when 390 then
					--|#line 2361 "et_eiffel_parser.y"
				yy_do_action_390
			when 391 then
					--|#line 2371 "et_eiffel_parser.y"
				yy_do_action_391
			when 392 then
					--|#line 2382 "et_eiffel_parser.y"
				yy_do_action_392
			when 393 then
					--|#line 2389 "et_eiffel_parser.y"
				yy_do_action_393
			when 394 then
					--|#line 2398 "et_eiffel_parser.y"
				yy_do_action_394
			when 395 then
					--|#line 2407 "et_eiffel_parser.y"
				yy_do_action_395
			when 396 then
					--|#line 2416 "et_eiffel_parser.y"
				yy_do_action_396
			when 397 then
					--|#line 2425 "et_eiffel_parser.y"
				yy_do_action_397
			when 398 then
					--|#line 2436 "et_eiffel_parser.y"
				yy_do_action_398
			when 399 then
					--|#line 2438 "et_eiffel_parser.y"
				yy_do_action_399
			when 400 then
					--|#line 2440 "et_eiffel_parser.y"
				yy_do_action_400
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_401_600 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 401 then
					--|#line 2442 "et_eiffel_parser.y"
				yy_do_action_401
			when 402 then
					--|#line 2444 "et_eiffel_parser.y"
				yy_do_action_402
			when 403 then
					--|#line 2453 "et_eiffel_parser.y"
				yy_do_action_403
			when 404 then
					--|#line 2462 "et_eiffel_parser.y"
				yy_do_action_404
			when 405 then
					--|#line 2464 "et_eiffel_parser.y"
				yy_do_action_405
			when 406 then
					--|#line 2466 "et_eiffel_parser.y"
				yy_do_action_406
			when 407 then
					--|#line 2468 "et_eiffel_parser.y"
				yy_do_action_407
			when 408 then
					--|#line 2470 "et_eiffel_parser.y"
				yy_do_action_408
			when 409 then
					--|#line 2479 "et_eiffel_parser.y"
				yy_do_action_409
			when 410 then
					--|#line 2490 "et_eiffel_parser.y"
				yy_do_action_410
			when 411 then
					--|#line 2494 "et_eiffel_parser.y"
				yy_do_action_411
			when 412 then
					--|#line 2496 "et_eiffel_parser.y"
				yy_do_action_412
			when 413 then
					--|#line 2498 "et_eiffel_parser.y"
				yy_do_action_413
			when 414 then
					--|#line 2500 "et_eiffel_parser.y"
				yy_do_action_414
			when 415 then
					--|#line 2502 "et_eiffel_parser.y"
				yy_do_action_415
			when 416 then
					--|#line 2506 "et_eiffel_parser.y"
				yy_do_action_416
			when 417 then
					--|#line 2510 "et_eiffel_parser.y"
				yy_do_action_417
			when 418 then
					--|#line 2512 "et_eiffel_parser.y"
				yy_do_action_418
			when 419 then
					--|#line 2514 "et_eiffel_parser.y"
				yy_do_action_419
			when 420 then
					--|#line 2516 "et_eiffel_parser.y"
				yy_do_action_420
			when 421 then
					--|#line 2518 "et_eiffel_parser.y"
				yy_do_action_421
			when 422 then
					--|#line 2522 "et_eiffel_parser.y"
				yy_do_action_422
			when 423 then
					--|#line 2526 "et_eiffel_parser.y"
				yy_do_action_423
			when 424 then
					--|#line 2528 "et_eiffel_parser.y"
				yy_do_action_424
			when 425 then
					--|#line 2532 "et_eiffel_parser.y"
				yy_do_action_425
			when 426 then
					--|#line 2534 "et_eiffel_parser.y"
				yy_do_action_426
			when 427 then
					--|#line 2538 "et_eiffel_parser.y"
				yy_do_action_427
			when 428 then
					--|#line 2542 "et_eiffel_parser.y"
				yy_do_action_428
			when 429 then
					--|#line 2546 "et_eiffel_parser.y"
				yy_do_action_429
			when 430 then
					--|#line 2548 "et_eiffel_parser.y"
				yy_do_action_430
			when 431 then
					--|#line 2552 "et_eiffel_parser.y"
				yy_do_action_431
			when 432 then
					--|#line 2554 "et_eiffel_parser.y"
				yy_do_action_432
			when 433 then
					--|#line 2558 "et_eiffel_parser.y"
				yy_do_action_433
			when 434 then
					--|#line 2560 "et_eiffel_parser.y"
				yy_do_action_434
			when 435 then
					--|#line 2564 "et_eiffel_parser.y"
				yy_do_action_435
			when 436 then
					--|#line 2566 "et_eiffel_parser.y"
				yy_do_action_436
			when 437 then
					--|#line 2572 "et_eiffel_parser.y"
				yy_do_action_437
			when 438 then
					--|#line 2574 "et_eiffel_parser.y"
				yy_do_action_438
			when 439 then
					--|#line 2580 "et_eiffel_parser.y"
				yy_do_action_439
			when 440 then
					--|#line 2582 "et_eiffel_parser.y"
				yy_do_action_440
			when 441 then
					--|#line 2586 "et_eiffel_parser.y"
				yy_do_action_441
			when 442 then
					--|#line 2588 "et_eiffel_parser.y"
				yy_do_action_442
			when 443 then
					--|#line 2590 "et_eiffel_parser.y"
				yy_do_action_443
			when 444 then
					--|#line 2592 "et_eiffel_parser.y"
				yy_do_action_444
			when 445 then
					--|#line 2594 "et_eiffel_parser.y"
				yy_do_action_445
			when 446 then
					--|#line 2596 "et_eiffel_parser.y"
				yy_do_action_446
			when 447 then
					--|#line 2598 "et_eiffel_parser.y"
				yy_do_action_447
			when 448 then
					--|#line 2600 "et_eiffel_parser.y"
				yy_do_action_448
			when 449 then
					--|#line 2602 "et_eiffel_parser.y"
				yy_do_action_449
			when 450 then
					--|#line 2604 "et_eiffel_parser.y"
				yy_do_action_450
			when 451 then
					--|#line 2606 "et_eiffel_parser.y"
				yy_do_action_451
			when 452 then
					--|#line 2608 "et_eiffel_parser.y"
				yy_do_action_452
			when 453 then
					--|#line 2610 "et_eiffel_parser.y"
				yy_do_action_453
			when 454 then
					--|#line 2612 "et_eiffel_parser.y"
				yy_do_action_454
			when 455 then
					--|#line 2614 "et_eiffel_parser.y"
				yy_do_action_455
			when 456 then
					--|#line 2616 "et_eiffel_parser.y"
				yy_do_action_456
			when 457 then
					--|#line 2618 "et_eiffel_parser.y"
				yy_do_action_457
			when 458 then
					--|#line 2620 "et_eiffel_parser.y"
				yy_do_action_458
			when 459 then
					--|#line 2622 "et_eiffel_parser.y"
				yy_do_action_459
			when 460 then
					--|#line 2624 "et_eiffel_parser.y"
				yy_do_action_460
			when 461 then
					--|#line 2626 "et_eiffel_parser.y"
				yy_do_action_461
			when 462 then
					--|#line 2628 "et_eiffel_parser.y"
				yy_do_action_462
			when 463 then
					--|#line 2632 "et_eiffel_parser.y"
				yy_do_action_463
			when 464 then
					--|#line 2634 "et_eiffel_parser.y"
				yy_do_action_464
			when 465 then
					--|#line 2636 "et_eiffel_parser.y"
				yy_do_action_465
			when 466 then
					--|#line 2638 "et_eiffel_parser.y"
				yy_do_action_466
			when 467 then
					--|#line 2640 "et_eiffel_parser.y"
				yy_do_action_467
			when 468 then
					--|#line 2642 "et_eiffel_parser.y"
				yy_do_action_468
			when 469 then
					--|#line 2644 "et_eiffel_parser.y"
				yy_do_action_469
			when 470 then
					--|#line 2646 "et_eiffel_parser.y"
				yy_do_action_470
			when 471 then
					--|#line 2648 "et_eiffel_parser.y"
				yy_do_action_471
			when 472 then
					--|#line 2650 "et_eiffel_parser.y"
				yy_do_action_472
			when 473 then
					--|#line 2652 "et_eiffel_parser.y"
				yy_do_action_473
			when 474 then
					--|#line 2654 "et_eiffel_parser.y"
				yy_do_action_474
			when 475 then
					--|#line 2656 "et_eiffel_parser.y"
				yy_do_action_475
			when 476 then
					--|#line 2658 "et_eiffel_parser.y"
				yy_do_action_476
			when 477 then
					--|#line 2660 "et_eiffel_parser.y"
				yy_do_action_477
			when 478 then
					--|#line 2662 "et_eiffel_parser.y"
				yy_do_action_478
			when 479 then
					--|#line 2664 "et_eiffel_parser.y"
				yy_do_action_479
			when 480 then
					--|#line 2666 "et_eiffel_parser.y"
				yy_do_action_480
			when 481 then
					--|#line 2668 "et_eiffel_parser.y"
				yy_do_action_481
			when 482 then
					--|#line 2670 "et_eiffel_parser.y"
				yy_do_action_482
			when 483 then
					--|#line 2672 "et_eiffel_parser.y"
				yy_do_action_483
			when 484 then
					--|#line 2674 "et_eiffel_parser.y"
				yy_do_action_484
			when 485 then
					--|#line 2678 "et_eiffel_parser.y"
				yy_do_action_485
			when 486 then
					--|#line 2680 "et_eiffel_parser.y"
				yy_do_action_486
			when 487 then
					--|#line 2682 "et_eiffel_parser.y"
				yy_do_action_487
			when 488 then
					--|#line 2684 "et_eiffel_parser.y"
				yy_do_action_488
			when 489 then
					--|#line 2686 "et_eiffel_parser.y"
				yy_do_action_489
			when 490 then
					--|#line 2688 "et_eiffel_parser.y"
				yy_do_action_490
			when 491 then
					--|#line 2690 "et_eiffel_parser.y"
				yy_do_action_491
			when 492 then
					--|#line 2692 "et_eiffel_parser.y"
				yy_do_action_492
			when 493 then
					--|#line 2694 "et_eiffel_parser.y"
				yy_do_action_493
			when 494 then
					--|#line 2696 "et_eiffel_parser.y"
				yy_do_action_494
			when 495 then
					--|#line 2698 "et_eiffel_parser.y"
				yy_do_action_495
			when 496 then
					--|#line 2700 "et_eiffel_parser.y"
				yy_do_action_496
			when 497 then
					--|#line 2702 "et_eiffel_parser.y"
				yy_do_action_497
			when 498 then
					--|#line 2704 "et_eiffel_parser.y"
				yy_do_action_498
			when 499 then
					--|#line 2706 "et_eiffel_parser.y"
				yy_do_action_499
			when 500 then
					--|#line 2708 "et_eiffel_parser.y"
				yy_do_action_500
			when 501 then
					--|#line 2710 "et_eiffel_parser.y"
				yy_do_action_501
			when 502 then
					--|#line 2712 "et_eiffel_parser.y"
				yy_do_action_502
			when 503 then
					--|#line 2714 "et_eiffel_parser.y"
				yy_do_action_503
			when 504 then
					--|#line 2716 "et_eiffel_parser.y"
				yy_do_action_504
			when 505 then
					--|#line 2718 "et_eiffel_parser.y"
				yy_do_action_505
			when 506 then
					--|#line 2720 "et_eiffel_parser.y"
				yy_do_action_506
			when 507 then
					--|#line 2722 "et_eiffel_parser.y"
				yy_do_action_507
			when 508 then
					--|#line 2726 "et_eiffel_parser.y"
				yy_do_action_508
			when 509 then
					--|#line 2728 "et_eiffel_parser.y"
				yy_do_action_509
			when 510 then
					--|#line 2732 "et_eiffel_parser.y"
				yy_do_action_510
			when 511 then
					--|#line 2734 "et_eiffel_parser.y"
				yy_do_action_511
			when 512 then
					--|#line 2738 "et_eiffel_parser.y"
				yy_do_action_512
			when 513 then
					--|#line 2741 "et_eiffel_parser.y"
				yy_do_action_513
			when 514 then
					--|#line 2749 "et_eiffel_parser.y"
				yy_do_action_514
			when 515 then
					--|#line 2756 "et_eiffel_parser.y"
				yy_do_action_515
			when 516 then
					--|#line 2767 "et_eiffel_parser.y"
				yy_do_action_516
			when 517 then
					--|#line 2772 "et_eiffel_parser.y"
				yy_do_action_517
			when 518 then
					--|#line 2777 "et_eiffel_parser.y"
				yy_do_action_518
			when 519 then
					--|#line 2782 "et_eiffel_parser.y"
				yy_do_action_519
			when 520 then
					--|#line 2789 "et_eiffel_parser.y"
				yy_do_action_520
			when 521 then
					--|#line 2795 "et_eiffel_parser.y"
				yy_do_action_521
			when 522 then
					--|#line 2804 "et_eiffel_parser.y"
				yy_do_action_522
			when 523 then
					--|#line 2806 "et_eiffel_parser.y"
				yy_do_action_523
			when 524 then
					--|#line 2810 "et_eiffel_parser.y"
				yy_do_action_524
			when 525 then
					--|#line 2813 "et_eiffel_parser.y"
				yy_do_action_525
			when 526 then
					--|#line 2819 "et_eiffel_parser.y"
				yy_do_action_526
			when 527 then
					--|#line 2827 "et_eiffel_parser.y"
				yy_do_action_527
			when 528 then
					--|#line 2832 "et_eiffel_parser.y"
				yy_do_action_528
			when 529 then
					--|#line 2837 "et_eiffel_parser.y"
				yy_do_action_529
			when 530 then
					--|#line 2842 "et_eiffel_parser.y"
				yy_do_action_530
			when 531 then
					--|#line 2853 "et_eiffel_parser.y"
				yy_do_action_531
			when 532 then
					--|#line 2864 "et_eiffel_parser.y"
				yy_do_action_532
			when 533 then
					--|#line 2877 "et_eiffel_parser.y"
				yy_do_action_533
			when 534 then
					--|#line 2886 "et_eiffel_parser.y"
				yy_do_action_534
			when 535 then
					--|#line 2895 "et_eiffel_parser.y"
				yy_do_action_535
			when 536 then
					--|#line 2897 "et_eiffel_parser.y"
				yy_do_action_536
			when 537 then
					--|#line 2899 "et_eiffel_parser.y"
				yy_do_action_537
			when 538 then
					--|#line 2903 "et_eiffel_parser.y"
				yy_do_action_538
			when 539 then
					--|#line 2905 "et_eiffel_parser.y"
				yy_do_action_539
			when 540 then
					--|#line 2907 "et_eiffel_parser.y"
				yy_do_action_540
			when 541 then
					--|#line 2909 "et_eiffel_parser.y"
				yy_do_action_541
			when 542 then
					--|#line 2911 "et_eiffel_parser.y"
				yy_do_action_542
			when 543 then
					--|#line 2913 "et_eiffel_parser.y"
				yy_do_action_543
			when 544 then
					--|#line 2915 "et_eiffel_parser.y"
				yy_do_action_544
			when 545 then
					--|#line 2917 "et_eiffel_parser.y"
				yy_do_action_545
			when 546 then
					--|#line 2919 "et_eiffel_parser.y"
				yy_do_action_546
			when 547 then
					--|#line 2921 "et_eiffel_parser.y"
				yy_do_action_547
			when 548 then
					--|#line 2923 "et_eiffel_parser.y"
				yy_do_action_548
			when 549 then
					--|#line 2925 "et_eiffel_parser.y"
				yy_do_action_549
			when 550 then
					--|#line 2927 "et_eiffel_parser.y"
				yy_do_action_550
			when 551 then
					--|#line 2929 "et_eiffel_parser.y"
				yy_do_action_551
			when 552 then
					--|#line 2931 "et_eiffel_parser.y"
				yy_do_action_552
			when 553 then
					--|#line 2933 "et_eiffel_parser.y"
				yy_do_action_553
			when 554 then
					--|#line 2935 "et_eiffel_parser.y"
				yy_do_action_554
			when 555 then
					--|#line 2937 "et_eiffel_parser.y"
				yy_do_action_555
			when 556 then
					--|#line 2939 "et_eiffel_parser.y"
				yy_do_action_556
			when 557 then
					--|#line 2941 "et_eiffel_parser.y"
				yy_do_action_557
			when 558 then
					--|#line 2943 "et_eiffel_parser.y"
				yy_do_action_558
			when 559 then
					--|#line 2947 "et_eiffel_parser.y"
				yy_do_action_559
			when 560 then
					--|#line 2949 "et_eiffel_parser.y"
				yy_do_action_560
			when 561 then
					--|#line 2953 "et_eiffel_parser.y"
				yy_do_action_561
			when 562 then
					--|#line 2955 "et_eiffel_parser.y"
				yy_do_action_562
			when 563 then
					--|#line 2957 "et_eiffel_parser.y"
				yy_do_action_563
			when 564 then
					--|#line 2959 "et_eiffel_parser.y"
				yy_do_action_564
			when 565 then
					--|#line 2961 "et_eiffel_parser.y"
				yy_do_action_565
			when 566 then
					--|#line 2963 "et_eiffel_parser.y"
				yy_do_action_566
			when 567 then
					--|#line 2965 "et_eiffel_parser.y"
				yy_do_action_567
			when 568 then
					--|#line 2973 "et_eiffel_parser.y"
				yy_do_action_568
			when 569 then
					--|#line 2981 "et_eiffel_parser.y"
				yy_do_action_569
			when 570 then
					--|#line 2989 "et_eiffel_parser.y"
				yy_do_action_570
			when 571 then
					--|#line 2997 "et_eiffel_parser.y"
				yy_do_action_571
			when 572 then
					--|#line 2999 "et_eiffel_parser.y"
				yy_do_action_572
			when 573 then
					--|#line 3001 "et_eiffel_parser.y"
				yy_do_action_573
			when 574 then
					--|#line 3003 "et_eiffel_parser.y"
				yy_do_action_574
			when 575 then
					--|#line 3005 "et_eiffel_parser.y"
				yy_do_action_575
			when 576 then
					--|#line 3007 "et_eiffel_parser.y"
				yy_do_action_576
			when 577 then
					--|#line 3009 "et_eiffel_parser.y"
				yy_do_action_577
			when 578 then
					--|#line 3011 "et_eiffel_parser.y"
				yy_do_action_578
			when 579 then
					--|#line 3013 "et_eiffel_parser.y"
				yy_do_action_579
			when 580 then
					--|#line 3019 "et_eiffel_parser.y"
				yy_do_action_580
			when 581 then
					--|#line 3023 "et_eiffel_parser.y"
				yy_do_action_581
			when 582 then
					--|#line 3027 "et_eiffel_parser.y"
				yy_do_action_582
			when 583 then
					--|#line 3031 "et_eiffel_parser.y"
				yy_do_action_583
			when 584 then
					--|#line 3035 "et_eiffel_parser.y"
				yy_do_action_584
			when 585 then
					--|#line 3039 "et_eiffel_parser.y"
				yy_do_action_585
			when 586 then
					--|#line 3043 "et_eiffel_parser.y"
				yy_do_action_586
			when 587 then
					--|#line 3047 "et_eiffel_parser.y"
				yy_do_action_587
			when 588 then
					--|#line 3051 "et_eiffel_parser.y"
				yy_do_action_588
			when 589 then
					--|#line 3053 "et_eiffel_parser.y"
				yy_do_action_589
			when 590 then
					--|#line 3057 "et_eiffel_parser.y"
				yy_do_action_590
			when 591 then
					--|#line 3061 "et_eiffel_parser.y"
				yy_do_action_591
			when 592 then
					--|#line 3068 "et_eiffel_parser.y"
				yy_do_action_592
			when 593 then
					--|#line 3070 "et_eiffel_parser.y"
				yy_do_action_593
			when 594 then
					--|#line 3074 "et_eiffel_parser.y"
				yy_do_action_594
			when 595 then
					--|#line 3076 "et_eiffel_parser.y"
				yy_do_action_595
			when 596 then
					--|#line 3080 "et_eiffel_parser.y"
				yy_do_action_596
			when 597 then
					--|#line 3091 "et_eiffel_parser.y"
				yy_do_action_597
			when 598 then
					--|#line 3091 "et_eiffel_parser.y"
				yy_do_action_598
			when 599 then
					--|#line 3112 "et_eiffel_parser.y"
				yy_do_action_599
			when 600 then
					--|#line 3114 "et_eiffel_parser.y"
				yy_do_action_600
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_601_800 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 601 then
					--|#line 3116 "et_eiffel_parser.y"
				yy_do_action_601
			when 602 then
					--|#line 3118 "et_eiffel_parser.y"
				yy_do_action_602
			when 603 then
					--|#line 3120 "et_eiffel_parser.y"
				yy_do_action_603
			when 604 then
					--|#line 3122 "et_eiffel_parser.y"
				yy_do_action_604
			when 605 then
					--|#line 3124 "et_eiffel_parser.y"
				yy_do_action_605
			when 606 then
					--|#line 3126 "et_eiffel_parser.y"
				yy_do_action_606
			when 607 then
					--|#line 3128 "et_eiffel_parser.y"
				yy_do_action_607
			when 608 then
					--|#line 3130 "et_eiffel_parser.y"
				yy_do_action_608
			when 609 then
					--|#line 3132 "et_eiffel_parser.y"
				yy_do_action_609
			when 610 then
					--|#line 3140 "et_eiffel_parser.y"
				yy_do_action_610
			when 611 then
					--|#line 3153 "et_eiffel_parser.y"
				yy_do_action_611
			when 612 then
					--|#line 3155 "et_eiffel_parser.y"
				yy_do_action_612
			when 613 then
					--|#line 3157 "et_eiffel_parser.y"
				yy_do_action_613
			when 614 then
					--|#line 3159 "et_eiffel_parser.y"
				yy_do_action_614
			when 615 then
					--|#line 3161 "et_eiffel_parser.y"
				yy_do_action_615
			when 616 then
					--|#line 3163 "et_eiffel_parser.y"
				yy_do_action_616
			when 617 then
					--|#line 3169 "et_eiffel_parser.y"
				yy_do_action_617
			when 618 then
					--|#line 3173 "et_eiffel_parser.y"
				yy_do_action_618
			when 619 then
					--|#line 3175 "et_eiffel_parser.y"
				yy_do_action_619
			when 620 then
					--|#line 3177 "et_eiffel_parser.y"
				yy_do_action_620
			when 621 then
					--|#line 3179 "et_eiffel_parser.y"
				yy_do_action_621
			when 622 then
					--|#line 3185 "et_eiffel_parser.y"
				yy_do_action_622
			when 623 then
					--|#line 3187 "et_eiffel_parser.y"
				yy_do_action_623
			when 624 then
					--|#line 3189 "et_eiffel_parser.y"
				yy_do_action_624
			when 625 then
					--|#line 3191 "et_eiffel_parser.y"
				yy_do_action_625
			when 626 then
					--|#line 3195 "et_eiffel_parser.y"
				yy_do_action_626
			when 627 then
					--|#line 3197 "et_eiffel_parser.y"
				yy_do_action_627
			when 628 then
					--|#line 3199 "et_eiffel_parser.y"
				yy_do_action_628
			when 629 then
					--|#line 3201 "et_eiffel_parser.y"
				yy_do_action_629
			when 630 then
					--|#line 3205 "et_eiffel_parser.y"
				yy_do_action_630
			when 631 then
					--|#line 3207 "et_eiffel_parser.y"
				yy_do_action_631
			when 632 then
					--|#line 3211 "et_eiffel_parser.y"
				yy_do_action_632
			when 633 then
					--|#line 3212 "et_eiffel_parser.y"
				yy_do_action_633
			when 634 then
					--|#line 3218 "et_eiffel_parser.y"
				yy_do_action_634
			when 635 then
					--|#line 3220 "et_eiffel_parser.y"
				yy_do_action_635
			when 636 then
					--|#line 3222 "et_eiffel_parser.y"
				yy_do_action_636
			when 637 then
					--|#line 3224 "et_eiffel_parser.y"
				yy_do_action_637
			when 638 then
					--|#line 3228 "et_eiffel_parser.y"
				yy_do_action_638
			when 639 then
					--|#line 3235 "et_eiffel_parser.y"
				yy_do_action_639
			when 640 then
					--|#line 3242 "et_eiffel_parser.y"
				yy_do_action_640
			when 641 then
					--|#line 3251 "et_eiffel_parser.y"
				yy_do_action_641
			when 642 then
					--|#line 3262 "et_eiffel_parser.y"
				yy_do_action_642
			when 643 then
					--|#line 3264 "et_eiffel_parser.y"
				yy_do_action_643
			when 644 then
					--|#line 3268 "et_eiffel_parser.y"
				yy_do_action_644
			when 645 then
					--|#line 3275 "et_eiffel_parser.y"
				yy_do_action_645
			when 646 then
					--|#line 3282 "et_eiffel_parser.y"
				yy_do_action_646
			when 647 then
					--|#line 3291 "et_eiffel_parser.y"
				yy_do_action_647
			when 648 then
					--|#line 3302 "et_eiffel_parser.y"
				yy_do_action_648
			when 649 then
					--|#line 3304 "et_eiffel_parser.y"
				yy_do_action_649
			when 650 then
					--|#line 3308 "et_eiffel_parser.y"
				yy_do_action_650
			when 651 then
					--|#line 3310 "et_eiffel_parser.y"
				yy_do_action_651
			when 652 then
					--|#line 3317 "et_eiffel_parser.y"
				yy_do_action_652
			when 653 then
					--|#line 3324 "et_eiffel_parser.y"
				yy_do_action_653
			when 654 then
					--|#line 3333 "et_eiffel_parser.y"
				yy_do_action_654
			when 655 then
					--|#line 3342 "et_eiffel_parser.y"
				yy_do_action_655
			when 656 then
					--|#line 3344 "et_eiffel_parser.y"
				yy_do_action_656
			when 657 then
					--|#line 3344 "et_eiffel_parser.y"
				yy_do_action_657
			when 658 then
					--|#line 3357 "et_eiffel_parser.y"
				yy_do_action_658
			when 659 then
					--|#line 3368 "et_eiffel_parser.y"
				yy_do_action_659
			when 660 then
					--|#line 3376 "et_eiffel_parser.y"
				yy_do_action_660
			when 661 then
					--|#line 3385 "et_eiffel_parser.y"
				yy_do_action_661
			when 662 then
					--|#line 3394 "et_eiffel_parser.y"
				yy_do_action_662
			when 663 then
					--|#line 3396 "et_eiffel_parser.y"
				yy_do_action_663
			when 664 then
					--|#line 3400 "et_eiffel_parser.y"
				yy_do_action_664
			when 665 then
					--|#line 3402 "et_eiffel_parser.y"
				yy_do_action_665
			when 666 then
					--|#line 3404 "et_eiffel_parser.y"
				yy_do_action_666
			when 667 then
					--|#line 3406 "et_eiffel_parser.y"
				yy_do_action_667
			when 668 then
					--|#line 3412 "et_eiffel_parser.y"
				yy_do_action_668
			when 669 then
					--|#line 3414 "et_eiffel_parser.y"
				yy_do_action_669
			when 670 then
					--|#line 3418 "et_eiffel_parser.y"
				yy_do_action_670
			when 671 then
					--|#line 3420 "et_eiffel_parser.y"
				yy_do_action_671
			when 672 then
					--|#line 3427 "et_eiffel_parser.y"
				yy_do_action_672
			when 673 then
					--|#line 3434 "et_eiffel_parser.y"
				yy_do_action_673
			when 674 then
					--|#line 3443 "et_eiffel_parser.y"
				yy_do_action_674
			when 675 then
					--|#line 3454 "et_eiffel_parser.y"
				yy_do_action_675
			when 676 then
					--|#line 3456 "et_eiffel_parser.y"
				yy_do_action_676
			when 677 then
					--|#line 3460 "et_eiffel_parser.y"
				yy_do_action_677
			when 678 then
					--|#line 3464 "et_eiffel_parser.y"
				yy_do_action_678
			when 679 then
					--|#line 3466 "et_eiffel_parser.y"
				yy_do_action_679
			when 680 then
					--|#line 3472 "et_eiffel_parser.y"
				yy_do_action_680
			when 681 then
					--|#line 3476 "et_eiffel_parser.y"
				yy_do_action_681
			when 682 then
					--|#line 3478 "et_eiffel_parser.y"
				yy_do_action_682
			when 683 then
					--|#line 3480 "et_eiffel_parser.y"
				yy_do_action_683
			when 684 then
					--|#line 3480 "et_eiffel_parser.y"
				yy_do_action_684
			when 685 then
					--|#line 3493 "et_eiffel_parser.y"
				yy_do_action_685
			when 686 then
					--|#line 3504 "et_eiffel_parser.y"
				yy_do_action_686
			when 687 then
					--|#line 3513 "et_eiffel_parser.y"
				yy_do_action_687
			when 688 then
					--|#line 3524 "et_eiffel_parser.y"
				yy_do_action_688
			when 689 then
					--|#line 3526 "et_eiffel_parser.y"
				yy_do_action_689
			when 690 then
					--|#line 3528 "et_eiffel_parser.y"
				yy_do_action_690
			when 691 then
					--|#line 3530 "et_eiffel_parser.y"
				yy_do_action_691
			when 692 then
					--|#line 3532 "et_eiffel_parser.y"
				yy_do_action_692
			when 693 then
					--|#line 3534 "et_eiffel_parser.y"
				yy_do_action_693
			when 694 then
					--|#line 3536 "et_eiffel_parser.y"
				yy_do_action_694
			when 695 then
					--|#line 3540 "et_eiffel_parser.y"
				yy_do_action_695
			when 696 then
					--|#line 3542 "et_eiffel_parser.y"
				yy_do_action_696
			when 697 then
					--|#line 3546 "et_eiffel_parser.y"
				yy_do_action_697
			when 698 then
					--|#line 3550 "et_eiffel_parser.y"
				yy_do_action_698
			when 699 then
					--|#line 3552 "et_eiffel_parser.y"
				yy_do_action_699
			when 700 then
					--|#line 3556 "et_eiffel_parser.y"
				yy_do_action_700
			when 701 then
					--|#line 3558 "et_eiffel_parser.y"
				yy_do_action_701
			when 702 then
					--|#line 3562 "et_eiffel_parser.y"
				yy_do_action_702
			when 703 then
					--|#line 3564 "et_eiffel_parser.y"
				yy_do_action_703
			when 704 then
					--|#line 3568 "et_eiffel_parser.y"
				yy_do_action_704
			when 705 then
					--|#line 3570 "et_eiffel_parser.y"
				yy_do_action_705
			when 706 then
					--|#line 3572 "et_eiffel_parser.y"
				yy_do_action_706
			when 707 then
					--|#line 3574 "et_eiffel_parser.y"
				yy_do_action_707
			when 708 then
					--|#line 3576 "et_eiffel_parser.y"
				yy_do_action_708
			when 709 then
					--|#line 3578 "et_eiffel_parser.y"
				yy_do_action_709
			when 710 then
					--|#line 3580 "et_eiffel_parser.y"
				yy_do_action_710
			when 711 then
					--|#line 3588 "et_eiffel_parser.y"
				yy_do_action_711
			when 712 then
					--|#line 3590 "et_eiffel_parser.y"
				yy_do_action_712
			when 713 then
					--|#line 3594 "et_eiffel_parser.y"
				yy_do_action_713
			when 714 then
					--|#line 3602 "et_eiffel_parser.y"
				yy_do_action_714
			when 715 then
					--|#line 3608 "et_eiffel_parser.y"
				yy_do_action_715
			when 716 then
					--|#line 3610 "et_eiffel_parser.y"
				yy_do_action_716
			when 717 then
					--|#line 3612 "et_eiffel_parser.y"
				yy_do_action_717
			when 718 then
					--|#line 3612 "et_eiffel_parser.y"
				yy_do_action_718
			when 719 then
					--|#line 3625 "et_eiffel_parser.y"
				yy_do_action_719
			when 720 then
					--|#line 3636 "et_eiffel_parser.y"
				yy_do_action_720
			when 721 then
					--|#line 3644 "et_eiffel_parser.y"
				yy_do_action_721
			when 722 then
					--|#line 3653 "et_eiffel_parser.y"
				yy_do_action_722
			when 723 then
					--|#line 3662 "et_eiffel_parser.y"
				yy_do_action_723
			when 724 then
					--|#line 3664 "et_eiffel_parser.y"
				yy_do_action_724
			when 725 then
					--|#line 3666 "et_eiffel_parser.y"
				yy_do_action_725
			when 726 then
					--|#line 3668 "et_eiffel_parser.y"
				yy_do_action_726
			when 727 then
					--|#line 3675 "et_eiffel_parser.y"
				yy_do_action_727
			when 728 then
					--|#line 3677 "et_eiffel_parser.y"
				yy_do_action_728
			when 729 then
					--|#line 3683 "et_eiffel_parser.y"
				yy_do_action_729
			when 730 then
					--|#line 3685 "et_eiffel_parser.y"
				yy_do_action_730
			when 731 then
					--|#line 3689 "et_eiffel_parser.y"
				yy_do_action_731
			when 732 then
					--|#line 3691 "et_eiffel_parser.y"
				yy_do_action_732
			when 733 then
					--|#line 3693 "et_eiffel_parser.y"
				yy_do_action_733
			when 734 then
					--|#line 3695 "et_eiffel_parser.y"
				yy_do_action_734
			when 735 then
					--|#line 3697 "et_eiffel_parser.y"
				yy_do_action_735
			when 736 then
					--|#line 3699 "et_eiffel_parser.y"
				yy_do_action_736
			when 737 then
					--|#line 3701 "et_eiffel_parser.y"
				yy_do_action_737
			when 738 then
					--|#line 3703 "et_eiffel_parser.y"
				yy_do_action_738
			when 739 then
					--|#line 3705 "et_eiffel_parser.y"
				yy_do_action_739
			when 740 then
					--|#line 3707 "et_eiffel_parser.y"
				yy_do_action_740
			when 741 then
					--|#line 3709 "et_eiffel_parser.y"
				yy_do_action_741
			when 742 then
					--|#line 3711 "et_eiffel_parser.y"
				yy_do_action_742
			when 743 then
					--|#line 3713 "et_eiffel_parser.y"
				yy_do_action_743
			when 744 then
					--|#line 3715 "et_eiffel_parser.y"
				yy_do_action_744
			when 745 then
					--|#line 3717 "et_eiffel_parser.y"
				yy_do_action_745
			when 746 then
					--|#line 3719 "et_eiffel_parser.y"
				yy_do_action_746
			when 747 then
					--|#line 3721 "et_eiffel_parser.y"
				yy_do_action_747
			when 748 then
					--|#line 3723 "et_eiffel_parser.y"
				yy_do_action_748
			when 749 then
					--|#line 3725 "et_eiffel_parser.y"
				yy_do_action_749
			when 750 then
					--|#line 3727 "et_eiffel_parser.y"
				yy_do_action_750
			when 751 then
					--|#line 3729 "et_eiffel_parser.y"
				yy_do_action_751
			when 752 then
					--|#line 3731 "et_eiffel_parser.y"
				yy_do_action_752
			when 753 then
					--|#line 3733 "et_eiffel_parser.y"
				yy_do_action_753
			when 754 then
					--|#line 3735 "et_eiffel_parser.y"
				yy_do_action_754
			when 755 then
					--|#line 3737 "et_eiffel_parser.y"
				yy_do_action_755
			when 756 then
					--|#line 3739 "et_eiffel_parser.y"
				yy_do_action_756
			when 757 then
					--|#line 3741 "et_eiffel_parser.y"
				yy_do_action_757
			when 758 then
					--|#line 3743 "et_eiffel_parser.y"
				yy_do_action_758
			when 759 then
					--|#line 3745 "et_eiffel_parser.y"
				yy_do_action_759
			when 760 then
					--|#line 3749 "et_eiffel_parser.y"
				yy_do_action_760
			when 761 then
					--|#line 3751 "et_eiffel_parser.y"
				yy_do_action_761
			when 762 then
					--|#line 3753 "et_eiffel_parser.y"
				yy_do_action_762
			when 763 then
					--|#line 3755 "et_eiffel_parser.y"
				yy_do_action_763
			when 764 then
					--|#line 3757 "et_eiffel_parser.y"
				yy_do_action_764
			when 765 then
					--|#line 3759 "et_eiffel_parser.y"
				yy_do_action_765
			when 766 then
					--|#line 3763 "et_eiffel_parser.y"
				yy_do_action_766
			when 767 then
					--|#line 3765 "et_eiffel_parser.y"
				yy_do_action_767
			when 768 then
					--|#line 3767 "et_eiffel_parser.y"
				yy_do_action_768
			when 769 then
					--|#line 3769 "et_eiffel_parser.y"
				yy_do_action_769
			when 770 then
					--|#line 3771 "et_eiffel_parser.y"
				yy_do_action_770
			when 771 then
					--|#line 3773 "et_eiffel_parser.y"
				yy_do_action_771
			when 772 then
					--|#line 3775 "et_eiffel_parser.y"
				yy_do_action_772
			when 773 then
					--|#line 3777 "et_eiffel_parser.y"
				yy_do_action_773
			when 774 then
					--|#line 3779 "et_eiffel_parser.y"
				yy_do_action_774
			when 775 then
					--|#line 3781 "et_eiffel_parser.y"
				yy_do_action_775
			when 776 then
					--|#line 3783 "et_eiffel_parser.y"
				yy_do_action_776
			when 777 then
					--|#line 3785 "et_eiffel_parser.y"
				yy_do_action_777
			when 778 then
					--|#line 3787 "et_eiffel_parser.y"
				yy_do_action_778
			when 779 then
					--|#line 3789 "et_eiffel_parser.y"
				yy_do_action_779
			when 780 then
					--|#line 3791 "et_eiffel_parser.y"
				yy_do_action_780
			when 781 then
					--|#line 3793 "et_eiffel_parser.y"
				yy_do_action_781
			when 782 then
					--|#line 3795 "et_eiffel_parser.y"
				yy_do_action_782
			when 783 then
					--|#line 3797 "et_eiffel_parser.y"
				yy_do_action_783
			when 784 then
					--|#line 3805 "et_eiffel_parser.y"
				yy_do_action_784
			when 785 then
					--|#line 3807 "et_eiffel_parser.y"
				yy_do_action_785
			when 786 then
					--|#line 3809 "et_eiffel_parser.y"
				yy_do_action_786
			when 787 then
					--|#line 3811 "et_eiffel_parser.y"
				yy_do_action_787
			when 788 then
					--|#line 3815 "et_eiffel_parser.y"
				yy_do_action_788
			when 789 then
					--|#line 3817 "et_eiffel_parser.y"
				yy_do_action_789
			when 790 then
					--|#line 3819 "et_eiffel_parser.y"
				yy_do_action_790
			when 791 then
					--|#line 3821 "et_eiffel_parser.y"
				yy_do_action_791
			when 792 then
					--|#line 3823 "et_eiffel_parser.y"
				yy_do_action_792
			when 793 then
					--|#line 3825 "et_eiffel_parser.y"
				yy_do_action_793
			when 794 then
					--|#line 3827 "et_eiffel_parser.y"
				yy_do_action_794
			when 795 then
					--|#line 3829 "et_eiffel_parser.y"
				yy_do_action_795
			when 796 then
					--|#line 3831 "et_eiffel_parser.y"
				yy_do_action_796
			when 797 then
					--|#line 3833 "et_eiffel_parser.y"
				yy_do_action_797
			when 798 then
					--|#line 3835 "et_eiffel_parser.y"
				yy_do_action_798
			when 799 then
					--|#line 3837 "et_eiffel_parser.y"
				yy_do_action_799
			when 800 then
					--|#line 3839 "et_eiffel_parser.y"
				yy_do_action_800
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_801_1000 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 801 then
					--|#line 3841 "et_eiffel_parser.y"
				yy_do_action_801
			when 802 then
					--|#line 3874 "et_eiffel_parser.y"
				yy_do_action_802
			when 803 then
					--|#line 3876 "et_eiffel_parser.y"
				yy_do_action_803
			when 804 then
					--|#line 3878 "et_eiffel_parser.y"
				yy_do_action_804
			when 805 then
					--|#line 3882 "et_eiffel_parser.y"
				yy_do_action_805
			when 806 then
					--|#line 3884 "et_eiffel_parser.y"
				yy_do_action_806
			when 807 then
					--|#line 3886 "et_eiffel_parser.y"
				yy_do_action_807
			when 808 then
					--|#line 3894 "et_eiffel_parser.y"
				yy_do_action_808
			when 809 then
					--|#line 3898 "et_eiffel_parser.y"
				yy_do_action_809
			when 810 then
					--|#line 3900 "et_eiffel_parser.y"
				yy_do_action_810
			when 811 then
					--|#line 3904 "et_eiffel_parser.y"
				yy_do_action_811
			when 812 then
					--|#line 3904 "et_eiffel_parser.y"
				yy_do_action_812
			when 813 then
					--|#line 3915 "et_eiffel_parser.y"
				yy_do_action_813
			when 814 then
					--|#line 3915 "et_eiffel_parser.y"
				yy_do_action_814
			when 815 then
					--|#line 3928 "et_eiffel_parser.y"
				yy_do_action_815
			when 816 then
					--|#line 3928 "et_eiffel_parser.y"
				yy_do_action_816
			when 817 then
					--|#line 3939 "et_eiffel_parser.y"
				yy_do_action_817
			when 818 then
					--|#line 3939 "et_eiffel_parser.y"
				yy_do_action_818
			when 819 then
					--|#line 3952 "et_eiffel_parser.y"
				yy_do_action_819
			when 820 then
					--|#line 3963 "et_eiffel_parser.y"
				yy_do_action_820
			when 821 then
					--|#line 3971 "et_eiffel_parser.y"
				yy_do_action_821
			when 822 then
					--|#line 3980 "et_eiffel_parser.y"
				yy_do_action_822
			when 823 then
					--|#line 3988 "et_eiffel_parser.y"
				yy_do_action_823
			when 824 then
					--|#line 3990 "et_eiffel_parser.y"
				yy_do_action_824
			when 825 then
					--|#line 3990 "et_eiffel_parser.y"
				yy_do_action_825
			when 826 then
					--|#line 4003 "et_eiffel_parser.y"
				yy_do_action_826
			when 827 then
					--|#line 4012 "et_eiffel_parser.y"
				yy_do_action_827
			when 828 then
					--|#line 4023 "et_eiffel_parser.y"
				yy_do_action_828
			when 829 then
					--|#line 4031 "et_eiffel_parser.y"
				yy_do_action_829
			when 830 then
					--|#line 4040 "et_eiffel_parser.y"
				yy_do_action_830
			when 831 then
					--|#line 4042 "et_eiffel_parser.y"
				yy_do_action_831
			when 832 then
					--|#line 4042 "et_eiffel_parser.y"
				yy_do_action_832
			when 833 then
					--|#line 4055 "et_eiffel_parser.y"
				yy_do_action_833
			when 834 then
					--|#line 4066 "et_eiffel_parser.y"
				yy_do_action_834
			when 835 then
					--|#line 4074 "et_eiffel_parser.y"
				yy_do_action_835
			when 836 then
					--|#line 4083 "et_eiffel_parser.y"
				yy_do_action_836
			when 837 then
					--|#line 4085 "et_eiffel_parser.y"
				yy_do_action_837
			when 838 then
					--|#line 4085 "et_eiffel_parser.y"
				yy_do_action_838
			when 839 then
					--|#line 4100 "et_eiffel_parser.y"
				yy_do_action_839
			when 840 then
					--|#line 4111 "et_eiffel_parser.y"
				yy_do_action_840
			when 841 then
					--|#line 4119 "et_eiffel_parser.y"
				yy_do_action_841
			when 842 then
					--|#line 4128 "et_eiffel_parser.y"
				yy_do_action_842
			when 843 then
					--|#line 4130 "et_eiffel_parser.y"
				yy_do_action_843
			when 844 then
					--|#line 4132 "et_eiffel_parser.y"
				yy_do_action_844
			when 845 then
					--|#line 4134 "et_eiffel_parser.y"
				yy_do_action_845
			when 846 then
					--|#line 4136 "et_eiffel_parser.y"
				yy_do_action_846
			when 847 then
					--|#line 4140 "et_eiffel_parser.y"
				yy_do_action_847
			when 848 then
					--|#line 4144 "et_eiffel_parser.y"
				yy_do_action_848
			when 849 then
					--|#line 4148 "et_eiffel_parser.y"
				yy_do_action_849
			when 850 then
					--|#line 4150 "et_eiffel_parser.y"
				yy_do_action_850
			when 851 then
					--|#line 4154 "et_eiffel_parser.y"
				yy_do_action_851
			when 852 then
					--|#line 4158 "et_eiffel_parser.y"
				yy_do_action_852
			when 853 then
					--|#line 4160 "et_eiffel_parser.y"
				yy_do_action_853
			when 854 then
					--|#line 4164 "et_eiffel_parser.y"
				yy_do_action_854
			when 855 then
					--|#line 4176 "et_eiffel_parser.y"
				yy_do_action_855
			when 856 then
					--|#line 4178 "et_eiffel_parser.y"
				yy_do_action_856
			when 857 then
					--|#line 4182 "et_eiffel_parser.y"
				yy_do_action_857
			when 858 then
					--|#line 4189 "et_eiffel_parser.y"
				yy_do_action_858
			when 859 then
					--|#line 4199 "et_eiffel_parser.y"
				yy_do_action_859
			when 860 then
					--|#line 4205 "et_eiffel_parser.y"
				yy_do_action_860
			when 861 then
					--|#line 4211 "et_eiffel_parser.y"
				yy_do_action_861
			when 862 then
					--|#line 4217 "et_eiffel_parser.y"
				yy_do_action_862
			when 863 then
					--|#line 4223 "et_eiffel_parser.y"
				yy_do_action_863
			when 864 then
					--|#line 4229 "et_eiffel_parser.y"
				yy_do_action_864
			when 865 then
					--|#line 4235 "et_eiffel_parser.y"
				yy_do_action_865
			when 866 then
					--|#line 4241 "et_eiffel_parser.y"
				yy_do_action_866
			when 867 then
					--|#line 4247 "et_eiffel_parser.y"
				yy_do_action_867
			when 868 then
					--|#line 4252 "et_eiffel_parser.y"
				yy_do_action_868
			when 869 then
					--|#line 4258 "et_eiffel_parser.y"
				yy_do_action_869
			when 870 then
					--|#line 4266 "et_eiffel_parser.y"
				yy_do_action_870
			when 871 then
					--|#line 4273 "et_eiffel_parser.y"
				yy_do_action_871
			when 872 then
					--|#line 4277 "et_eiffel_parser.y"
				yy_do_action_872
			when 873 then
					--|#line 4279 "et_eiffel_parser.y"
				yy_do_action_873
			when 874 then
					--|#line 4281 "et_eiffel_parser.y"
				yy_do_action_874
			when 875 then
					--|#line 4283 "et_eiffel_parser.y"
				yy_do_action_875
			when 876 then
					--|#line 4285 "et_eiffel_parser.y"
				yy_do_action_876
			when 877 then
					--|#line 4289 "et_eiffel_parser.y"
				yy_do_action_877
			when 878 then
					--|#line 4291 "et_eiffel_parser.y"
				yy_do_action_878
			when 879 then
					--|#line 4293 "et_eiffel_parser.y"
				yy_do_action_879
			when 880 then
					--|#line 4293 "et_eiffel_parser.y"
				yy_do_action_880
			when 881 then
					--|#line 4306 "et_eiffel_parser.y"
				yy_do_action_881
			when 882 then
					--|#line 4317 "et_eiffel_parser.y"
				yy_do_action_882
			when 883 then
					--|#line 4325 "et_eiffel_parser.y"
				yy_do_action_883
			when 884 then
					--|#line 4334 "et_eiffel_parser.y"
				yy_do_action_884
			when 885 then
					--|#line 4343 "et_eiffel_parser.y"
				yy_do_action_885
			when 886 then
					--|#line 4345 "et_eiffel_parser.y"
				yy_do_action_886
			when 887 then
					--|#line 4347 "et_eiffel_parser.y"
				yy_do_action_887
			when 888 then
					--|#line 4353 "et_eiffel_parser.y"
				yy_do_action_888
			when 889 then
					--|#line 4355 "et_eiffel_parser.y"
				yy_do_action_889
			when 890 then
					--|#line 4359 "et_eiffel_parser.y"
				yy_do_action_890
			when 891 then
					--|#line 4361 "et_eiffel_parser.y"
				yy_do_action_891
			when 892 then
					--|#line 4363 "et_eiffel_parser.y"
				yy_do_action_892
			when 893 then
					--|#line 4365 "et_eiffel_parser.y"
				yy_do_action_893
			when 894 then
					--|#line 4367 "et_eiffel_parser.y"
				yy_do_action_894
			when 895 then
					--|#line 4369 "et_eiffel_parser.y"
				yy_do_action_895
			when 896 then
					--|#line 4371 "et_eiffel_parser.y"
				yy_do_action_896
			when 897 then
					--|#line 4373 "et_eiffel_parser.y"
				yy_do_action_897
			when 898 then
					--|#line 4375 "et_eiffel_parser.y"
				yy_do_action_898
			when 899 then
					--|#line 4377 "et_eiffel_parser.y"
				yy_do_action_899
			when 900 then
					--|#line 4379 "et_eiffel_parser.y"
				yy_do_action_900
			when 901 then
					--|#line 4381 "et_eiffel_parser.y"
				yy_do_action_901
			when 902 then
					--|#line 4383 "et_eiffel_parser.y"
				yy_do_action_902
			when 903 then
					--|#line 4385 "et_eiffel_parser.y"
				yy_do_action_903
			when 904 then
					--|#line 4387 "et_eiffel_parser.y"
				yy_do_action_904
			when 905 then
					--|#line 4389 "et_eiffel_parser.y"
				yy_do_action_905
			when 906 then
					--|#line 4391 "et_eiffel_parser.y"
				yy_do_action_906
			when 907 then
					--|#line 4393 "et_eiffel_parser.y"
				yy_do_action_907
			when 908 then
					--|#line 4395 "et_eiffel_parser.y"
				yy_do_action_908
			when 909 then
					--|#line 4397 "et_eiffel_parser.y"
				yy_do_action_909
			when 910 then
					--|#line 4399 "et_eiffel_parser.y"
				yy_do_action_910
			when 911 then
					--|#line 4401 "et_eiffel_parser.y"
				yy_do_action_911
			when 912 then
					--|#line 4403 "et_eiffel_parser.y"
				yy_do_action_912
			when 913 then
					--|#line 4405 "et_eiffel_parser.y"
				yy_do_action_913
			when 914 then
					--|#line 4407 "et_eiffel_parser.y"
				yy_do_action_914
			when 915 then
					--|#line 4409 "et_eiffel_parser.y"
				yy_do_action_915
			when 916 then
					--|#line 4411 "et_eiffel_parser.y"
				yy_do_action_916
			when 917 then
					--|#line 4413 "et_eiffel_parser.y"
				yy_do_action_917
			when 918 then
					--|#line 4415 "et_eiffel_parser.y"
				yy_do_action_918
			when 919 then
					--|#line 4417 "et_eiffel_parser.y"
				yy_do_action_919
			when 920 then
					--|#line 4419 "et_eiffel_parser.y"
				yy_do_action_920
			when 921 then
					--|#line 4423 "et_eiffel_parser.y"
				yy_do_action_921
			when 922 then
					--|#line 4432 "et_eiffel_parser.y"
				yy_do_action_922
			when 923 then
					--|#line 4434 "et_eiffel_parser.y"
				yy_do_action_923
			when 924 then
					--|#line 4438 "et_eiffel_parser.y"
				yy_do_action_924
			when 925 then
					--|#line 4440 "et_eiffel_parser.y"
				yy_do_action_925
			when 926 then
					--|#line 4444 "et_eiffel_parser.y"
				yy_do_action_926
			when 927 then
					--|#line 4453 "et_eiffel_parser.y"
				yy_do_action_927
			when 928 then
					--|#line 4455 "et_eiffel_parser.y"
				yy_do_action_928
			when 929 then
					--|#line 4459 "et_eiffel_parser.y"
				yy_do_action_929
			when 930 then
					--|#line 4461 "et_eiffel_parser.y"
				yy_do_action_930
			when 931 then
					--|#line 4465 "et_eiffel_parser.y"
				yy_do_action_931
			when 932 then
					--|#line 4467 "et_eiffel_parser.y"
				yy_do_action_932
			when 933 then
					--|#line 4471 "et_eiffel_parser.y"
				yy_do_action_933
			when 934 then
					--|#line 4478 "et_eiffel_parser.y"
				yy_do_action_934
			when 935 then
					--|#line 4487 "et_eiffel_parser.y"
				yy_do_action_935
			when 936 then
					--|#line 4496 "et_eiffel_parser.y"
				yy_do_action_936
			when 937 then
					--|#line 4498 "et_eiffel_parser.y"
				yy_do_action_937
			when 938 then
					--|#line 4502 "et_eiffel_parser.y"
				yy_do_action_938
			when 939 then
					--|#line 4504 "et_eiffel_parser.y"
				yy_do_action_939
			when 940 then
					--|#line 4508 "et_eiffel_parser.y"
				yy_do_action_940
			when 941 then
					--|#line 4515 "et_eiffel_parser.y"
				yy_do_action_941
			when 942 then
					--|#line 4524 "et_eiffel_parser.y"
				yy_do_action_942
			when 943 then
					--|#line 4533 "et_eiffel_parser.y"
				yy_do_action_943
			when 944 then
					--|#line 4535 "et_eiffel_parser.y"
				yy_do_action_944
			when 945 then
					--|#line 4537 "et_eiffel_parser.y"
				yy_do_action_945
			when 946 then
					--|#line 4543 "et_eiffel_parser.y"
				yy_do_action_946
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_1
			--|#line 255 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 255 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 255")
end

			-- END
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp44 := yyvsp44 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_2
			--|#line 259 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 259 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 259")
end

			if attached yyvs44.item (yyvsp44) as l_class_declaration then
				l_class_declaration.set_leading_break (yyvs8.item (yyvsp8))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp8 := yyvsp8 -1
	yyvsp44 := yyvsp44 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_3
			--|#line 267 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 267 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 267")
end

			yyval44 := yyvs44.item (yyvsp44)
			if yyval44 /= Void then
				yyval44.set_first_indexing (yyvs86.item (yyvsp86))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp86 := yyvsp86 -1
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_4
			--|#line 276 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 276 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 276")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_5
			--|#line 277 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 277 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 277")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp44 := yyvsp44 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_6
			--|#line 277 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 277 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 277")
end

			if not system_processor.preparse_multiple_mode then
					-- Raise syntax error: it is not valid to have more
					-- than one class text in the same file.
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_7
			--|#line 288 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 288 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 288")
end

			yyval44 := yyvs44.item (yyvsp44)
			set_class_to_end (yyval44, yyvs106.item (yyvsp106), yyvs109.item (yyvsp109), yyvs61.item (yyvsp61), yyvs57.item (yyvsp57), yyvs74.item (yyvsp74), yyvs95.item (yyvsp95), yyvs86.item (yyvsp86), yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp83 := yyvsp83 -1
	yyvsp106 := yyvsp106 -1
	yyvsp109 := yyvsp109 -1
	yyvsp61 := yyvsp61 -1
	yyvsp57 := yyvsp57 -1
	yyvsp74 := yyvsp74 -1
	yyvsp95 := yyvsp95 -1
	yyvsp86 := yyvsp86 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_8
			--|#line 296 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 296 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 296")
end

set_class_providers 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_9
			--|#line 301 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 301 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 301")
end

yyval86 := ast_factory.new_indexings (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_10
			--|#line 303 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 303 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 303")
end

			yyval86 := yyvs86.item (yyvsp86)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_11
			--|#line 303 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 303 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 303")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_12
			--|#line 314 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 314 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 314")
end

yyval86 := ast_factory.new_indexings (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_13
			--|#line 316 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 316 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 316")
end

			yyval86 := yyvs86.item (yyvsp86)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_14
			--|#line 316 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 316 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 316")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_15
			--|#line 329 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 329 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 329")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_16
			--|#line 331 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 331 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 331")
end

yyval86 := yyvs86.item (yyvsp86) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_17
			--|#line 335 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 335 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 335")
end

			if attached yyvs87.item (yyvsp87) as l_note then
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value + 1)
				if yyval86 /= Void then
					yyval86.put_first (l_note)
				end
			else
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp87 := yyvsp87 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_18
			--|#line 346 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 346 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 346")
end

			yyval86 := yyvs86.item (yyvsp86)
			if yyval86 /= Void and attached yyvs87.item (yyvsp87) as l_note then
				yyval86.put_first (l_note)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp87 := yyvsp87 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_19
			--|#line 346 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 346 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 346")
end

increment_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_20
			--|#line 355 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 355 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 355")
end

			yyval86 := yyvs86.item (yyvsp86)
			if yyval86 /= Void and attached yyvs87.item (yyvsp87) as l_note then
				yyval86.put_first (l_note)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp87 := yyvsp87 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_21
			--|#line 355 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 355 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 355")
end

increment_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_22
			--|#line 366 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 366 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 366")
end

			yyval87 := yyvs87.item (yyvsp87)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_23
			--|#line 373 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 373 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 373")
end

			yyval87 := ast_factory.new_tagged_indexing (ast_factory.new_tag (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs90.item (yyvsp90))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp87 := yyvsp87 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp90 := yyvsp90 -1
	if yyvsp87 >= yyvsc87 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs87")
		end
		yyvsc87 := yyvsc87 + yyInitial_yyvs_size
		yyvs87 := yyspecial_routines87.aliased_resized_area (yyvs87, yyvsc87)
	end
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_24
			--|#line 379 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 379 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 379")
end

yyval87 := ast_factory.new_indexing_semicolon (yyvs87.item (yyvsp87), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp21 := yyvsp21 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_25
			--|#line 383 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 383 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 383")
end

			if attached yyvs87.item (yyvsp87) as l_indexing_clause then
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value + 1)
				if yyval86 /= Void then
					yyval86.put_first (l_indexing_clause)
				end
			else
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp87 := yyvsp87 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_26
			--|#line 394 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 394 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 394")
end

			if attached yyvs87.item (yyvsp87) as l_indexing_clause then
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value + 1)
				if yyval86 /= Void then
					yyval86.put_first (l_indexing_clause)
				end
			else
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp87 := yyvsp87 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_27
			--|#line 406 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 406 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 406")
end

			yyval86 := yyvs86.item (yyvsp86)
			if yyval86 /= Void and attached yyvs87.item (yyvsp87) as l_indexing_clause then
				yyval86.put_first (l_indexing_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp87 := yyvsp87 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_28
			--|#line 406 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 406 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 406")
end

increment_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_29
			--|#line 415 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 415 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 415")
end

			yyval86 := yyvs86.item (yyvsp86)
			if yyval86 /= Void and attached yyvs87.item (yyvsp87) as l_indexing_clause then
				yyval86.put_first (l_indexing_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp87 := yyvsp87 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_30
			--|#line 415 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 415 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 415")
end

increment_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_31
			--|#line 426 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 426 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 426")
end

			yyval87 := yyvs87.item (yyvsp87)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_32
			--|#line 433 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 433 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 433")
end

			yyval87 := ast_factory.new_indexing (yyvs90.item (yyvsp90))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp87 := yyvsp87 + 1
	yyvsp90 := yyvsp90 -1
	if yyvsp87 >= yyvsc87 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs87")
		end
		yyvsc87 := yyvsc87 + yyInitial_yyvs_size
		yyvs87 := yyspecial_routines87.aliased_resized_area (yyvs87, yyvsc87)
	end
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_33
			--|#line 437 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 437 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 437")
end

			yyval87 := ast_factory.new_tagged_indexing (ast_factory.new_tag (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs90.item (yyvsp90))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp87 := yyvsp87 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp90 := yyvsp90 -1
	if yyvsp87 >= yyvsc87 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs87")
		end
		yyvsc87 := yyvsc87 + yyInitial_yyvs_size
		yyvs87 := yyspecial_routines87.aliased_resized_area (yyvs87, yyvsc87)
	end
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_34
			--|#line 443 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 443 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 443")
end

yyval87 := ast_factory.new_indexing_semicolon (yyvs87.item (yyvsp87), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp21 := yyvsp21 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_35
			--|#line 445 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 445 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 445")
end

yyval87 := ast_factory.new_indexing_semicolon (yyvs87.item (yyvsp87), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp21 := yyvsp21 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_36
			--|#line 450 "et_eiffel_parser.y"
		local
			yyval90: detachable ET_INDEXING_TERM_LIST
		do
--|#line 450 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 450")
end

			if attached yyvs88.item (yyvsp88) as l_index_value then
				yyval90 := ast_factory.new_indexing_terms (counter_value + 1)
				if yyval90 /= Void then
					yyval90.put_first (l_index_value)
				end
			else
				yyval90 := ast_factory.new_indexing_terms (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp90 := yyvsp90 + 1
	yyvsp88 := yyvsp88 -1
	if yyvsp90 >= yyvsc90 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs90")
		end
		yyvsc90 := yyvsc90 + yyInitial_yyvs_size
		yyvs90 := yyspecial_routines90.aliased_resized_area (yyvs90, yyvsc90)
	end
	yyspecial_routines90.force (yyvs90, yyval90, yyvsp90)
end
		end

	yy_do_action_37
			--|#line 461 "et_eiffel_parser.y"
		local
			yyval90: detachable ET_INDEXING_TERM_LIST
		do
--|#line 461 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 461")
end

			yyval90 := yyvs90.item (yyvsp90)
			if yyval90 /= Void and attached yyvs89.item (yyvsp89) as l_index_value then
				yyval90.put_first (l_index_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp89 := yyvsp89 -1
	yyspecial_routines90.force (yyvs90, yyval90, yyvsp90)
end
		end

	yy_do_action_38
			--|#line 470 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 470 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 470")
end

yyval88 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_39
			--|#line 472 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 472 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 472")
end

yyval88 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_40
			--|#line 474 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 474 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 474")
end

yyval88 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_41
			--|#line 476 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 476 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 476")
end

yyval88 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_42
			--|#line 478 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 478 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 478")
end

yyval88 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_43
			--|#line 480 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 480 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 480")
end

yyval88 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_44
			--|#line 482 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 482 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 482")
end

yyval88 := ast_factory.new_custom_attribute (yyvs58.item (yyvsp58), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp88 := yyvsp88 + 1
	yyvsp58 := yyvsp58 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_45
			--|#line 484 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 484 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 484")
end

yyval88 := ast_factory.new_custom_attribute (yyvs58.item (yyvsp58), yyvs105.item (yyvsp105), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp88 := yyvsp88 + 1
	yyvsp58 := yyvsp58 -1
	yyvsp105 := yyvsp105 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_46
			--|#line 488 "et_eiffel_parser.y"
		local
			yyval89: detachable ET_INDEXING_TERM_ITEM
		do
--|#line 488 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 488")
end

			yyval89 := ast_factory.new_indexing_term_comma (yyvs88.item (yyvsp88), yyvs5.item (yyvsp5))
			if yyval89 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp89 := yyvsp89 + 1
	yyvsp88 := yyvsp88 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp89 >= yyvsc89 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs89")
		end
		yyvsc89 := yyvsc89 + yyInitial_yyvs_size
		yyvs89 := yyspecial_routines89.aliased_resized_area (yyvs89, yyvsc89)
	end
	yyspecial_routines89.force (yyvs89, yyval89, yyvsp89)
end
		end

	yy_do_action_47
			--|#line 499 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 499 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 499")
end

			yyval44 := new_class (yyvs12.item (yyvsp12))
			if yyval44 /= Void then
				if attached yyvs2.item (yyvsp2) as l_class_keyword then
					yyval44.set_class_keyword (l_class_keyword)
				end
				yyval44.set_frozen_keyword (yyvs2.item (yyvsp2 - 2))
				yyval44.set_external_keyword (yyvs2.item (yyvsp2 - 1))
			end
			last_class := yyval44
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp44 := yyvsp44 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp12 := yyvsp12 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_48
			--|#line 511 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 511 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 511")
end

			yyval44 := new_class (yyvs12.item (yyvsp12))
			if yyval44 /= Void then
				if attached yyvs2.item (yyvsp2) as l_class_keyword then
					yyval44.set_class_keyword (l_class_keyword)
				end
				yyval44.set_class_mark (yyvs2.item (yyvsp2 - 2))
				yyval44.set_frozen_keyword (yyvs2.item (yyvsp2 - 3))
				yyval44.set_external_keyword (yyvs2.item (yyvsp2 - 1))
			end
			last_class := yyval44
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp44 := yyvsp44 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp12 := yyvsp12 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_49
			--|#line 524 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 524 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 524")
end

			yyval44 := new_class (yyvs12.item (yyvsp12))
			if yyval44 /= Void then
				if attached yyvs2.item (yyvsp2) as l_class_keyword then
					yyval44.set_class_keyword (l_class_keyword)
				end
				yyval44.set_class_mark (yyvs2.item (yyvsp2 - 2))
				yyval44.set_frozen_keyword (yyvs2.item (yyvsp2 - 3))
				yyval44.set_external_keyword (yyvs2.item (yyvsp2 - 1))
			end
			last_class := yyval44
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp44 := yyvsp44 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp12 := yyvsp12 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_50
			--|#line 537 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 537 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 537")
end

			yyval44 := new_class (yyvs12.item (yyvsp12))
			if yyval44 /= Void then
				if attached yyvs2.item (yyvsp2) as l_class_keyword then
					yyval44.set_class_keyword (l_class_keyword)
				end
				yyval44.set_class_mark (yyvs2.item (yyvsp2 - 2))
				yyval44.set_frozen_keyword (yyvs2.item (yyvsp2 - 3))
				yyval44.set_external_keyword (yyvs2.item (yyvsp2 - 1))
			end
			last_class := yyval44
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp44 := yyvsp44 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp12 := yyvsp12 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_51
			--|#line 552 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 552 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 552")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_52
			--|#line 554 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 554 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 554")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_53
			--|#line 558 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 558 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 558")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_54
			--|#line 560 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 560 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 560")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_55
			--|#line 566 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 566 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 566")
end

			set_formal_parameters (Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp83 := yyvsp83 + 1
	if yyvsp83 >= yyvsc83 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs83")
		end
		yyvsc83 := yyvsc83 + yyInitial_yyvs_size
		yyvs83 := yyspecial_routines83.aliased_resized_area (yyvs83, yyvsc83)
	end
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_56
			--|#line 570 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 570 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 570")
end

			yyval83 := ast_factory.new_formal_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0)
			set_formal_parameters (yyval83)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp83 := yyvsp83 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp83 >= yyvsc83 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs83")
		end
		yyvsc83 := yyvsc83 + yyInitial_yyvs_size
		yyvs83 := yyspecial_routines83.aliased_resized_area (yyvs83, yyvsc83)
	end
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_57
			--|#line 576 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 576 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 576")
end

			yyval83 := yyvs83.item (yyvsp83)
			set_formal_parameters (yyval83)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp83 := yyvsp83 -1
	yyvsp22 := yyvsp22 -1
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_58
			--|#line 576 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 576 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 576")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp83 := yyvsp83 + 1
	if yyvsp83 >= yyvsc83 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs83")
		end
		yyvsc83 := yyvsc83 + yyInitial_yyvs_size
		yyvs83 := yyspecial_routines83.aliased_resized_area (yyvs83, yyvsc83)
	end
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_59
			--|#line 590 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 590 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 590")
end

			if attached yyvs81.item (yyvsp81) as l_formal_parameter then
				yyval83 := ast_factory.new_formal_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval83 /= Void then
					yyval83.put_first (l_formal_parameter)
				end
			else
				yyval83 := ast_factory.new_formal_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp83 := yyvsp83 + 1
	yyvsp81 := yyvsp81 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp83 >= yyvsc83 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs83")
		end
		yyvsc83 := yyvsc83 + yyInitial_yyvs_size
		yyvs83 := yyspecial_routines83.aliased_resized_area (yyvs83, yyvsc83)
	end
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_60
			--|#line 601 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 601 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 601")
end

			yyval83 := yyvs83.item (yyvsp83)
			if yyval83 /= Void and attached yyvs82.item (yyvsp82) as l_formal_parameter then
				yyval83.put_first (l_formal_parameter)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp82 := yyvsp82 -1
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_61
			--|#line 610 "et_eiffel_parser.y"
		local
			yyval82: detachable ET_FORMAL_PARAMETER_ITEM
		do
--|#line 610 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 610")
end

			yyval82 := ast_factory.new_formal_parameter_comma (yyvs81.item (yyvsp81), yyvs5.item (yyvsp5))
			if yyval82 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp82 := yyvsp82 + 1
	yyvsp81 := yyvsp81 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp82 >= yyvsc82 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs82")
		end
		yyvsc82 := yyvsc82 + yyInitial_yyvs_size
		yyvs82 := yyspecial_routines82.aliased_resized_area (yyvs82, yyvsc82)
	end
	yyspecial_routines82.force (yyvs82, yyval82, yyvsp82)
end
		end

	yy_do_action_62
			--|#line 619 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 619 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 619")
end

yyval81 := ast_factory.new_formal_parameter (Void, yyvs12.item (yyvsp12), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp81 := yyvsp81 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_63
			--|#line 621 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 621 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 621")
end

yyval81 := ast_factory.new_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_64
			--|#line 623 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 623 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 623")
end

yyval81 := ast_factory.new_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_65
			--|#line 625 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 625 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 625")
end

yyval81 := ast_factory.new_constrained_formal_parameter (Void, yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs124.item (yyvsp124), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp81 := yyvsp81 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp124 := yyvsp124 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_66
			--|#line 627 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 627 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 627")
end

yyval81 := ast_factory.new_constrained_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs124.item (yyvsp124), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp124 := yyvsp124 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_67
			--|#line 629 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 629 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 629")
end

yyval81 := ast_factory.new_constrained_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs124.item (yyvsp124), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp124 := yyvsp124 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_68
			--|#line 631 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 631 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 631")
end

yyval81 := ast_factory.new_constrained_formal_parameter (Void, yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs126.item (yyvsp126), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp81 := yyvsp81 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp126 := yyvsp126 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_69
			--|#line 633 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 633 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 633")
end

yyval81 := ast_factory.new_constrained_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs126.item (yyvsp126), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp126 := yyvsp126 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_70
			--|#line 635 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 635 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 635")
end

yyval81 := ast_factory.new_constrained_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs126.item (yyvsp126), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp126 := yyvsp126 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_71
			--|#line 639 "et_eiffel_parser.y"
		local
			yyval124: detachable ET_TYPE_CONSTRAINT
		do
--|#line 639 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 639")
end

			yyval124 := dummy_constraint (yyvs54.item (yyvsp54))
			if yyval124 /= Void then
				register_constraint (yyvs54.item (yyvsp54))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp124 := yyvsp124 + 1
	yyvsp54 := yyvsp54 -1
	if yyvsp124 >= yyvsc124 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs124")
		end
		yyvsc124 := yyvsc124 + yyInitial_yyvs_size
		yyvs124 := yyspecial_routines124.aliased_resized_area (yyvs124, yyvsc124)
	end
	yyspecial_routines124.force (yyvs124, yyval124, yyvsp124)
end
		end

	yy_do_action_72
			--|#line 646 "et_eiffel_parser.y"
		local
			yyval124: detachable ET_TYPE_CONSTRAINT
		do
--|#line 646 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 646")
end

			yyval124 := ast_factory.new_type_rename_constraint (dummy_constraint (yyvs54.item (yyvsp54)), yyvs53.item (yyvsp53))
			if yyval124 /= Void then
				register_constraint (yyvs54.item (yyvsp54))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp124 := yyvsp124 + 1
	yyvsp54 := yyvsp54 -1
	yyvsp53 := yyvsp53 -1
	if yyvsp124 >= yyvsc124 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs124")
		end
		yyvsc124 := yyvsc124 + yyInitial_yyvs_size
		yyvs124 := yyspecial_routines124.aliased_resized_area (yyvs124, yyvsc124)
	end
	yyspecial_routines124.force (yyvs124, yyval124, yyvsp124)
end
		end

	yy_do_action_73
			--|#line 655 "et_eiffel_parser.y"
		local
			yyval126: detachable ET_TYPE_CONSTRAINT_LIST
		do
--|#line 655 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 655")
end

			yyval126 := yyvs126.item (yyvsp126)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp126 := yyvsp126 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines126.force (yyvs126, yyval126, yyvsp126)
end
		end

	yy_do_action_74
			--|#line 655 "et_eiffel_parser.y"
		local
			yyval126: detachable ET_TYPE_CONSTRAINT_LIST
		do
--|#line 655 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 655")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp126 := yyvsp126 + 1
	if yyvsp126 >= yyvsc126 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs126")
		end
		yyvsc126 := yyvsc126 + yyInitial_yyvs_size
		yyvs126 := yyspecial_routines126.aliased_resized_area (yyvs126, yyvsc126)
	end
	yyspecial_routines126.force (yyvs126, yyval126, yyvsp126)
end
		end

	yy_do_action_75
			--|#line 668 "et_eiffel_parser.y"
		local
			yyval126: detachable ET_TYPE_CONSTRAINT_LIST
		do
--|#line 668 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 668")
end

			if attached yyvs124.item (yyvsp124) as l_type_constraint then
				yyval126 := ast_factory.new_type_constraint_list (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval126 /= Void then
					yyval126.put_first (l_type_constraint)
				end
			else
				yyval126 := ast_factory.new_type_constraint_list (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp126 := yyvsp126 + 1
	yyvsp124 := yyvsp124 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp126 >= yyvsc126 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs126")
		end
		yyvsc126 := yyvsc126 + yyInitial_yyvs_size
		yyvs126 := yyspecial_routines126.aliased_resized_area (yyvs126, yyvsc126)
	end
	yyspecial_routines126.force (yyvs126, yyval126, yyvsp126)
end
		end

	yy_do_action_76
			--|#line 679 "et_eiffel_parser.y"
		local
			yyval126: detachable ET_TYPE_CONSTRAINT_LIST
		do
--|#line 679 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 679")
end

			yyval126 := yyvs126.item (yyvsp126)
			if yyval126 /= Void and attached yyvs125.item (yyvsp125) as l_type_constraint then
				yyval126.put_first (l_type_constraint)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp125 := yyvsp125 -1
	yyspecial_routines126.force (yyvs126, yyval126, yyvsp126)
end
		end

	yy_do_action_77
			--|#line 688 "et_eiffel_parser.y"
		local
			yyval125: detachable ET_TYPE_CONSTRAINT_ITEM
		do
--|#line 688 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 688")
end

			yyval125 := ast_factory.new_type_constraint_comma (yyvs124.item (yyvsp124), yyvs5.item (yyvsp5))
			if yyval125 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp125 := yyvsp125 + 1
	yyvsp124 := yyvsp124 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp125 >= yyvsc125 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs125")
		end
		yyvsc125 := yyvsc125 + yyInitial_yyvs_size
		yyvs125 := yyspecial_routines125.aliased_resized_area (yyvs125, yyvsc125)
	end
	yyspecial_routines125.force (yyvs125, yyval125, yyvsp125)
end
		end

	yy_do_action_78
			--|#line 697 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 697 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 697")
end

yyval53 := ast_factory.new_constraint_renames (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp53 := yyvsp53 + 1
	yyvsp2 := yyvsp2 -2
	if yyvsp53 >= yyvsc53 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs53")
		end
		yyvsc53 := yyvsc53 + yyInitial_yyvs_size
		yyvs53 := yyspecial_routines53.aliased_resized_area (yyvs53, yyvsc53)
	end
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_79
			--|#line 699 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 699 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 699")
end

			yyval53 := yyvs53.item (yyvsp53)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp53 := yyvsp53 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_80
			--|#line 699 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 699 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 699")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp53 := yyvsp53 + 1
	if yyvsp53 >= yyvsc53 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs53")
		end
		yyvsc53 := yyvsc53 + yyInitial_yyvs_size
		yyvs53 := yyspecial_routines53.aliased_resized_area (yyvs53, yyvsc53)
	end
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_81
			--|#line 712 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 712 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 712")
end

			if attached yyvs118.item (yyvsp118) as l_rename then
				yyval53 := ast_factory.new_constraint_renames (last_keyword, yyvs2.item (yyvsp2), counter_value + 1)
				if yyval53 /= Void then
					yyval53.put_first (l_rename)
				end
			else
				yyval53 := ast_factory.new_constraint_renames (last_keyword, yyvs2.item (yyvsp2), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp53 := yyvsp53 + 1
	yyvsp118 := yyvsp118 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp53 >= yyvsc53 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs53")
		end
		yyvsc53 := yyvsc53 + yyInitial_yyvs_size
		yyvs53 := yyspecial_routines53.aliased_resized_area (yyvs53, yyvsc53)
	end
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_82
			--|#line 723 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 723 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 723")
end

			yyval53 := ast_factory.new_constraint_renames (last_keyword, yyvs2.item (yyvsp2), counter_value)
			if yyval53 /= Void and attached yyvs118.item (yyvsp118) as l_rename then
				yyval53.put_first (l_rename)
			end
				-- TODO: syntax error.
			raise_error
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp53 := yyvsp53 + 1
	yyvsp118 := yyvsp118 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp53 >= yyvsc53 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs53")
		end
		yyvsc53 := yyvsc53 + yyInitial_yyvs_size
		yyvs53 := yyspecial_routines53.aliased_resized_area (yyvs53, yyvsc53)
	end
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_83
			--|#line 732 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 732 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 732")
end

			yyval53 := yyvs53.item (yyvsp53)
			if yyval53 /= Void and attached yyvs118.item (yyvsp118) as l_rename then
				yyval53.put_first (l_rename)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp118 := yyvsp118 -1
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_84
			--|#line 741 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 741 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 741")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp52 := yyvsp52 + 1
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_85
			--|#line 743 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 743 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 743")
end

yyval52 := yyvs52.item (yyvsp52) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_86
			--|#line 747 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 747 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 747")
end

yyval52 := ast_factory.new_constraint_creator (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp52 := yyvsp52 + 1
	yyvsp2 := yyvsp2 -2
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_87
			--|#line 749 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 749 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 749")
end

			yyval52 := yyvs52.item (yyvsp52)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp52 := yyvsp52 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_88
			--|#line 749 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 749 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 749")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp52 := yyvsp52 + 1
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_89
			--|#line 762 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 762 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 762")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval52 := ast_factory.new_constraint_creator (last_keyword, yyvs2.item (yyvsp2), counter_value + 1)
				if yyval52 /= Void then
					yyval52.put_first (l_identifier)
				end
			else
				yyval52 := ast_factory.new_constraint_creator (last_keyword, yyvs2.item (yyvsp2), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp52 := yyvsp52 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_90
			--|#line 774 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 774 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 774")
end

			yyval52 := ast_factory.new_constraint_creator (last_keyword, yyvs2.item (yyvsp2), counter_value)
			if yyval52 /= Void and attached yyvs77.item (yyvsp77) as l_creation_procedure then
				yyval52.put_first (l_creation_procedure)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp52 := yyvsp52 + 1
	yyvsp77 := yyvsp77 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_91
			--|#line 782 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 782 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 782")
end

			yyval52 := yyvs52.item (yyvsp52)
			if yyval52 /= Void and attached yyvs77.item (yyvsp77) as l_creation_procedure then
				yyval52.put_first (l_creation_procedure)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_92
			--|#line 791 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 791 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 791")
end

yyval54 := new_constraint_named_type (Void, yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp54 := yyvsp54 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_93
			--|#line 793 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 793 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 793")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_94
			--|#line 795 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 795 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 795")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_95
			--|#line 797 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 797 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 797")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_96
			--|#line 799 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 799 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 799")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_97
			--|#line 801 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 801 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 801")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_98
			--|#line 803 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 803 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 803")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_99
			--|#line 805 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 805 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 805")
end

yyval54 := new_constraint_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_100
			--|#line 807 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 807 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 807")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_101
			--|#line 809 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 809 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 809")
end

yyval54 := new_constraint_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_102
			--|#line 811 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 811 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 811")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_103
			--|#line 813 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 813 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 813")
end

yyval54 := yyvs97.item (yyvsp97) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp54 := yyvsp54 + 1
	yyvsp97 := yyvsp97 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_104
			--|#line 815 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 815 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 815")
end

yyval54 := new_constraint_named_type (Void, yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp54 := yyvsp54 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_105
			--|#line 817 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 817 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 817")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_106
			--|#line 819 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 819 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 819")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_107
			--|#line 821 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 821 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 821")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_108
			--|#line 823 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 823 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 823")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_109
			--|#line 825 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 825 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 825")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_110
			--|#line 827 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 827 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 827")
end

yyval54 := new_constraint_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_111
			--|#line 829 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 829 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 829")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_112
			--|#line 831 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 831 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 831")
end

yyval54 := new_constraint_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_113
			--|#line 833 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 833 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 833")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_114
			--|#line 837 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 837 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 837")
end

yyval54 := new_constraint_named_type (Void, yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp54 := yyvsp54 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_115
			--|#line 839 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 839 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 839")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_116
			--|#line 841 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 841 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 841")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_117
			--|#line 843 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 843 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 843")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_118
			--|#line 845 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 845 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 845")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_119
			--|#line 847 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 847 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 847")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_120
			--|#line 849 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 849 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 849")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_121
			--|#line 851 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 851 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 851")
end

yyval54 := new_constraint_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_122
			--|#line 853 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 853 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 853")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_123
			--|#line 855 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 855 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 855")
end

yyval54 := new_constraint_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_124
			--|#line 857 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 857 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 857")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_125
			--|#line 859 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 859 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 859")
end

yyval54 := yyvs97.item (yyvsp97) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp54 := yyvsp54 + 1
	yyvsp97 := yyvsp97 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_126
			--|#line 861 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 861 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 861")
end

yyval54 := new_constraint_named_type (Void, yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp54 := yyvsp54 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_127
			--|#line 863 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 863 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 863")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_128
			--|#line 865 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 865 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 865")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_129
			--|#line 867 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 867 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 867")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_130
			--|#line 869 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 869 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 869")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_131
			--|#line 871 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 871 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 871")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_132
			--|#line 873 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 873 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 873")
end

yyval54 := new_constraint_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_133
			--|#line 875 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 875 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 875")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_134
			--|#line 877 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 877 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 877")
end

yyval54 := new_constraint_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_135
			--|#line 879 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 879 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 879")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_136
			--|#line 883 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 883 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 883")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp51 := yyvsp51 + 1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_137
			--|#line 885 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 885 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 885")
end

yyval51 := yyvs51.item (yyvsp51) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_138
			--|#line 889 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 889 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 889")
end

yyval51 := ast_factory.new_constraint_actual_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp51 := yyvsp51 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_139
			--|#line 892 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 892 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 892")
end

			yyval51 := yyvs51.item (yyvsp51)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_140
			--|#line 900 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 900 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 900")
end

			if attached yyvs54.item (yyvsp54) as l_constraint_type then
				yyval51 := ast_factory.new_constraint_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval51 /= Void then
					yyval51.put_first (l_constraint_type)
				end
			else
				yyval51 := ast_factory.new_constraint_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp51 := yyvsp51 + 1
	yyvsp54 := yyvsp54 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_141
			--|#line 911 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 911 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 911")
end

			yyval51 := yyvs51.item (yyvsp51)
			add_to_constraint_actual_parameter_list (yyvs50.item (yyvsp50), yyval51)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_142
			--|#line 916 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 916 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 916")
end

			yyval51 := yyvs51.item (yyvsp51)
			add_to_constraint_actual_parameter_list (ast_factory.new_constraint_actual_parameter_comma (new_constraint_named_type (Void, yyvs12.item (yyvsp12), Void), yyvs5.item (yyvsp5)), yyval51)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_143
			--|#line 923 "et_eiffel_parser.y"
		local
			yyval50: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM
		do
--|#line 923 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 923")
end

			yyval50 := ast_factory.new_constraint_actual_parameter_comma (yyvs54.item (yyvsp54), yyvs5.item (yyvsp5))
			if yyval50 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 + 1
	yyvsp54 := yyvsp54 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp50 >= yyvsc50 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs50")
		end
		yyvsc50 := yyvsc50 + yyInitial_yyvs_size
		yyvs50 := yyspecial_routines50.aliased_resized_area (yyvs50, yyvsc50)
	end
	yyspecial_routines50.force (yyvs50, yyval50, yyvsp50)
end
		end

	yy_do_action_144
			--|#line 932 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 932 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 932")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp51 := yyvsp51 + 1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_145
			--|#line 934 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 934 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 934")
end

yyval51 := yyvs51.item (yyvsp51) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_146
			--|#line 938 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 938 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 938")
end

yyval51 := ast_factory.new_constraint_actual_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp51 := yyvsp51 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_147
			--|#line 941 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 941 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 941")
end

			yyval51 := yyvs51.item (yyvsp51)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_148
			--|#line 947 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 947 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 947")
end

			yyval51 := yyvs51.item (yyvsp51)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_149
			--|#line 955 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 955 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 955")
end

			yyval51 := ast_factory.new_constraint_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
			add_to_constraint_actual_parameter_list (ast_factory.new_constraint_labeled_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs54.item (yyvsp54)), yyval51)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp51 := yyvsp51 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -2
	yyvsp54 := yyvsp54 -1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_150
			--|#line 960 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 960 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 960")
end

			yyval51 := yyvs51.item (yyvsp51)
			add_to_constraint_actual_parameter_list (yyvs50.item (yyvsp50), yyvs51.item (yyvsp51))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_151
			--|#line 965 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 965 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 965")
end

			yyval51 := yyvs51.item (yyvsp51)
			add_to_constraint_actual_parameter_list (yyvs50.item (yyvsp50), yyvs51.item (yyvsp51))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_152
			--|#line 970 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 970 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 970")
end

			yyval51 := yyvs51.item (yyvsp51)
			if yyval51 /= Void then
				if not yyval51.is_empty then
					add_to_constraint_actual_parameter_list (ast_factory.new_constraint_labeled_comma_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyval51.first.type), yyval51)
				else
					add_to_constraint_actual_parameter_list (ast_factory.new_constraint_labeled_comma_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), Void), yyval51)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_153
			--|#line 983 "et_eiffel_parser.y"
		local
			yyval50: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM
		do
--|#line 983 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 983")
end

			yyval50 := ast_factory.new_constraint_labeled_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs54.item (yyvsp54))
			if yyval50 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp50 := yyvsp50 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp54 := yyvsp54 -1
	if yyvsp50 >= yyvsc50 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs50")
		end
		yyvsc50 := yyvsc50 + yyInitial_yyvs_size
		yyvs50 := yyspecial_routines50.aliased_resized_area (yyvs50, yyvsc50)
	end
	yyspecial_routines50.force (yyvs50, yyval50, yyvsp50)
end
		end

	yy_do_action_154
			--|#line 992 "et_eiffel_parser.y"
		local
			yyval50: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM
		do
--|#line 992 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 992")
end

			yyval50 := ast_factory.new_constraint_labeled_actual_parameter_semicolon (ast_factory.new_constraint_labeled_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs54.item (yyvsp54)), yyvs21.item (yyvsp21))
			if yyval50 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp50 := yyvsp50 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp54 := yyvsp54 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp50 >= yyvsc50 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs50")
		end
		yyvsc50 := yyvsc50 + yyInitial_yyvs_size
		yyvs50 := yyspecial_routines50.aliased_resized_area (yyvs50, yyvsc50)
	end
	yyspecial_routines50.force (yyvs50, yyval50, yyvsp50)
end
		end

	yy_do_action_155
			--|#line 1003 "et_eiffel_parser.y"
		local
			yyval106: detachable ET_OBSOLETE
		do
--|#line 1003 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1003")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp106 := yyvsp106 + 1
	if yyvsp106 >= yyvsc106 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs106")
		end
		yyvsc106 := yyvsc106 + yyInitial_yyvs_size
		yyvs106 := yyspecial_routines106.aliased_resized_area (yyvs106, yyvsc106)
	end
	yyspecial_routines106.force (yyvs106, yyval106, yyvsp106)
end
		end

	yy_do_action_156
			--|#line 1005 "et_eiffel_parser.y"
		local
			yyval106: detachable ET_OBSOLETE
		do
--|#line 1005 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1005")
end

yyval106 := ast_factory.new_obsolete_message (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp106 := yyvsp106 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp106 >= yyvsc106 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs106")
		end
		yyvsc106 := yyvsc106 + yyInitial_yyvs_size
		yyvs106 := yyspecial_routines106.aliased_resized_area (yyvs106, yyvsc106)
	end
	yyspecial_routines106.force (yyvs106, yyval106, yyvsp106)
end
		end

	yy_do_action_157
			--|#line 1011 "et_eiffel_parser.y"
		local
			yyval109: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1011 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1011")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp109 := yyvsp109 + 1
	if yyvsp109 >= yyvsc109 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs109")
		end
		yyvsc109 := yyvsc109 + yyInitial_yyvs_size
		yyvs109 := yyspecial_routines109.aliased_resized_area (yyvs109, yyvsc109)
	end
	yyspecial_routines109.force (yyvs109, yyval109, yyvsp109)
end
		end

	yy_do_action_158
			--|#line 1013 "et_eiffel_parser.y"
		local
			yyval109: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1013 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1013")
end

			yyval109 := yyvs109.item (yyvsp109)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines109.force (yyvs109, yyval109, yyvsp109)
end
		end

	yy_do_action_159
			--|#line 1020 "et_eiffel_parser.y"
		local
			yyval109: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1020 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1020")
end

			if attached yyvs111.item (yyvsp111) as l_inheritance_clause then
				yyval109 := ast_factory.new_parent_clauses (counter_value + 1)
				if yyval109 /= Void then
					yyval109.put_first (l_inheritance_clause)
				end
			else
				yyval109 := ast_factory.new_parent_clauses (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp109 := yyvsp109 + 1
	yyvsp111 := yyvsp111 -1
	if yyvsp109 >= yyvsc109 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs109")
		end
		yyvsc109 := yyvsc109 + yyInitial_yyvs_size
		yyvs109 := yyspecial_routines109.aliased_resized_area (yyvs109, yyvsc109)
	end
	yyspecial_routines109.force (yyvs109, yyval109, yyvsp109)
end
		end

	yy_do_action_160
			--|#line 1031 "et_eiffel_parser.y"
		local
			yyval109: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1031 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1031")
end

			yyval109 := yyvs109.item (yyvsp109)
			if yyval109 /= Void and attached yyvs111.item (yyvsp111) as l_inheritance_clause then
				yyval109.put_first (l_inheritance_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp109 := yyvsp109 -1
	yyvsp111 := yyvsp111 -1
	yyspecial_routines109.force (yyvs109, yyval109, yyvsp109)
end
		end

	yy_do_action_161
			--|#line 1031 "et_eiffel_parser.y"
		local
			yyval109: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1031 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1031")
end

			if yyvs111.item (yyvsp111) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp109 := yyvsp109 + 1
	if yyvsp109 >= yyvsc109 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs109")
		end
		yyvsc109 := yyvsc109 + yyInitial_yyvs_size
		yyvs109 := yyspecial_routines109.aliased_resized_area (yyvs109, yyvsc109)
	end
	yyspecial_routines109.force (yyvs109, yyval109, yyvsp109)
end
		end

	yy_do_action_162
			--|#line 1046 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_PARENT_LIST
		do
--|#line 1046 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1046")
end

			yyval111 := ast_factory.new_parents (yyvs2.item (yyvsp2), 0)
			if yyval111 /= Void then
				yyval111.set_clients_clause (yyvs46.item (yyvsp46))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp111 := yyvsp111 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_163
			--|#line 1053 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_PARENT_LIST
		do
--|#line 1053 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1053")
end

			yyval111 := yyvs111.item (yyvsp111)
			if yyval111 /= Void then
				yyval111.set_clients_clause (yyvs46.item (yyvsp46))
			end
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp111 := yyvsp111 -1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_164
			--|#line 1053 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_PARENT_LIST
		do
--|#line 1053 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1053")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp111 := yyvsp111 + 1
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_165
			--|#line 1069 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT
		do
--|#line 1069 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1069")
end

			yyval108 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, Void, Void, Void, Void, Void)
			if yyval108 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp108 := yyvsp108 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_166
			--|#line 1076 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT
		do
--|#line 1076 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1076")
end

			yyval108 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), yyvs119.item (yyvsp119), yyvs68.item (yyvsp68), yyvs96.item (yyvsp96 - 2), yyvs96.item (yyvsp96 - 1), yyvs96.item (yyvsp96), yyvs2.item (yyvsp2))
			if yyval108 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp108 := yyvsp108 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp119 := yyvsp119 -1
	yyvsp68 := yyvsp68 -1
	yyvsp96 := yyvsp96 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_167
			--|#line 1084 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT
		do
--|#line 1084 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1084")
end

			yyval108 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, yyvs68.item (yyvsp68), yyvs96.item (yyvsp96 - 2), yyvs96.item (yyvsp96 - 1), yyvs96.item (yyvsp96), yyvs2.item (yyvsp2))
			if yyval108 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp108 := yyvsp108 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp68 := yyvsp68 -1
	yyvsp96 := yyvsp96 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_168
			--|#line 1091 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT
		do
--|#line 1091 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1091")
end

			yyval108 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, Void, yyvs96.item (yyvsp96 - 2), yyvs96.item (yyvsp96 - 1), yyvs96.item (yyvsp96), yyvs2.item (yyvsp2))
			if yyval108 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp108 := yyvsp108 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp96 := yyvsp96 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_169
			--|#line 1098 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT
		do
--|#line 1098 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1098")
end

			yyval108 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, Void, Void, yyvs96.item (yyvsp96 - 1), yyvs96.item (yyvsp96), yyvs2.item (yyvsp2))
			if yyval108 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp108 := yyvsp108 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp96 := yyvsp96 -2
	yyvsp2 := yyvsp2 -1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_170
			--|#line 1105 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT
		do
--|#line 1105 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1105")
end

			yyval108 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, Void, Void, Void, yyvs96.item (yyvsp96), yyvs2.item (yyvsp2))
			if yyval108 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp108 := yyvsp108 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp96 := yyvsp96 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_171
			--|#line 1114 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_PARENT_LIST
		do
--|#line 1114 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1114")
end

			yyval111 := ast_factory.new_parents (last_keyword, counter_value)
			if yyval111 /= Void and attached yyvs108.item (yyvsp108) as l_parent then
				yyval111.put_first (l_parent)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp111 := yyvsp111 + 1
	yyvsp108 := yyvsp108 -1
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_172
			--|#line 1121 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_PARENT_LIST
		do
--|#line 1121 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1121")
end

			yyval111 := ast_factory.new_parents (last_keyword, counter_value)
			if yyval111 /= Void and attached yyvs110.item (yyvsp110) as l_parent then
				yyval111.put_first (l_parent)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp111 := yyvsp111 + 1
	yyvsp110 := yyvsp110 -1
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_173
			--|#line 1128 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_PARENT_LIST
		do
--|#line 1128 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1128")
end

			yyval111 := yyvs111.item (yyvsp111)
			if yyval111 /= Void and attached yyvs108.item (yyvsp108) as l_parent then
				yyval111.put_first (l_parent)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp108 := yyvsp108 -1
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_174
			--|#line 1135 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_PARENT_LIST
		do
--|#line 1135 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1135")
end

			yyval111 := yyvs111.item (yyvsp111)
			if yyval111 /= Void and attached yyvs110.item (yyvsp110) as l_parent then
				yyval111.put_first (l_parent)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp110 := yyvsp110 -1
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_175
			--|#line 1144 "et_eiffel_parser.y"
		local
			yyval110: detachable ET_PARENT_ITEM
		do
--|#line 1144 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1144")
end

			yyval110 := ast_factory.new_parent_semicolon (yyvs108.item (yyvsp108), yyvs21.item (yyvsp21))
			if yyval110 /= Void and yyvs108.item (yyvsp108) = Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp110 := yyvsp110 + 1
	yyvsp108 := yyvsp108 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp110 >= yyvsc110 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs110")
		end
		yyvsc110 := yyvsc110 + yyInitial_yyvs_size
		yyvs110 := yyspecial_routines110.aliased_resized_area (yyvs110, yyvsc110)
	end
	yyspecial_routines110.force (yyvs110, yyval110, yyvsp110)
end
		end

	yy_do_action_176
			--|#line 1155 "et_eiffel_parser.y"
		local
			yyval119: detachable ET_RENAME_LIST
		do
--|#line 1155 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1155")
end

yyval119 := ast_factory.new_renames (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp119 := yyvsp119 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp119 >= yyvsc119 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs119")
		end
		yyvsc119 := yyvsc119 + yyInitial_yyvs_size
		yyvs119 := yyspecial_routines119.aliased_resized_area (yyvs119, yyvsc119)
	end
	yyspecial_routines119.force (yyvs119, yyval119, yyvsp119)
end
		end

	yy_do_action_177
			--|#line 1157 "et_eiffel_parser.y"
		local
			yyval119: detachable ET_RENAME_LIST
		do
--|#line 1157 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1157")
end

			yyval119 := yyvs119.item (yyvsp119)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp119 := yyvsp119 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines119.force (yyvs119, yyval119, yyvsp119)
end
		end

	yy_do_action_178
			--|#line 1157 "et_eiffel_parser.y"
		local
			yyval119: detachable ET_RENAME_LIST
		do
--|#line 1157 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1157")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp119 := yyvsp119 + 1
	if yyvsp119 >= yyvsc119 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs119")
		end
		yyvsc119 := yyvsc119 + yyInitial_yyvs_size
		yyvs119 := yyspecial_routines119.aliased_resized_area (yyvs119, yyvsc119)
	end
	yyspecial_routines119.force (yyvs119, yyval119, yyvsp119)
end
		end

	yy_do_action_179
			--|#line 1170 "et_eiffel_parser.y"
		local
			yyval119: detachable ET_RENAME_LIST
		do
--|#line 1170 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1170")
end

			yyval119 := ast_factory.new_renames (last_keyword, counter_value)
			if yyval119 /= Void and attached yyvs118.item (yyvsp118) as l_rename then
				yyval119.put_first (l_rename)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp119 := yyvsp119 + 1
	yyvsp118 := yyvsp118 -1
	if yyvsp119 >= yyvsc119 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs119")
		end
		yyvsc119 := yyvsc119 + yyInitial_yyvs_size
		yyvs119 := yyspecial_routines119.aliased_resized_area (yyvs119, yyvsc119)
	end
	yyspecial_routines119.force (yyvs119, yyval119, yyvsp119)
end
		end

	yy_do_action_180
			--|#line 1177 "et_eiffel_parser.y"
		local
			yyval119: detachable ET_RENAME_LIST
		do
--|#line 1177 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1177")
end

			yyval119 := ast_factory.new_renames (last_keyword, counter_value)
			if yyval119 /= Void and attached yyvs118.item (yyvsp118) as l_rename then
				yyval119.put_first (l_rename)
			end
				-- TODO: syntax error.
			raise_error
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp119 := yyvsp119 + 1
	yyvsp118 := yyvsp118 -1
	if yyvsp119 >= yyvsc119 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs119")
		end
		yyvsc119 := yyvsc119 + yyInitial_yyvs_size
		yyvs119 := yyspecial_routines119.aliased_resized_area (yyvs119, yyvsc119)
	end
	yyspecial_routines119.force (yyvs119, yyval119, yyvsp119)
end
		end

	yy_do_action_181
			--|#line 1186 "et_eiffel_parser.y"
		local
			yyval119: detachable ET_RENAME_LIST
		do
--|#line 1186 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1186")
end

			yyval119 := yyvs119.item (yyvsp119)
			if yyval119 /= Void and attached yyvs118.item (yyvsp118) as l_rename then
				yyval119.put_first (l_rename)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp118 := yyvsp118 -1
	yyspecial_routines119.force (yyvs119, yyval119, yyvsp119)
end
		end

	yy_do_action_182
			--|#line 1195 "et_eiffel_parser.y"
		local
			yyval118: detachable ET_RENAME_ITEM
		do
--|#line 1195 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1195")
end

			yyval118 := ast_factory.new_rename (yyvs76.item (yyvsp76), yyvs2.item (yyvsp2), yyvs71.item (yyvsp71))
			if yyval118 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp118 := yyvsp118 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	if yyvsp118 >= yyvsc118 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs118")
		end
		yyvsc118 := yyvsc118 + yyInitial_yyvs_size
		yyvs118 := yyspecial_routines118.aliased_resized_area (yyvs118, yyvsc118)
	end
	yyspecial_routines118.force (yyvs118, yyval118, yyvsp118)
end
		end

	yy_do_action_183
			--|#line 1204 "et_eiffel_parser.y"
		local
			yyval118: detachable ET_RENAME_ITEM
		do
--|#line 1204 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1204")
end

			yyval118 := ast_factory.new_rename_comma (yyvs76.item (yyvsp76), yyvs2.item (yyvsp2), yyvs71.item (yyvsp71), yyvs5.item (yyvsp5))
			if yyval118 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp118 := yyvsp118 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp118 >= yyvsc118 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs118")
		end
		yyvsc118 := yyvsc118 + yyInitial_yyvs_size
		yyvs118 := yyspecial_routines118.aliased_resized_area (yyvs118, yyvsc118)
	end
	yyspecial_routines118.force (yyvs118, yyval118, yyvsp118)
end
		end

	yy_do_action_184
			--|#line 1215 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1215 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1215")
end

yyval68 := ast_factory.new_exports (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp68 := yyvsp68 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_185
			--|#line 1217 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1217 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1217")
end

			yyval68 := yyvs68.item (yyvsp68)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp68 := yyvsp68 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_186
			--|#line 1217 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1217 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1217")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp68 := yyvsp68 + 1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_187
			--|#line 1230 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1230 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1230")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp68 := yyvsp68 + 1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_188
			--|#line 1232 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1232 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1232")
end

yyval68 := yyvs68.item (yyvsp68) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_189
			--|#line 1236 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1236 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1236")
end

			if attached yyvs67.item (yyvsp67) as l_new_export then
				yyval68 := ast_factory.new_exports (last_keyword, counter_value + 1)
				if yyval68 /= Void then
					yyval68.put_first (l_new_export)
				end
			else
				yyval68 := ast_factory.new_exports (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp68 := yyvsp68 + 1
	yyvsp67 := yyvsp67 -1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_190
			--|#line 1247 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1247 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1247")
end

			yyval68 := yyvs68.item (yyvsp68)
			if yyval68 /= Void and attached yyvs67.item (yyvsp67) as l_new_export then
				yyval68.put_first (l_new_export)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp68 := yyvsp68 -1
	yyvsp67 := yyvsp67 -1
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_191
			--|#line 1247 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1247 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1247")
end

			if yyvs67.item (yyvsp67) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp68 := yyvsp68 + 1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_192
			--|#line 1262 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1262 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1262")
end

			yyval67 := ast_factory.new_all_export (yyvs46.item (yyvsp46), yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp67 := yyvsp67 + 1
	yyvsp46 := yyvsp46 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp67 >= yyvsc67 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs67")
		end
		yyvsc67 := yyvsc67 + yyInitial_yyvs_size
		yyvs67 := yyspecial_routines67.aliased_resized_area (yyvs67, yyvsc67)
	end
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_193
			--|#line 1266 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1266 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1266")
end

			last_export_clients := yyvs46.item (yyvsp46)
			yyval67 := ast_factory.new_feature_export (last_export_clients, 0)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp67 := yyvsp67 + 1
	yyvsp46 := yyvsp46 -1
	if yyvsp67 >= yyvsc67 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs67")
		end
		yyvsc67 := yyvsc67 + yyInitial_yyvs_size
		yyvs67 := yyspecial_routines67.aliased_resized_area (yyvs67, yyvsc67)
	end
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_194
			--|#line 1271 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1271 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1271")
end

			yyval67 := yyvs75.item (yyvsp75)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp46 := yyvsp46 -1
	yyvsp75 := yyvsp75 -1
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_195
			--|#line 1271 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1271 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1271")
end

			last_export_clients := yyvs46.item (yyvsp46)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp67 := yyvsp67 + 1
	if yyvsp67 >= yyvsc67 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs67")
		end
		yyvsc67 := yyvsc67 + yyInitial_yyvs_size
		yyvs67 := yyspecial_routines67.aliased_resized_area (yyvs67, yyvsc67)
	end
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_196
			--|#line 1281 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1281 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1281")
end

yyval67 := ast_factory.new_null_export (yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp67 := yyvsp67 + 1
	yyvsp21 := yyvsp21 -1
	if yyvsp67 >= yyvsc67 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs67")
		end
		yyvsc67 := yyvsc67 + yyInitial_yyvs_size
		yyvs67 := yyspecial_routines67.aliased_resized_area (yyvs67, yyvsc67)
	end
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_197
			--|#line 1285 "et_eiffel_parser.y"
		local
			yyval75: detachable ET_FEATURE_EXPORT
		do
--|#line 1285 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1285")
end

			if attached yyvs76.item (yyvsp76) as l_feature_name then
				yyval75 := ast_factory.new_feature_export (last_export_clients, counter_value + 1)
				if yyval75 /= Void then
					yyval75.put_first (l_feature_name)
				end
			else
				yyval75 := ast_factory.new_feature_export (last_export_clients, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp75 := yyvsp75 + 1
	yyvsp76 := yyvsp76 -1
	if yyvsp75 >= yyvsc75 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs75")
		end
		yyvsc75 := yyvsc75 + yyInitial_yyvs_size
		yyvs75 := yyspecial_routines75.aliased_resized_area (yyvs75, yyvsc75)
	end
	yyspecial_routines75.force (yyvs75, yyval75, yyvsp75)
end
		end

	yy_do_action_198
			--|#line 1296 "et_eiffel_parser.y"
		local
			yyval75: detachable ET_FEATURE_EXPORT
		do
--|#line 1296 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1296")
end

			yyval75 := ast_factory.new_feature_export (last_export_clients, counter_value)
			if yyval75 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval75.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp75 := yyvsp75 + 1
	yyvsp77 := yyvsp77 -1
	if yyvsp75 >= yyvsc75 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs75")
		end
		yyvsc75 := yyvsc75 + yyInitial_yyvs_size
		yyvs75 := yyspecial_routines75.aliased_resized_area (yyvs75, yyvsc75)
	end
	yyspecial_routines75.force (yyvs75, yyval75, yyvsp75)
end
		end

	yy_do_action_199
			--|#line 1304 "et_eiffel_parser.y"
		local
			yyval75: detachable ET_FEATURE_EXPORT
		do
--|#line 1304 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1304")
end

			yyval75 := yyvs75.item (yyvsp75)
			if yyval75 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval75.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines75.force (yyvs75, yyval75, yyvsp75)
end
		end

	yy_do_action_200
			--|#line 1315 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1315 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1315")
end

			yyval46 := yyvs46.item (yyvsp46)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp46 := yyvsp46 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_201
			--|#line 1315 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1315 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1315")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp46 := yyvsp46 + 1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_202
			--|#line 1326 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1326 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1326")
end

yyval46 := ast_factory.new_none_clients (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp46 := yyvsp46 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_203
			--|#line 1330 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1330 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1330")
end

			yyval46 := ast_factory.new_clients (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval46 /= Void and attached yyvs45.item (yyvsp45) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp46 := yyvsp46 + 1
	yyvsp45 := yyvsp45 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_204
			--|#line 1337 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1337 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1337")
end

			yyval46 := ast_factory.new_clients (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval46 /= Void and attached yyvs45.item (yyvsp45) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp46 := yyvsp46 + 1
	yyvsp45 := yyvsp45 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_205
			--|#line 1345 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1345 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1345")
end

			yyval46 := yyvs46.item (yyvsp46)
			if yyval46 /= Void and attached yyvs45.item (yyvsp45) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp45 := yyvsp45 -1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_206
			--|#line 1352 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1352 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1352")
end

			yyval46 := yyvs46.item (yyvsp46)
			if yyval46 /= Void and attached yyvs45.item (yyvsp45) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp45 := yyvsp45 -1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_207
			--|#line 1362 "et_eiffel_parser.y"
		local
			yyval45: detachable ET_CLIENT_ITEM
		do
--|#line 1362 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1362")
end

			yyval45 := new_client (yyvs12.item (yyvsp12))
			if yyval45 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp45 := yyvsp45 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp45 >= yyvsc45 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs45")
		end
		yyvsc45 := yyvsc45 + yyInitial_yyvs_size
		yyvs45 := yyspecial_routines45.aliased_resized_area (yyvs45, yyvsc45)
	end
	yyspecial_routines45.force (yyvs45, yyval45, yyvsp45)
end
		end

	yy_do_action_208
			--|#line 1371 "et_eiffel_parser.y"
		local
			yyval45: detachable ET_CLIENT_ITEM
		do
--|#line 1371 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1371")
end

			yyval45 := new_client_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5))
			if yyval45 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp45 := yyvsp45 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp45 >= yyvsc45 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs45")
		end
		yyvsc45 := yyvsc45 + yyInitial_yyvs_size
		yyvs45 := yyspecial_routines45.aliased_resized_area (yyvs45, yyvsc45)
	end
	yyspecial_routines45.force (yyvs45, yyval45, yyvsp45)
end
		end

	yy_do_action_209
			--|#line 1381 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1381 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1381")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp46 := yyvsp46 + 1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_210
			--|#line 1383 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1383 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1383")
end

yyval46 := yyvs46.item (yyvsp46) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_211
			--|#line 1387 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1387 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1387")
end

			yyval46 := ast_factory.new_clients (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 1)
			if yyval46 /= Void and attached new_client (yyvs12.item (yyvsp12)) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp46 := yyvsp46 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_212
			--|#line 1398 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1398 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1398")
end

yyval96 := ast_factory.new_keyword_feature_name_list (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_213
			--|#line 1400 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1400 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1400")
end

			yyval96 := yyvs96.item (yyvsp96)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_214
			--|#line 1400 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1400 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1400")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp96 := yyvsp96 + 1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_215
			--|#line 1413 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1413 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1413")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp96 := yyvsp96 + 1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_216
			--|#line 1415 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1415 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1415")
end

yyval96 := yyvs96.item (yyvsp96) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_217
			--|#line 1419 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1419 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1419")
end

yyval96 := ast_factory.new_keyword_feature_name_list (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_218
			--|#line 1421 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1421 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1421")
end

			yyval96 := yyvs96.item (yyvsp96)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_219
			--|#line 1421 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1421 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1421")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp96 := yyvsp96 + 1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_220
			--|#line 1434 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1434 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1434")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp96 := yyvsp96 + 1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_221
			--|#line 1436 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1436 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1436")
end

yyval96 := yyvs96.item (yyvsp96) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_222
			--|#line 1440 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1440 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1440")
end

yyval96 := ast_factory.new_keyword_feature_name_list (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_223
			--|#line 1442 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1442 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1442")
end

			yyval96 := yyvs96.item (yyvsp96)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_224
			--|#line 1442 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1442 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1442")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp96 := yyvsp96 + 1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_225
			--|#line 1455 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1455 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1455")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp96 := yyvsp96 + 1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_226
			--|#line 1457 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1457 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1457")
end

yyval96 := yyvs96.item (yyvsp96) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_227
			--|#line 1461 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1461 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1461")
end

			if attached yyvs76.item (yyvsp76) as l_feature_name then
				yyval96 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value + 1)
				if yyval96 /= Void then
					yyval96.put_first (l_feature_name)
				end
			else
				yyval96 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp96 := yyvsp96 + 1
	yyvsp76 := yyvsp76 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_228
			--|#line 1472 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1472 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1472")
end

			yyval96 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value)
			if yyval96 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval96.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp96 := yyvsp96 + 1
	yyvsp77 := yyvsp77 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_229
			--|#line 1480 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1480 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1480")
end

			yyval96 := yyvs96.item (yyvsp96)
			if yyval96 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval96.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_230
			--|#line 1489 "et_eiffel_parser.y"
		local
			yyval77: detachable ET_FEATURE_NAME_ITEM
		do
--|#line 1489 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1489")
end

			yyval77 := ast_factory.new_feature_name_comma (yyvs76.item (yyvsp76), yyvs5.item (yyvsp5))
			if yyval77 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp77 >= yyvsc77 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs77")
		end
		yyvsc77 := yyvsc77 + yyInitial_yyvs_size
		yyvs77 := yyspecial_routines77.aliased_resized_area (yyvs77, yyvsc77)
	end
	yyspecial_routines77.force (yyvs77, yyval77, yyvsp77)
end
		end

	yy_do_action_231
			--|#line 1500 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1500 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1500")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp61 := yyvsp61 + 1
	if yyvsp61 >= yyvsc61 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs61")
		end
		yyvsc61 := yyvsc61 + yyInitial_yyvs_size
		yyvs61 := yyspecial_routines61.aliased_resized_area (yyvs61, yyvsc61)
	end
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_232
			--|#line 1502 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1502 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1502")
end

			yyval61 := yyvs61.item (yyvsp61)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_233
			--|#line 1509 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1509 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1509")
end

			if attached yyvs60.item (yyvsp60) as l_creation_clause then
				yyval61 := ast_factory.new_creators (counter_value + 1)
				if yyval61 /= Void then
					yyval61.put_first (l_creation_clause)
				end
			else
				yyval61 := ast_factory.new_creators (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp61 := yyvsp61 + 1
	yyvsp60 := yyvsp60 -1
	if yyvsp61 >= yyvsc61 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs61")
		end
		yyvsc61 := yyvsc61 + yyInitial_yyvs_size
		yyvs61 := yyspecial_routines61.aliased_resized_area (yyvs61, yyvsc61)
	end
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_234
			--|#line 1520 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1520 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1520")
end

			yyval61 := yyvs61.item (yyvsp61)
			if yyval61 /= Void and attached yyvs60.item (yyvsp60) as l_creation_clause then
				yyval61.put_first (l_creation_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp61 := yyvsp61 -1
	yyvsp60 := yyvsp60 -1
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_235
			--|#line 1520 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1520 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1520")
end

			if yyvs60.item (yyvsp60) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp61 := yyvsp61 + 1
	if yyvsp61 >= yyvsc61 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs61")
		end
		yyvsc61 := yyvsc61 + yyInitial_yyvs_size
		yyvs61 := yyspecial_routines61.aliased_resized_area (yyvs61, yyvsc61)
	end
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_236
			--|#line 1535 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1535 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1535")
end

yyval60 := ast_factory.new_creator (yyvs2.item (yyvsp2), yyvs46.item (yyvsp46), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp60 := yyvsp60 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_237
			--|#line 1537 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1537 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1537")
end

yyval60 := ast_factory.new_creator (yyvs2.item (yyvsp2), new_any_clients (yyvs2.item (yyvsp2)), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp60 := yyvsp60 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_238
			--|#line 1539 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1539 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1539")
end

			yyval60 := yyvs60.item (yyvsp60)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp60 := yyvsp60 -1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_239
			--|#line 1539 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1539 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1539")
end

			add_keyword (yyvs2.item (yyvsp2))
			last_clients := yyvs46.item (yyvsp46)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp60 := yyvsp60 + 1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_240
			--|#line 1551 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1551 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1551")
end

			yyval60 := yyvs60.item (yyvsp60)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp60 := yyvsp60 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_241
			--|#line 1551 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1551 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1551")
end

			add_keyword (yyvs2.item (yyvsp2))
			last_clients := new_any_clients (last_keyword)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp60 := yyvsp60 + 1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_242
			--|#line 1563 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1563 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1563")
end

yyval60 := ast_factory.new_creator (yyvs2.item (yyvsp2), yyvs46.item (yyvsp46), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp60 := yyvsp60 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_243
			--|#line 1565 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1565 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1565")
end

yyval60 := ast_factory.new_creator (yyvs2.item (yyvsp2), new_any_clients (yyvs2.item (yyvsp2)), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp60 := yyvsp60 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_244
			--|#line 1567 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1567 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1567")
end

			yyval60 := yyvs60.item (yyvsp60)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp60 := yyvsp60 -1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_245
			--|#line 1567 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1567 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1567")
end

			add_keyword (yyvs2.item (yyvsp2))
			last_clients := yyvs46.item (yyvsp46)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp60 := yyvsp60 + 1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_246
			--|#line 1579 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1579 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1579")
end

			yyval60 := yyvs60.item (yyvsp60)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp60 := yyvsp60 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_247
			--|#line 1579 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1579 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1579")
end

			add_keyword (yyvs2.item (yyvsp2))
			last_clients := new_any_clients (last_keyword)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp60 := yyvsp60 + 1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_248
			--|#line 1593 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1593 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1593")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval60 := ast_factory.new_creator (last_keyword, last_clients, counter_value + 1)
				if yyval60 /= Void then
					yyval60.put_first (l_identifier)
				end
			else
				yyval60 := ast_factory.new_creator (last_keyword, last_clients, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp60 := yyvsp60 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_249
			--|#line 1605 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1605 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1605")
end

			if system_processor.is_ise then
				raise_error
			else
				yyval60 := ast_factory.new_creator (last_keyword, last_clients, counter_value)
				if yyval60 /= Void and attached yyvs77.item (yyvsp77) as l_creation_procedure then
					yyval60.put_first (l_creation_procedure)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp60 := yyvsp60 + 1
	yyvsp77 := yyvsp77 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_250
			--|#line 1617 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1617 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1617")
end

			yyval60 := yyvs60.item (yyvsp60)
			if yyval60 /= Void and attached yyvs77.item (yyvsp77) as l_creation_procedure then
				yyval60.put_first (l_creation_procedure)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_251
			--|#line 1626 "et_eiffel_parser.y"
		local
			yyval77: detachable ET_FEATURE_NAME_ITEM
		do
--|#line 1626 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1626")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval77 := ast_factory.new_feature_name_comma (l_identifier, yyvs5.item (yyvsp5))
			else
				yyval77 := ast_factory.new_feature_name_comma (Void, yyvs5.item (yyvsp5))
			end
			if yyval77 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp77 >= yyvsc77 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs77")
		end
		yyvsc77 := yyvsc77 + yyInitial_yyvs_size
		yyvs77 := yyspecial_routines77.aliased_resized_area (yyvs77, yyvsc77)
	end
	yyspecial_routines77.force (yyvs77, yyval77, yyvsp77)
end
		end

	yy_do_action_252
			--|#line 1642 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1642 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1642")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp57 := yyvsp57 + 1
	if yyvsp57 >= yyvsc57 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs57")
		end
		yyvsc57 := yyvsc57 + yyInitial_yyvs_size
		yyvs57 := yyspecial_routines57.aliased_resized_area (yyvs57, yyvsc57)
	end
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_253
			--|#line 1644 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1644 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1644")
end

yyval57 := yyvs57.item (yyvsp57) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_254
			--|#line 1648 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1648 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1648")
end

			yyval57 := yyvs57.item (yyvsp57)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp57 := yyvsp57 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_255
			--|#line 1648 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1648 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1648")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp57 := yyvsp57 + 1
	if yyvsp57 >= yyvsc57 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs57")
		end
		yyvsc57 := yyvsc57 + yyInitial_yyvs_size
		yyvs57 := yyspecial_routines57.aliased_resized_area (yyvs57, yyvsc57)
	end
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_256
			--|#line 1661 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1661 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1661")
end

			yyval57 := ast_factory.new_convert_features (last_keyword, counter_value + 1)
			if yyval57 /= Void and attached yyvs55.item (yyvsp55) as l_convert_feature then
				yyval57.put_first (l_convert_feature)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp57 := yyvsp57 + 1
	yyvsp55 := yyvsp55 -1
	if yyvsp57 >= yyvsc57 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs57")
		end
		yyvsc57 := yyvsc57 + yyInitial_yyvs_size
		yyvs57 := yyspecial_routines57.aliased_resized_area (yyvs57, yyvsc57)
	end
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_257
			--|#line 1668 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1668 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1668")
end

			yyval57 := ast_factory.new_convert_features (last_keyword, counter_value)
			if yyval57 /= Void and attached yyvs56.item (yyvsp56) as l_convert_feature then
				yyval57.put_first (l_convert_feature)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp57 := yyvsp57 + 1
	yyvsp56 := yyvsp56 -1
	if yyvsp57 >= yyvsc57 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs57")
		end
		yyvsc57 := yyvsc57 + yyInitial_yyvs_size
		yyvs57 := yyspecial_routines57.aliased_resized_area (yyvs57, yyvsc57)
	end
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_258
			--|#line 1675 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1675 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1675")
end

			yyval57 := yyvs57.item (yyvsp57)
			if yyval57 /= Void and attached yyvs56.item (yyvsp56) as l_convert_feature then
				yyval57.put_first (l_convert_feature)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp56 := yyvsp56 -1
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_259
			--|#line 1684 "et_eiffel_parser.y"
		local
			yyval56: detachable ET_CONVERT_FEATURE_ITEM
		do
--|#line 1684 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1684")
end

			yyval56 := ast_factory.new_convert_feature_comma (yyvs55.item (yyvsp55), yyvs5.item (yyvsp5))
			if yyval56 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp56 := yyvsp56 + 1
	yyvsp55 := yyvsp55 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp56 >= yyvsc56 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs56")
		end
		yyvsc56 := yyvsc56 + yyInitial_yyvs_size
		yyvs56 := yyspecial_routines56.aliased_resized_area (yyvs56, yyvsc56)
	end
	yyspecial_routines56.force (yyvs56, yyval56, yyvsp56)
end
		end

	yy_do_action_260
			--|#line 1693 "et_eiffel_parser.y"
		local
			yyval55: detachable ET_CONVERT_FEATURE
		do
--|#line 1693 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1693")
end

			yyval55 := ast_factory.new_convert_function (yyvs76.item (yyvsp76), yyvs5.item (yyvsp5), yyvs128.item (yyvsp128))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp55 := yyvsp55 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp5 := yyvsp5 -1
	yyvsp128 := yyvsp128 -1
	if yyvsp55 >= yyvsc55 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs55")
		end
		yyvsc55 := yyvsc55 + yyInitial_yyvs_size
		yyvs55 := yyspecial_routines55.aliased_resized_area (yyvs55, yyvsc55)
	end
	yyspecial_routines55.force (yyvs55, yyval55, yyvsp55)
end
		end

	yy_do_action_261
			--|#line 1697 "et_eiffel_parser.y"
		local
			yyval55: detachable ET_CONVERT_FEATURE
		do
--|#line 1697 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1697")
end

			yyval55 := ast_factory.new_convert_procedure (yyvs76.item (yyvsp76), yyvs5.item (yyvsp5 - 1), yyvs128.item (yyvsp128), yyvs5.item (yyvsp5))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp55 := yyvsp55 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp5 := yyvsp5 -2
	yyvsp128 := yyvsp128 -1
	if yyvsp55 >= yyvsc55 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs55")
		end
		yyvsc55 := yyvsc55 + yyInitial_yyvs_size
		yyvs55 := yyspecial_routines55.aliased_resized_area (yyvs55, yyvsc55)
	end
	yyspecial_routines55.force (yyvs55, yyval55, yyvsp55)
end
		end

	yy_do_action_262
			--|#line 1703 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_TYPE_LIST
		do
--|#line 1703 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1703")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp128 := yyvsp128 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp128 >= yyvsc128 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs128")
		end
		yyvsc128 := yyvsc128 + yyInitial_yyvs_size
		yyvs128 := yyspecial_routines128.aliased_resized_area (yyvs128, yyvsc128)
	end
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_263
			--|#line 1705 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_TYPE_LIST
		do
--|#line 1705 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1705")
end

			yyval128 := yyvs128.item (yyvsp128)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp128 := yyvsp128 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_264
			--|#line 1705 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_TYPE_LIST
		do
--|#line 1705 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1705")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp128 := yyvsp128 + 1
	if yyvsp128 >= yyvsc128 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs128")
		end
		yyvsc128 := yyvsc128 + yyInitial_yyvs_size
		yyvs128 := yyspecial_routines128.aliased_resized_area (yyvs128, yyvsc128)
	end
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_265
			--|#line 1718 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_TYPE_LIST
		do
--|#line 1718 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1718")
end

			if attached yyvs123.item (yyvsp123) as l_convert_type then
				yyval128 := ast_factory.new_convert_types (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval128 /= Void then
					yyval128.put_first (l_convert_type)
				end
			else
				yyval128 := ast_factory.new_convert_types (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp128 := yyvsp128 + 1
	yyvsp123 := yyvsp123 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp128 >= yyvsc128 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs128")
		end
		yyvsc128 := yyvsc128 + yyInitial_yyvs_size
		yyvs128 := yyspecial_routines128.aliased_resized_area (yyvs128, yyvsc128)
	end
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_266
			--|#line 1729 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_TYPE_LIST
		do
--|#line 1729 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1729")
end

			yyval128 := yyvs128.item (yyvsp128)
			if yyval128 /= Void and attached yyvs127.item (yyvsp127) as l_convert_type then
				yyval128.put_first (l_convert_type)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp127 := yyvsp127 -1
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_267
			--|#line 1738 "et_eiffel_parser.y"
		local
			yyval127: detachable ET_TYPE_ITEM
		do
--|#line 1738 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1738")
end

			yyval127 := ast_factory.new_type_comma (yyvs123.item (yyvsp123), yyvs5.item (yyvsp5))
			if yyval127 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp127 := yyvsp127 + 1
	yyvsp123 := yyvsp123 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp127 >= yyvsc127 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs127")
		end
		yyvsc127 := yyvsc127 + yyInitial_yyvs_size
		yyvs127 := yyspecial_routines127.aliased_resized_area (yyvs127, yyvsc127)
	end
	yyspecial_routines127.force (yyvs127, yyval127, yyvsp127)
end
		end

	yy_do_action_268
			--|#line 1749 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1749 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1749")
end

			-- $$ := Void
			set_class_features
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp74 := yyvsp74 + 1
	if yyvsp74 >= yyvsc74 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs74")
		end
		yyvsc74 := yyvsc74 + yyInitial_yyvs_size
		yyvs74 := yyspecial_routines74.aliased_resized_area (yyvs74, yyvsc74)
	end
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_269
			--|#line 1754 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1754 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1754")
end

yyval74 := yyvs74.item (yyvsp74) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_270
			--|#line 1758 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1758 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1758")
end

			yyval74 := yyvs74.item (yyvsp74)
			set_class_features
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_271
			--|#line 1766 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1766 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1766")
end

			yyval74 := ast_factory.new_feature_clauses (counter_value)
			if yyval74 /= Void and attached yyvs73.item (yyvsp73) as l_feature_clause then
				yyval74.put_first (l_feature_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp74 := yyvsp74 + 1
	yyvsp73 := yyvsp73 -1
	if yyvsp74 >= yyvsc74 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs74")
		end
		yyvsc74 := yyvsc74 + yyInitial_yyvs_size
		yyvs74 := yyspecial_routines74.aliased_resized_area (yyvs74, yyvsc74)
	end
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_272
			--|#line 1773 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1773 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1773")
end

			yyval74 := yyvs74.item (yyvsp74)
			if yyval74 /= Void and attached yyvs73.item (yyvsp73) as l_feature_clause then
				yyval74.put_first (l_feature_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp73 := yyvsp73 -1
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_273
			--|#line 1782 "et_eiffel_parser.y"
		local
			yyval73: detachable ET_FEATURE_CLAUSE
		do
--|#line 1782 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1782")
end

			yyval73 := last_feature_clause
			if yyval73 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines73.force (yyvs73, yyval73, yyvsp73)
end
		end

	yy_do_action_274
			--|#line 1789 "et_eiffel_parser.y"
		local
			yyval73: detachable ET_FEATURE_CLAUSE
		do
--|#line 1789 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1789")
end

			yyval73 := last_feature_clause
			if yyval73 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines73.force (yyvs73, yyval73, yyvsp73)
end
		end

	yy_do_action_275
			--|#line 1798 "et_eiffel_parser.y"
		local
			yyval73: detachable ET_FEATURE_CLAUSE
		do
--|#line 1798 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1798")
end

			last_clients := yyvs46.item (yyvsp46)
			last_feature_clause := ast_factory.new_feature_clause (yyvs2.item (yyvsp2), last_clients)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp73 := yyvsp73 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	if yyvsp73 >= yyvsc73 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs73")
		end
		yyvsc73 := yyvsc73 + yyInitial_yyvs_size
		yyvs73 := yyspecial_routines73.aliased_resized_area (yyvs73, yyvsc73)
	end
	yyspecial_routines73.force (yyvs73, yyval73, yyvsp73)
end
		end

	yy_do_action_276
			--|#line 1803 "et_eiffel_parser.y"
		local
			yyval73: detachable ET_FEATURE_CLAUSE
		do
--|#line 1803 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1803")
end

			last_clients := new_any_clients (yyvs2.item (yyvsp2))
			last_feature_clause := ast_factory.new_feature_clause (yyvs2.item (yyvsp2), last_clients)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp73 := yyvsp73 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp73 >= yyvsc73 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs73")
		end
		yyvsc73 := yyvsc73 + yyInitial_yyvs_size
		yyvs73 := yyspecial_routines73.aliased_resized_area (yyvs73, yyvsc73)
	end
	yyspecial_routines73.force (yyvs73, yyval73, yyvsp73)
end
		end

	yy_do_action_277
			--|#line 1810 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 1810 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1810")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp117 := yyvsp117 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_278
			--|#line 1811 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 1811 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1811")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp114 := yyvsp114 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_279
			--|#line 1812 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 1812 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1812")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp117 := yyvsp117 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_280
			--|#line 1813 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 1813 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1813")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp114 := yyvsp114 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_281
			--|#line 1818 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1818 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1818")
end

			yyval117 := yyvs117.item (yyvsp117)
			register_query (yyval117)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_282
			--|#line 1823 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1823 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1823")
end

			yyval117 := yyvs117.item (yyvsp117)
			if yyval117 /= Void then
				yyval117.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_query (yyval117)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_283
			--|#line 1831 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1831 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1831")
end

			yyval117 := new_query_synonym (ast_factory.new_extended_feature_name_comma (yyvs71.item (yyvsp71), yyvs5.item (yyvsp5)), yyvs117.item (yyvsp117))
			register_query_synonym (yyval117)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_284
			--|#line 1836 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1836 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1836")
end

			yyval117 := new_query_synonym (yyvs71.item (yyvsp71), yyvs117.item (yyvsp117))
			register_query_synonym (yyval117)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp71 := yyvsp71 -1
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_285
			--|#line 1842 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1842 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1842")
end

			yyval117 := new_query_synonym (ast_factory.new_extended_feature_name_comma (yyvs71.item (yyvsp71), yyvs5.item (yyvsp5)), yyvs117.item (yyvsp117))
			if yyval117 /= Void then
				yyval117.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_query_synonym (yyval117)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_286
			--|#line 1850 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1850 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1850")
end

			yyval117 := new_query_synonym (yyvs71.item (yyvsp71), yyvs117.item (yyvsp117))
			if yyval117 /= Void then
				yyval117.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_query_synonym (yyval117)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_287
			--|#line 1861 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 1861 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1861")
end

			yyval114 := yyvs114.item (yyvsp114)
			register_procedure (yyval114)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_288
			--|#line 1866 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 1866 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1866")
end

			yyval114 := yyvs114.item (yyvsp114)
			if yyval114 /= Void then
				yyval114.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_procedure (yyval114)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_289
			--|#line 1874 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 1874 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1874")
end

			yyval114 := new_procedure_synonym (ast_factory.new_extended_feature_name_comma (yyvs71.item (yyvsp71), yyvs5.item (yyvsp5)), yyvs114.item (yyvsp114))
			register_procedure_synonym (yyval114)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_290
			--|#line 1879 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 1879 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1879")
end

			yyval114 := new_procedure_synonym (yyvs71.item (yyvsp71), yyvs114.item (yyvsp114))
			register_procedure_synonym (yyval114)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp71 := yyvsp71 -1
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_291
			--|#line 1885 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 1885 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1885")
end

			yyval114 := new_procedure_synonym (ast_factory.new_extended_feature_name_comma (yyvs71.item (yyvsp71), yyvs5.item (yyvsp5)), yyvs114.item (yyvsp114))
			if yyval114 /= Void then
				yyval114.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_procedure_synonym (yyval114)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_292
			--|#line 1893 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 1893 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1893")
end

			yyval114 := new_procedure_synonym (yyvs71.item (yyvsp71), yyvs114.item (yyvsp114))
			if yyval114 /= Void then
				yyval114.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_procedure_synonym (yyval114)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_293
			--|#line 1904 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1904 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1904")
end

yyval117 := ast_factory.new_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_294
			--|#line 1906 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1906 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1906")
end

yyval117 := ast_factory.new_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_295
			--|#line 1908 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1908 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1908")
end

			yyval117 := ast_factory.new_extended_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_296
			--|#line 1912 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1912 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1912")
end

yyval117 := ast_factory.new_constant_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2), yyvs49.item (yyvsp49), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -1
	yyvsp49 := yyvsp49 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_297
			--|#line 1914 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1914 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1914")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := ast_factory.new_constant_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs5.item (yyvsp5), yyvs49.item (yyvsp49), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp49 := yyvsp49 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_298
			--|#line 1922 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1922 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1922")
end

yyval117 := ast_factory.new_unique_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -2
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_299
			--|#line 1924 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1924 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1924")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := ast_factory.new_unique_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs5.item (yyvsp5), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_300
			--|#line 1932 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1932 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1932")
end

yyval117 := ast_factory.new_do_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 1), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -2
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_301
			--|#line 1935 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1935 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1935")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := ast_factory.new_do_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_302
			--|#line 1944 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1944 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1944")
end

yyval117 := ast_factory.new_do_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 1), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 15
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -2
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_303
			--|#line 1948 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1948 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1948")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := ast_factory.new_do_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_304
			--|#line 1958 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1958 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1958")
end

yyval117 := ast_factory.new_once_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 16
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_305
			--|#line 1961 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1961 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1961")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := ast_factory.new_once_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 15
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -2
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_306
			--|#line 1970 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1970 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1970")
end

yyval117 := ast_factory.new_once_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 17
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_307
			--|#line 1974 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1974 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1974")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := ast_factory.new_once_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 16
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -2
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_308
			--|#line 1984 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1984 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1984")
end

yyval117 := ast_factory.new_deferred_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs2.item (yyvsp2 - 1), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_309
			--|#line 1986 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1986 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1986")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := ast_factory.new_deferred_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs2.item (yyvsp2 - 1), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 11
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp2 := yyvsp2 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_310
			--|#line 1994 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1994 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1994")
end

yyval117 := ast_factory.new_deferred_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs2.item (yyvsp2 - 1), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_311
			--|#line 1997 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 1997 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1997")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := ast_factory.new_deferred_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs2.item (yyvsp2 - 1), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp2 := yyvsp2 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_312
			--|#line 2006 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 2006 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2006")
end

yyval117 := new_external_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_313
			--|#line 2009 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 2009 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2009")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := new_external_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_314
			--|#line 2018 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 2018 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2018")
end

yyval117 := new_external_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 15
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_315
			--|#line 2022 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_QUERY
		do
--|#line 2022 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2022")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval117 := new_external_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp117 := yyvsp117 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_316
			--|#line 2034 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 2034 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2034")
end

yyval114 := ast_factory.new_do_procedure (yyvs71.item (yyvsp71), Void, yyvs2.item (yyvsp2 - 1), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 11
	yyvsp114 := yyvsp114 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp2 := yyvsp2 -2
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_317
			--|#line 2037 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 2037 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2037")
end

yyval114 := ast_factory.new_do_procedure (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), yyvs2.item (yyvsp2 - 1), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp114 := yyvsp114 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp2 := yyvsp2 -2
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_318
			--|#line 2041 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 2041 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2041")
end

yyval114 := ast_factory.new_once_procedure (yyvs71.item (yyvsp71), Void, yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp114 := yyvsp114 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_319
			--|#line 2044 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 2044 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2044")
end

yyval114 := ast_factory.new_once_procedure (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp114 := yyvsp114 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_320
			--|#line 2048 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 2048 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2048")
end

yyval114 := ast_factory.new_deferred_procedure (yyvs71.item (yyvsp71), Void, yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs2.item (yyvsp2 - 1), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 9
	yyvsp114 := yyvsp114 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_321
			--|#line 2050 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 2050 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2050")
end

yyval114 := ast_factory.new_deferred_procedure (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), yyvs2.item (yyvsp2 - 1), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp114 := yyvsp114 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_322
			--|#line 2053 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 2053 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2053")
end

yyval114 := new_external_procedure (yyvs71.item (yyvsp71), Void, yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 11
	yyvsp114 := yyvsp114 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_323
			--|#line 2056 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_PROCEDURE
		do
--|#line 2056 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2056")
end

yyval114 := new_external_procedure (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs106.item (yyvsp106), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp114 := yyvsp114 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp106 := yyvsp106 -1
	yyvsp113 := yyvsp113 -1
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_324
			--|#line 2062 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 2062 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2062")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval2 := Void
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_325
			--|#line 2070 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 2070 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2070")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_326
			--|#line 2074 "et_eiffel_parser.y"
		local
			yyval21: detachable ET_SEMICOLON_SYMBOL
		do
--|#line 2074 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2074")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp21 := yyvsp21 + 1
	if yyvsp21 >= yyvsc21 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs21")
		end
		yyvsc21 := yyvsc21 + yyInitial_yyvs_size
		yyvs21 := yyspecial_routines21.aliased_resized_area (yyvs21, yyvsc21)
	end
	yyspecial_routines21.force (yyvs21, yyval21, yyvsp21)
end
		end

	yy_do_action_327
			--|#line 2076 "et_eiffel_parser.y"
		local
			yyval21: detachable ET_SEMICOLON_SYMBOL
		do
--|#line 2076 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2076")
end

yyval21 := yyvs21.item (yyvsp21) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines21.force (yyvs21, yyval21, yyvsp21)
end
		end

	yy_do_action_328
			--|#line 2080 "et_eiffel_parser.y"
		local
			yyval72: detachable ET_EXTERNAL_ALIAS
		do
--|#line 2080 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2080")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp72 := yyvsp72 + 1
	if yyvsp72 >= yyvsc72 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs72")
		end
		yyvsc72 := yyvsc72 + yyInitial_yyvs_size
		yyvs72 := yyspecial_routines72.aliased_resized_area (yyvs72, yyvsc72)
	end
	yyspecial_routines72.force (yyvs72, yyval72, yyvsp72)
end
		end

	yy_do_action_329
			--|#line 2082 "et_eiffel_parser.y"
		local
			yyval72: detachable ET_EXTERNAL_ALIAS
		do
--|#line 2082 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2082")
end

yyval72 := ast_factory.new_external_alias (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp72 := yyvsp72 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp72 >= yyvsc72 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs72")
		end
		yyvsc72 := yyvsc72 + yyInitial_yyvs_size
		yyvs72 := yyspecial_routines72.aliased_resized_area (yyvs72, yyvsc72)
	end
	yyspecial_routines72.force (yyvs72, yyval72, yyvsp72)
end
		end

	yy_do_action_330
			--|#line 2086 "et_eiffel_parser.y"
		local
			yyval35: detachable ET_ASSIGNER
		do
--|#line 2086 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2086")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp35 := yyvsp35 + 1
	if yyvsp35 >= yyvsc35 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs35")
		end
		yyvsc35 := yyvsc35 + yyInitial_yyvs_size
		yyvs35 := yyspecial_routines35.aliased_resized_area (yyvs35, yyvsc35)
	end
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
		end

	yy_do_action_331
			--|#line 2088 "et_eiffel_parser.y"
		local
			yyval35: detachable ET_ASSIGNER
		do
--|#line 2088 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2088")
end

yyval35 := ast_factory.new_assigner (yyvs2.item (yyvsp2), yyvs76.item (yyvsp76)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp35 := yyvsp35 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp76 := yyvsp76 -1
	if yyvsp35 >= yyvsc35 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs35")
		end
		yyvsc35 := yyvsc35 + yyInitial_yyvs_size
		yyvs35 := yyspecial_routines35.aliased_resized_area (yyvs35, yyvsc35)
	end
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
		end

	yy_do_action_332
			--|#line 2094 "et_eiffel_parser.y"
		local
			yyval76: detachable ET_FEATURE_NAME
		do
--|#line 2094 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2094")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval76 := l_identifier 
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp76 := yyvsp76 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp76 >= yyvsc76 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs76")
		end
		yyvsc76 := yyvsc76 + yyInitial_yyvs_size
		yyvs76 := yyspecial_routines76.aliased_resized_area (yyvs76, yyvsc76)
	end
	yyspecial_routines76.force (yyvs76, yyval76, yyvsp76)
end
		end

	yy_do_action_333
			--|#line 2103 "et_eiffel_parser.y"
		local
			yyval71: detachable ET_EXTENDED_FEATURE_NAME
		do
--|#line 2103 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2103")
end

yyval71 := yyvs76.item (yyvsp76) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp71 := yyvsp71 + 1
	yyvsp76 := yyvsp76 -1
	if yyvsp71 >= yyvsc71 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs71")
		end
		yyvsc71 := yyvsc71 + yyInitial_yyvs_size
		yyvs71 := yyspecial_routines71.aliased_resized_area (yyvs71, yyvsc71)
	end
	yyspecial_routines71.force (yyvs71, yyval71, yyvsp71)
end
		end

	yy_do_action_334
			--|#line 2105 "et_eiffel_parser.y"
		local
			yyval71: detachable ET_EXTENDED_FEATURE_NAME
		do
--|#line 2105 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2105")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval71 := ast_factory.new_aliased_feature_name (l_identifier, yyvs34.item (yyvsp34))
			else
				yyval71 := ast_factory.new_aliased_feature_name (Void, yyvs34.item (yyvsp34))
			end
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp71 := yyvsp71 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp1 := yyvsp1 -1
	yyvsp34 := yyvsp34 -1
	if yyvsp71 >= yyvsc71 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs71")
		end
		yyvsc71 := yyvsc71 + yyInitial_yyvs_size
		yyvs71 := yyspecial_routines71.aliased_resized_area (yyvs71, yyvsc71)
	end
	yyspecial_routines71.force (yyvs71, yyval71, yyvsp71)
end
		end

	yy_do_action_335
			--|#line 2117 "et_eiffel_parser.y"
		local
			yyval34: detachable ET_ALIAS_NAME_LIST
		do
--|#line 2117 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2117")
end

			if attached yyvs33.item (yyvsp33) as l_alias_name then
				yyval34 := ast_factory.new_alias_name_list (counter_value + 1)
				if yyval34 /= Void then
					yyval34.put_first (l_alias_name)
				end
			else
				yyval34 := ast_factory.new_alias_name_list (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp33 := yyvsp33 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
		end

	yy_do_action_336
			--|#line 2128 "et_eiffel_parser.y"
		local
			yyval34: detachable ET_ALIAS_NAME_LIST
		do
--|#line 2128 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2128")
end

			yyval34 := yyvs34.item (yyvsp34)
			if yyval34 /= Void and attached yyvs33.item (yyvsp33) as l_alias_name then
				yyval34.put_first (l_alias_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp34 := yyvsp34 -1
	yyvsp33 := yyvsp33 -1
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
		end

	yy_do_action_337
			--|#line 2128 "et_eiffel_parser.y"
		local
			yyval34: detachable ET_ALIAS_NAME_LIST
		do
--|#line 2128 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2128")
end

			if yyvs33.item (yyvsp33) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp34 := yyvsp34 + 1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
		end

	yy_do_action_338
			--|#line 2143 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2143 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2143")
end

yyval33 := ast_factory.new_alias_not_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_339
			--|#line 2145 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2145 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2145")
end

yyval33 := ast_factory.new_alias_not_symbol_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_340
			--|#line 2147 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2147 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2147")
end

yyval33 := ast_factory.new_alias_plus_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_341
			--|#line 2149 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2149 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2149")
end

yyval33 := ast_factory.new_alias_minus_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_342
			--|#line 2151 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2151 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2151")
end

yyval33 := ast_factory.new_alias_times_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_343
			--|#line 2153 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2153 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2153")
end

yyval33 := ast_factory.new_alias_divide_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_344
			--|#line 2155 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2155 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2155")
end

yyval33 := ast_factory.new_alias_div_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_345
			--|#line 2157 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2157 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2157")
end

yyval33 := ast_factory.new_alias_mod_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_346
			--|#line 2159 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2159 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2159")
end

yyval33 := ast_factory.new_alias_power_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_347
			--|#line 2161 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2161 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2161")
end

yyval33 := ast_factory.new_alias_lt_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_348
			--|#line 2163 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2163 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2163")
end

yyval33 := ast_factory.new_alias_le_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_349
			--|#line 2165 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2165 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2165")
end

yyval33 := ast_factory.new_alias_gt_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_350
			--|#line 2167 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2167 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2167")
end

yyval33 := ast_factory.new_alias_ge_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_351
			--|#line 2169 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2169 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2169")
end

yyval33 := ast_factory.new_alias_and_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_352
			--|#line 2171 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2171 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2171")
end

yyval33 := ast_factory.new_alias_and_symbol_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_353
			--|#line 2173 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2173 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2173")
end

yyval33 := ast_factory.new_alias_and_then_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_354
			--|#line 2175 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2175 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2175")
end

yyval33 := ast_factory.new_alias_and_then_symbol_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_355
			--|#line 2177 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2177 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2177")
end

yyval33 := ast_factory.new_alias_or_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_356
			--|#line 2179 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2179 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2179")
end

yyval33 := ast_factory.new_alias_or_symbol_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_357
			--|#line 2181 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2181 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2181")
end

yyval33 := ast_factory.new_alias_or_else_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_358
			--|#line 2183 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2183 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2183")
end

yyval33 := ast_factory.new_alias_or_else_symbol_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_359
			--|#line 2185 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2185 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2185")
end

yyval33 := ast_factory.new_alias_implies_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_360
			--|#line 2187 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2187 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2187")
end

yyval33 := ast_factory.new_alias_implies_symbol_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_361
			--|#line 2189 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2189 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2189")
end

yyval33 := ast_factory.new_alias_xor_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_362
			--|#line 2191 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2191 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2191")
end

yyval33 := ast_factory.new_alias_xor_symbol_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_363
			--|#line 2193 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2193 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2193")
end

yyval33 := ast_factory.new_alias_dotdot_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_364
			--|#line 2195 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2195 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2195")
end

yyval33 := ast_factory.new_alias_free_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_365
			--|#line 2197 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2197 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2197")
end

yyval33 := ast_factory.new_alias_bracket_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_366
			--|#line 2199 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2199 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2199")
end

yyval33 := ast_factory.new_alias_parenthesis_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_367
			--|#line 2201 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2201 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2201")
end

yyval33 := new_invalid_alias_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_368
			--|#line 2205 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 2205 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2205")
end

yyval2 := Void 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_369
			--|#line 2207 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 2207 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2207")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_370
			--|#line 2213 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2213 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2213")
end

			yyval80 := yyvs80.item (yyvsp80)
			set_start_closure (yyval80)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_371
			--|#line 2220 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2220 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2220")
end

yyval80 := new_formal_arguments (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp80 := yyvsp80 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp80 >= yyvsc80 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs80")
		end
		yyvsc80 := yyvsc80 + yyInitial_yyvs_size
		yyvs80 := yyspecial_routines80.aliased_resized_area (yyvs80, yyvsc80)
	end
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_372
			--|#line 2222 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2222 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2222")
end

			yyval80 := yyvs80.item (yyvsp80)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_373
			--|#line 2230 "et_eiffel_parser.y"
		local
			yyval5: detachable ET_SYMBOL
		do
--|#line 2230 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2230")
end

			-- Needed to solve ambiguity when parsing:
			--   agent (a).f
			--   agent (a: A) do ... end
			yyval5 := yyvs5.item (yyvsp5)
			add_symbol (yyval5)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines5.force (yyvs5, yyval5, yyvsp5)
end
		end

	yy_do_action_374
			--|#line 2241 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2241 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2241")
end

			yyval80 := new_formal_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval80 /= Void and attached yyvs79.item (yyvsp79) as l_formal_argument then
				yyval80.put_first (l_formal_argument)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp80 := yyvsp80 + 1
	yyvsp79 := yyvsp79 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp80 >= yyvsc80 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs80")
		end
		yyvsc80 := yyvsc80 + yyInitial_yyvs_size
		yyvs80 := yyspecial_routines80.aliased_resized_area (yyvs80, yyvsc80)
	end
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_375
			--|#line 2248 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2248 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2248")
end

			yyval80 := new_formal_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval80 /= Void and attached yyvs79.item (yyvsp79) as l_formal_argument then
				yyval80.put_first (l_formal_argument)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp80 := yyvsp80 + 1
	yyvsp79 := yyvsp79 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp80 >= yyvsc80 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs80")
		end
		yyvsc80 := yyvsc80 + yyInitial_yyvs_size
		yyvs80 := yyspecial_routines80.aliased_resized_area (yyvs80, yyvsc80)
	end
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_376
			--|#line 2255 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2255 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2255")
end

			yyval80 := yyvs80.item (yyvsp80)
			if yyval80 /= Void and attached yyvs78.item (yyvsp78) as l_formal_argument then
				if not yyval80.is_empty then
					l_formal_argument.set_declared_type (yyval80.first.type)
					yyval80.put_first (l_formal_argument)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp78 := yyvsp78 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_377
			--|#line 2265 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2265 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2265")
end

			-- TODO: Syntax error
			yyval80 := yyvs80.item (yyvsp80)
			if yyval80 /= Void and attached yyvs78.item (yyvsp78) as l_formal_argument then
				if not yyval80.is_empty then
					l_formal_argument.set_declared_type (yyval80.first.type)
					yyval80.put_first (l_formal_argument)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp78 := yyvsp78 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_378
			--|#line 2276 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2276 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2276")
end

			yyval80 := yyvs80.item (yyvsp80)
			if yyval80 /= Void and attached yyvs79.item (yyvsp79) as l_formal_argument then
				yyval80.put_first (l_formal_argument)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp79 := yyvsp79 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_379
			--|#line 2283 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2283 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2283")
end

			yyval80 := yyvs80.item (yyvsp80)
			if yyval80 /= Void and attached yyvs79.item (yyvsp79) as l_formal_argument then
				yyval80.put_first (l_formal_argument)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp79 := yyvsp79 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_380
			--|#line 2292 "et_eiffel_parser.y"
		local
			yyval78: detachable ET_FORMAL_ARGUMENT
		do
--|#line 2292 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2292")
end

			yyval78 := ast_factory.new_formal_comma_argument (ast_factory.new_argument_name_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), dummy_type)
			if yyval78 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp78 := yyvsp78 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp78 >= yyvsc78 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs78")
		end
		yyvsc78 := yyvsc78 + yyInitial_yyvs_size
		yyvs78 := yyspecial_routines78.aliased_resized_area (yyvs78, yyvsc78)
	end
	yyspecial_routines78.force (yyvs78, yyval78, yyvsp78)
end
		end

	yy_do_action_381
			--|#line 2301 "et_eiffel_parser.y"
		local
			yyval78: detachable ET_FORMAL_ARGUMENT
		do
--|#line 2301 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2301")
end

			yyval78 := ast_factory.new_formal_comma_argument (yyvs12.item (yyvsp12), dummy_type)
			if yyval78 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp78 := yyvsp78 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp78 >= yyvsc78 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs78")
		end
		yyvsc78 := yyvsc78 + yyInitial_yyvs_size
		yyvs78 := yyspecial_routines78.aliased_resized_area (yyvs78, yyvsc78)
	end
	yyspecial_routines78.force (yyvs78, yyval78, yyvsp78)
end
		end

	yy_do_action_382
			--|#line 2310 "et_eiffel_parser.y"
		local
			yyval79: detachable ET_FORMAL_ARGUMENT_ITEM
		do
--|#line 2310 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2310")
end

			yyval79 := ast_factory.new_formal_argument (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)))
			if yyval79 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp79 := yyvsp79 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	if yyvsp79 >= yyvsc79 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs79")
		end
		yyvsc79 := yyvsc79 + yyInitial_yyvs_size
		yyvs79 := yyspecial_routines79.aliased_resized_area (yyvs79, yyvsc79)
	end
	yyspecial_routines79.force (yyvs79, yyval79, yyvsp79)
end
		end

	yy_do_action_383
			--|#line 2319 "et_eiffel_parser.y"
		local
			yyval79: detachable ET_FORMAL_ARGUMENT_ITEM
		do
--|#line 2319 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2319")
end

			yyval79 := ast_factory.new_formal_argument_semicolon (ast_factory.new_formal_argument (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123))), yyvs21.item (yyvsp21))
			if yyval79 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp79 := yyvsp79 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp79 >= yyvsc79 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs79")
		end
		yyvsc79 := yyvsc79 + yyInitial_yyvs_size
		yyvs79 := yyspecial_routines79.aliased_resized_area (yyvs79, yyvsc79)
	end
	yyspecial_routines79.force (yyvs79, yyval79, yyvsp79)
end
		end

	yy_do_action_384
			--|#line 2330 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2330 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2330")
end

yyval100 := Void 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp100 := yyvsp100 + 1
	if yyvsp100 >= yyvsc100 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs100")
		end
		yyvsc100 := yyvsc100 + yyInitial_yyvs_size
		yyvs100 := yyspecial_routines100.aliased_resized_area (yyvs100, yyvsc100)
	end
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_385
			--|#line 2332 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2332 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2332")
end

yyval100 := new_local_variables (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp100 := yyvsp100 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp100 >= yyvsc100 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs100")
		end
		yyvsc100 := yyvsc100 + yyInitial_yyvs_size
		yyvs100 := yyspecial_routines100.aliased_resized_area (yyvs100, yyvsc100)
	end
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_386
			--|#line 2334 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2334 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2334")
end

			yyval100 := yyvs100.item (yyvsp100)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_387
			--|#line 2334 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2334 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2334")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp100 := yyvsp100 + 1
	if yyvsp100 >= yyvsc100 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs100")
		end
		yyvsc100 := yyvsc100 + yyInitial_yyvs_size
		yyvs100 := yyspecial_routines100.aliased_resized_area (yyvs100, yyvsc100)
	end
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_388
			--|#line 2347 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2347 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2347")
end

			yyval100 := new_local_variables (last_keyword, counter_value)
			if yyval100 /= Void and attached yyvs99.item (yyvsp99) as l_local_variable then
				yyval100.put_first (l_local_variable)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp100 := yyvsp100 + 1
	yyvsp99 := yyvsp99 -1
	if yyvsp100 >= yyvsc100 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs100")
		end
		yyvsc100 := yyvsc100 + yyInitial_yyvs_size
		yyvs100 := yyspecial_routines100.aliased_resized_area (yyvs100, yyvsc100)
	end
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_389
			--|#line 2354 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2354 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2354")
end

			yyval100 := new_local_variables (last_keyword, counter_value)
			if yyval100 /= Void and attached yyvs99.item (yyvsp99) as l_local_variable then
				yyval100.put_first (l_local_variable)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp100 := yyvsp100 + 1
	yyvsp99 := yyvsp99 -1
	if yyvsp100 >= yyvsc100 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs100")
		end
		yyvsc100 := yyvsc100 + yyInitial_yyvs_size
		yyvs100 := yyspecial_routines100.aliased_resized_area (yyvs100, yyvsc100)
	end
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_390
			--|#line 2361 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2361 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2361")
end

			yyval100 := yyvs100.item (yyvsp100)
			if yyval100 /= Void and attached yyvs98.item (yyvsp98) as l_local_variable then
				if not yyval100.is_empty then
					l_local_variable.set_declared_type (yyval100.first.type)
					yyval100.put_first (l_local_variable)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp98 := yyvsp98 -1
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_391
			--|#line 2371 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2371 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2371")
end

			-- TODO: Syntax error
			yyval100 := yyvs100.item (yyvsp100)
			if yyval100 /= Void and attached yyvs98.item (yyvsp98) as l_local_variable then
				if not yyval100.is_empty then
					l_local_variable.set_declared_type (yyval100.first.type)
					yyval100.put_first (l_local_variable)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp98 := yyvsp98 -1
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_392
			--|#line 2382 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2382 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2382")
end

			yyval100 := yyvs100.item (yyvsp100)
			if yyval100 /= Void and attached yyvs99.item (yyvsp99) as l_local_variable then
				yyval100.put_first (l_local_variable)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp99 := yyvsp99 -1
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_393
			--|#line 2389 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2389 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2389")
end

			yyval100 := yyvs100.item (yyvsp100)
			if yyval100 /= Void and attached yyvs99.item (yyvsp99) as l_local_variable then
				yyval100.put_first (l_local_variable)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp99 := yyvsp99 -1
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_394
			--|#line 2398 "et_eiffel_parser.y"
		local
			yyval98: detachable ET_LOCAL_VARIABLE
		do
--|#line 2398 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2398")
end

			yyval98 := ast_factory.new_local_comma_variable (ast_factory.new_local_name_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), dummy_type)
			if yyval98 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp98 := yyvsp98 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp98 >= yyvsc98 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs98")
		end
		yyvsc98 := yyvsc98 + yyInitial_yyvs_size
		yyvs98 := yyspecial_routines98.aliased_resized_area (yyvs98, yyvsc98)
	end
	yyspecial_routines98.force (yyvs98, yyval98, yyvsp98)
end
		end

	yy_do_action_395
			--|#line 2407 "et_eiffel_parser.y"
		local
			yyval98: detachable ET_LOCAL_VARIABLE
		do
--|#line 2407 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2407")
end

			yyval98 := ast_factory.new_local_comma_variable (yyvs12.item (yyvsp12), dummy_type)
			if yyval98 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp98 := yyvsp98 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp98 >= yyvsc98 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs98")
		end
		yyvsc98 := yyvsc98 + yyInitial_yyvs_size
		yyvs98 := yyspecial_routines98.aliased_resized_area (yyvs98, yyvsc98)
	end
	yyspecial_routines98.force (yyvs98, yyval98, yyvsp98)
end
		end

	yy_do_action_396
			--|#line 2416 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_ITEM
		do
--|#line 2416 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2416")
end

			yyval99 := ast_factory.new_local_variable (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)))
			if yyval99 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp99 := yyvsp99 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	if yyvsp99 >= yyvsc99 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs99")
		end
		yyvsc99 := yyvsc99 + yyInitial_yyvs_size
		yyvs99 := yyspecial_routines99.aliased_resized_area (yyvs99, yyvsc99)
	end
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_397
			--|#line 2425 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_ITEM
		do
--|#line 2425 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2425")
end

			yyval99 := ast_factory.new_local_variable_semicolon (ast_factory.new_local_variable (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123))), yyvs21.item (yyvsp21))
			if yyval99 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp99 := yyvsp99 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp99 >= yyvsc99 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs99")
		end
		yyvsc99 := yyvsc99 + yyInitial_yyvs_size
		yyvs99 := yyspecial_routines99.aliased_resized_area (yyvs99, yyvsc99)
	end
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_398
			--|#line 2436 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2436 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2436")
end

add_expression_assertion (yyvs69.item (yyvsp69), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp69 := yyvsp69 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_399
			--|#line 2438 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2438 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2438")
end

add_expression_assertion (yyvs69.item (yyvsp69), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_400
			--|#line 2440 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2440 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2440")
end

add_tagged_assertion (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_401
			--|#line 2442 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2442 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2442")
end

add_tagged_assertion (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_402
			--|#line 2444 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2444 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2444")
end

			if assertion_kind = assertion_kind_postcondition then
					-- 'class' assertions only allowed in postconditions.
				add_class_assertion (ast_factory.new_class_assertion (yyvs2.item (yyvsp2)), Void)
			else
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_403
			--|#line 2453 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2453 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2453")
end

			if assertion_kind = assertion_kind_postcondition then
					-- 'class' assertions only allowed in postconditions.
				add_class_assertion (ast_factory.new_class_assertion (yyvs2.item (yyvsp2)), yyvs21.item (yyvsp21))
			else
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_404
			--|#line 2462 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2462 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2462")
end

add_expression_assertion (yyvs69.item (yyvsp69), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_405
			--|#line 2464 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2464 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2464")
end

add_expression_assertion (yyvs69.item (yyvsp69), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp21 := yyvsp21 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_406
			--|#line 2466 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2466 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2466")
end

add_tagged_assertion (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_407
			--|#line 2468 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2468 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2468")
end

add_tagged_assertion (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp21 := yyvsp21 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_408
			--|#line 2470 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2470 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2470")
end

			if assertion_kind = assertion_kind_postcondition then
					-- 'class' assertions only allowed in postconditions.
				add_class_assertion (ast_factory.new_class_assertion (yyvs2.item (yyvsp2)), Void)
			else
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_409
			--|#line 2479 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2479 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2479")
end

			if assertion_kind = assertion_kind_postcondition then
					-- 'class' assertions only allowed in postconditions.
				add_class_assertion (ast_factory.new_class_assertion (yyvs2.item (yyvsp2)), yyvs21.item (yyvsp21))
			else
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_410
			--|#line 2490 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2490 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2490")
end

start_precondition 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_411
			--|#line 2494 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PRECONDITIONS
		do
--|#line 2494 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2494")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp113 := yyvsp113 + 1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_412
			--|#line 2496 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PRECONDITIONS
		do
--|#line 2496 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2496")
end

yyval113 := new_preconditions (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp113 := yyvsp113 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_413
			--|#line 2498 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PRECONDITIONS
		do
--|#line 2498 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2498")
end

yyval113 := new_preconditions (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp113 := yyvsp113 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_414
			--|#line 2500 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PRECONDITIONS
		do
--|#line 2500 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2500")
end

yyval113 := new_preconditions (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp113 := yyvsp113 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_415
			--|#line 2502 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PRECONDITIONS
		do
--|#line 2502 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2502")
end

yyval113 := new_preconditions (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp113 := yyvsp113 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -2
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_416
			--|#line 2506 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2506 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2506")
end

start_postcondition 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_417
			--|#line 2510 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_POSTCONDITIONS
		do
--|#line 2510 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2510")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp112 := yyvsp112 + 1
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_418
			--|#line 2512 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_POSTCONDITIONS
		do
--|#line 2512 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2512")
end

yyval112 := new_postconditions (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp112 := yyvsp112 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_419
			--|#line 2514 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_POSTCONDITIONS
		do
--|#line 2514 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2514")
end

yyval112 := new_postconditions (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp112 := yyvsp112 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_420
			--|#line 2516 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_POSTCONDITIONS
		do
--|#line 2516 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2516")
end

yyval112 := new_postconditions (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp112 := yyvsp112 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_421
			--|#line 2518 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_POSTCONDITIONS
		do
--|#line 2518 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2518")
end

yyval112 := new_postconditions (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp112 := yyvsp112 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -2
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_422
			--|#line 2522 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2522 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2522")
end

start_invariant 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_423
			--|#line 2526 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_INVARIANTS
		do
--|#line 2526 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2526")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp95 := yyvsp95 + 1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_424
			--|#line 2528 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_INVARIANTS
		do
--|#line 2528 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2528")
end

yyval95 := yyvs95.item (yyvsp95) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_425
			--|#line 2532 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_INVARIANTS
		do
--|#line 2532 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2532")
end

yyval95 := new_invariants (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp95 := yyvsp95 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_426
			--|#line 2534 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_INVARIANTS
		do
--|#line 2534 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2534")
end

yyval95 := new_invariants (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp95 := yyvsp95 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_427
			--|#line 2538 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2538 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2538")
end

set_start_closure (Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_428
			--|#line 2542 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2542 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2542")
end

start_loop_invariant 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_429
			--|#line 2546 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_LOOP_INVARIANTS
		do
--|#line 2546 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2546")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp101 := yyvsp101 + 1
	if yyvsp101 >= yyvsc101 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs101")
		end
		yyvsc101 := yyvsc101 + yyInitial_yyvs_size
		yyvs101 := yyspecial_routines101.aliased_resized_area (yyvs101, yyvsc101)
	end
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_430
			--|#line 2548 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_LOOP_INVARIANTS
		do
--|#line 2548 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2548")
end

yyval101 := yyvs101.item (yyvsp101) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_431
			--|#line 2552 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_LOOP_INVARIANTS
		do
--|#line 2552 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2552")
end

yyval101 := new_loop_invariants (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp101 := yyvsp101 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp101 >= yyvsc101 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs101")
		end
		yyvsc101 := yyvsc101 + yyInitial_yyvs_size
		yyvs101 := yyspecial_routines101.aliased_resized_area (yyvs101, yyvsc101)
	end
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_432
			--|#line 2554 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_LOOP_INVARIANTS
		do
--|#line 2554 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2554")
end

yyval101 := new_loop_invariants (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp101 := yyvsp101 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp101 >= yyvsc101 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs101")
		end
		yyvsc101 := yyvsc101 + yyInitial_yyvs_size
		yyvs101 := yyspecial_routines101.aliased_resized_area (yyvs101, yyvsc101)
	end
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_433
			--|#line 2558 "et_eiffel_parser.y"
		local
			yyval129: detachable ET_VARIANT
		do
--|#line 2558 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2558")
end

yyval129 := ast_factory.new_variant (yyvs2.item (yyvsp2), Void, yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp129 := yyvsp129 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp129 >= yyvsc129 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs129")
		end
		yyvsc129 := yyvsc129 + yyInitial_yyvs_size
		yyvs129 := yyspecial_routines129.aliased_resized_area (yyvs129, yyvsc129)
	end
	yyspecial_routines129.force (yyvs129, yyval129, yyvsp129)
end
		end

	yy_do_action_434
			--|#line 2560 "et_eiffel_parser.y"
		local
			yyval129: detachable ET_VARIANT
		do
--|#line 2560 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2560")
end

yyval129 := ast_factory.new_variant (yyvs2.item (yyvsp2), ast_factory.new_tag (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp129 := yyvsp129 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp129 >= yyvsc129 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs129")
		end
		yyvsc129 := yyvsc129 + yyInitial_yyvs_size
		yyvs129 := yyspecial_routines129.aliased_resized_area (yyvs129, yyvsc129)
	end
	yyspecial_routines129.force (yyvs129, yyval129, yyvsp129)
end
		end

	yy_do_action_435
			--|#line 2564 "et_eiffel_parser.y"
		local
			yyval129: detachable ET_VARIANT
		do
--|#line 2564 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2564")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp129 := yyvsp129 + 1
	if yyvsp129 >= yyvsc129 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs129")
		end
		yyvsc129 := yyvsc129 + yyInitial_yyvs_size
		yyvs129 := yyspecial_routines129.aliased_resized_area (yyvs129, yyvsc129)
	end
	yyspecial_routines129.force (yyvs129, yyval129, yyvsp129)
end
		end

	yy_do_action_436
			--|#line 2566 "et_eiffel_parser.y"
		local
			yyval129: detachable ET_VARIANT
		do
--|#line 2566 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2566")
end

yyval129 := yyvs129.item (yyvsp129) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines129.force (yyvs129, yyval129, yyvsp129)
end
		end

	yy_do_action_437
			--|#line 2572 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 2572 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2572")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_438
			--|#line 2574 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 2574 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2574")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_439
			--|#line 2580 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2580 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2580")
end

yyval123 := new_named_type (Void, yyvs12.item (yyvsp12), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp123 := yyvsp123 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_440
			--|#line 2582 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2582 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2582")
end

yyval123 := yyvs123.item (yyvsp123) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_441
			--|#line 2586 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2586 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2586")
end

yyval123 := new_named_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp123 := yyvsp123 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_442
			--|#line 2588 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2588 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2588")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_443
			--|#line 2590 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2590 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2590")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_444
			--|#line 2592 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2592 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2592")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_445
			--|#line 2594 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2594 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2594")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_446
			--|#line 2596 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2596 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2596")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_447
			--|#line 2598 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2598 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2598")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_448
			--|#line 2600 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2600 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2600")
end

yyval123 := new_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_449
			--|#line 2602 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2602 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2602")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_450
			--|#line 2604 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2604 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2604")
end

yyval123 := new_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_451
			--|#line 2606 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2606 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2606")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_452
			--|#line 2608 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2608 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2608")
end

yyval123 := yyvs97.item (yyvsp97) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp123 := yyvsp123 + 1
	yyvsp97 := yyvsp97 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_453
			--|#line 2610 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2610 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2610")
end

yyval123 := new_tuple_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp123 := yyvsp123 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_454
			--|#line 2612 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2612 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2612")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_455
			--|#line 2614 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2614 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2614")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_456
			--|#line 2616 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2616 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2616")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_457
			--|#line 2618 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2618 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2618")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_458
			--|#line 2620 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2620 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2620")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_459
			--|#line 2622 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2622 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2622")
end

yyval123 := new_tuple_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_460
			--|#line 2624 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2624 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2624")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_461
			--|#line 2626 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2626 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2626")
end

yyval123 := new_tuple_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_462
			--|#line 2628 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2628 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2628")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_463
			--|#line 2632 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2632 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2632")
end

yyval123 := new_named_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp123 := yyvsp123 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_464
			--|#line 2634 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2634 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2634")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_465
			--|#line 2636 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2636 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2636")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_466
			--|#line 2638 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2638 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2638")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_467
			--|#line 2640 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2640 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2640")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_468
			--|#line 2642 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2642 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2642")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_469
			--|#line 2644 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2644 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2644")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_470
			--|#line 2646 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2646 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2646")
end

yyval123 := new_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_471
			--|#line 2648 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2648 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2648")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_472
			--|#line 2650 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2650 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2650")
end

yyval123 := new_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_473
			--|#line 2652 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2652 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2652")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_474
			--|#line 2654 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2654 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2654")
end

yyval123 := yyvs97.item (yyvsp97) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp123 := yyvsp123 + 1
	yyvsp97 := yyvsp97 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_475
			--|#line 2656 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2656 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2656")
end

yyval123 := new_tuple_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp123 := yyvsp123 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_476
			--|#line 2658 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2658 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2658")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_477
			--|#line 2660 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2660 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2660")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_478
			--|#line 2662 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2662 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2662")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_479
			--|#line 2664 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2664 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2664")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_480
			--|#line 2666 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2666 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2666")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_481
			--|#line 2668 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2668 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2668")
end

yyval123 := new_tuple_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_482
			--|#line 2670 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2670 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2670")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_483
			--|#line 2672 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2672 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2672")
end

yyval123 := new_tuple_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_484
			--|#line 2674 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2674 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2674")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_485
			--|#line 2678 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2678 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2678")
end

yyval123 := new_named_type (Void, yyvs12.item (yyvsp12), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp123 := yyvsp123 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_486
			--|#line 2680 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2680 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2680")
end

yyval123 := new_named_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp123 := yyvsp123 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_487
			--|#line 2682 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2682 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2682")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_488
			--|#line 2684 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2684 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2684")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_489
			--|#line 2686 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2686 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2686")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_490
			--|#line 2688 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2688 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2688")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_491
			--|#line 2690 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2690 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2690")
end

yyval123 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_492
			--|#line 2692 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2692 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2692")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_493
			--|#line 2694 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2694 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2694")
end

yyval123 := new_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_494
			--|#line 2696 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2696 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2696")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_495
			--|#line 2698 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2698 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2698")
end

yyval123 := new_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_496
			--|#line 2700 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2700 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2700")
end

yyval123 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_497
			--|#line 2702 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2702 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2702")
end

yyval123 := yyvs97.item (yyvsp97) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp123 := yyvsp123 + 1
	yyvsp97 := yyvsp97 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_498
			--|#line 2704 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2704 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2704")
end

yyval123 := new_tuple_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp123 := yyvsp123 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_499
			--|#line 2706 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2706 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2706")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_500
			--|#line 2708 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2708 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2708")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_501
			--|#line 2710 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2710 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2710")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_502
			--|#line 2712 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2712 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2712")
end

yyval123 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_503
			--|#line 2714 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2714 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2714")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_504
			--|#line 2716 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2716 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2716")
end

yyval123 := new_tuple_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_505
			--|#line 2718 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2718 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2718")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_506
			--|#line 2720 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2720 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2720")
end

yyval123 := new_tuple_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_507
			--|#line 2722 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE
		do
--|#line 2722 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2722")
end

yyval123 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp123 := yyvsp123 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_508
			--|#line 2726 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 2726 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2726")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_509
			--|#line 2728 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 2728 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2728")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_510
			--|#line 2732 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2732 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2732")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp28 := yyvsp28 + 1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_511
			--|#line 2734 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2734 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2734")
end

yyval28 := yyvs28.item (yyvsp28) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_512
			--|#line 2738 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2738 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2738")
end

yyval28 := ast_factory.new_actual_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp28 := yyvsp28 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_513
			--|#line 2741 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2741 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2741")
end

			yyval28 := yyvs28.item (yyvsp28)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_514
			--|#line 2749 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2749 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2749")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp22 := yyvsp22 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_515
			--|#line 2756 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2756 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2756")
end

			if attached yyvs123.item (yyvsp123) as l_type then
				yyval28 := ast_factory.new_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval28 /= Void then
					yyval28.put_first (l_type)
				end
			else
				yyval28 := ast_factory.new_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp28 := yyvsp28 + 1
	yyvsp123 := yyvsp123 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_516
			--|#line 2767 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2767 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2767")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (yyvs27.item (yyvsp27), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp27 := yyvsp27 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_517
			--|#line 2772 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2772 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2772")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (ast_factory.new_actual_parameter_comma (new_named_type (Void, yyvs12.item (yyvsp12), Void), yyvs5.item (yyvsp5)), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_518
			--|#line 2777 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2777 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2777")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (ast_factory.new_actual_parameter_comma (new_named_type (Void, yyvs12.item (yyvsp12), Void), yyvs5.item (yyvsp5)), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_519
			--|#line 2782 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2782 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2782")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (ast_factory.new_actual_parameter_comma (new_tuple_type (Void, yyvs12.item (yyvsp12), Void), yyvs5.item (yyvsp5)), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_520
			--|#line 2789 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2789 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2789")
end

			increment_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_521
			--|#line 2795 "et_eiffel_parser.y"
		local
			yyval27: detachable ET_ACTUAL_PARAMETER_ITEM
		do
--|#line 2795 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2795")
end

			yyval27 := ast_factory.new_actual_parameter_comma (yyvs123.item (yyvsp123), yyvs5.item (yyvsp5))
			if yyval27 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp27 := yyvsp27 + 1
	yyvsp123 := yyvsp123 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp27 >= yyvsc27 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs27")
		end
		yyvsc27 := yyvsc27 + yyInitial_yyvs_size
		yyvs27 := yyspecial_routines27.aliased_resized_area (yyvs27, yyvsc27)
	end
	yyspecial_routines27.force (yyvs27, yyval27, yyvsp27)
end
		end

	yy_do_action_522
			--|#line 2804 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2804 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2804")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp28 := yyvsp28 + 1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_523
			--|#line 2806 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2806 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2806")
end

yyval28 := yyvs28.item (yyvsp28) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_524
			--|#line 2810 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2810 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2810")
end

yyval28 := ast_factory.new_actual_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp28 := yyvsp28 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_525
			--|#line 2813 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2813 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2813")
end

			yyval28 := yyvs28.item (yyvsp28)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_526
			--|#line 2819 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2819 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2819")
end

			yyval28 := yyvs28.item (yyvsp28)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_527
			--|#line 2827 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2827 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2827")
end

			yyval28 := ast_factory.new_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
			add_to_actual_parameter_list (ast_factory.new_labeled_actual_parameter (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123))), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp28 := yyvsp28 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_528
			--|#line 2832 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2832 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2832")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (yyvs27.item (yyvsp27), yyvs28.item (yyvsp28))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp27 := yyvsp27 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_529
			--|#line 2837 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2837 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2837")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (yyvs27.item (yyvsp27), yyvs28.item (yyvsp28))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp27 := yyvsp27 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_530
			--|#line 2842 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2842 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2842")
end

			yyval28 := yyvs28.item (yyvsp28)
			if yyval28 /= Void then
				if not yyval28.is_empty then
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyval28.first.type), yyval28)
				else
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), Void), yyval28)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_531
			--|#line 2853 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2853 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2853")
end

			yyval28 := yyvs28.item (yyvsp28)
			if yyval28 /= Void then
				if not yyval28.is_empty then
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyval28.first.type), yyval28)
				else
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), Void), yyval28)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_532
			--|#line 2864 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2864 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2864")
end

			yyval28 := yyvs28.item (yyvsp28)
			if yyval28 /= Void then
				if not yyval28.is_empty then
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyval28.first.type), yyval28)
				else
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), Void), yyval28)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_533
			--|#line 2877 "et_eiffel_parser.y"
		local
			yyval27: detachable ET_ACTUAL_PARAMETER_ITEM
		do
--|#line 2877 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2877")
end

			yyval27 := ast_factory.new_labeled_actual_parameter (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)))
			if yyval27 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp27 := yyvsp27 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	if yyvsp27 >= yyvsc27 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs27")
		end
		yyvsc27 := yyvsc27 + yyInitial_yyvs_size
		yyvs27 := yyspecial_routines27.aliased_resized_area (yyvs27, yyvsc27)
	end
	yyspecial_routines27.force (yyvs27, yyval27, yyvsp27)
end
		end

	yy_do_action_534
			--|#line 2886 "et_eiffel_parser.y"
		local
			yyval27: detachable ET_ACTUAL_PARAMETER_ITEM
		do
--|#line 2886 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2886")
end

			yyval27 := ast_factory.new_labeled_actual_parameter_semicolon (ast_factory.new_labeled_actual_parameter (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123))), yyvs21.item (yyvsp21))
			if yyval27 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp27 := yyvsp27 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp27 >= yyvsc27 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs27")
		end
		yyvsc27 := yyvsc27 + yyInitial_yyvs_size
		yyvs27 := yyspecial_routines27.aliased_resized_area (yyvs27, yyvsc27)
	end
	yyspecial_routines27.force (yyvs27, yyval27, yyvsp27)
end
		end

	yy_do_action_535
			--|#line 2895 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2895 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2895")
end

yyval97 := new_like_feature (Void, yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_536
			--|#line 2897 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2897 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2897")
end

yyval97 := ast_factory.new_like_current (tokens.implicit_attached_type_mark, yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_537
			--|#line 2899 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2899 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2899")
end

yyval97 := yyvs115.item (yyvsp115) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp97 := yyvsp97 + 1
	yyvsp115 := yyvsp115 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_538
			--|#line 2903 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2903 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2903")
end

yyval97 := new_like_feature (Void, yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_539
			--|#line 2905 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2905 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2905")
end

yyval97 := new_like_feature (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_540
			--|#line 2907 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2907 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2907")
end

yyval97 := new_like_feature (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_541
			--|#line 2909 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2909 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2909")
end

yyval97 := new_like_feature (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_542
			--|#line 2911 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2911 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2911")
end

yyval97 := new_like_feature (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_543
			--|#line 2913 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2913 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2913")
end

yyval97 := new_like_feature (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_544
			--|#line 2915 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2915 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2915")
end

yyval97 := new_like_feature (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_545
			--|#line 2917 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2917 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2917")
end

yyval97 := new_like_feature (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp97 := yyvsp97 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_546
			--|#line 2919 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2919 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2919")
end

yyval97 := new_like_feature (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_547
			--|#line 2921 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2921 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2921")
end

yyval97 := new_like_feature (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp97 := yyvsp97 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_548
			--|#line 2923 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2923 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2923")
end

yyval97 := ast_factory.new_like_current (tokens.implicit_attached_type_mark, yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_549
			--|#line 2925 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2925 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2925")
end

yyval97 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (tokens.implicit_attached_type_mark, yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_550
			--|#line 2927 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2927 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2927")
end

yyval97 := ast_factory.new_like_current (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_551
			--|#line 2929 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2929 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2929")
end

yyval97 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_552
			--|#line 2931 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2931 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2931")
end

yyval97 := ast_factory.new_like_current (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_553
			--|#line 2933 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2933 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2933")
end

yyval97 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp97 := yyvsp97 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_554
			--|#line 2935 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2935 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2935")
end

yyval97 := ast_factory.new_like_current (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_555
			--|#line 2937 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2937 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2937")
end

yyval97 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp97 := yyvsp97 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_556
			--|#line 2939 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2939 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2939")
end

yyval97 := ast_factory.new_like_current (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp97 := yyvsp97 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_557
			--|#line 2941 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2941 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2941")
end

yyval97 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp97 := yyvsp97 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_558
			--|#line 2943 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LIKE_TYPE
		do
--|#line 2943 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2943")
end

yyval97 := yyvs115.item (yyvsp115) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp97 := yyvsp97 + 1
	yyvsp115 := yyvsp115 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_559
			--|#line 2947 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2947 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2947")
end

yyval115 := ast_factory.new_qualified_like_braced_type (Void, yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_560
			--|#line 2949 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2949 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2949")
end

yyval115 := ast_factory.new_qualified_like_type (Void, yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp115 := yyvsp115 + 1
	yyvsp97 := yyvsp97 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_561
			--|#line 2953 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2953 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2953")
end

yyval115 := yyvs115.item (yyvsp115) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_562
			--|#line 2955 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2955 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2955")
end

yyval115 := ast_factory.new_qualified_like_braced_type (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_563
			--|#line 2957 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2957 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2957")
end

yyval115 := ast_factory.new_qualified_like_braced_type (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_564
			--|#line 2959 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2959 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2959")
end

yyval115 := ast_factory.new_qualified_like_braced_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_565
			--|#line 2961 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2961 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2961")
end

yyval115 := ast_factory.new_qualified_like_braced_type (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_566
			--|#line 2963 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2963 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2963")
end

yyval115 := ast_factory.new_qualified_like_braced_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_567
			--|#line 2965 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2965 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2965")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval115 := ast_factory.new_qualified_like_braced_type (yyvs5.item (yyvsp5 - 3), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp115 := yyvsp115 + 1
	yyvsp5 := yyvsp5 -4
	yyvsp2 := yyvsp2 -1
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_568
			--|#line 2973 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2973 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2973")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval115 := ast_factory.new_qualified_like_braced_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5 - 3), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp115 := yyvsp115 + 1
	yyvsp5 := yyvsp5 -4
	yyvsp2 := yyvsp2 -2
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_569
			--|#line 2981 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2981 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2981")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval115 := ast_factory.new_qualified_like_braced_type (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp115 := yyvsp115 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_570
			--|#line 2989 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2989 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2989")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval115 := ast_factory.new_qualified_like_braced_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp115 := yyvsp115 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_571
			--|#line 2997 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2997 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2997")
end

yyval115 := ast_factory.new_qualified_like_type (yyvs2.item (yyvsp2), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp97 := yyvsp97 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_572
			--|#line 2999 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2999 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2999")
end

yyval115 := ast_factory.new_qualified_like_type (yyvs2.item (yyvsp2), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp97 := yyvsp97 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_573
			--|#line 3001 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 3001 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3001")
end

yyval115 := ast_factory.new_qualified_like_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp97 := yyvsp97 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_574
			--|#line 3003 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 3003 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3003")
end

yyval115 := ast_factory.new_qualified_like_type (yyvs2.item (yyvsp2), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp97 := yyvsp97 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_575
			--|#line 3005 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 3005 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3005")
end

yyval115 := ast_factory.new_qualified_like_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp115 := yyvsp115 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp97 := yyvsp97 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_576
			--|#line 3007 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 3007 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3007")
end

yyval115 := ast_factory.new_qualified_like_type (yyvs5.item (yyvsp5 - 1), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp115 := yyvsp115 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp97 := yyvsp97 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_577
			--|#line 3009 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 3009 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3009")
end

yyval115 := ast_factory.new_qualified_like_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5 - 1), yyvs2.item (yyvsp2)), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp115 := yyvsp115 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp2 := yyvsp2 -1
	yyvsp97 := yyvsp97 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_578
			--|#line 3011 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 3011 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3011")
end

yyval115 := ast_factory.new_qualified_like_type (yyvs23.item (yyvsp23), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp115 := yyvsp115 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp97 := yyvsp97 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_579
			--|#line 3013 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 3013 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3013")
end

yyval115 := ast_factory.new_qualified_like_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs97.item (yyvsp97), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp115 := yyvsp115 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp97 := yyvsp97 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_580
			--|#line 3019 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3019 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3019")
end

yyval47 := ast_factory.new_do_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_581
			--|#line 3023 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3023 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3023")
end

yyval47 := ast_factory.new_attribute_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_582
			--|#line 3027 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3027 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3027")
end

yyval47 := ast_factory.new_then_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_583
			--|#line 3031 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3031 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3031")
end

yyval47 := ast_factory.new_then_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_584
			--|#line 3035 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3035 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3035")
end

yyval47 := ast_factory.new_else_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_585
			--|#line 3039 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3039 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3039")
end

yyval47 := ast_factory.new_else_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_586
			--|#line 3043 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3043 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3043")
end

yyval47 := ast_factory.new_rescue_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_587
			--|#line 3047 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3047 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3047")
end

yyval47 := ast_factory.new_from_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_588
			--|#line 3051 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3051 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3051")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_589
			--|#line 3053 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3053 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3053")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_590
			--|#line 3057 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3057 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3057")
end

yyval47 := ast_factory.new_loop_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_591
			--|#line 3061 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3061 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3061")
end

			yyval47 := yyvs47.item (yyvsp47)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_592
			--|#line 3068 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3068 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3068")
end

yyval47 := ast_factory.new_empty_compound 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_593
			--|#line 3070 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3070 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3070")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_594
			--|#line 3074 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3074 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3074")
end

yyval47 := ast_factory.new_compound (0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_595
			--|#line 3076 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3076 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3076")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_596
			--|#line 3080 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3080 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3080")
end

			if attached yyvs94.item (yyvsp94) as l_instruction then
				yyval47 := ast_factory.new_compound (counter_value + 1)
				if yyval47 /= Void then
					yyval47.put_first (l_instruction)
				end
			else
				yyval47 := ast_factory.new_compound (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp47 := yyvsp47 + 1
	yyvsp94 := yyvsp94 -1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_597
			--|#line 3091 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3091 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3091")
end

			yyval47 := yyvs47.item (yyvsp47)
			if yyval47 /= Void and attached yyvs94.item (yyvsp94) as l_instruction then
				yyval47.put_first (l_instruction)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp47 := yyvsp47 -1
	yyvsp94 := yyvsp94 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_598
			--|#line 3091 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3091 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3091")
end

			if yyvs94.item (yyvsp94) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_599
			--|#line 3112 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3112 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3112")
end

yyval94 := yyvs94.item (yyvsp94) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_600
			--|#line 3114 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3114 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3114")
end

yyval94 := yyvs94.item (yyvsp94) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_601
			--|#line 3116 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3116 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3116")
end

yyval94 := yyvs94.item (yyvsp94) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_602
			--|#line 3118 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3118 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3118")
end

yyval94 := ast_factory.new_assigner_instruction (yyvs38.item (yyvsp38), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp94 := yyvsp94 + 1
	yyvsp38 := yyvsp38 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_603
			--|#line 3120 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3120 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3120")
end

yyval94 := ast_factory.new_assigner_instruction (yyvs36.item (yyvsp36), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp94 := yyvsp94 + 1
	yyvsp36 := yyvsp36 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_604
			--|#line 3122 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3122 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3122")
end

yyval94 := ast_factory.new_assignment (yyvs134.item (yyvsp134), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp94 := yyvsp94 + 1
	yyvsp134 := yyvsp134 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_605
			--|#line 3124 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3124 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3124")
end

yyval94 := ast_factory.new_assignment_attempt (yyvs134.item (yyvsp134), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp94 := yyvsp94 + 1
	yyvsp134 := yyvsp134 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_606
			--|#line 3126 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3126 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3126")
end

yyval94 := yyvs85.item (yyvsp85) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp94 := yyvsp94 + 1
	yyvsp85 := yyvsp85 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_607
			--|#line 3128 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3128 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3128")
end

yyval94 := yyvs93.item (yyvsp93) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp94 := yyvsp94 + 1
	yyvsp93 := yyvsp93 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_608
			--|#line 3130 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3130 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3130")
end

yyval94 := ast_factory.new_loop_instruction_old_syntax (yyvs47.item (yyvsp47 - 1), yyvs101.item (yyvsp101), yyvs129.item (yyvsp129), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp94 := yyvsp94 + 1
	yyvsp47 := yyvsp47 -2
	yyvsp101 := yyvsp101 -1
	yyvsp129 := yyvsp129 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_609
			--|#line 3132 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3132 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3132")
end

			if system_processor.older_ise_version (ise_6_3_7_4554) then
				yyval94 := ast_factory.new_loop_instruction_old_syntax (yyvs47.item (yyvsp47 - 1), yyvs101.item (yyvsp101), Void, ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2))
			else
				yyval94 := ast_factory.new_loop_instruction (yyvs47.item (yyvsp47 - 1), yyvs101.item (yyvsp101), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), Void, yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp94 := yyvsp94 + 1
	yyvsp47 := yyvsp47 -2
	yyvsp101 := yyvsp101 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_610
			--|#line 3140 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3140 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3140")
end

			if system_processor.older_ise_version (ise_6_3_7_4554) then
				raise_error
			else
				yyval94 := ast_factory.new_loop_instruction (yyvs47.item (yyvsp47 - 1), yyvs101.item (yyvsp101), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), yyvs129.item (yyvsp129), yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp94 := yyvsp94 + 1
	yyvsp47 := yyvsp47 -2
	yyvsp101 := yyvsp101 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp129 := yyvsp129 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_611
			--|#line 3153 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3153 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3153")
end

yyval94 := new_across_instruction (yyvs25.item (yyvsp25), yyvs47.item (yyvsp47 - 1), yyvs101.item (yyvsp101), yyvs48.item (yyvsp48), yyvs47.item (yyvsp47), yyvs129.item (yyvsp129), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp94 := yyvsp94 + 1
	yyvsp25 := yyvsp25 -1
	yyvsp47 := yyvsp47 -2
	yyvsp101 := yyvsp101 -1
	yyvsp48 := yyvsp48 -1
	yyvsp129 := yyvsp129 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_612
			--|#line 3155 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3155 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3155")
end

yyval94 := new_repeat_instruction (yyvs120.item (yyvsp120), yyvs47.item (yyvsp47), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp94 := yyvsp94 + 1
	yyvsp120 := yyvsp120 -1
	yyvsp47 := yyvsp47 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_613
			--|#line 3157 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3157 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3157")
end

yyval94 := yyvs62.item (yyvsp62) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp94 := yyvsp94 + 1
	yyvsp62 := yyvsp62 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_614
			--|#line 3159 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3159 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3159")
end

yyval94 := yyvs39.item (yyvsp39) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp94 := yyvsp94 + 1
	yyvsp39 := yyvsp39 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_615
			--|#line 3161 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3161 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3161")
end

yyval94 := yyvs18.item (yyvsp18) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp94 := yyvsp94 + 1
	yyvsp18 := yyvsp18 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_616
			--|#line 3163 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3163 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3163")
end

yyval94 := ast_factory.new_null_instruction (yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp94 := yyvsp94 + 1
	yyvsp21 := yyvsp21 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_617
			--|#line 3169 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 3169 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3169")
end

start_check_instruction 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_618
			--|#line 3173 "et_eiffel_parser.y"
		local
			yyval39: detachable ET_CHECK_INSTRUCTION
		do
--|#line 3173 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3173")
end

yyval39 := new_check_instruction (yyvs2.item (yyvsp2 - 1), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp39 := yyvsp39 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
		end

	yy_do_action_619
			--|#line 3175 "et_eiffel_parser.y"
		local
			yyval39: detachable ET_CHECK_INSTRUCTION
		do
--|#line 3175 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3175")
end

yyval39 := new_check_instruction (yyvs2.item (yyvsp2 - 1), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp39 := yyvsp39 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -2
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
		end

	yy_do_action_620
			--|#line 3177 "et_eiffel_parser.y"
		local
			yyval39: detachable ET_CHECK_INSTRUCTION
		do
--|#line 3177 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3177")
end

yyval39 := new_check_instruction (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp39 := yyvsp39 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
		end

	yy_do_action_621
			--|#line 3179 "et_eiffel_parser.y"
		local
			yyval39: detachable ET_CHECK_INSTRUCTION
		do
--|#line 3179 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3179")
end

yyval39 := new_check_instruction (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp39 := yyvsp39 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -2
	yyvsp47 := yyvsp47 -1
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
		end

	yy_do_action_622
			--|#line 3185 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3185 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3185")
end

yyval94 := ast_factory.new_bang_instruction (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5), yyvs134.item (yyvsp134), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp94 := yyvsp94 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyvsp134 := yyvsp134 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_623
			--|#line 3187 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3187 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3187")
end

yyval94 := ast_factory.new_bang_instruction (yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1), yyvs134.item (yyvsp134), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp94 := yyvsp94 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp134 := yyvsp134 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_624
			--|#line 3189 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3189 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3189")
end

yyval94 := ast_factory.new_bang_instruction (yyvs5.item (yyvsp5 - 1), Void, yyvs5.item (yyvsp5), yyvs134.item (yyvsp134), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp94 := yyvsp94 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp134 := yyvsp134 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_625
			--|#line 3191 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3191 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3191")
end

yyval94 := ast_factory.new_bang_instruction (yyvs5.item (yyvsp5 - 2), Void, yyvs5.item (yyvsp5 - 1), yyvs134.item (yyvsp134), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp94 := yyvsp94 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp134 := yyvsp134 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_626
			--|#line 3195 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3195 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3195")
end

yyval94 := ast_factory.new_create_instruction (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)), yyvs134.item (yyvsp134), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp94 := yyvsp94 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyvsp134 := yyvsp134 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_627
			--|#line 3197 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3197 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3197")
end

yyval94 := ast_factory.new_create_instruction (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1)), yyvs134.item (yyvsp134), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 9
	yyvsp94 := yyvsp94 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp134 := yyvsp134 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_628
			--|#line 3199 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3199 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3199")
end

yyval94 := ast_factory.new_create_instruction (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), Void, yyvs134.item (yyvsp134), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp94 := yyvsp94 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp134 := yyvsp134 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_629
			--|#line 3201 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3201 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3201")
end

yyval94 := ast_factory.new_create_instruction (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), Void, yyvs134.item (yyvsp134), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp94 := yyvsp94 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp134 := yyvsp134 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_630
			--|#line 3205 "et_eiffel_parser.y"
		local
			yyval58: detachable ET_CREATE_EXPRESSION
		do
--|#line 3205 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3205")
end

yyval58 := ast_factory.new_create_expression (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp58 := yyvsp58 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	if yyvsp58 >= yyvsc58 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs58")
		end
		yyvsc58 := yyvsc58 + yyInitial_yyvs_size
		yyvs58 := yyspecial_routines58.aliased_resized_area (yyvs58, yyvsc58)
	end
	yyspecial_routines58.force (yyvs58, yyval58, yyvsp58)
end
		end

	yy_do_action_631
			--|#line 3207 "et_eiffel_parser.y"
		local
			yyval58: detachable ET_CREATE_EXPRESSION
		do
--|#line 3207 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3207")
end

yyval58 := ast_factory.new_create_expression (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1)), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp58 := yyvsp58 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp58 >= yyvsc58 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs58")
		end
		yyvsc58 := yyvsc58 + yyInitial_yyvs_size
		yyvs58 := yyspecial_routines58.aliased_resized_area (yyvs58, yyvsc58)
	end
	yyspecial_routines58.force (yyvs58, yyval58, yyvsp58)
end
		end

	yy_do_action_632
			--|#line 3211 "et_eiffel_parser.y"
		local
			yyval59: detachable ET_CREATION_REGION
		do
--|#line 3211 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3211")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp59 := yyvsp59 + 1
	if yyvsp59 >= yyvsc59 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs59")
		end
		yyvsc59 := yyvsc59 + yyInitial_yyvs_size
		yyvs59 := yyspecial_routines59.aliased_resized_area (yyvs59, yyvsc59)
	end
	yyspecial_routines59.force (yyvs59, yyval59, yyvsp59)
end
		end

	yy_do_action_633
			--|#line 3212 "et_eiffel_parser.y"
		local
			yyval59: detachable ET_CREATION_REGION
		do
--|#line 3212 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3212")
end

yyval59 := ast_factory.new_creation_region (yyvs19.item (yyvsp19 - 1), yyvs12.item (yyvsp12), yyvs19.item (yyvsp19)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp59 := yyvsp59 + 1
	yyvsp19 := yyvsp19 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp59 >= yyvsc59 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs59")
		end
		yyvsc59 := yyvsc59 + yyInitial_yyvs_size
		yyvs59 := yyspecial_routines59.aliased_resized_area (yyvs59, yyvsc59)
	end
	yyspecial_routines59.force (yyvs59, yyval59, yyvsp59)
end
		end

	yy_do_action_634
			--|#line 3218 "et_eiffel_parser.y"
		local
			yyval85: detachable ET_IF_INSTRUCTION
		do
--|#line 3218 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3218")
end

yyval85 := ast_factory.new_if_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), Void, Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp85 := yyvsp85 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp85 >= yyvsc85 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs85")
		end
		yyvsc85 := yyvsc85 + yyInitial_yyvs_size
		yyvs85 := yyspecial_routines85.aliased_resized_area (yyvs85, yyvsc85)
	end
	yyspecial_routines85.force (yyvs85, yyval85, yyvsp85)
end
		end

	yy_do_action_635
			--|#line 3220 "et_eiffel_parser.y"
		local
			yyval85: detachable ET_IF_INSTRUCTION
		do
--|#line 3220 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3220")
end

yyval85 := ast_factory.new_if_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47 - 1), Void, yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp85 := yyvsp85 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -2
	if yyvsp85 >= yyvsc85 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs85")
		end
		yyvsc85 := yyvsc85 + yyInitial_yyvs_size
		yyvs85 := yyspecial_routines85.aliased_resized_area (yyvs85, yyvsc85)
	end
	yyspecial_routines85.force (yyvs85, yyval85, yyvsp85)
end
		end

	yy_do_action_636
			--|#line 3222 "et_eiffel_parser.y"
		local
			yyval85: detachable ET_IF_INSTRUCTION
		do
--|#line 3222 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3222")
end

yyval85 := ast_factory.new_if_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), yyvs66.item (yyvsp66), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp85 := yyvsp85 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -1
	yyvsp66 := yyvsp66 -1
	if yyvsp85 >= yyvsc85 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs85")
		end
		yyvsc85 := yyvsc85 + yyInitial_yyvs_size
		yyvs85 := yyspecial_routines85.aliased_resized_area (yyvs85, yyvsc85)
	end
	yyspecial_routines85.force (yyvs85, yyval85, yyvsp85)
end
		end

	yy_do_action_637
			--|#line 3224 "et_eiffel_parser.y"
		local
			yyval85: detachable ET_IF_INSTRUCTION
		do
--|#line 3224 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3224")
end

yyval85 := ast_factory.new_if_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47 - 1), yyvs66.item (yyvsp66), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp85 := yyvsp85 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -2
	yyvsp66 := yyvsp66 -1
	if yyvsp85 >= yyvsc85 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs85")
		end
		yyvsc85 := yyvsc85 + yyInitial_yyvs_size
		yyvs85 := yyspecial_routines85.aliased_resized_area (yyvs85, yyvsc85)
	end
	yyspecial_routines85.force (yyvs85, yyval85, yyvsp85)
end
		end

	yy_do_action_638
			--|#line 3228 "et_eiffel_parser.y"
		local
			yyval66: detachable ET_ELSEIF_PART_LIST
		do
--|#line 3228 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3228")
end

			yyval66 := yyvs66.item (yyvsp66)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines66.force (yyvs66, yyval66, yyvsp66)
end
		end

	yy_do_action_639
			--|#line 3235 "et_eiffel_parser.y"
		local
			yyval66: detachable ET_ELSEIF_PART_LIST
		do
--|#line 3235 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3235")
end

			yyval66 := ast_factory.new_elseif_part_list (counter_value)
			if yyval66 /= Void and attached yyvs65.item (yyvsp65) as l_elseif_part then
				yyval66.put_first (l_elseif_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp66 := yyvsp66 + 1
	yyvsp65 := yyvsp65 -1
	if yyvsp66 >= yyvsc66 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs66")
		end
		yyvsc66 := yyvsc66 + yyInitial_yyvs_size
		yyvs66 := yyspecial_routines66.aliased_resized_area (yyvs66, yyvsc66)
	end
	yyspecial_routines66.force (yyvs66, yyval66, yyvsp66)
end
		end

	yy_do_action_640
			--|#line 3242 "et_eiffel_parser.y"
		local
			yyval66: detachable ET_ELSEIF_PART_LIST
		do
--|#line 3242 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3242")
end

			yyval66 := yyvs66.item (yyvsp66)
			if yyval66 /= Void and attached yyvs65.item (yyvsp65) as l_elseif_part then
				yyval66.put_first (l_elseif_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp65 := yyvsp65 -1
	yyspecial_routines66.force (yyvs66, yyval66, yyvsp66)
end
		end

	yy_do_action_641
			--|#line 3251 "et_eiffel_parser.y"
		local
			yyval65: detachable ET_ELSEIF_PART
		do
--|#line 3251 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3251")
end

			yyval65 := ast_factory.new_elseif_part (ast_factory.new_conditional (yyvs2.item (yyvsp2), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47))
			if yyval65 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp65 := yyvsp65 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp65 >= yyvsc65 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs65")
		end
		yyvsc65 := yyvsc65 + yyInitial_yyvs_size
		yyvs65 := yyspecial_routines65.aliased_resized_area (yyvs65, yyvsc65)
	end
	yyspecial_routines65.force (yyvs65, yyval65, yyvsp65)
end
		end

	yy_do_action_642
			--|#line 3262 "et_eiffel_parser.y"
		local
			yyval84: detachable ET_IF_EXPRESSION
		do
--|#line 3262 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3262")
end

yyval84 := ast_factory.new_if_expression (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 3), yyvs69.item (yyvsp69 - 2)), yyvs2.item (yyvsp2 - 2), yyvs69.item (yyvsp69 - 1), Void, yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp84 := yyvsp84 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp69 := yyvsp69 -3
	if yyvsp84 >= yyvsc84 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs84")
		end
		yyvsc84 := yyvsc84 + yyInitial_yyvs_size
		yyvs84 := yyspecial_routines84.aliased_resized_area (yyvs84, yyvsc84)
	end
	yyspecial_routines84.force (yyvs84, yyval84, yyvsp84)
end
		end

	yy_do_action_643
			--|#line 3264 "et_eiffel_parser.y"
		local
			yyval84: detachable ET_IF_EXPRESSION
		do
--|#line 3264 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3264")
end

yyval84 := ast_factory.new_if_expression (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 3), yyvs69.item (yyvsp69 - 2)), yyvs2.item (yyvsp2 - 2), yyvs69.item (yyvsp69 - 1), yyvs64.item (yyvsp64), yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp84 := yyvsp84 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp69 := yyvsp69 -3
	yyvsp64 := yyvsp64 -1
	if yyvsp84 >= yyvsc84 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs84")
		end
		yyvsc84 := yyvsc84 + yyInitial_yyvs_size
		yyvs84 := yyspecial_routines84.aliased_resized_area (yyvs84, yyvsc84)
	end
	yyspecial_routines84.force (yyvs84, yyval84, yyvsp84)
end
		end

	yy_do_action_644
			--|#line 3268 "et_eiffel_parser.y"
		local
			yyval64: detachable ET_ELSEIF_EXPRESSION_LIST
		do
--|#line 3268 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3268")
end

			yyval64 := yyvs64.item (yyvsp64)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines64.force (yyvs64, yyval64, yyvsp64)
end
		end

	yy_do_action_645
			--|#line 3275 "et_eiffel_parser.y"
		local
			yyval64: detachable ET_ELSEIF_EXPRESSION_LIST
		do
--|#line 3275 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3275")
end

			yyval64 := ast_factory.new_elseif_expression_list (counter_value)
			if yyval64 /= Void and attached yyvs63.item (yyvsp63) as l_elseif_part then
				yyval64.put_first (l_elseif_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp64 := yyvsp64 + 1
	yyvsp63 := yyvsp63 -1
	if yyvsp64 >= yyvsc64 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs64")
		end
		yyvsc64 := yyvsc64 + yyInitial_yyvs_size
		yyvs64 := yyspecial_routines64.aliased_resized_area (yyvs64, yyvsc64)
	end
	yyspecial_routines64.force (yyvs64, yyval64, yyvsp64)
end
		end

	yy_do_action_646
			--|#line 3282 "et_eiffel_parser.y"
		local
			yyval64: detachable ET_ELSEIF_EXPRESSION_LIST
		do
--|#line 3282 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3282")
end

			yyval64 := yyvs64.item (yyvsp64)
			if yyval64 /= Void and attached yyvs63.item (yyvsp63) as l_elseif_part then
				yyval64.put_first (l_elseif_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp63 := yyvsp63 -1
	yyspecial_routines64.force (yyvs64, yyval64, yyvsp64)
end
		end

	yy_do_action_647
			--|#line 3291 "et_eiffel_parser.y"
		local
			yyval63: detachable ET_ELSEIF_EXPRESSION
		do
--|#line 3291 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3291")
end

			yyval63 := ast_factory.new_elseif_expression (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69 - 1)), yyvs2.item (yyvsp2), yyvs69.item (yyvsp69))
			if yyval63 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp63 := yyvsp63 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -2
	if yyvsp63 >= yyvsc63 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs63")
		end
		yyvsc63 := yyvsc63 + yyInitial_yyvs_size
		yyvs63 := yyspecial_routines63.aliased_resized_area (yyvs63, yyvsc63)
	end
	yyspecial_routines63.force (yyvs63, yyval63, yyvsp63)
end
		end

	yy_do_action_648
			--|#line 3302 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSPECT_INSTRUCTION
		do
--|#line 3302 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3302")
end

yyval93 := ast_factory.new_inspect_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs133.item (yyvsp133), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp93 := yyvsp93 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp133 := yyvsp133 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_649
			--|#line 3304 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSPECT_INSTRUCTION
		do
--|#line 3304 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3304")
end

yyval93 := ast_factory.new_inspect_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs133.item (yyvsp133), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp93 := yyvsp93 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp133 := yyvsp133 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_650
			--|#line 3308 "et_eiffel_parser.y"
		local
			yyval133: detachable ET_WHEN_PART_LIST
		do
--|#line 3308 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3308")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp133 := yyvsp133 + 1
	if yyvsp133 >= yyvsc133 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs133")
		end
		yyvsc133 := yyvsc133 + yyInitial_yyvs_size
		yyvs133 := yyspecial_routines133.aliased_resized_area (yyvs133, yyvsc133)
	end
	yyspecial_routines133.force (yyvs133, yyval133, yyvsp133)
end
		end

	yy_do_action_651
			--|#line 3310 "et_eiffel_parser.y"
		local
			yyval133: detachable ET_WHEN_PART_LIST
		do
--|#line 3310 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3310")
end

			yyval133 := yyvs133.item (yyvsp133)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines133.force (yyvs133, yyval133, yyvsp133)
end
		end

	yy_do_action_652
			--|#line 3317 "et_eiffel_parser.y"
		local
			yyval133: detachable ET_WHEN_PART_LIST
		do
--|#line 3317 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3317")
end

			yyval133 := ast_factory.new_when_part_list (counter_value)
			if yyval133 /= Void and attached yyvs132.item (yyvsp132) as l_when_part then
				yyval133.put_first (l_when_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp133 := yyvsp133 + 1
	yyvsp132 := yyvsp132 -1
	if yyvsp133 >= yyvsc133 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs133")
		end
		yyvsc133 := yyvsc133 + yyInitial_yyvs_size
		yyvs133 := yyspecial_routines133.aliased_resized_area (yyvs133, yyvsc133)
	end
	yyspecial_routines133.force (yyvs133, yyval133, yyvsp133)
end
		end

	yy_do_action_653
			--|#line 3324 "et_eiffel_parser.y"
		local
			yyval133: detachable ET_WHEN_PART_LIST
		do
--|#line 3324 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3324")
end

			yyval133 := yyvs133.item (yyvsp133)
			if yyval133 /= Void and attached yyvs132.item (yyvsp132) as l_when_part then
				yyval133.put_first (l_when_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp132 := yyvsp132 -1
	yyspecial_routines133.force (yyvs133, yyval133, yyvsp133)
end
		end

	yy_do_action_654
			--|#line 3333 "et_eiffel_parser.y"
		local
			yyval132: detachable ET_WHEN_PART
		do
--|#line 3333 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3333")
end

			yyval132 := ast_factory.new_when_part (yyvs43.item (yyvsp43), yyvs47.item (yyvsp47))
			if yyval132 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp132 := yyvsp132 + 1
	yyvsp43 := yyvsp43 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp132 >= yyvsc132 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs132")
		end
		yyvsc132 := yyvsc132 + yyInitial_yyvs_size
		yyvs132 := yyspecial_routines132.aliased_resized_area (yyvs132, yyvsc132)
	end
	yyspecial_routines132.force (yyvs132, yyval132, yyvsp132)
end
		end

	yy_do_action_655
			--|#line 3342 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3342 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3342")
end

yyval43 := ast_factory.new_choice_list (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp43 := yyvsp43 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_656
			--|#line 3344 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3344 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3344")
end

			yyval43 := yyvs43.item (yyvsp43)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp43 := yyvsp43 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_657
			--|#line 3344 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3344 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3344")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp43 := yyvsp43 + 1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_658
			--|#line 3357 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3357 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3357")
end

			if attached yyvs40.item (yyvsp40) as l_choice then
				yyval43 := ast_factory.new_choice_list (last_keyword, counter_value + 1)
				if yyval43 /= Void then
					yyval43.put_first (l_choice)
				end
			else
				yyval43 := ast_factory.new_choice_list (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp43 := yyvsp43 + 1
	yyvsp40 := yyvsp40 -1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_659
			--|#line 3368 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3368 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3368")
end

			yyval43 := ast_factory.new_choice_list (last_keyword, counter_value)
			if yyval43 /= Void and attached yyvs42.item (yyvsp42) as l_choice then
				yyval43.put_first (l_choice)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp43 := yyvsp43 + 1
	yyvsp42 := yyvsp42 -1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_660
			--|#line 3376 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3376 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3376")
end

			yyval43 := yyvs43.item (yyvsp43)
			if yyval43 /= Void and attached yyvs42.item (yyvsp42) as l_choice then
				yyval43.put_first (l_choice)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp42 := yyvsp42 -1
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_661
			--|#line 3385 "et_eiffel_parser.y"
		local
			yyval42: detachable ET_CHOICE_ITEM
		do
--|#line 3385 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3385")
end

			yyval42 := ast_factory.new_choice_comma (yyvs40.item (yyvsp40), yyvs5.item (yyvsp5))
			if yyval42 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp42 := yyvsp42 + 1
	yyvsp40 := yyvsp40 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp42 >= yyvsc42 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs42")
		end
		yyvsc42 := yyvsc42 + yyInitial_yyvs_size
		yyvs42 := yyspecial_routines42.aliased_resized_area (yyvs42, yyvsc42)
	end
	yyspecial_routines42.force (yyvs42, yyval42, yyvsp42)
end
		end

	yy_do_action_662
			--|#line 3394 "et_eiffel_parser.y"
		local
			yyval40: detachable ET_CHOICE
		do
--|#line 3394 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3394")
end

yyval40 := yyvs41.item (yyvsp41) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp40 := yyvsp40 + 1
	yyvsp41 := yyvsp41 -1
	if yyvsp40 >= yyvsc40 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs40")
		end
		yyvsc40 := yyvsc40 + yyInitial_yyvs_size
		yyvs40 := yyspecial_routines40.aliased_resized_area (yyvs40, yyvsc40)
	end
	yyspecial_routines40.force (yyvs40, yyval40, yyvsp40)
end
		end

	yy_do_action_663
			--|#line 3396 "et_eiffel_parser.y"
		local
			yyval40: detachable ET_CHOICE
		do
--|#line 3396 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3396")
end

yyval40 := ast_factory.new_choice_range (yyvs41.item (yyvsp41 - 1), yyvs5.item (yyvsp5), yyvs41.item (yyvsp41)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp40 := yyvsp40 + 1
	yyvsp41 := yyvsp41 -2
	yyvsp5 := yyvsp5 -1
	if yyvsp40 >= yyvsc40 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs40")
		end
		yyvsc40 := yyvsc40 + yyInitial_yyvs_size
		yyvs40 := yyspecial_routines40.aliased_resized_area (yyvs40, yyvsc40)
	end
	yyspecial_routines40.force (yyvs40, yyval40, yyvsp40)
end
		end

	yy_do_action_664
			--|#line 3400 "et_eiffel_parser.y"
		local
			yyval41: detachable ET_CHOICE_CONSTANT
		do
--|#line 3400 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3400")
end

yyval41 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp41 := yyvsp41 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
		end

	yy_do_action_665
			--|#line 3402 "et_eiffel_parser.y"
		local
			yyval41: detachable ET_CHOICE_CONSTANT
		do
--|#line 3402 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3402")
end

yyval41 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp41 := yyvsp41 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
		end

	yy_do_action_666
			--|#line 3404 "et_eiffel_parser.y"
		local
			yyval41: detachable ET_CHOICE_CONSTANT
		do
--|#line 3404 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3404")
end

yyval41 := new_choice_attribute_constant (yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp41 := yyvsp41 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
		end

	yy_do_action_667
			--|#line 3406 "et_eiffel_parser.y"
		local
			yyval41: detachable ET_CHOICE_CONSTANT
		do
--|#line 3406 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3406")
end

yyval41 := yyvs121.item (yyvsp121) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp41 := yyvsp41 + 1
	yyvsp121 := yyvsp121 -1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
		end

	yy_do_action_668
			--|#line 3412 "et_eiffel_parser.y"
		local
			yyval92: detachable ET_INSPECT_EXPRESSION
		do
--|#line 3412 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3412")
end

yyval92 := ast_factory.new_inspect_expression (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 2), yyvs69.item (yyvsp69 - 1)), yyvs131.item (yyvsp131), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp92 := yyvsp92 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp69 := yyvsp69 -2
	yyvsp131 := yyvsp131 -1
	if yyvsp92 >= yyvsc92 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs92")
		end
		yyvsc92 := yyvsc92 + yyInitial_yyvs_size
		yyvs92 := yyspecial_routines92.aliased_resized_area (yyvs92, yyvsc92)
	end
	yyspecial_routines92.force (yyvs92, yyval92, yyvsp92)
end
		end

	yy_do_action_669
			--|#line 3414 "et_eiffel_parser.y"
		local
			yyval92: detachable ET_INSPECT_EXPRESSION
		do
--|#line 3414 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3414")
end

yyval92 := ast_factory.new_inspect_expression (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs131.item (yyvsp131), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp92 := yyvsp92 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp131 := yyvsp131 -1
	if yyvsp92 >= yyvsc92 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs92")
		end
		yyvsc92 := yyvsc92 + yyInitial_yyvs_size
		yyvs92 := yyspecial_routines92.aliased_resized_area (yyvs92, yyvsc92)
	end
	yyspecial_routines92.force (yyvs92, yyval92, yyvsp92)
end
		end

	yy_do_action_670
			--|#line 3418 "et_eiffel_parser.y"
		local
			yyval131: detachable ET_WHEN_EXPRESSION_LIST
		do
--|#line 3418 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3418")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp131 := yyvsp131 + 1
	if yyvsp131 >= yyvsc131 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs131")
		end
		yyvsc131 := yyvsc131 + yyInitial_yyvs_size
		yyvs131 := yyspecial_routines131.aliased_resized_area (yyvs131, yyvsc131)
	end
	yyspecial_routines131.force (yyvs131, yyval131, yyvsp131)
end
		end

	yy_do_action_671
			--|#line 3420 "et_eiffel_parser.y"
		local
			yyval131: detachable ET_WHEN_EXPRESSION_LIST
		do
--|#line 3420 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3420")
end

			yyval131 := yyvs131.item (yyvsp131)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines131.force (yyvs131, yyval131, yyvsp131)
end
		end

	yy_do_action_672
			--|#line 3427 "et_eiffel_parser.y"
		local
			yyval131: detachable ET_WHEN_EXPRESSION_LIST
		do
--|#line 3427 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3427")
end

			yyval131 := ast_factory.new_when_expression_list (counter_value)
			if yyval131 /= Void and attached yyvs130.item (yyvsp130) as l_when_part then
				yyval131.put_first (l_when_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp131 := yyvsp131 + 1
	yyvsp130 := yyvsp130 -1
	if yyvsp131 >= yyvsc131 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs131")
		end
		yyvsc131 := yyvsc131 + yyInitial_yyvs_size
		yyvs131 := yyspecial_routines131.aliased_resized_area (yyvs131, yyvsc131)
	end
	yyspecial_routines131.force (yyvs131, yyval131, yyvsp131)
end
		end

	yy_do_action_673
			--|#line 3434 "et_eiffel_parser.y"
		local
			yyval131: detachable ET_WHEN_EXPRESSION_LIST
		do
--|#line 3434 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3434")
end

			yyval131 := yyvs131.item (yyvsp131)
			if yyval131 /= Void and attached yyvs130.item (yyvsp130) as l_when_part then
				yyval131.put_first (l_when_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp130 := yyvsp130 -1
	yyspecial_routines131.force (yyvs131, yyval131, yyvsp131)
end
		end

	yy_do_action_674
			--|#line 3443 "et_eiffel_parser.y"
		local
			yyval130: detachable ET_WHEN_EXPRESSION
		do
--|#line 3443 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3443")
end

			yyval130 := ast_factory.new_when_expression (yyvs43.item (yyvsp43), yyvs2.item (yyvsp2), yyvs69.item (yyvsp69))
			if yyval130 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp130 := yyvsp130 + 1
	yyvsp43 := yyvsp43 -1
	yyvsp2 := yyvsp2 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp130 >= yyvsc130 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs130")
		end
		yyvsc130 := yyvsc130 + yyInitial_yyvs_size
		yyvs130 := yyspecial_routines130.aliased_resized_area (yyvs130, yyvsc130)
	end
	yyspecial_routines130.force (yyvs130, yyval130, yyvsp130)
end
		end

	yy_do_action_675
			--|#line 3454 "et_eiffel_parser.y"
		local
			yyval25: detachable ET_ACROSS_INSTRUCTION
		do
--|#line 3454 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3454")
end

yyval25 := new_across_instruction_header (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp25 := yyvsp25 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp25 >= yyvsc25 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs25")
		end
		yyvsc25 := yyvsc25 + yyInitial_yyvs_size
		yyvs25 := yyspecial_routines25.aliased_resized_area (yyvs25, yyvsc25)
	end
	yyspecial_routines25.force (yyvs25, yyval25, yyvsp25)
end
		end

	yy_do_action_676
			--|#line 3456 "et_eiffel_parser.y"
		local
			yyval25: detachable ET_ACROSS_INSTRUCTION
		do
--|#line 3456 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3456")
end

yyval25 := new_across_instruction_header (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp25 := yyvsp25 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp25 >= yyvsc25 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs25")
		end
		yyvsc25 := yyvsc25 + yyInitial_yyvs_size
		yyvs25 := yyspecial_routines25.aliased_resized_area (yyvs25, yyvsc25)
	end
	yyspecial_routines25.force (yyvs25, yyval25, yyvsp25)
end
		end

	yy_do_action_677
			--|#line 3460 "et_eiffel_parser.y"
		local
			yyval120: detachable ET_REPEAT_INSTRUCTION
		do
--|#line 3460 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3460")
end

yyval120 := new_repeat_instruction_header (yyvs5.item (yyvsp5 - 2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs69.item (yyvsp69), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp120 := yyvsp120 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp12 := yyvsp12 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp120 >= yyvsc120 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs120")
		end
		yyvsc120 := yyvsc120 + yyInitial_yyvs_size
		yyvs120 := yyspecial_routines120.aliased_resized_area (yyvs120, yyvsc120)
	end
	yyspecial_routines120.force (yyvs120, yyval120, yyvsp120)
end
		end

	yy_do_action_678
			--|#line 3464 "et_eiffel_parser.y"
		local
			yyval48: detachable ET_CONDITIONAL
		do
--|#line 3464 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3464")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp48 := yyvsp48 + 1
	if yyvsp48 >= yyvsc48 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs48")
		end
		yyvsc48 := yyvsc48 + yyInitial_yyvs_size
		yyvs48 := yyspecial_routines48.aliased_resized_area (yyvs48, yyvsc48)
	end
	yyspecial_routines48.force (yyvs48, yyval48, yyvsp48)
end
		end

	yy_do_action_679
			--|#line 3466 "et_eiffel_parser.y"
		local
			yyval48: detachable ET_CONDITIONAL
		do
--|#line 3466 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3466")
end

yyval48 := ast_factory.new_conditional (yyvs2.item (yyvsp2), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp48 := yyvsp48 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp48 >= yyvsc48 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs48")
		end
		yyvsc48 := yyvsc48 + yyInitial_yyvs_size
		yyvs48 := yyspecial_routines48.aliased_resized_area (yyvs48, yyvsc48)
	end
	yyspecial_routines48.force (yyvs48, yyval48, yyvsp48)
end
		end

	yy_do_action_680
			--|#line 3472 "et_eiffel_parser.y"
		local
			yyval62: detachable ET_DEBUG_INSTRUCTION
		do
--|#line 3472 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3472")
end

yyval62 := ast_factory.new_debug_instruction (yyvs104.item (yyvsp104), ast_factory.new_debug_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47)), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp62 := yyvsp62 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp62 >= yyvsc62 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs62")
		end
		yyvsc62 := yyvsc62 + yyInitial_yyvs_size
		yyvs62 := yyspecial_routines62.aliased_resized_area (yyvs62, yyvsc62)
	end
	yyspecial_routines62.force (yyvs62, yyval62, yyvsp62)
end
		end

	yy_do_action_681
			--|#line 3476 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3476 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3476")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp104 := yyvsp104 + 1
	if yyvsp104 >= yyvsc104 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs104")
		end
		yyvsc104 := yyvsc104 + yyInitial_yyvs_size
		yyvs104 := yyspecial_routines104.aliased_resized_area (yyvs104, yyvsc104)
	end
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_682
			--|#line 3478 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3478 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3478")
end

yyval104 := ast_factory.new_manifest_string_list (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp104 := yyvsp104 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp104 >= yyvsc104 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs104")
		end
		yyvsc104 := yyvsc104 + yyInitial_yyvs_size
		yyvs104 := yyspecial_routines104.aliased_resized_area (yyvs104, yyvsc104)
	end
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_683
			--|#line 3480 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3480 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3480")
end

			yyval104 := yyvs104.item (yyvsp104)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp104 := yyvsp104 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_684
			--|#line 3480 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3480 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3480")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp104 := yyvsp104 + 1
	if yyvsp104 >= yyvsc104 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs104")
		end
		yyvsc104 := yyvsc104 + yyInitial_yyvs_size
		yyvs104 := yyspecial_routines104.aliased_resized_area (yyvs104, yyvsc104)
	end
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_685
			--|#line 3493 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3493 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3493")
end

			if attached yyvs15.item (yyvsp15) as l_manifest_string then
				yyval104 := ast_factory.new_manifest_string_list (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval104 /= Void then
					yyval104.put_first (l_manifest_string)
				end
			else
				yyval104 := ast_factory.new_manifest_string_list (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp104 := yyvsp104 + 1
	yyvsp15 := yyvsp15 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp104 >= yyvsc104 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs104")
		end
		yyvsc104 := yyvsc104 + yyInitial_yyvs_size
		yyvs104 := yyspecial_routines104.aliased_resized_area (yyvs104, yyvsc104)
	end
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_686
			--|#line 3504 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3504 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3504")
end

			yyval104 := yyvs104.item (yyvsp104)
			if yyval104 /= Void and attached yyvs103.item (yyvsp103) as l_manifest_string then
				yyval104.put_first (l_manifest_string)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp103 := yyvsp103 -1
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_687
			--|#line 3513 "et_eiffel_parser.y"
		local
			yyval103: detachable ET_MANIFEST_STRING_ITEM
		do
--|#line 3513 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3513")
end

			yyval103 := ast_factory.new_manifest_string_comma (yyvs15.item (yyvsp15), yyvs5.item (yyvsp5))
			if yyval103 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp103 := yyvsp103 + 1
	yyvsp15 := yyvsp15 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp103 >= yyvsc103 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs103")
		end
		yyvsc103 := yyvsc103 + yyInitial_yyvs_size
		yyvs103 := yyspecial_routines103.aliased_resized_area (yyvs103, yyvsc103)
	end
	yyspecial_routines103.force (yyvs103, yyval103, yyvsp103)
end
		end

	yy_do_action_688
			--|#line 3524 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3524 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3524")
end

yyval94 := new_unqualified_call_instruction (yyvs12.item (yyvsp12), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp94 := yyvsp94 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_689
			--|#line 3526 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3526 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3526")
end

yyval94 := ast_factory.new_qualified_call_instruction (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp94 := yyvsp94 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_690
			--|#line 3528 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3528 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3528")
end

yyval94 := ast_factory.new_qualified_call_instruction (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp94 := yyvsp94 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_691
			--|#line 3530 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3530 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3530")
end

yyval94 := ast_factory.new_precursor_instruction (False, yyvs4.item (yyvsp4), Void, yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp94 := yyvsp94 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_692
			--|#line 3532 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3532 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3532")
end

yyval94 := ast_factory.new_precursor_instruction (False, yyvs4.item (yyvsp4), ast_factory.new_precursor_class_name (yyvs5.item (yyvsp5 - 1), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp94 := yyvsp94 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp5 := yyvsp5 -2
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_693
			--|#line 3534 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3534 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3534")
end

yyval94 := ast_factory.new_static_call_instruction (yyvs2.item (yyvsp2), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1)), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp94 := yyvsp94 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_694
			--|#line 3536 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INSTRUCTION
		do
--|#line 3536 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3536")
end

yyval94 := ast_factory.new_static_call_instruction (Void, ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1)), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp94 := yyvsp94 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_695
			--|#line 3540 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3540 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3540")
end

yyval69 := new_unqualified_call_expression (yyvs12.item (yyvsp12), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_696
			--|#line 3542 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3542 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3542")
end

yyval69 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_697
			--|#line 3546 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3546 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3546")
end

yyval69 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_698
			--|#line 3550 "et_eiffel_parser.y"
		local
			yyval38: detachable ET_QUALIFIED_CALL_EXPRESSION
		do
--|#line 3550 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3550")
end

yyval38 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp38 := yyvsp38 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
		end

	yy_do_action_699
			--|#line 3552 "et_eiffel_parser.y"
		local
			yyval38: detachable ET_QUALIFIED_CALL_EXPRESSION
		do
--|#line 3552 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3552")
end

yyval38 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp38 := yyvsp38 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
		end

	yy_do_action_700
			--|#line 3556 "et_eiffel_parser.y"
		local
			yyval121: detachable ET_STATIC_CALL_EXPRESSION
		do
--|#line 3556 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3556")
end

yyval121 := ast_factory.new_static_call_expression (yyvs2.item (yyvsp2), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1)), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp121 := yyvsp121 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp121 >= yyvsc121 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs121")
		end
		yyvsc121 := yyvsc121 + yyInitial_yyvs_size
		yyvs121 := yyspecial_routines121.aliased_resized_area (yyvs121, yyvsc121)
	end
	yyspecial_routines121.force (yyvs121, yyval121, yyvsp121)
end
		end

	yy_do_action_701
			--|#line 3558 "et_eiffel_parser.y"
		local
			yyval121: detachable ET_STATIC_CALL_EXPRESSION
		do
--|#line 3558 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3558")
end

yyval121 := ast_factory.new_static_call_expression (Void, ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5 - 1)), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp121 := yyvsp121 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp121 >= yyvsc121 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs121")
		end
		yyvsc121 := yyvsc121 + yyInitial_yyvs_size
		yyvs121 := yyspecial_routines121.aliased_resized_area (yyvs121, yyvsc121)
	end
	yyspecial_routines121.force (yyvs121, yyval121, yyvsp121)
end
		end

	yy_do_action_702
			--|#line 3562 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3562 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3562")
end

yyval69 := ast_factory.new_precursor_expression (False, yyvs4.item (yyvsp4), Void, yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_703
			--|#line 3564 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3564 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3564")
end

yyval69 := ast_factory.new_precursor_expression (False, yyvs4.item (yyvsp4), ast_factory.new_precursor_class_name (yyvs5.item (yyvsp5 - 1), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp69 := yyvsp69 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp5 := yyvsp5 -2
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_704
			--|#line 3568 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3568 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3568")
end

yyval69 := new_unqualified_call_expression (yyvs12.item (yyvsp12), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_705
			--|#line 3570 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3570 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3570")
end

yyval69 := yyvs17.item (yyvsp17) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp17 := yyvsp17 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_706
			--|#line 3572 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3572 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3572")
end

yyval69 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_707
			--|#line 3574 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3574 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3574")
end

yyval69 := yyvs107.item (yyvsp107) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp107 := yyvsp107 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_708
			--|#line 3576 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3576 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3576")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_709
			--|#line 3578 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3578 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3578")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_710
			--|#line 3580 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3580 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3580")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval69 := yyvs36.item (yyvsp36)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_711
			--|#line 3588 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3588 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3588")
end

yyval69 := yyvs121.item (yyvsp121) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp121 := yyvsp121 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_712
			--|#line 3590 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3590 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3590")
end

yyval69 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_713
			--|#line 3594 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3594 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3594")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval69 := yyvs36.item (yyvsp36)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_714
			--|#line 3602 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3602 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3602")
end

yyval69 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_715
			--|#line 3608 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3608 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3608")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp26 := yyvsp26 + 1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_716
			--|#line 3610 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3610 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3610")
end

yyval26 := ast_factory.new_actual_arguments (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_717
			--|#line 3612 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3612 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3612")
end

			yyval26 := yyvs26.item (yyvsp26)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp26 := yyvsp26 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_718
			--|#line 3612 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3612 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3612")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp26 := yyvsp26 + 1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_719
			--|#line 3625 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3625 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3625")
end

			if attached yyvs69.item (yyvsp69) as l_expression then
				yyval26 := ast_factory.new_actual_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval26 /= Void then
					yyval26.put_first (l_expression)
				end
			else
				yyval26 := ast_factory.new_actual_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_720
			--|#line 3636 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3636 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3636")
end

			yyval26 := ast_factory.new_actual_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval26 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval26.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp70 := yyvsp70 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_721
			--|#line 3644 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3644 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3644")
end

			yyval26 := yyvs26.item (yyvsp26)
			if yyval26 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval26.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 -1
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_722
			--|#line 3653 "et_eiffel_parser.y"
		local
			yyval70: detachable ET_EXPRESSION_ITEM
		do
--|#line 3653 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3653")
end

			yyval70 := ast_factory.new_expression_comma (yyvs69.item (yyvsp69), yyvs5.item (yyvsp5))
			if yyval70 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp70 >= yyvsc70 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs70")
		end
		yyvsc70 := yyvsc70 + yyInitial_yyvs_size
		yyvs70 := yyspecial_routines70.aliased_resized_area (yyvs70, yyvsc70)
	end
	yyspecial_routines70.force (yyvs70, yyval70, yyvsp70)
end
		end

	yy_do_action_723
			--|#line 3662 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3662 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3662")
end

yyval69 := new_feature_address (yyvs5.item (yyvsp5), yyvs76.item (yyvsp76)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp76 := yyvsp76 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_724
			--|#line 3664 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3664 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3664")
end

yyval69 := ast_factory.new_current_address (yyvs5.item (yyvsp5), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_725
			--|#line 3666 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3666 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3666")
end

yyval69 := ast_factory.new_result_address (yyvs5.item (yyvsp5), yyvs17.item (yyvsp17)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp17 := yyvsp17 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_726
			--|#line 3668 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3668 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3668")
end

yyval69 := ast_factory.new_expression_address (yyvs5.item (yyvsp5), yyvs107.item (yyvsp107)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp107 := yyvsp107 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_727
			--|#line 3675 "et_eiffel_parser.y"
		local
			yyval134: detachable ET_WRITABLE
		do
--|#line 3675 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3675")
end

yyval134 := new_writable (yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp134 := yyvsp134 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp134 >= yyvsc134 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs134")
		end
		yyvsc134 := yyvsc134 + yyInitial_yyvs_size
		yyvs134 := yyspecial_routines134.aliased_resized_area (yyvs134, yyvsc134)
	end
	yyspecial_routines134.force (yyvs134, yyval134, yyvsp134)
end
		end

	yy_do_action_728
			--|#line 3677 "et_eiffel_parser.y"
		local
			yyval134: detachable ET_WRITABLE
		do
--|#line 3677 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3677")
end

yyval134 := yyvs17.item (yyvsp17) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp134 := yyvsp134 + 1
	yyvsp17 := yyvsp17 -1
	if yyvsp134 >= yyvsc134 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs134")
		end
		yyvsc134 := yyvsc134 + yyInitial_yyvs_size
		yyvs134 := yyspecial_routines134.aliased_resized_area (yyvs134, yyvsc134)
	end
	yyspecial_routines134.force (yyvs134, yyval134, yyvsp134)
end
		end

	yy_do_action_729
			--|#line 3683 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3683 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3683")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_730
			--|#line 3685 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3685 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3685")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_731
			--|#line 3689 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3689 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3689")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_free_operator (yyvs11.item (yyvsp11)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp11 := yyvsp11 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_732
			--|#line 3691 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3691 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3691")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_free_operator_from_symbol (yyvs5.item (yyvsp5)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_733
			--|#line 3693 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3693 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3693")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_plus_operator (yyvs19.item (yyvsp19)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_734
			--|#line 3695 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3695 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3695")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_minus_operator (yyvs19.item (yyvsp19)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_735
			--|#line 3697 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3697 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3697")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_736
			--|#line 3699 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3699 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3699")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_737
			--|#line 3701 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3701 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3701")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_738
			--|#line 3703 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3703 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3703")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_739
			--|#line 3705 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3705 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3705")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_740
			--|#line 3707 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3707 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3707")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_741
			--|#line 3709 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3709 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3709")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_742
			--|#line 3711 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3711 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3711")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_743
			--|#line 3713 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3713 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3713")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_744
			--|#line 3715 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3715 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3715")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_745
			--|#line 3717 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3717 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3717")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_746
			--|#line 3719 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3719 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3719")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_747
			--|#line 3721 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3721 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3721")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_748
			--|#line 3723 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3723 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3723")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_749
			--|#line 3725 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3725 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3725")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_750
			--|#line 3727 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3727 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3727")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_and_then_operator (yyvs14.item (yyvsp14), yyvs2.item (yyvsp2)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_751
			--|#line 3729 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3729 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3729")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_752
			--|#line 3731 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3731 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3731")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_or_else_operator (yyvs14.item (yyvsp14), yyvs2.item (yyvsp2)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_753
			--|#line 3733 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3733 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3733")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_754
			--|#line 3735 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3735 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3735")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_755
			--|#line 3737 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3737 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3737")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_756
			--|#line 3739 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3739 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3739")
end

yyval69 := ast_factory.new_equality_expression (yyvs69.item (yyvsp69 - 1), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_757
			--|#line 3741 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3741 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3741")
end

yyval69 := ast_factory.new_equality_expression (yyvs69.item (yyvsp69 - 1), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_758
			--|#line 3743 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3743 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3743")
end

yyval69 := ast_factory.new_object_equality_expression (yyvs69.item (yyvsp69 - 1), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_759
			--|#line 3745 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3745 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3745")
end

yyval69 := ast_factory.new_object_equality_expression (yyvs69.item (yyvsp69 - 1), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_760
			--|#line 3749 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3749 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3749")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_761
			--|#line 3751 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3751 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3751")
end

yyval69 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_762
			--|#line 3753 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3753 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3753")
end

yyval69 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_763
			--|#line 3755 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3755 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3755")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_764
			--|#line 3757 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3757 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3757")
end

yyval69 := yyvs36.item (yyvsp36) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_765
			--|#line 3759 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3759 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3759")
end

yyval69 := ast_factory.new_manifest_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_766
			--|#line 3763 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3763 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3763")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_767
			--|#line 3765 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3765 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3765")
end

yyval69 := yyvs36.item (yyvsp36) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_768
			--|#line 3767 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3767 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3767")
end

yyval69 := yyvs58.item (yyvsp58) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp58 := yyvsp58 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_769
			--|#line 3769 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3769 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3769")
end

yyval69 := yyvs24.item (yyvsp24) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp24 := yyvsp24 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_770
			--|#line 3771 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3771 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3771")
end

yyval69 := yyvs24.item (yyvsp24) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp24 := yyvsp24 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_771
			--|#line 3773 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3773 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3773")
end

yyval69 := yyvs116.item (yyvsp116) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp116 := yyvsp116 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_772
			--|#line 3775 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3775 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3775")
end

yyval69 := yyvs84.item (yyvsp84) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp84 := yyvsp84 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_773
			--|#line 3777 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3777 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3777")
end

yyval69 := yyvs92.item (yyvsp92) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp92 := yyvsp92 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_774
			--|#line 3779 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3779 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3779")
end

yyval69 := yyvs105.item (yyvsp105) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp105 := yyvsp105 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_775
			--|#line 3781 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3781 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3781")
end

yyval69 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_776
			--|#line 3783 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3783 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3783")
end

yyval69 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_777
			--|#line 3785 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3785 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3785")
end

yyval69 := new_prefix_plus_expression (yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_778
			--|#line 3787 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3787 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3787")
end

yyval69 := new_prefix_minus_expression (yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_779
			--|#line 3789 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3789 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3789")
end

yyval69 := ast_factory.new_prefix_expression (yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_780
			--|#line 3791 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3791 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3791")
end

yyval69 := ast_factory.new_prefix_expression (yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_781
			--|#line 3793 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3793 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3793")
end

yyval69 := ast_factory.new_prefix_expression (ast_factory.new_prefix_free_operator (yyvs11.item (yyvsp11)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp11 := yyvsp11 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_782
			--|#line 3795 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3795 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3795")
end

yyval69 := ast_factory.new_old_expression (yyvs2.item (yyvsp2), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_783
			--|#line 3797 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3797 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3797")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval69 := new_old_object_test (yyvs5.item (yyvsp5 - 2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp5 := yyvsp5 -3
	yyvsp12 := yyvsp12 -1
	yyvsp123 := yyvsp123 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_784
			--|#line 3805 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3805 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3805")
end

yyval69 := ast_factory.new_object_test (yyvs2.item (yyvsp2), Void, yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_785
			--|#line 3807 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3807 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3807")
end

yyval69 := ast_factory.new_object_test (yyvs2.item (yyvsp2), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_786
			--|#line 3809 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3809 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3809")
end

yyval69 := new_named_object_test (yyvs2.item (yyvsp2 - 1), Void, yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_787
			--|#line 3811 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3811 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3811")
end

yyval69 := new_named_object_test (yyvs2.item (yyvsp2 - 1), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyvsp12 := yyvsp12 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_788
			--|#line 3815 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3815 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3815")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_789
			--|#line 3817 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3817 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3817")
end

yyval69 := yyvs121.item (yyvsp121) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp121 := yyvsp121 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_790
			--|#line 3819 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3819 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3819")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_791
			--|#line 3821 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3821 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3821")
end

yyval69 := yyvs17.item (yyvsp17) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp17 := yyvsp17 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_792
			--|#line 3823 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3823 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3823")
end

yyval69 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_793
			--|#line 3825 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3825 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3825")
end

yyval69 := yyvs107.item (yyvsp107) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp107 := yyvsp107 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_794
			--|#line 3827 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3827 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3827")
end

yyval69 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_795
			--|#line 3829 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3829 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3829")
end

yyval69 := yyvs37.item (yyvsp37) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp37 := yyvsp37 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_796
			--|#line 3831 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3831 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3831")
end

yyval69 := yyvs91.item (yyvsp91) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp91 := yyvsp91 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_797
			--|#line 3833 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3833 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3833")
end

yyval69 := yyvs20.item (yyvsp20) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp20 := yyvsp20 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_798
			--|#line 3835 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3835 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3835")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_799
			--|#line 3837 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3837 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3837")
end

yyval69 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_800
			--|#line 3839 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3839 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3839")
end

yyval69 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_801
			--|#line 3841 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3841 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3841")
end

yyval69 := new_once_manifest_string (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_802
			--|#line 3874 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3874 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3874")
end

yyval69 := yyvs102.item (yyvsp102) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp102 := yyvsp102 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_803
			--|#line 3876 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3876 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3876")
end

yyval69 := yyvs122.item (yyvsp122) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp122 := yyvsp122 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_804
			--|#line 3878 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3878 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3878")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_805
			--|#line 3882 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3882 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3882")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_806
			--|#line 3884 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3884 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3884")
end

yyval69 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_807
			--|#line 3886 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3886 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3886")
end

			if system_processor.older_ise_version (ise_17_11_0) then
				raise_error
			else
				yyval69 := yyvs102.item (yyvsp102)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp102 := yyvsp102 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_808
			--|#line 3894 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3894 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3894")
end

yyval69 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_809
			--|#line 3898 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3898 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3898")
end

yyval36 := yyvs36.item (yyvsp36) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_810
			--|#line 3900 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3900 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3900")
end

yyval36 := yyvs36.item (yyvsp36) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_811
			--|#line 3904 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3904 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3904")
end

			yyval36 := ast_factory.new_bracket_expression (yyvs69.item (yyvsp69), yyvs22.item (yyvsp22), yyvs26.item (yyvsp26))
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp69 := yyvsp69 -1
	yyvsp22 := yyvsp22 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_812
			--|#line 3904 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3904 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3904")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_813
			--|#line 3915 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3915 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3915")
end

			yyval36 := ast_factory.new_bracket_expression (yyvs36.item (yyvsp36 - 1), yyvs22.item (yyvsp22), yyvs26.item (yyvsp26))
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp36 := yyvsp36 -1
	yyvsp22 := yyvsp22 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_814
			--|#line 3915 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3915 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3915")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_815
			--|#line 3928 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3928 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3928")
end

			yyval36 := ast_factory.new_bracket_expression (yyvs69.item (yyvsp69), yyvs22.item (yyvsp22), yyvs26.item (yyvsp26))
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp69 := yyvsp69 -1
	yyvsp22 := yyvsp22 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_816
			--|#line 3928 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3928 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3928")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_817
			--|#line 3939 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3939 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3939")
end

			yyval36 := ast_factory.new_bracket_expression (yyvs36.item (yyvsp36 - 1), yyvs22.item (yyvsp22), yyvs26.item (yyvsp26))
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp36 := yyvsp36 -1
	yyvsp22 := yyvsp22 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_818
			--|#line 3939 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3939 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3939")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_819
			--|#line 3952 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3952 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3952")
end

			if attached yyvs69.item (yyvsp69) as l_expression then
				yyval26 := ast_factory.new_bracket_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval26 /= Void then
					yyval26.put_first (l_expression)
				end
			else
				yyval26 := ast_factory.new_bracket_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_820
			--|#line 3963 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3963 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3963")
end

			yyval26 := ast_factory.new_bracket_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval26 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval26.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp70 := yyvsp70 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_821
			--|#line 3971 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3971 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3971")
end

			yyval26 := yyvs26.item (yyvsp26)
			if yyval26 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval26.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 -1
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_822
			--|#line 3980 "et_eiffel_parser.y"
		local
			yyval107: detachable ET_PARENTHESIZED_EXPRESSION
		do
--|#line 3980 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3980")
end

			remove_symbol
			remove_counter
		 	yyval107 := ast_factory.new_parenthesized_expression (yyvs5.item (yyvsp5 - 1), yyvs69.item (yyvsp69), yyvs5.item (yyvsp5))
		 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp107 := yyvsp107 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp69 := yyvsp69 -1
	if yyvsp107 >= yyvsc107 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs107")
		end
		yyvsc107 := yyvsc107 + yyInitial_yyvs_size
		yyvs107 := yyspecial_routines107.aliased_resized_area (yyvs107, yyvsc107)
	end
	yyspecial_routines107.force (yyvs107, yyval107, yyvsp107)
end
		end

	yy_do_action_823
			--|#line 3988 "et_eiffel_parser.y"
		local
			yyval102: detachable ET_MANIFEST_ARRAY
		do
--|#line 3988 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3988")
end

yyval102 := ast_factory.new_manifest_array (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp102 := yyvsp102 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp102 >= yyvsc102 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs102")
		end
		yyvsc102 := yyvsc102 + yyInitial_yyvs_size
		yyvs102 := yyspecial_routines102.aliased_resized_area (yyvs102, yyvsc102)
	end
	yyspecial_routines102.force (yyvs102, yyval102, yyvsp102)
end
		end

	yy_do_action_824
			--|#line 3990 "et_eiffel_parser.y"
		local
			yyval102: detachable ET_MANIFEST_ARRAY
		do
--|#line 3990 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3990")
end

			yyval102 := yyvs102.item (yyvsp102)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp102 := yyvsp102 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines102.force (yyvs102, yyval102, yyvsp102)
end
		end

	yy_do_action_825
			--|#line 3990 "et_eiffel_parser.y"
		local
			yyval102: detachable ET_MANIFEST_ARRAY
		do
--|#line 3990 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3990")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp102 := yyvsp102 + 1
	if yyvsp102 >= yyvsc102 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs102")
		end
		yyvsc102 := yyvsc102 + yyInitial_yyvs_size
		yyvs102 := yyspecial_routines102.aliased_resized_area (yyvs102, yyvsc102)
	end
	yyspecial_routines102.force (yyvs102, yyval102, yyvsp102)
end
		end

	yy_do_action_826
			--|#line 4003 "et_eiffel_parser.y"
		local
			yyval102: detachable ET_MANIFEST_ARRAY
		do
--|#line 4003 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4003")
end

			yyval102 := yyvs102.item (yyvsp102)
			if yyval102 /= Void then
				yyval102.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyspecial_routines102.force (yyvs102, yyval102, yyvsp102)
end
		end

	yy_do_action_827
			--|#line 4012 "et_eiffel_parser.y"
		local
			yyval102: detachable ET_MANIFEST_ARRAY
		do
--|#line 4012 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4012")
end

			if attached yyvs69.item (yyvsp69) as l_expression then
				yyval102 := ast_factory.new_manifest_array (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval102 /= Void then
					yyval102.put_first (l_expression)
				end
			else
				yyval102 := ast_factory.new_manifest_array (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp102 := yyvsp102 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp102 >= yyvsc102 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs102")
		end
		yyvsc102 := yyvsc102 + yyInitial_yyvs_size
		yyvs102 := yyspecial_routines102.aliased_resized_area (yyvs102, yyvsc102)
	end
	yyspecial_routines102.force (yyvs102, yyval102, yyvsp102)
end
		end

	yy_do_action_828
			--|#line 4023 "et_eiffel_parser.y"
		local
			yyval102: detachable ET_MANIFEST_ARRAY
		do
--|#line 4023 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4023")
end

			yyval102 := ast_factory.new_manifest_array (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval102 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval102.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp102 := yyvsp102 + 1
	yyvsp70 := yyvsp70 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp102 >= yyvsc102 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs102")
		end
		yyvsc102 := yyvsc102 + yyInitial_yyvs_size
		yyvs102 := yyspecial_routines102.aliased_resized_area (yyvs102, yyvsc102)
	end
	yyspecial_routines102.force (yyvs102, yyval102, yyvsp102)
end
		end

	yy_do_action_829
			--|#line 4031 "et_eiffel_parser.y"
		local
			yyval102: detachable ET_MANIFEST_ARRAY
		do
--|#line 4031 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4031")
end

			yyval102 := yyvs102.item (yyvsp102)
			if yyval102 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval102.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 -1
	yyspecial_routines102.force (yyvs102, yyval102, yyvsp102)
end
		end

	yy_do_action_830
			--|#line 4040 "et_eiffel_parser.y"
		local
			yyval105: detachable ET_MANIFEST_TUPLE
		do
--|#line 4040 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4040")
end

yyval105 := ast_factory.new_manifest_tuple (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp105 := yyvsp105 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp105 >= yyvsc105 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs105")
		end
		yyvsc105 := yyvsc105 + yyInitial_yyvs_size
		yyvs105 := yyspecial_routines105.aliased_resized_area (yyvs105, yyvsc105)
	end
	yyspecial_routines105.force (yyvs105, yyval105, yyvsp105)
end
		end

	yy_do_action_831
			--|#line 4042 "et_eiffel_parser.y"
		local
			yyval105: detachable ET_MANIFEST_TUPLE
		do
--|#line 4042 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4042")
end

			yyval105 := yyvs105.item (yyvsp105)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp105 := yyvsp105 -1
	yyvsp22 := yyvsp22 -1
	yyspecial_routines105.force (yyvs105, yyval105, yyvsp105)
end
		end

	yy_do_action_832
			--|#line 4042 "et_eiffel_parser.y"
		local
			yyval105: detachable ET_MANIFEST_TUPLE
		do
--|#line 4042 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4042")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp105 := yyvsp105 + 1
	if yyvsp105 >= yyvsc105 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs105")
		end
		yyvsc105 := yyvsc105 + yyInitial_yyvs_size
		yyvs105 := yyspecial_routines105.aliased_resized_area (yyvs105, yyvsc105)
	end
	yyspecial_routines105.force (yyvs105, yyval105, yyvsp105)
end
		end

	yy_do_action_833
			--|#line 4055 "et_eiffel_parser.y"
		local
			yyval105: detachable ET_MANIFEST_TUPLE
		do
--|#line 4055 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4055")
end

			if attached yyvs69.item (yyvsp69) as l_expression then
				yyval105 := ast_factory.new_manifest_tuple (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval105 /= Void then
					yyval105.put_first (l_expression)
				end
			else
				yyval105 := ast_factory.new_manifest_tuple (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp105 := yyvsp105 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp105 >= yyvsc105 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs105")
		end
		yyvsc105 := yyvsc105 + yyInitial_yyvs_size
		yyvs105 := yyspecial_routines105.aliased_resized_area (yyvs105, yyvsc105)
	end
	yyspecial_routines105.force (yyvs105, yyval105, yyvsp105)
end
		end

	yy_do_action_834
			--|#line 4066 "et_eiffel_parser.y"
		local
			yyval105: detachable ET_MANIFEST_TUPLE
		do
--|#line 4066 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4066")
end

			yyval105 := ast_factory.new_manifest_tuple (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval105 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval105.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp105 := yyvsp105 + 1
	yyvsp70 := yyvsp70 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp105 >= yyvsc105 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs105")
		end
		yyvsc105 := yyvsc105 + yyInitial_yyvs_size
		yyvs105 := yyspecial_routines105.aliased_resized_area (yyvs105, yyvsc105)
	end
	yyspecial_routines105.force (yyvs105, yyval105, yyvsp105)
end
		end

	yy_do_action_835
			--|#line 4074 "et_eiffel_parser.y"
		local
			yyval105: detachable ET_MANIFEST_TUPLE
		do
--|#line 4074 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4074")
end

			yyval105 := yyvs105.item (yyvsp105)
			if yyval105 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval105.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 -1
	yyspecial_routines105.force (yyvs105, yyval105, yyvsp105)
end
		end

	yy_do_action_836
			--|#line 4083 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_STRIP_EXPRESSION
		do
--|#line 4083 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4083")
end

yyval122 := ast_factory.new_strip_expression (yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -2
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_837
			--|#line 4085 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_STRIP_EXPRESSION
		do
--|#line 4085 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4085")
end

			yyval122 := yyvs122.item (yyvsp122)
			remove_keyword
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 -1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_838
			--|#line 4085 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_STRIP_EXPRESSION
		do
--|#line 4085 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4085")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp122 := yyvsp122 + 1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_839
			--|#line 4100 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_STRIP_EXPRESSION
		do
--|#line 4100 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4100")
end

			if attached yyvs76.item (yyvsp76) as l_feature_name then
				yyval122 := ast_factory.new_strip_expression (last_keyword, last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval122 /= Void then
					yyval122.put_first (l_feature_name)
				end
			else
				yyval122 := ast_factory.new_strip_expression (last_keyword, last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp122 := yyvsp122 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_840
			--|#line 4111 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_STRIP_EXPRESSION
		do
--|#line 4111 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4111")
end

			yyval122 := ast_factory.new_strip_expression (last_keyword, last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval122 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval122.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp122 := yyvsp122 + 1
	yyvsp77 := yyvsp77 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_841
			--|#line 4119 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_STRIP_EXPRESSION
		do
--|#line 4119 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4119")
end

			yyval122 := yyvs122.item (yyvsp122)
			if yyval122 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval122.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_842
			--|#line 4128 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4128 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4128")
end

yyval49 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_843
			--|#line 4130 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4130 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4130")
end

yyval49 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_844
			--|#line 4132 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4132 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4132")
end

yyval49 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_845
			--|#line 4134 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4134 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4134")
end

yyval49 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_846
			--|#line 4136 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4136 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4136")
end

yyval49 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_847
			--|#line 4140 "et_eiffel_parser.y"
		local
			yyval24: detachable ET_ACROSS_EXPRESSION
		do
--|#line 4140 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4140")
end

yyval24 := new_across_some_expression (yyvs24.item (yyvsp24), yyvs101.item (yyvsp101), yyvs48.item (yyvsp48), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs129.item (yyvsp129), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp101 := yyvsp101 -1
	yyvsp48 := yyvsp48 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp129 := yyvsp129 -1
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
		end

	yy_do_action_848
			--|#line 4144 "et_eiffel_parser.y"
		local
			yyval24: detachable ET_ACROSS_EXPRESSION
		do
--|#line 4144 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4144")
end

yyval24 := new_across_all_expression (yyvs24.item (yyvsp24), yyvs101.item (yyvsp101), yyvs48.item (yyvsp48), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs129.item (yyvsp129), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp101 := yyvsp101 -1
	yyvsp48 := yyvsp48 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp129 := yyvsp129 -1
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
		end

	yy_do_action_849
			--|#line 4148 "et_eiffel_parser.y"
		local
			yyval24: detachable ET_ACROSS_EXPRESSION
		do
--|#line 4148 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4148")
end

yyval24 := new_across_expression_header (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp24 := yyvsp24 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp24 >= yyvsc24 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs24")
		end
		yyvsc24 := yyvsc24 + yyInitial_yyvs_size
		yyvs24 := yyspecial_routines24.aliased_resized_area (yyvs24, yyvsc24)
	end
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
		end

	yy_do_action_850
			--|#line 4150 "et_eiffel_parser.y"
		local
			yyval24: detachable ET_ACROSS_EXPRESSION
		do
--|#line 4150 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4150")
end

yyval24 := new_across_expression_header (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp24 := yyvsp24 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp24 >= yyvsc24 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs24")
		end
		yyvsc24 := yyvsc24 + yyInitial_yyvs_size
		yyvs24 := yyspecial_routines24.aliased_resized_area (yyvs24, yyvsc24)
	end
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
		end

	yy_do_action_851
			--|#line 4154 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUANTIFIER_EXPRESSION
		do
--|#line 4154 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4154")
end

yyval116 := new_quantifier_expression (yyvs116.item (yyvsp116), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 -1
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_852
			--|#line 4158 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUANTIFIER_EXPRESSION
		do
--|#line 4158 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4158")
end

yyval116 := new_for_all_quantifier_expression_header (yyvs5.item (yyvsp5 - 2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs69.item (yyvsp69), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp116 := yyvsp116 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp12 := yyvsp12 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_853
			--|#line 4160 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUANTIFIER_EXPRESSION
		do
--|#line 4160 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4160")
end

yyval116 := new_there_exists_quantifier_expression_header (yyvs5.item (yyvsp5 - 2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs69.item (yyvsp69), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp116 := yyvsp116 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp12 := yyvsp12 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_854
			--|#line 4164 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 4164 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4164")
end

			if current_universe.use_obsolete_syntax_mode then
				yyval69 := ast_factory.new_prefix_expression (ast_factory.new_prefix_free_operator_from_symbol (yyvs5.item (yyvsp5)), yyvs12.item (yyvsp12))
			else
				yyval69 := new_iteration_cursor (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_855
			--|#line 4176 "et_eiffel_parser.y"
		local
			yyval37: detachable ET_CALL_AGENT
		do
--|#line 4176 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4176")
end

yyval37 := ast_factory.new_call_agent (yyvs3.item (yyvsp3), Void, yyvs76.item (yyvsp76), yyvs31.item (yyvsp31)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp37 := yyvsp37 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp76 := yyvsp76 -1
	yyvsp31 := yyvsp31 -1
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
		end

	yy_do_action_856
			--|#line 4178 "et_eiffel_parser.y"
		local
			yyval37: detachable ET_CALL_AGENT
		do
--|#line 4178 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4178")
end

yyval37 := ast_factory.new_call_agent (yyvs3.item (yyvsp3), yyvs32.item (yyvsp32), ast_factory.new_dot_feature_name (yyvs5.item (yyvsp5), yyvs76.item (yyvsp76)), yyvs31.item (yyvsp31)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp37 := yyvsp37 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp32 := yyvsp32 -1
	yyvsp5 := yyvsp5 -1
	yyvsp76 := yyvsp76 -1
	yyvsp31 := yyvsp31 -1
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
		end

	yy_do_action_857
			--|#line 4182 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4182 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4182")
end

			set_inline_agent_actual_arguments (yyvs91.item (yyvsp91), yyvs31.item (yyvsp31))
			yyval91 := yyvs91.item (yyvsp91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 -1
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_858
			--|#line 4189 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4189 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4189")
end

			yyval91 := ast_factory.new_do_function_inline_agent (yyvs3.item (yyvsp3), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_859
			--|#line 4199 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4199 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4199")
end

			yyval91 := ast_factory.new_do_function_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_860
			--|#line 4205 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4205 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4205")
end

			yyval91 := ast_factory.new_once_function_inline_agent (yyvs3.item (yyvsp3), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -2
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_861
			--|#line 4211 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4211 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4211")
end

			yyval91 := ast_factory.new_once_function_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -2
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_862
			--|#line 4217 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4217 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4217")
end

			yyval91 := ast_factory.new_external_function_inline_agent (yyvs3.item (yyvsp3), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp113 := yyvsp113 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_863
			--|#line 4223 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4223 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4223")
end

			yyval91 := ast_factory.new_external_function_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs123.item (yyvsp123)), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp113 := yyvsp113 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_864
			--|#line 4229 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4229 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4229")
end

			yyval91 := ast_factory.new_do_procedure_inline_agent (yyvs3.item (yyvsp3), Void, yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_865
			--|#line 4235 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4235 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4235")
end

			yyval91 := ast_factory.new_do_procedure_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs47.item (yyvsp47 - 1), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_866
			--|#line 4241 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4241 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4241")
end

			yyval91 := ast_factory.new_once_procedure_inline_agent (yyvs3.item (yyvsp3), Void, yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -2
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_867
			--|#line 4247 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4247 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4247")
end

			yyval91 := ast_factory.new_once_procedure_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), yyvs113.item (yyvsp113), yyvs100.item (yyvsp100), yyvs104.item (yyvsp104), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs112.item (yyvsp112), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp113 := yyvsp113 -1
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -2
	yyvsp104 := yyvsp104 -1
	yyvsp47 := yyvsp47 -2
	yyvsp112 := yyvsp112 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_868
			--|#line 4252 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4252 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4252")
end

			yyval91 := ast_factory.new_external_procedure_inline_agent (yyvs3.item (yyvsp3), Void, yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp113 := yyvsp113 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_869
			--|#line 4258 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4258 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4258")
end

			yyval91 := ast_factory.new_external_procedure_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), yyvs113.item (yyvsp113), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp113 := yyvsp113 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp112 := yyvsp112 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_870
			--|#line 4266 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 4266 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4266")
end

			yyval80 := yyvs80.item (yyvsp80)
			set_start_closure (yyval80)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_871
			--|#line 4273 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 4273 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4273")
end

set_start_closure (Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_872
			--|#line 4277 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4277 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4277")
end

yyval32 := new_agent_identifier_target (yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_873
			--|#line 4279 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4279 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4279")
end

yyval32 := yyvs107.item (yyvsp107) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp107 := yyvsp107 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_874
			--|#line 4281 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4281 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4281")
end

yyval32 := yyvs17.item (yyvsp17) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp17 := yyvsp17 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_875
			--|#line 4283 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4283 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4283")
end

yyval32 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_876
			--|#line 4285 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4285 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4285")
end

yyval32 := ast_factory.new_agent_open_target (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp32 := yyvsp32 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_877
			--|#line 4289 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4289 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4289")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp31 := yyvsp31 + 1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_878
			--|#line 4291 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4291 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4291")
end

yyval31 := ast_factory.new_agent_argument_operands (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_879
			--|#line 4293 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4293 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4293")
end

			yyval31 := yyvs31.item (yyvsp31)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp31 := yyvsp31 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_880
			--|#line 4293 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4293 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4293")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp31 := yyvsp31 + 1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_881
			--|#line 4306 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4306 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4306")
end

			if attached yyvs29.item (yyvsp29) as l_agent_actual then
				yyval31 := ast_factory.new_agent_argument_operands (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval31 /= Void then
					yyval31.put_first (l_agent_actual)
				end
			else
				yyval31 := ast_factory.new_agent_argument_operands (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 + 1
	yyvsp29 := yyvsp29 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_882
			--|#line 4317 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4317 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4317")
end

			yyval31 := ast_factory.new_agent_argument_operands (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval31 /= Void and attached yyvs30.item (yyvsp30) as l_agent_actual then
				yyval31.put_first (l_agent_actual)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 + 1
	yyvsp30 := yyvsp30 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_883
			--|#line 4325 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4325 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4325")
end

			yyval31 := yyvs31.item (yyvsp31)
			if yyval31 /= Void and attached yyvs30.item (yyvsp30) as l_agent_actual then
				yyval31.put_first (l_agent_actual)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp30 := yyvsp30 -1
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_884
			--|#line 4334 "et_eiffel_parser.y"
		local
			yyval30: detachable ET_AGENT_ARGUMENT_OPERAND_ITEM
		do
--|#line 4334 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4334")
end

			yyval30 := ast_factory.new_agent_argument_operand_comma (yyvs29.item (yyvsp29), yyvs5.item (yyvsp5))
			if yyval30 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp30 := yyvsp30 + 1
	yyvsp29 := yyvsp29 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp30 >= yyvsc30 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs30")
		end
		yyvsc30 := yyvsc30 + yyInitial_yyvs_size
		yyvs30 := yyspecial_routines30.aliased_resized_area (yyvs30, yyvsc30)
	end
	yyspecial_routines30.force (yyvs30, yyval30, yyvsp30)
end
		end

	yy_do_action_885
			--|#line 4343 "et_eiffel_parser.y"
		local
			yyval29: detachable ET_AGENT_ARGUMENT_OPERAND
		do
--|#line 4343 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4343")
end

yyval29 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp29 := yyvsp29 + 1
	yyvsp69 := yyvsp69 -1
	if yyvsp29 >= yyvsc29 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs29")
		end
		yyvsc29 := yyvsc29 + yyInitial_yyvs_size
		yyvs29 := yyspecial_routines29.aliased_resized_area (yyvs29, yyvsc29)
	end
	yyspecial_routines29.force (yyvs29, yyval29, yyvsp29)
end
		end

	yy_do_action_886
			--|#line 4345 "et_eiffel_parser.y"
		local
			yyval29: detachable ET_AGENT_ARGUMENT_OPERAND
		do
--|#line 4345 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4345")
end

yyval29 := yyvs23.item (yyvsp23) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp29 := yyvsp29 + 1
	yyvsp23 := yyvsp23 -1
	if yyvsp29 >= yyvsc29 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs29")
		end
		yyvsc29 := yyvsc29 + yyInitial_yyvs_size
		yyvs29 := yyspecial_routines29.aliased_resized_area (yyvs29, yyvsc29)
	end
	yyspecial_routines29.force (yyvs29, yyval29, yyvsp29)
end
		end

	yy_do_action_887
			--|#line 4347 "et_eiffel_parser.y"
		local
			yyval29: detachable ET_AGENT_ARGUMENT_OPERAND
		do
--|#line 4347 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4347")
end

yyval29 := ast_factory.new_agent_typed_open_argument (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5), yyvs23.item (yyvsp23)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp29 := yyvsp29 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyvsp23 := yyvsp23 -1
	if yyvsp29 >= yyvsc29 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs29")
		end
		yyvsc29 := yyvsc29 + yyInitial_yyvs_size
		yyvs29 := yyspecial_routines29.aliased_resized_area (yyvs29, yyvsc29)
	end
	yyspecial_routines29.force (yyvs29, yyval29, yyvsp29)
end
		end

	yy_do_action_888
			--|#line 4353 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4353 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4353")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_889
			--|#line 4355 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4355 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4355")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_890
			--|#line 4359 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4359 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4359")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_891
			--|#line 4361 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4361 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4361")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_892
			--|#line 4363 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4363 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4363")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_893
			--|#line 4365 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4365 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4365")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_894
			--|#line 4367 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4367 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4367")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_895
			--|#line 4369 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4369 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4369")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_896
			--|#line 4371 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4371 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4371")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_897
			--|#line 4373 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4373 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4373")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_898
			--|#line 4375 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4375 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4375")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_899
			--|#line 4377 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4377 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4377")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_900
			--|#line 4379 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4379 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4379")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_901
			--|#line 4381 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4381 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4381")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_902
			--|#line 4383 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4383 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4383")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_903
			--|#line 4385 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4385 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4385")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_904
			--|#line 4387 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4387 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4387")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_905
			--|#line 4389 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4389 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4389")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_906
			--|#line 4391 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4391 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4391")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_907
			--|#line 4393 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4393 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4393")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_908
			--|#line 4395 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4395 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4395")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_909
			--|#line 4397 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4397 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4397")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_910
			--|#line 4399 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4399 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4399")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_911
			--|#line 4401 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4401 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4401")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_912
			--|#line 4403 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4403 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4403")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_913
			--|#line 4405 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4405 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4405")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_914
			--|#line 4407 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4407 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4407")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_915
			--|#line 4409 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4409 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4409")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_916
			--|#line 4411 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4411 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4411")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_917
			--|#line 4413 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4413 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4413")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_918
			--|#line 4415 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4415 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4415")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_919
			--|#line 4417 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4417 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4417")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_920
			--|#line 4419 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4419 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4419")
end

abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp15 := yyvsp15 + 1
	yyvsp6 := yyvsp6 -1
	if yyvsp15 >= yyvsc15 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs15")
		end
		yyvsc15 := yyvsc15 + yyInitial_yyvs_size
		yyvs15 := yyspecial_routines15.aliased_resized_area (yyvs15, yyvsc15)
	end
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_921
			--|#line 4423 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4423 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4423")
end

			yyval15 := yyvs15.item (yyvsp15)
			if yyval15 /= Void then
				yyval15.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_922
			--|#line 4432 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4432 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4432")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_923
			--|#line 4434 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4434 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4434")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_924
			--|#line 4438 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4438 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4438")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_925
			--|#line 4440 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4440 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4440")
end

abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp6 := yyvsp6 -1
	if yyvsp9 >= yyvsc9 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs9")
		end
		yyvsc9 := yyvsc9 + yyInitial_yyvs_size
		yyvs9 := yyspecial_routines9.aliased_resized_area (yyvs9, yyvsc9)
	end
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_926
			--|#line 4444 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4444 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4444")
end

			yyval9 := yyvs9.item (yyvsp9)
			if yyval9 /= Void then
				yyval9.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_927
			--|#line 4453 "et_eiffel_parser.y"
		local
			yyval7: detachable ET_BOOLEAN_CONSTANT
		do
--|#line 4453 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4453")
end

yyval7 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines7.force (yyvs7, yyval7, yyvsp7)
end
		end

	yy_do_action_928
			--|#line 4455 "et_eiffel_parser.y"
		local
			yyval7: detachable ET_BOOLEAN_CONSTANT
		do
--|#line 4455 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4455")
end

yyval7 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines7.force (yyvs7, yyval7, yyvsp7)
end
		end

	yy_do_action_929
			--|#line 4459 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4459 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4459")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_930
			--|#line 4461 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4461 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4461")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_931
			--|#line 4465 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4465 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4465")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_932
			--|#line 4467 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4467 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4467")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_933
			--|#line 4471 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4471 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4471")
end

			yyval13 := yyvs13.item (yyvsp13)
			if yyval13 /= Void then
				yyval13.set_sign (yyvs19.item (yyvsp19))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_934
			--|#line 4478 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4478 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4478")
end

			yyval13 := yyvs13.item (yyvsp13)
			if yyval13 /= Void then
				yyval13.set_sign (yyvs19.item (yyvsp19))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_935
			--|#line 4487 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4487 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4487")
end

			yyval13 := yyvs13.item (yyvsp13)
			if yyval13 /= Void then
				yyval13.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_936
			--|#line 4496 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4496 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4496")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_937
			--|#line 4498 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4498 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4498")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_938
			--|#line 4502 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4502 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4502")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_939
			--|#line 4504 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4504 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4504")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_940
			--|#line 4508 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4508 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4508")
end

			yyval16 := yyvs16.item (yyvsp16)
			if yyval16 /= Void then
				yyval16.set_sign (yyvs19.item (yyvsp19))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_941
			--|#line 4515 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4515 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4515")
end

			yyval16 := yyvs16.item (yyvsp16)
			if yyval16 /= Void then
				yyval16.set_sign (yyvs19.item (yyvsp19))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_942
			--|#line 4524 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4524 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4524")
end

			yyval16 := yyvs16.item (yyvsp16)
			if yyval16 /= Void then
				yyval16.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs123.item (yyvsp123), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp123 := yyvsp123 -1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_943
			--|#line 4533 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 4533 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4533")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_944
			--|#line 4535 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 4535 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4535")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_945
			--|#line 4537 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 4537 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4537")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_946
			--|#line 4543 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 4543 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4543")
end

add_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_error_action (yy_act: INTEGER)
			-- Execute error action.
		do
			if yy_act <= 199 then
				yy_do_error_action_0_199 (yy_act)
			elseif yy_act <= 399 then
				yy_do_error_action_200_399 (yy_act)
			elseif yy_act <= 599 then
				yy_do_error_action_400_599 (yy_act)
			elseif yy_act <= 799 then
				yy_do_error_action_600_799 (yy_act)
			elseif yy_act <= 999 then
				yy_do_error_action_800_999 (yy_act)
			elseif yy_act <= 1199 then
				yy_do_error_action_1000_1199 (yy_act)
			elseif yy_act <= 1399 then
				yy_do_error_action_1200_1399 (yy_act)
			elseif yy_act <= 1599 then
				yy_do_error_action_1400_1599 (yy_act)
			elseif yy_act <= 1799 then
				yy_do_error_action_1600_1799 (yy_act)
			elseif yy_act <= 1999 then
				yy_do_error_action_1800_1999 (yy_act)
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_0_199 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_200_399 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_400_599 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_600_799 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_800_999 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1000_1199 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1200_1399 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1400_1599 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1600_1799 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1800_1999 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			when 1815 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: SPECIAL [INTEGER]
			-- Template for `yytranslate'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 391)
			yytranslate_template_1 (an_array)
			yytranslate_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytranslate_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytranslate'.
		do
			yyarray_subcopy (an_array, <<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,  136,    2,    2,  134,    2,    2,    2,
			  129,  130,  122,  144,  132,  143,  135,  115,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,  131,  156,
			  119,  152,  117,  158,  142,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,  157,    2,  133,  121,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,  127,    2,  128,  153,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2, yyDummy>>,
			1, 200, 0)
		end

	yytranslate_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytranslate'.
		do
			yyarray_subcopy (an_array, <<
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,

			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
			  116,  118,  120,  123,  124,  125,  126,  137,  138,  139,
			  140,  141,  145,  146,  147,  148,  149,  150,  151,  154,
			  155,  159, yyDummy>>,
			1, 192, 200)
		end

	yyr1_template: SPECIAL [INTEGER]
			-- Template for `yyr1'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 946)
			yyr1_template_1 (an_array)
			yyr1_template_2 (an_array)
			yyr1_template_3 (an_array)
			yyr1_template_4 (an_array)
			yyr1_template_5 (an_array)
			Result := yyfixed_array (an_array)
		end

	yyr1_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			    0,  415,  415,  201,  416,  416,  417,  200,  418,  304,
			  304,  419,  304,  304,  420,  305,  305,  307,  307,  421,
			  307,  422,  311,  313,  312,  306,  306,  306,  424,  306,
			  425,  308,  310,  310,  309,  309,  316,  316,  314,  314,
			  314,  314,  314,  314,  314,  314,  315,  199,  199,  199,
			  199,  331,  331,  332,  332,  298,  298,  298,  426,  299,
			  299,  297,  296,  296,  296,  296,  296,  296,  296,  296,
			  296,  399,  399,  401,  427,  402,  402,  400,  237,  237,
			  428,  238,  238,  238,  235,  235,  234,  234,  429,  236,
			  236,  236,  239,  239,  239,  239,  239,  239,  239,  239,

			  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
			  239,  239,  239,  239,  240,  240,  240,  240,  240,  240,
			  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
			  240,  240,  240,  240,  240,  240,  229,  229,  228,  228,
			  230,  230,  230,  225,  232,  232,  231,  231,  231,  233,
			  233,  233,  233,  226,  227,  363,  363,  366,  366,  367,
			  367,  432,  369,  369,  433,  365,  365,  365,  365,  365,
			  365,  370,  370,  370,  370,  368,  387,  387,  434,  388,
			  388,  388,  385,  386,  260,  260,  435,  261,  261,  262,
			  262,  436,  259,  259,  259,  437,  259,  284,  284,  284, yyDummy>>,
			1, 200, 0)
		end

	yyr1_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  204,  438,  204,  205,  205,  205,  205,  202,  203,  207,
			  207,  206,  340,  340,  439,  341,  341,  338,  338,  440,
			  339,  339,  336,  336,  441,  337,  337,  335,  335,  335,
			  286,  250,  250,  251,  251,  442,  248,  248,  248,  443,
			  248,  444,  248,  248,  248,  445,  248,  446,  249,  249,
			  249,  287,  243,  243,  244,  447,  245,  245,  245,  242,
			  241,  241,  404,  404,  448,  405,  405,  403,  282,  282,
			  281,  283,  283,  279,  279,  280,  280,  449,  449,  449,
			  449,  379,  379,  379,  379,  379,  379,  373,  373,  373,
			  373,  373,  373,  380,  380,  380,  380,  380,  380,  380,

			  380,  380,  380,  380,  380,  380,  380,  380,  380,  380,
			  380,  380,  380,  380,  380,  380,  374,  374,  374,  374,
			  374,  374,  374,  374,  333,  333,  390,  390,  278,  278,
			  183,  183,  285,  277,  277,  182,  182,  450,  181,  181,
			  181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
			  181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
			  181,  181,  181,  181,  181,  181,  181,  181,  334,  334,
			  295,  292,  292,  394,  293,  293,  293,  293,  293,  293,
			  289,  288,  290,  291,  348,  348,  348,  451,  349,  349,
			  349,  349,  349,  349,  345,  344,  346,  347,  452,  452, yyDummy>>,
			1, 200, 200)
		end

	yyr1_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
			  453,  372,  372,  372,  372,  372,  454,  371,  371,  371,
			  371,  371,  455,  330,  330,  329,  329,  456,  457,  351,
			  351,  350,  350,  406,  406,  407,  407,  209,  209,  395,
			  395,  396,  396,  396,  396,  396,  396,  396,  396,  396,
			  396,  396,  396,  396,  396,  396,  396,  396,  396,  396,
			  396,  396,  396,  397,  397,  397,  397,  397,  397,  397,
			  397,  397,  397,  397,  397,  397,  397,  397,  397,  397,
			  397,  397,  397,  397,  397,  398,  398,  398,  398,  398,
			  398,  398,  398,  398,  398,  398,  398,  398,  398,  398,

			  398,  398,  398,  398,  398,  398,  398,  398,  301,  301,
			  170,  170,  172,  172,  430,  171,  171,  171,  171,  171,
			  431,  167,  173,  173,  174,  174,  174,  175,  175,  175,
			  175,  175,  175,  168,  169,  343,  343,  343,  342,  342,
			  342,  342,  342,  342,  342,  342,  342,  342,  342,  342,
			  342,  342,  342,  342,  342,  342,  342,  342,  342,  376,
			  376,  375,  375,  375,  375,  375,  375,  375,  375,  375,
			  375,  375,  375,  375,  375,  375,  375,  375,  375,  375,
			  210,  219,  211,  212,  213,  214,  215,  216,  217,  217,
			  218,  208,  221,  221,  222,  222,  220,  220,  458,  321, yyDummy>>,
			1, 200, 400)
		end

	yyr1_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  321,  321,  321,  321,  321,  321,  321,  321,  321,  321,
			  321,  321,  321,  321,  321,  321,  321,  459,  193,  193,
			  193,  193,  322,  322,  322,  322,  324,  324,  324,  324,
			  246,  246,  247,  247,  303,  303,  303,  303,  257,  258,
			  258,  256,  302,  302,  254,  255,  255,  253,  320,  320,
			  413,  413,  412,  412,  411,  197,  197,  460,  198,  198,
			  198,  196,  194,  194,  195,  195,  195,  195,  319,  319,
			  410,  410,  409,  409,  408,  163,  163,  389,  223,  223,
			  252,  360,  360,  360,  461,  359,  359,  358,  323,  323,
			  323,  323,  323,  323,  323,  269,  269,  268,  189,  189,

			  391,  391,  266,  266,  265,  265,  265,  265,  265,  265,
			  265,  265,  265,  264,  264,  164,  164,  164,  462,  165,
			  165,  165,  276,  267,  267,  267,  267,  414,  414,  263,
			  263,  272,  272,  272,  272,  272,  272,  272,  272,  272,
			  272,  272,  272,  272,  272,  272,  272,  272,  272,  272,
			  272,  272,  272,  272,  272,  272,  272,  272,  272,  272,
			  273,  273,  273,  273,  273,  273,  274,  274,  274,  274,
			  274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
			  274,  274,  274,  274,  274,  274,  274,  274,  271,  271,
			  271,  271,  271,  271,  271,  271,  271,  271,  271,  271, yyDummy>>,
			1, 200, 600)
		end

	yyr1_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  271,  271,  271,  271,  271,  270,  270,  270,  270,  185,
			  185,  186,  463,  186,  464,  187,  465,  187,  466,  166,
			  166,  166,  364,  353,  353,  467,  352,  354,  354,  354,
			  361,  361,  468,  362,  362,  362,  392,  392,  469,  393,
			  393,  393,  224,  224,  224,  224,  224,  161,  160,  162,
			  162,  378,  377,  377,  275,  188,  188,  317,  318,  318,
			  318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
			  294,  470,  180,  180,  180,  180,  180,  178,  178,  178,
			  471,  179,  179,  179,  177,  176,  176,  176,  355,  355,
			  357,  357,  357,  357,  357,  357,  357,  357,  357,  357,

			  357,  357,  357,  357,  357,  357,  357,  357,  357,  357,
			  357,  357,  357,  357,  357,  357,  357,  357,  357,  357,
			  357,  356,  190,  190,  192,  192,  191,  184,  184,  325,
			  325,  327,  327,  328,  328,  326,  381,  381,  383,  383,
			  384,  384,  382,  300,  300,  300,  423, yyDummy>>,
			1, 147, 800)
		end

	yytypes1_template: SPECIAL [INTEGER]
			-- Template for `yytypes1'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 1817)
			yytypes1_template_1 (an_array)
			yytypes1_template_2 (an_array)
			yytypes1_template_3 (an_array)
			yytypes1_template_4 (an_array)
			yytypes1_template_5 (an_array)
			yytypes1_template_6 (an_array)
			yytypes1_template_7 (an_array)
			yytypes1_template_8 (an_array)
			yytypes1_template_9 (an_array)
			yytypes1_template_10 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytypes1_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    1,    8,    2,    2,   44,   86,   86,   44,   86,   86,
			    2,   44,   44,    2,   86,   87,   87,    1,   86,   87,
			   87,    1,   22,   83,    2,    2,    2,    2,    2,   21,
			   86,   86,   12,   12,   12,   12,   87,   21,   86,   21,
			   86,   19,   19,    5,    6,    6,   16,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   13,    9,    7,
			    7,    2,    7,    9,    9,    9,   58,   12,   87,   88,
			   89,   90,   13,   13,   13,   13,   15,   15,   15,   16,

			   16,   16,   16,    5,   83,    2,  106,    2,    2,    2,
			    2,   86,   86,    5,   86,   86,   16,   13,   16,   13,
			   23,    5,   12,   12,   12,    2,    2,    2,    2,    2,
			   12,   97,   97,  115,  115,  123,  123,   19,   59,   22,
			    2,  105,    5,    5,   12,   90,    2,    2,   81,   82,
			   83,   12,   15,  109,    1,    2,    2,    2,   12,   90,
			   12,    2,    2,   12,   97,  115,   12,    2,    2,   12,
			   97,   22,   28,   28,    1,   12,    2,    2,   12,   97,
			   12,    2,    2,   12,   97,   12,    2,   12,   97,   12,
			    5,   10,   12,   22,   28,    1,    5,    5,   12,    5, yyDummy>>,
			1, 200, 0)
		end

	yytypes1_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    5,  105,    2,   90,   12,   12,    5,    5,   83,    5,
			   61,    1,    2,  109,  111,   12,   12,   12,   28,   12,
			    2,   12,   97,    5,   10,   12,   28,   28,    5,   28,
			   12,    2,   12,   97,    5,   10,   12,   28,    5,    5,
			   23,    5,   12,   12,   12,    2,    2,    2,    2,   27,
			   27,   27,   28,   28,   12,   12,   97,  123,  123,   28,
			   12,    2,   12,   97,    5,   10,   12,   28,    5,   28,
			   12,    2,   12,   97,    5,   10,   12,   28,    5,   28,
			    5,   10,   12,   28,    5,   28,  123,    5,   12,   12,
			   12,   28,   12,    9,   13,   15,   16,   19,  123,   19,

			   19,   19,    5,    5,    5,    5,    5,    5,    2,   20,
			   17,   16,   14,   13,   11,   10,    5,    4,    3,    2,
			    2,    2,    2,    2,    2,    2,   24,   24,   24,    7,
			   36,   36,   37,    9,    9,   58,   69,   69,   69,   69,
			   69,   69,   69,   69,   69,   69,   69,   69,   69,   70,
			   12,   84,   91,   91,   92,   13,  102,  102,   15,   15,
			  105,  105,  107,  116,  116,   16,  121,  122,    5,    5,
			    5,   23,    5,    5,   12,    2,    2,    2,    2,   54,
			   12,   97,  124,  126,    2,   57,   57,    2,    2,   60,
			   61,    5,   46,   46,  109,   28,    5,   10,   12,   28, yyDummy>>,
			1, 200, 200)
		end

	yytypes1_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    5,  123,   12,   28,    5,   10,   12,   28,    5,  123,
			   12,   12,    2,   12,   12,    2,   12,    5,    5,   28,
			    5,   12,    2,   12,   12,    2,   12,   12,   12,   12,
			   28,   12,   12,   12,   28,   28,    5,   28,    5,    5,
			   28,    5,   10,   12,   28,    5,  123,   12,   28,    5,
			   10,   12,   28,    5,  123,   12,  123,   12,    5,    5,
			    5,    5,    5,   69,   69,   69,   12,   12,   12,   17,
			   10,   76,   12,  107,   12,   12,   12,   12,  123,   69,
			   69,   69,    5,  102,    5,    5,   26,    5,    5,   17,
			   10,   32,   76,   80,   80,   12,  107,    5,    1,   69,

			    5,   69,    5,    5,   15,   69,   69,    5,    2,  101,
			  101,   22,   22,    5,    5,    5,    5,   19,   19,   19,
			   19,   19,   19,   19,   19,    5,    5,    5,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   14,   14,   14,
			   14,   11,    5,    5,   22,   22,    5,  105,   26,    5,
			   31,   69,   69,  124,  126,  124,  126,   12,    2,   12,
			   12,    2,   12,  126,   22,   51,   51,    1,   12,    2,
			   12,   12,    2,   12,   12,   12,   12,    2,   53,   22,
			   51,   51,    1,    2,   52,   52,   52,   57,   74,   74,
			    1,    5,   46,   60,   46,   60,   61,   12,  111,  109, yyDummy>>,
			1, 200, 400)
		end

	yytypes1_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			  123,   12,    5,  123,   12,    5,   28,   12,   12,   28,
			   28,   12,   12,   28,    1,    1,    1,   28,   12,   12,
			   28,   28,   12,   12,   28,   28,   28,   28,    5,    5,
			    5,  123,  123,   12,    5,  123,   12,    5,    5,    5,
			    1,    1,    1,    5,    5,    5,    5,    5,   69,   70,
			  102,    5,   26,   12,    5,  123,    5,   31,    5,    2,
			  113,   78,   78,   79,   79,   80,   12,    5,  113,    2,
			    2,  123,    2,    5,  122,  123,  131,    1,    2,  123,
			    1,    2,   48,   36,   36,   69,   69,   69,   69,   69,
			   69,   69,   69,   69,   69,   69,   69,   69,   69,   69,

			   69,   69,   69,   69,   69,   69,   69,   69,   69,    2,
			   69,    2,   69,   69,   12,   12,   36,   36,    5,   31,
			    5,   52,   52,   52,   52,   51,   12,   12,   51,   51,
			   12,   12,   51,  124,  125,  126,    5,   23,    5,   12,
			    2,    2,    2,    2,   50,   50,   50,   51,   51,   54,
			   54,   12,   12,   97,   51,   12,   12,   51,   51,   12,
			   12,   51,   51,   51,   51,    2,   53,    5,   51,   12,
			    2,   52,   55,   56,   57,   76,    2,   95,   95,    2,
			   73,   73,   74,    5,   46,   60,   60,   77,   12,   60,
			   60,   61,    5,   12,  108,  110,  111,    5,    5,    5, yyDummy>>,
			1, 200, 600)
		end

	yytypes1_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    5,   28,   28,   28,   28,   28,   28,   28,   28,   28,
			   28,   28,   28,   28,   28,    1,    1,    1,   21,    5,
			    5,    5,    5,    5,    5,   12,   12,   69,   69,  123,
			    5,  102,    5,    5,  102,   26,   69,   70,    5,    5,
			   76,  123,    2,    1,    2,    2,  100,   80,   12,   80,
			    5,   80,    5,   80,    5,    5,  123,    2,  100,   12,
			   12,    5,   12,   76,   77,  122,    5,    2,    2,    2,
			   43,  130,  131,   69,    5,    2,   69,   12,    1,   69,
			    2,    2,   26,   69,   70,   26,   69,   69,   26,   26,
			   26,   26,   23,    5,   29,   30,   31,   69,   51,   51,

			   51,   51,    5,    5,  126,   12,    2,   12,   12,    2,
			   12,   51,   12,    2,   12,   12,    2,   12,   12,   12,
			   12,   51,   51,   12,   51,    5,    5,    5,    5,   51,
			   51,   51,   51,   51,   53,   76,  118,  118,    5,   52,
			   77,   12,    5,   57,    5,    5,    1,   86,   46,   74,
			    2,   71,   76,   12,  114,  114,  117,  117,    1,   45,
			   45,   46,   12,   60,   60,    5,   60,   28,   21,  111,
			  111,    5,   12,    5,   12,    5,   12,    5,   12,   12,
			   26,    5,    5,    5,   12,    5,    5,   26,   26,   31,
			  113,    1,    1,  100,   15,    2,    2,   47,  123,  113, yyDummy>>,
			1, 200, 800)
		end

	yytypes1_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			   15,    2,   47,    5,   69,    5,    5,    5,  122,   69,
			   43,    2,  131,    2,   64,    1,    5,   21,   21,    5,
			    2,   69,   12,   69,   69,    5,    5,   26,  123,    5,
			    5,    5,   31,   51,   12,   12,   51,   51,   12,   12,
			   51,   51,   12,   12,   51,   51,   12,   12,   51,   51,
			   51,   51,    5,    1,   54,    2,    2,    2,   53,    1,
			    2,   52,    2,    5,  128,  128,    1,    2,   71,  114,
			  117,    5,    5,    2,   80,   80,    2,  114,  117,    5,
			    1,  114,  117,    5,   46,    5,   46,    5,    2,    2,
			    2,    2,    2,   68,   96,   96,   96,  119,   12,   12,

			   12,   12,   69,   26,    2,  100,    1,   12,   98,   98,
			   99,   99,  100,    2,   72,    5,  104,   47,   47,    1,
			    2,  112,   21,    2,  100,   72,  104,  112,  123,    2,
			    2,   19,   19,    5,    9,   40,   41,   42,   43,   12,
			   13,  121,   69,   69,    2,    2,   63,   64,   12,   21,
			   21,   21,    5,    2,  129,  129,  129,    5,   51,   51,
			   51,   51,   51,   51,   51,   51,    1,   51,   51,   21,
			    5,   71,    5,  128,    5,    1,    1,    5,  114,  117,
			  114,  117,  123,    5,    2,   86,    2,   33,   34,   96,
			   96,  119,   96,   68,   96,   96,    2,   96,   96,   96, yyDummy>>,
			1, 200, 1000)
		end

	yytypes1_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			   96,   68,   68,   15,    2,   47,    5,    5,  100,  100,
			  100,  100,   15,  112,    5,  104,   47,   21,    5,    5,
			    5,   18,   17,    4,    2,    2,    2,    2,    2,    2,
			    2,    2,   25,   36,   36,   36,   38,   39,   47,   47,
			   62,   69,   69,   69,   69,   12,   85,   93,   94,   94,
			   94,   94,  120,  134,    2,    1,    2,   47,   47,   15,
			    2,   47,  112,   47,   47,    5,   12,  123,    5,    5,
			   43,    2,   69,   69,   64,   26,   21,   69,   12,    2,
			    2,   23,    5,  123,  127,  128,    1,    1,  114,  117,
			    2,   35,  123,   86,  106,   15,   15,   15,   15,   15,

			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   15,   15,   15,   15,   34,   76,   77,   96,   96,
			  118,  118,  119,   96,   21,   46,   67,   68,   96,   96,
			    2,   96,   72,  104,  112,  123,    2,   15,  103,  104,
			  112,   12,   23,    5,   12,    2,    2,    2,    2,   12,
			   97,  123,  123,    5,   26,   69,   69,   69,   47,    5,
			  104,   59,    1,   47,   47,    5,    5,  101,    5,    5,
			   26,   47,   47,    5,    5,    1,    1,   47,    2,   72,
			  104,  112,    2,  112,    2,    5,   41,    2,    2,    5, yyDummy>>,
			1, 200, 1200)
		end

	yytypes1_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    5,    5,  128,   44,   76,   21,    5,    2,   86,   35,
			  106,  113,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,   34,   96,  119,    2,   67,   68,   96,
			    2,   96,  112,   47,   47,   21,    5,    5,  104,   47,
			    5,   12,    2,   12,   17,   12,    2,   12,   12,  134,
			   28,   12,    2,   12,   12,    2,   12,   12,   12,   12,
			   28,    5,    5,   12,    2,    2,  133,    1,    2,   47,
			  123,   47,    5,  134,    2,    2,   47,    1,  101,   69,

			   69,    2,  129,   12,   12,   47,    5,   69,   69,    1,
			  112,   47,   47,   47,   69,   69,    2,    7,    9,   49,
			   13,   15,   16,    2,   49,   86,  106,    2,   86,  113,
			    2,    2,  100,   75,   76,   77,   68,    2,   96,    2,
			  112,    2,    2,   69,   28,   12,   12,   28,   28,   12,
			   12,   28,    5,   28,   12,   12,   28,   28,   12,   12,
			   28,   28,   28,   28,  134,    5,    5,   12,   12,    2,
			    2,   47,   43,  132,  133,   47,    2,    2,   47,   66,
			    1,    5,    2,  123,    5,   47,   47,    2,    2,   47,
			   48,   69,    2,   26,   26,    2,  112,    2,    2,   21, yyDummy>>,
			1, 200, 1400)
		end

	yytypes1_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			   21,   21,   21,   21,  106,  113,   86,  106,    2,    2,
			  100,  112,   15,    2,   47,   75,    2,   47,    5,   28,
			   28,   28,   28,   12,   28,   28,   28,   28,    5,   12,
			   26,   47,    2,   47,  133,   47,    2,    2,   47,    2,
			   65,   66,    5,    5,   12,    2,    2,   47,   47,   69,
			   47,  113,    2,    2,  100,  106,  113,  112,   15,    2,
			   47,    2,   72,  104,  112,    2,   26,   12,   26,    2,
			   69,   66,   12,  134,   26,   47,  129,    2,  129,   47,
			    2,    2,    2,  100,  112,   15,    2,    2,   47,   47,
			  113,    2,    2,  100,    2,   72,  104,  112,   21,  112,

			   47,   47,   26,   47,   26,    5,    2,    2,    2,  112,
			   15,    2,   47,    2,   72,   47,  104,  112,  112,    2,
			    2,  100,  112,   15,    2,   47,   21,  112,   47,   47,
			    2,  112,    2,   12,    2,   72,  104,  112,   21,  112,
			   47,   47,   47,  112,   15,    2,   47,    2,   72,  104,
			  112,    2,  112,    2,   21,   47,   21,   26,   21,  112,
			   47,   47,    2,  112,    2,    2,    2,   72,  104,  112,
			   21,  112,   47,   47,   21,   47,   21,    2,    2,  112,
			    2,   21,   47,   21,   21,   21,  112,   47,   47,    2,
			  112,    2,    2,   21,   21,   47,   21,    2,    2,  112, yyDummy>>,
			1, 200, 1600)
		end

	yytypes1_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    2,   21,   47,   21,   21,    2,   21,   21,   47,   21,
			    2,   21,    2,   21,   21,    1,    1,    1, yyDummy>>,
			1, 18, 1800)
		end

	yytypes2_template: SPECIAL [INTEGER]
			-- Template for `yytypes2'
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    3,    4,    5,
			    5,    5,    5,    5,    5,    6,    7,    7,    8,    9,
			   10,   11,   12,   12,   12,   13,   14,   14,   14,   14,
			   14,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,

			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   16,   17,   18,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   20,    6,    6,    2,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,    5,    5,    5,    5,   21,   22,   23,    1, yyDummy>>)
		end

	yydefact_template: SPECIAL [INTEGER]
			-- Template for `yydefact'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 1817)
			yydefact_template_1 (an_array)
			yydefact_template_2 (an_array)
			yydefact_template_3 (an_array)
			yydefact_template_4 (an_array)
			yydefact_template_5 (an_array)
			yydefact_template_6 (an_array)
			yydefact_template_7 (an_array)
			yydefact_template_8 (an_array)
			yydefact_template_9 (an_array)
			yydefact_template_10 (an_array)
			Result := yyfixed_array (an_array)
		end

	yydefact_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			   15,   15,   14,   11,    1,   16,   51,    2,  946,  946,
			   52,   55,    3,   53,   13,   19,   21,    0,   10,   28,
			   30,    0,   58,  155,   53,   53,   53,   54,    0,   24,
			  946,  946,  944,  945,  943,    0,   22,   34,  946,   35,
			  946,    0,    0,    0,  920,  925,  938,  916,  913,  911,
			  909,  907,  905,  903,  890,  915,  914,  912,  919,  918,
			  917,  910,  908,  906,  904,  902,  901,  900,  899,  898,
			  897,  896,  895,  894,  893,  892,  891,  931,  924,  927,
			  928,  632,   39,   40,  923,  922,    0,   38,   31,   36,
			    0,   32,   41,  930,  929,  932,   43,  889,  888,   42,

			  937,  936,  939,   56,    0,    0,  946,    0,    0,    0,
			    0,   18,   20,    0,   27,   29,  941,  934,  940,  933,
			    0,    0,  509,  522,  508,    0,    0,    0,    0,    0,
			  439,  452,    0,  558,  561,    0,  440,    0,    0,  832,
			   44,    0,    0,   46,   38,   37,    0,    0,    0,    0,
			   57,   62,  156,  946,    0,    0,    0,    0,   47,   23,
			  522,    0,    0,  510,    0,  537,  522,    0,    0,  510,
			    0,  514,  453,  523,    0,  522,    0,    0,  510,    0,
			  522,    0,    0,  510,    0,  522,    0,  510,    0,  510,
			    0,  548,  538,  514,  441,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 0)
		end

	yydefact_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  830,    0,   45,   33,   64,   63,   59,   61,   60,    0,
			  252,    0,  209,  158,  161,   50,   49,   48,  461,  522,
			    0,  510,    0,    0,  556,  546,  450,  511,    0,  459,
			  522,    0,  510,    0,    0,  554,  544,  448,    0,  524,
			    0,    0,  944,  945,  943,    0,    0,    0,    0,    0,
			    0,    0,  525,  526,    0,  439,  474,    0,    0,  457,
			  522,    0,  510,    0,    0,  552,  542,  446,    0,  455,
			  522,    0,  510,    0,    0,  550,  540,  444,    0,  454,
			    0,  549,  539,  443,    0,  442,    0,  512,  509,  522,
			  508,  513,  560,  926,  935,  921,  942,  633,    0,    0,

			    0,    0,    0,    0,    0,    0,  373,    0,    0,  797,
			  791,  776,    0,  775,    0,  792,  825,  715,  871,    0,
			    0,    0,    0,    0,    0,    0,  770,  769,  429,  794,
			  764,  767,  795,  808,  799,  768,    0,    0,    0,  790,
			  804,  805,  788,  763,  766,  729,  730,  760,  798,    0,
			  715,  772,  796,  877,  773,  761,  807,  802,  806,  800,
			  774,  831,  793,    0,  771,  762,  789,  803,    0,    0,
			    0,    0,    0,   74,  144,    0,    0,    0,    0,   71,
			  136,  103,   84,   84,  255,  946,  253,  241,  247,  235,
			  232,    0,  210,  164,    0,  462,    0,  557,  547,  451, yyDummy>>,
			1, 200, 200)
		end

	yydefact_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,  578,  460,    0,  555,  545,  449,    0,    0,
			  576,  522,    0,  510,  522,    0,  510,  520,  520,  523,
			  520,  522,    0,  510,  522,    0,  510,  522,  510,  510,
			  516,  944,  945,  943,  529,  528,    0,  463,  515,  521,
			  458,    0,  553,  543,  447,    0,    0,  574,  456,    0,
			  551,  541,  445,    0,    0,  572,    0,  571,    0,  520,
			  520,  520,  630,  780,  777,  778,  854,    0,    0,  725,
			  724,  723,  332,  726,  944,  945,  943,    0,    0,  782,
			  779,  781,  823,    0,  718,    0,  702,  373,    0,  874,
			  875,    0,  877,  870,  411,  872,  873,    0,  411,    0,

			    0,  784,  838,    0,  801,  946,    0,    0,  428,  430,
			  678,  814,  818,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  833,  722,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  812,  816,  834,  835,  704,  880,
			  857,  851,    0,   84,   84,   84,   84,  144,    0,  136,
			  144,    0,  136,    0,  514,  145,  104,    0,  144,    0,
			  136,  144,    0,  136,  144,  136,  136,   80,   72,  514,
			  137,   92,    0,   88,   85,   65,   68,    0,  269,  423,
			    0,  201,  239,    0,  245,    0,    0,    0,    0,  160, yyDummy>>,
			1, 200, 400)
		end

	yydefact_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			    0,  579,    0,    0,  577,    0,  483,  522,  510,  472,
			  481,  522,  510,  470,    0,    0,    0,  479,  522,  510,
			  468,  477,  522,  510,  466,  476,  465,  464,  520,  520,
			  520,  533,    0,  575,    0,    0,  573,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  765,    0,    0,
			  824,  716,    0,    0,  371,    0,    0,  855,    0,  410,
			  384,    0,    0,    0,    0,  372,  715,    0,  384,    0,
			    0,    0,    0,  836,    0,    0,    0,    0,    0,    0,
			  431,    0,    0,    0,    0,  759,  757,  758,  756,  751,
			  745,  749,  753,  747,  755,  733,  734,  732,  735,  737,

			  739,  740,  742,  741,  743,  736,  738,  754,  748,    0,
			  746,    0,  744,  731,  715,  715,    0,    0,  878,    0,
			  822,   67,   70,   66,   69,  112,  144,  136,  101,  110,
			  144,  136,   99,    0,    0,   73,  146,    0,    0,  945,
			    0,    0,    0,    0,    0,    0,    0,  147,  148,    0,
			    0,    0,  136,  125,  108,  144,  136,   97,  106,  144,
			  136,   95,  105,   94,   93,   78,    0,  138,  139,    0,
			   86,    0,  256,  257,  254,    0,  422,  424,   15,  276,
			  271,  273,  270,  202,    0,    0,  240,  249,  248,    0,
			  246,  234,  211,  510,  171,  172,  163,    0,    0,    0, yyDummy>>,
			1, 200, 600)
		end

	yydefact_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			    0,  484,  473,  482,  471,  518,  531,  519,  532,  517,
			  530,  480,  469,  478,  467,    0,    0,    0,  534,  527,
			    0,    0,    0,    0,    0,  559,  715,    0,    0,    0,
			    0,  826,  827,  828,  829,  717,    0,    0,  715,  876,
			  877,  411,  410,  412,  387,    0,    0,  377,  381,  376,
			  374,  379,  375,  378,  380,    0,  411,    0,    0,  850,
			  849,    0,  786,    0,    0,  837,    0,  669,    0,  657,
			    0,  672,  671,  946,    0,  402,  398,  715,  432,  679,
			    0,    0,  813,    0,    0,  817,  752,  750,  714,  712,
			  811,  815,  886,    0,    0,    0,  879,  885,  113,  102,

			  111,  100,   77,   75,   76,  144,    0,  136,  144,    0,
			  136,  145,  144,    0,  136,  144,    0,  136,  144,  136,
			  136,  141,  151,    0,  150,  140,  143,  520,    0,  137,
			  109,   98,  107,   96,   79,    0,    0,    0,  520,   87,
			    0,    0,  259,  258,    0,    0,  427,    0,  275,  272,
			    0,  324,  333,  946,  278,  287,  277,  281,  274,    0,
			    0,  200,  207,  238,  250,  251,  244,  165,  175,  173,
			  174,    0,  569,    0,  567,    0,  565,    0,  563,  562,
			  631,  853,  852,    0,  715,  719,  720,  721,  703,  856,
			  384,  413,  414,    0,  328,  681,  946,  417,  382,  384, yyDummy>>,
			1, 200, 800)
		end

	yydefact_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  328,  681,  417,    0,  785,  230,  839,  840,  841,    0,
			    0,    0,  673,    0,    0,    0,    0,  403,  399,  400,
			  408,  404,  715,  435,  435,  819,  820,  821,    0,  884,
			  881,  882,  883,  134,  144,  136,  123,  132,  144,  136,
			  121,  130,  144,  136,  119,  128,  144,  136,  117,  127,
			  116,  115,  520,    0,  153,    0,   81,   82,   83,    0,
			   90,   91,   89,  264,  260,    0,  425,    8,  324,  288,
			  282,    0,    0,  325,  370,  324,   15,  290,  284,    0,
			    0,  280,  279,  203,  206,  204,  205,  208,  219,  224,
			  178,  214,  186,  220,    0,  215,  225,  187,  570,  568,

			  566,  564,  783,  701,    0,    0,  415,  395,    0,    0,
			  388,  389,  386,    0,  417,  684,  946,  593,  580,    0,
			  416,  437,  383,    0,    0,  417,  946,  437,    0,    0,
			  668,    0,    0,    0,  665,  658,  662,  659,  656,  666,
			  664,  667,  674,    0,    0,    0,  645,  644,  715,  401,
			  409,  405,  406,    0,  436,    0,    0,  765,  135,  124,
			  133,  122,  131,  120,  129,  118,    0,  142,  152,  154,
			  149,  182,  262,    0,  261,  426,    6,    0,  292,  286,
			  289,  283,  330,    0,   15,  155,    0,  337,  334,    0,
			    0,    0,    0,    0,  221,  215,  170,  216,  225,  226, yyDummy>>,
			1, 200, 1000)
		end

	yydefact_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			    0,  188,  220,  328,  681,  417,  394,    0,  391,  390,
			  393,  392,  329,    0,  682,    0,  417,  616,    0,    0,
			    0,  615,  791,  715,    0,    0,    0,  946,    0,  681,
			  632,  617,  588,    0,  809,  810,    0,  614,  429,  591,
			  613,    0,    0,    0,    0,  727,  606,  607,  598,  599,
			  601,  600,  946,    0,  416,  418,  946,    0,  438,  328,
			  681,  417,    0,  417,    0,    0,  787,    0,  661,    0,
			  660,  642,    0,    0,  646,  700,  407,  433,  715,  847,
			  848,  887,  183,    0,    0,  263,    7,   15,  291,  285,
			    0,  293,  330,  155,  411,  368,  368,  368,  368,  368,

			  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,    0,  227,  228,  218,  223,
			  179,  180,  177,  213,  196,  195,  191,  185,  225,    0,
			  169,  215,  417,  946,  437,  396,  869,    0,    0,  683,
			  437,    0,    0,    0,  522,    0,    0,    0,    0,  485,
			  497,    0,    0,    0,  702,    0,  946,    0,  587,    0,
			  946,    0,    0,  589,  429,    0,    0,    0,    0,    0,
			  704,    0,    0,    0,    0,  419,  420,  586,  865,  417,
			  946,  437,  868,  437,  864,    0,  663,  643,    0,    0, yyDummy>>,
			1, 200, 1200)
		end

	yydefact_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  267,  265,  266,    5,  331,  294,    0,   15,  155,   15,
			  411,  384,  369,  339,  360,  358,  354,  362,  356,  352,
			  367,  338,  364,  359,  366,  365,  363,  357,  353,  361,
			  355,  351,  350,  349,  348,  347,  346,  345,  344,  343,
			  342,  341,  340,  336,  229,  181,  192,    0,    0,    0,
			  168,  225,    0,  417,    0,  397,  687,  685,  686,    0,
			    0,  522,    0,  510,  728,  945,    0,  727,    0,  624,
			  498,  522,    0,  510,  522,    0,  510,  522,  510,  510,
			  486,    0,    0,    0,    0,    0,    0,    0,  946,  946,
			    0,    0,    0,  628,  946,  618,    0,    0,  678,  603,

			  602,    0,    0,  715,  715,  597,  612,  605,  604,  421,
			    0,  417,    0,    0,  647,  434,  326,  842,  843,  326,
			  844,  846,  845,  326,  326,  155,  411,   15,  155,  384,
			  417,    0,    0,  194,  197,  198,  190,  167,    0,  863,
			  437,  859,  867,    0,  506,  522,  510,  495,  504,  522,
			  510,  493,    0,  502,  522,  510,  491,  500,  522,  510,
			  489,  499,  488,  487,  622,    0,  715,  676,  675,  649,
			  946,    0,    0,  652,  651,  582,  634,  946,    0,    0,
			    0,    0,  680,    0,    0,  595,  583,  620,  619,    0,
			    0,    0,    0,  714,  712,  862,  437,  858,  866,  327, yyDummy>>,
			1, 200, 1400)
		end

	yydefact_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  299,  297,  298,  296,  411,  384,  155,  411,  417,    0,
			    0,    0,  328,  681,  417,  199,  166,    0,  677,  507,
			  496,  505,  494,  715,  503,  492,  501,  490,    0,  715,
			  703,  585,  648,  654,  653,  584,  635,  636,    0,    0,
			  639,  638,    0,    0,  715,  621,  946,  435,    0,    0,
			    0,  384,  417,    0,    0,  411,  384,    0,  328,  681,
			  417,  326,  417,  946,  437,  861,  625,  715,  701,  637,
			    0,  640,  715,  626,  629,  590,    0,  609,    0,    0,
			  860,  417,    0,    0,    0,  328,  946,  681,  417,  417,
			  384,  417,    0,    0,  326,  417,  946,  437,  320,    0,

			  417,    0,  623,  641,  700,    0,  611,  610,  608,    0,
			  328,  681,  417,  326,  417,  581,  946,  437,  437,  417,
			    0,    0,    0,  328,  681,  417,  321,    0,  417,    0,
			  326,  437,  326,  715,  326,  417,  946,  437,  309,    0,
			  417,    0,    0,    0,  328,  681,  417,  326,  417,  946,
			  437,  326,  437,  326,  322,    0,  316,  627,  308,    0,
			  417,    0,  326,  437,  326,  326,  326,  417,  946,  437,
			  311,    0,  417,    0,  323,    0,  317,  326,  326,  437,
			  326,  313,    0,  301,  295,  310,    0,  417,    0,  326,
			  437,  326,  326,  318,  312,    0,  300,  326,  326,  437, yyDummy>>,
			1, 200, 1600)
		end

	yydefact_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  326,  315,    0,  303,  319,  326,  305,  314,    0,  302,
			  326,  304,  326,  307,  306,    0,    0,    0, yyDummy>>,
			1, 18, 1800)
		end

	yydefgoto_template: SPECIAL [INTEGER]
			-- Template for `yydefgoto'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 311)
			yydefgoto_template_1 (an_array)
			yydefgoto_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yydefgoto_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yydefgoto'.
		do
			yyarray_subcopy (an_array, <<
			  326,  327,  328, 1232,  548,  835,  882,  249,  250,  251,
			  226,  805,  227,  172,  173,  806,  894,  895,  550,  896,
			  491, 1187, 1188, 1291,  329, 1233,  330,  331,  332, 1236,
			   83,  333,  334, 1237, 1135, 1136, 1137,  870, 1138,   11,
			   12,    4,  959,  960, 1335,  961,  392,  393, 1117, 1257,
			  997, 1489, 1496, 1578, 1571, 1258, 1238, 1374, 1647, 1689,
			 1239, 1118, 1586,  682, 1519,  744,  745,  746,  580,  581,
			 1167,  565,  566, 1168,  584,  585,  939,  578,  934,  379,
			  750,  772,  773,  385,  386,  774,  335,  138,  389,  786,
			  210,  390, 1240, 1146, 1014, 1147, 1640, 1579, 1641, 1336,

			 1093, 1202, 1337,  876,  337,  338,  339,  340,  341,  342,
			  343,  344,  345,  346,  347,  348,  884,  951, 1114,  780,
			  781,  588,  589,  782, 1533,  952, 1327,  787,  661,  662,
			  663,  664, 1074,  665,  494, 1075,  148,  149,   23,  150,
			  350,  130,  351, 1246,    5,    6,   18,   14,   19,   20,
			   88,   15,   16,   36,   89,   90,   91,  352,  353,  354,
			 1247, 1248, 1249, 1250, 1251,   92,  355,   94,   95,  777,
			  778,   13,   28, 1076, 1413, 1328, 1199, 1200, 1194, 1195,
			 1197, 1198,  131,  132, 1108, 1109, 1110, 1111,  846, 1112,
			  509,  510,  356,  357,  650,   96,  358,  359, 1348, 1349, yyDummy>>,
			1, 200, 0)
		end

	yydefgoto_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yydefgoto'.
		do
			yyarray_subcopy (an_array, <<
			 1116,  360,  361,  106,  362,  794,  153,  213,  795,  214,
			  796, 1121,  660,  954,  955,  133,  134,  363,  364,  956,
			  957,   99,  365,  101,  102,  936,  937, 1097, 1332, 1252,
			 1600,  366,  367,  865,  368,  257,  136,  258, 1361,  733,
			  734,  383,  735, 1284, 1064, 1285, 1154, 1155,  871,  872,
			  676, 1573, 1574, 1486, 1253, 1815, 1286, 1287, 1176,    9,
			    8,   30,   31, 1119,   38,   40,  104,  563,  766,  771,
			  195,  614,  394,  598, 1191, 1193, 1448, 1447,  784, 1192,
			 1189, 1190,  596,  785,  593,  789,  595,  587, 1173,  958,
			 1325,  993,  878,  843, 1255,  946, 1066,  680, 1381, 1372,

			 1010, 1215,  652,  716,  683,  717,  684,  483,  201,  674,
			  498,  719, yyDummy>>,
			1, 112, 200)
		end

	yypact_template: SPECIAL [INTEGER]
			-- Template for `yypact'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 1817)
			yypact_template_1 (an_array)
			yypact_template_2 (an_array)
			yypact_template_3 (an_array)
			yypact_template_4 (an_array)
			yypact_template_5 (an_array)
			yypact_template_6 (an_array)
			yypact_template_7 (an_array)
			yypact_template_8 (an_array)
			yypact_template_9 (an_array)
			yypact_template_10 (an_array)
			Result := yyfixed_array (an_array)
		end

	yypact_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			  242,  401, 5764, 2498, -32768, -32768, 1837, -32768, -32768, -32768,
			 -32768, 1701, -32768,  490, -32768, 1035, -32768,  676, -32768,  972,
			  562, 7194, 1713,  848, 1828, 1828, 1828, -32768, 1833, -32768,
			 -32768, -32768, -32768, -32768, -32768, 1698, -32768, -32768, -32768, -32768,
			 -32768,   83,   32,  784, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, 1094, -32768, -32768, -32768, -32768,   54, 1697, -32768, 1692,
			 7194, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

			 -32768, -32768, -32768, -32768,  769, 7760, 2598, 1815, 1814, 1795,
			  676, -32768, -32768, 7194, -32768, -32768, -32768, -32768, -32768, -32768,
			 1707, 1704, -32768,  882, -32768, 1667, 1576, 1883,  228, 1227,
			  880, -32768, 1672, -32768, 1660, 1671, -32768,  228, 1666, 1659,
			 -32768, 1777, 7194, -32768, -32768, -32768,  676,  676,  831,  769,
			 -32768, 1730, -32768, 1453, 1646,  676,  676,  676, -32768, -32768,
			  882, 1880, 1151,  880, 1652, -32768,  882, 1850, 1123,  880,
			 1651, 1642, -32768, -32768, 1812,  882, 1829, 1005,  880, 1639,
			  882, 1820, 1000,  880, 1638,  882,  941,  880, 1636,  880,
			  784, 1528, 1522, 1637, -32768, 1776,  676, 8335, 1648,  784, yyDummy>>,
			1, 200, 0)
		end

	yypact_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, 6780, -32768, -32768, 1705, 1700, -32768, -32768, -32768,  740,
			 1699,  932, 1624, -32768, 2572, -32768, -32768, -32768, -32768,  882,
			  830,  880, 1615,  784, 1528, 1522, -32768, -32768,  676, -32768,
			  882,  792,  880, 1607,  784, 1528, 1522, -32768,  676, -32768,
			 1572, 1545,  474,  453,  127, 1505, 1502, 1779,  228, 1776,
			  844,  844, -32768, -32768, 1601,  880, 1610, 1603, 1568, -32768,
			  882,  723,  880, 1600,  784, 1528, 1522, -32768,  676, -32768,
			  882,  549,  880, 1598,  784, 1528, 1522, -32768,  676, -32768,
			  784, 1528, 1522, -32768,  676, -32768, 1573, -32768, 1565,   36,
			 1564, -32768, -32768, -32768, -32768, -32768, -32768, -32768, 1567, 6780,

			 6780, 6780,  676,  676,  676,  335, -32768, 1454, 6780, -32768,
			 1558, -32768, 6780, -32768, 6780, 1557, 1629,  823,  635, 6780,
			 6908, 1560, 7450, 6780, 6780, 1561, -32768, -32768, 1101, -32768,
			  414,  -24, -32768, -32768, -32768, -32768, 7874, 1552, 1550, 1549,
			 -32768, -32768, -32768, 1015, 1010, -32768, -32768, -32768, 1544, 6652,
			  434, -32768, -32768, 1294, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, 1543, 6780, -32768, -32768, 1541, -32768, 6780,  740,
			  740, 1413, 1400, -32768, 1169, 1352, 1310, 1770,  228, 1640,
			 1166, -32768, 1589, 1589, -32768,  730, -32768,  365,  322, 1295,
			 -32768, 1599, -32768, 1846, 1646, -32768,  784, 1528, 1522, -32768, yyDummy>>,
			1, 200, 200)
		end

	yypact_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			  676, 1515, 1387, -32768,  784, 1528, 1522, -32768,  676, 1513,
			 1387,  882, 1763,  880,  882, 1758,  880, -32768, -32768, 1536,
			 -32768,  882, 1745,  880,  882, 1742,  880,  882,  880,  880,
			 -32768, 1534, 1533, 1532, -32768, -32768,  784, 1507, -32768, -32768,
			 -32768,  784, 1528, 1522, -32768,  676, 1511, 1387, -32768,  784,
			 1528, 1522, -32768,  676, 1509, 1387, 1506, 1387, 1498, -32768,
			 -32768, -32768, 1488, -32768, -32768, -32768, -32768, 1504, 1500, -32768,
			 -32768, -32768, -32768, -32768,  376,  206,  253, 1493, 1492, -32768,
			 -32768, -32768, -32768, 6780, 1486,  228, -32768, 1485,  784, -32768,
			 -32768, 1475, 1294, -32768,   51, 3591, -32768, 6780,   30, 5741,

			 1454, 1604, 1476,  784, -32768, 2302, 7369,  784, -32768, -32768,
			 1041, -32768, -32768, 6780, 6780, 6780, 6780, 6780, 6780, 6780,
			 6780, 6780, 6780, 6780, 6780, 6780, -32768, -32768, 6780, 6780,
			 6780, 6780, 6780, 6780, 6780, 6780, 6780, 6780, 6780, 6524,
			 6396, 6780,  676,  676, -32768, -32768, -32768, -32768, 3437, 1470,
			 -32768, 8143, 8088, 1589, 1589, 1589, 1589, 1169, 1739, 1166,
			 1169, 1710, 1166, 1609, 1463, -32768, -32768, 1219, 1169, 1512,
			 1166, 1169, 1508, 1166, 1169, 1166, 1166, 1581, -32768, 1460,
			 -32768, -32768, 1219, 1578, -32768, -32768, -32768,  676, -32768, 1566,
			 1440, 1461, 2276,  676, 2202,  676,  932, 1459,  228, -32768, yyDummy>>,
			1, 200, 400)
		end

	yypact_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 1455, 1387, 1438, 1405, 1387, 1431, 1430,  882,  880, 1429,
			 1427,  882,  880, 1426, 1812, 1812, 1812, 1416,  882,  880,
			 1415, 1409,  882,  880, 1408, 1403, 1401, 1398, -32768, -32768,
			 -32768,  112, 1397, 1387, 1395, 1396, 1387, 1384, 1383,  676,
			 1776, 1776, 1776,  676, 6780, 6780,  784, 8271, 3284, 6268,
			 -32768, -32768, 6780, 1388, -32768, 1386,  676, -32768,  784, 1503,
			  641,  676,  676,  451,  438, -32768,  486,  784,  462,  676,
			  676, 1381,  676, -32768,  676, 1379,  909,  983, 6780, 1372,
			 5350, 6780,  161, 6780, 6780,  768,  768,  768,  768, 1901,
			 1901, 7089, 7089, 7089, 8195,  860,  860, -32768,  155,  155,

			  155,  768,  768,  768,  768,  155,  155, 8195, 7089, 6780,
			 7089, 6780, 1901, -32768,  434,  434, 6780, 6780, -32768, 5478,
			 -32768, -32768, -32768, -32768, -32768, -32768, 1169, 1166, -32768, -32768,
			 1169, 1166, -32768,  398, 1609, -32768, -32768, 1222, 1190,  249,
			 1159, 1081, 1472,  228, 1219,  676,  676, -32768, -32768, 1358,
			 1348,  729, 1166, 1357, -32768, 1169, 1166, -32768, -32768, 1169,
			 1166, -32768, -32768, -32768, -32768, -32768,  676, -32768, -32768, 1347,
			 -32768,  676, 1345,  676, -32768,  770, -32768, -32768,  401, 1338,
			 1440,  126, -32768, -32768,  676,  676, -32768,  676, 1316,  676,
			 -32768, -32768, -32768,  880,   28,  228, -32768, 1329,  676, 1328, yyDummy>>,
			1, 200, 600)
		end

	yypact_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			  676, 1327, 1326, 1323, 1322, -32768, -32768, -32768, -32768, -32768,
			 -32768, 1318, 1313, 1312, 1311,  844,  844,  844, -32768, -32768,
			 1308,  676, 1306,  676,  676, -32768,  434, 8036, 7984, 1307,
			  676, -32768, -32768, -32768, -32768, -32768, 7817, 6140,  434, -32768,
			 1294,  718, -32768, 5350,  408, 7760,  701, -32768,  720, -32768,
			 -32768, -32768, -32768, -32768, -32768,  784,  718, 7760,  691, -32768,
			 -32768, 6012, -32768,  743,  304, -32768, 7760, -32768, 6780, 1390,
			 1375,  983, -32768, 7009, 1277, 1255, 7673,  741, 5222, 8143,
			 6780, 6780, -32768, 7759, 5884, -32768, 7089, 1901, 3178, 2926,
			 -32768, -32768, -32768, 1454,  700, 5094, -32768, 8143, -32768, -32768,

			 -32768, -32768, -32768, -32768, -32768, 1169, 1423, 1166, 1169, 1380,
			 1166, 1276, 1169, 1325, 1166, 1169, 1315, 1166, 1169, 1166,
			 1166, -32768, -32768,  605, -32768, -32768, -32768, -32768, 1609, 1272,
			 -32768, -32768, -32768, -32768, -32768, 1389, 1382,  339, -32768, -32768,
			  329,   59, -32768, -32768, 1264, 1264, -32768, 1366, -32768, -32768,
			  676,  614, -32768, 2688, -32768, -32768, -32768, -32768,  126,  515,
			  425, -32768, 1244, -32768, -32768, -32768, -32768, 1145, -32768, -32768,
			 -32768,  676, 1146,  676, 1146,  676, 1146,  676, 1146, 1146,
			 -32768, -32768, -32768, 6780,  434, -32768, -32768, -32768, -32768, -32768,
			  420, 5350, 5222,  676,  471,  307,  352,  341, 1209,  108, yyDummy>>,
			1, 200, 800)
		end

	yypact_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			  471,  307,  341, 1454, 1355, -32768, -32768, -32768, -32768, 7104,
			  822, 6780, -32768, 6780, 1337, 1240,  676, -32768, -32768, 1178,
			 1176, 7654,  715, 7449, 7449, -32768, -32768, -32768, 1203, -32768,
			 -32768, -32768, -32768, 1242, 1169, 1166, 1236, 1225, 1169, 1166,
			 1211, 1207, 1169, 1166, 1206, 1195, 1169, 1166, 1191, 1188,
			 1185, 1181, -32768, 1219,   91,  676, -32768, -32768, -32768, 1219,
			 -32768, -32768, -32768, 1183, -32768, 1177, 5350, -32768,  610, -32768,
			 -32768,  126,  784, -32768, -32768,   56,  401, -32768, -32768,  676,
			 1137, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  683, 1292,
			 1588,  319,  682, 1170, 1291, 1097, 1067, 1287, 1146, 1146,

			 1146, 1146, -32768, -32768, 7760,  667, 5222,  596,  676,  676,
			  676,  676, -32768, 7760,  341, 1172,  352, -32768, -32768, 5620,
			 1232,  283, -32768, 7760,  659,  341,  352,  283, 1152,  676,
			 -32768, 1202, 1199,  784, -32768, 1135, 1198,  822, -32768, -32768,
			 -32768, -32768, 8143, 7024, 6780, 6780, 1240, -32768,  434, -32768,
			 -32768, -32768, 1100, 6780, -32768, 1212, 1208, 7604, 1119, 1115,
			 1114, 1111, 1109, 1103, 1102, 1086,  676, -32768, -32768, -32768,
			 -32768, 1084, -32768,  784, -32768, 5222, 1218,  126, -32768, -32768,
			 -32768, -32768, 1088,  784,  401,  848, 8455, 2447, -32768,  676,
			  676,  676,  676,  140, -32768, 1097, -32768, -32768, 1067, -32768, yyDummy>>,
			1, 200, 1000)
		end

	yypact_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 1201, -32768, 1170,  471,  307,  341, -32768,  784, -32768, -32768,
			 -32768, -32768, -32768, 1197, -32768, 7760,  341, -32768,  676, 1210,
			  784, -32768,   87,  678, 6780, 6780, 6780,  600, 1079,  307,
			 1094, -32768, 1186, 1129,  414,  -24, 1108, -32768, 1101, -32768,
			 -32768, 1055, 1050, 1015, 1010, 4023, -32768, -32768, 1144, -32768,
			 -32768, -32768, 1024,  382, -32768, 5350, 1008, 1149, -32768,  471,
			  307,  341, 1138,  341, 1134, 1014, -32768, 1018, -32768,  822,
			 -32768, -32768, 2127, 7355, -32768, -32768, -32768, 8143,  648, -32768,
			 -32768, -32768, -32768,  349,  784, -32768, -32768,  401, -32768, -32768,
			  676, 1089, 1088,  848,  718, 1092, 1092, 1092, 1092, 1092,

			 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
			 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
			 1092, 1092, 1092, 1092, 1092, 1137,  913,  676, -32768, -32768,
			 -32768,  676, -32768, -32768, -32768,  390,  618, -32768, 1067, 1125,
			 -32768, 1097,  341,  352,  283,  981, -32768,  643, 7760, -32768,
			  283, 1003, 1016,  288,  882,  865,  708, 1216,  228,  880,
			 -32768,  988,  990,  228, 4720, 5726, 2000, 3265, -32768,  784,
			 1008,  607, 4966, -32768, 1101, 6780, 6780,  630,  676,  676,
			 4163, 5620,  975, 6780, 6780, 5350, 5222, -32768, -32768,  341,
			  352,  283, -32768,  283, -32768,  460, -32768, -32768, 6780, 6780, yyDummy>>,
			1, 200, 1200)
		end

	yypact_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, -32768, -32768, -32768, -32768, -32768, 7539, 7284,  848,  403,
			  718,  574, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768,  676,  140, 1099,
			 -32768, 1067, 1098,  341, 1096, -32768, -32768, -32768, -32768, 1093,
			 6780,  882, 1155,  880, -32768,  882,  985, -32768,  880,  974,
			 -32768,  882,  854,  880,  882,  342,  880,  882,  880,  880,
			 -32768,  620, 8400,  973,  676,  676,  749,  983,  813,  533,
			  971, 1072,  784,  915, 1019, -32768, 1066, 4834, 1041, 8143,

			 8143, 6780, 1032,  434,  434, -32768, -32768, 8143, 8143, 5222,
			 1040,  341, 1034, 1033, 8143, 8143,   95, -32768, -32768,   95,
			 -32768, -32768, -32768,   95,   95,  848,  718,  401,  848,  537,
			  341, 7760,  653, -32768,  913,  676, -32768, -32768, 1027, -32768,
			  283, -32768, -32768, 7932, -32768,  882,  880, -32768, -32768,  882,
			  880, -32768,  676, -32768,  882,  880, -32768, -32768,  882,  880,
			 -32768, -32768, -32768, -32768,  900,  676,  434, -32768, -32768, -32768,
			 1019, 1013,  984,  983, -32768, -32768, -32768, 1008, 1006,  502,
			  785,  872, -32768,  888,  676, -32768, -32768, -32768, -32768,  991,
			  970, 3025, 6780, 3883, 3743, -32768,  283, -32768, -32768, -32768, yyDummy>>,
			1, 200, 1400)
		end

	yypact_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, -32768, -32768, -32768,  718,  456,  848,  718,  341, 7760,
			  581,  977,  471,  307,  341, -32768, -32768,  956, -32768, -32768,
			 -32768, -32768, -32768,  434, -32768, -32768, -32768, -32768,  676,  434,
			 4581, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  916, 6780,
			  785, -32768,  676,  620,  434, -32768,   94,  739,   77, 3025,
			  899,  448,  341, 7760,  241,  718,  422,  895,  471,  307,
			  341,   95,  341,  352,  283, -32768, -32768,  434, 4442, -32768,
			 3265, -32768,  434,  579, -32768, -32768,  891, -32768,  879,  870,
			 -32768,  341, 7760,  564,  855,  471,  352,  307,  341,  341,
			  203,  341, 7760,  545,   95,  341,  352,  283, -32768,  824,

			  341,  815, -32768, -32768, 4303,  676, -32768, -32768, -32768,  796,
			  471,  307,  341,   95,  341, -32768,  352,  283,  283,  341,
			 7760,  532,  789,  471,  307,  341, -32768,  780,  341,  774,
			   95,  283,   95,  434,   95,  341,  352,  283, -32768,  757,
			  341,  696,  624,  621,  471,  307,  341,   95,  341,  352,
			  283,   95,  283,   95, -32768,  602, -32768, -32768, -32768,  583,
			  341,  556,   95,  283,   95,   95,   95,  341,  352,  283,
			 -32768,  526,  341,  477, -32768,  472, -32768,   95,   95,  283,
			   95, -32768,  469, -32768, -32768, -32768,  358,  341,  345,   95,
			  283,   95,   95, -32768, -32768,  332, -32768,   95,   95,  283, yyDummy>>,
			1, 200, 1600)
		end

	yypact_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			   95, -32768,  263, -32768, -32768,   95, -32768, -32768,  252, -32768,
			   95, -32768,   95, -32768, -32768,  190,  170, -32768, yyDummy>>,
			1, 18, 1800)
		end

	yypgoto_template: SPECIAL [INTEGER]
			-- Template for `yypgoto'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 311)
			yypgoto_template_1 (an_array)
			yypgoto_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yypgoto_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yypgoto'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, -32768, -32768, -32768, -294, 1150, -599, -32768, -32768, -32768,
			   92, -153, -125,  -56, -235, -145, -32768, -32768, -470, 1095,
			 -32768, -32768,  660,  692,   22, -32768, -1058, -1062, -32768, -32768,
			 -952,    7,  -14, -32768, -32768,  712, -32768, -1404,  845, -32768,
			 -32768,    0, -32768, -32768, -357,   50, -32768, -32768, -1416,  214,
			 -806, -1491,  483,  400, -32768, -32768,  746, -32768, -1497, -32768,
			  595,   52,  405,  473,  567, -32768, -32768, -32768, 1221, 1597,
			 -505, 1230,  762, -508, -32768, -205, 1028, -32768, 1030, -511,
			 -32768, -32768, -32768, -32768, -32768, 1192,  102,  731, -32768, -507,
			 -32768, 1363, -32768, -32768, -32768,  816, -32768, -32768,  320, -32768,

			  853, -32768,  510, 1189, -1069, -1073, -32768, -32768, -32768, -32768,
			 -1075, -1083, -32768, -261, -304, -32768, -174, -860, -945, -32768,
			 -32768, -32768, -32768, 1164,  406, -161, -655, -706, -32768, -32768,
			 -32768, -32768, 1622,  538, -32768, -32768, -32768, -32768, -32768, 1789,
			  -15, 1754, -32768, -32768, -32768, -741,  921,  954, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768,   47, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -965,   -4, -188, -32768, -32768,
			 -32768, -32768, 1036,  862, 7270, -1077,  969, -1135,  966,  727,
			  958, -1131,  292, 2013, -32768, -32768, -32768, -32768, -658,  544,
			 -32768, -1178, -32768, -635, 1278, -309,    3,  -21, -32768,  572, yyDummy>>,
			1, 200, 0)
		end

	yypgoto_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yypgoto'.
		do
			yyarray_subcopy (an_array, <<
			 -986, 1830, 1570, -1137,  -11, -32768, -32768, 1510, -32768, -32768,
			  178, 1087, -457, -726,  959, -32768,   81, -32768, -32768, -785,
			  947, -439,   13, -186, -32768, -1112, -1119, -32768,  565, -32768,
			 1091, -940, -32768, 1031, -300,   31, -32768, -32768, -32768, -129,
			 -32768,  585, 1156, -32768,  944,  604, -1357, -1010, -32768, 1012,
			 -32768, -32768,  293, -32768, -1304, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768,   -5, -32768, -32768, -32768, -32768, -32768, -32768,
			 1187, -232, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -811, 1045,  611, -32768, -32768, -32768, -32768, -32768,

			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, yyDummy>>,
			1, 112, 200)
		end

	yytable_template: SPECIAL [INTEGER]
			-- Template for `yytable'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 8594)
			yytable_template_1 (an_array)
			yytable_template_2 (an_array)
			yytable_template_3 (an_array)
			yytable_template_4 (an_array)
			yytable_template_5 (an_array)
			yytable_template_6 (an_array)
			yytable_template_7 (an_array)
			yytable_template_8 (an_array)
			yytable_template_9 (an_array)
			yytable_template_10 (an_array)
			yytable_template_11 (an_array)
			yytable_template_12 (an_array)
			yytable_template_13 (an_array)
			yytable_template_14 (an_array)
			yytable_template_15 (an_array)
			yytable_template_16 (an_array)
			yytable_template_17 (an_array)
			yytable_template_18 (an_array)
			yytable_template_19 (an_array)
			yytable_template_20 (an_array)
			yytable_template_21 (an_array)
			yytable_template_22 (an_array)
			yytable_template_23 (an_array)
			yytable_template_24 (an_array)
			yytable_template_25 (an_array)
			yytable_template_26 (an_array)
			yytable_template_27 (an_array)
			yytable_template_28 (an_array)
			yytable_template_29 (an_array)
			yytable_template_30 (an_array)
			yytable_template_31 (an_array)
			yytable_template_32 (an_array)
			yytable_template_33 (an_array)
			yytable_template_34 (an_array)
			yytable_template_35 (an_array)
			yytable_template_36 (an_array)
			yytable_template_37 (an_array)
			yytable_template_38 (an_array)
			yytable_template_39 (an_array)
			yytable_template_40 (an_array)
			yytable_template_41 (an_array)
			yytable_template_42 (an_array)
			yytable_template_43 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytable_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   98,    7,   35,   17,   21,  194,   87,   85,  419,  294,
			  858,  296,  831,  504, 1156, 1126,  501,   93,  497,  864,
			 1502,  252,  657,  486,   97,   17,   17,  349,   84,  253,
			  592,  594,  992,   21,  100,   21, 1244,  947,  463,  464,
			  465,  668,  291,   82, 1243, 1140, 1242,  479, 1294, 1469,
			 1241,  480, 1002,  481,  419, 1125,  749, 1235, 1134,  748,
			 1377, 1234,  747, 1339, 1338,  940,  659, 1493,  140,   98,
			 1141,  749, 1331, 1062,  135,  144,   85,  768, 1585, 1330,
			  382, 1633, 1073, 1572,  152,  885,   93,  659,  790,  151,
			 1068, 1677,   98,   97, 1648,  158,  430,   84,  144,   85,

			  124,  154,  122,  100,  218,  434,  435,  119, -592,   93,
			  229, -710,   82, 1329,  192, 1333,   97,  890,  891,  259,
			   84,   98, 1153,   86,  269, 1123,  100,  144,   85,  279,
			  437,  204,  205,  512,  151,   82,  844,  145,   93, -592,
			  215,  216,  217,  118,  471,   97,  950,  225,  211,   84,
			 -728, -728, 1679,  236, 1585,  100, 1410,  492,  117,  254,
			  159,  667,  266,  395,   82,  881, 1078,  276,  460, 1572,
			 1817,  282, 1140, 1082,  403,  349,  295, 1564,  586, 1703,
			 1106,  292,  658,  293,  968, 1134,  615, 1183,  616,  203,
			 1816,  965,   86,  171,  116, 1171, 1498, 1141,   34,   33, yyDummy>>,
			1, 200, 0)
		end

	yytable_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   32,  165,  165, 1449,  440,  398,  165,  165,  165,  864,
			 1451,  139, 1331,  402,  448,   86,  406,  880, 1343, 1330,
			 1720,  286, -705,  410, 1170, 1077,  541,  640,  641,  642,
			  298,  844, 1081,  749,  940,  254,  254,  922,  924,  921,
			  553,  555,  165, 1370,   86,  819,  443, 1169,  165, 1719,
			 1444, 1599,  996,  447,  401, 1175,  451,  165, 1342,  420,
			 -508,  237,  165,  455,    3,  409, 1812,  591,  818,  457,
			  267, 1526,    2, 1687, 1390,  277,  529, 1810,  963,  283,
			  964,  285,  966, 1179, -508, 1027, 1181,  466,  467,  468,
			  472, 1678,  477, 1686,  473,  446, 1334,  525, 1244, 1205,

			  124,   98,  122,  495, 1140,  454, 1243,  496, 1242,  649,
			    1,  456, 1241,  399, 1389,  168, 1538, 1134, 1261, 1235,
			 1256,  165,  165, 1234,  407,   97,  165,  165,  165, 1141,
			 -243, -243, 1105, -212, -522, 1185, -243, 1466,  478, 1673,
			 -243, 1124, 1178, 1060, -243, 1180, 1805, -243,  721,  722,
			  723,  724, -243, 1057,  444,  606, 1120, -212,  610, 1800,
			  476, 1465,  474,  171,  452,  617, -592, -592,  621,  271,
			  989,  625, 1798, -237, -237, -243,   34,   33,   32, -237,
			  590, -508, -144, -237,  990,  601, -508, -237, 1604, -592,
			 -237, 1607, 1289,  604, 1446, -237,  815,  816,  817,  999, yyDummy>>,
			1, 200, 200)
		end

	yytable_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1464,   34,   33,   32, -193,  470,  564,   34,   33,   32,
			 -508,   34,   33,   32,  124, 1558,  122, 1054, -237, -385,
			  888,  889,  948,    3, -193,    3,  775,  600, -193, 1527,
			  633,    2, -193,    2, 1007,  603, 1115, 1104,  636, 1692,
			 -385, 1520, 1520, 1293, 1386, 1384, 1383,  469,  844,  591,
			  844, 1288,  165,  165, 1518, 1518,  165,  165,  165,  294,
			 -385,  296,  807,  809,  306, 1682,  256,  631, 1691, 1655,
			  808,  810,  632, 1653, 1113,  649,  844, 1401,  837,  857,
			  635, 1400,  666, 1797,  844,  477, 1792,  256,  807,  809,
			  844, 1791,  591,  165, 1681,  840,  165,   34,   33,   32,

			  677,  381, 1652,  165, -509,  609,  165,   27,  613, -509,
			   34,   33,   32,  863, 1577,  620, 1637, -193,  624,  655,
			  626,  627,  831,   34,   33,   32,  903,  714,  715,   78,
			  902,  671,  980, -509,  675,   77,   26,   25,  679,   24,
			 1789,  256,  749,  996,  988, 1577, -193, 1576,  749, -713,
			 1408,  801,  751, 1085, 1609,  803,  996, 1004, -381, -381,
			 -381, 1497,  811,  484, 1745,  844,  813,  769,  852,  -26,
			 1780,  511,  472,  -26, 1509,  996,  -26, 1724,  788,  -26,
			  788,  850,  -26, 1608,   45,  418, -522,   34,   33,   32,
			  -26, 1531,  996,  -26,  -26,  830, 1711, 1778,  -26,  254, yyDummy>>,
			1, 200, 400)
		end

	yytable_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  254,  254,  844, 1132, 1131,  935,  417, -509,  -26,  -26,
			  171,  -26,  775, 1659,  -26,  484, 1777,  855,  854,  450,
			 1530,   34,   33,   32,  825, -592,  295, 1663,  826, -592,
			  950, -509, -189,  293,  950, 1766, 1073, 1676, 1765,  165,
			 1073,  472,  165, 1083, -592, -592,  848,  848,  848,  848,
			  165, 1079, -189,  165,  859,  860, -189,  862,  845,  472,
			 -189,  381,  381,  837,  996,  877, 1525, 1662, 1528,  844,
			  996,  808,  810, 1696, 1501, 1153,  449,  829,  996,   34,
			   33,   32,   34,   33,   32, 1613,   34,   33,   32,  841,
			 1103, 1260,   34,   33,   32, 1053, -184, -217,  856, 1204,

			  802, 1716,  996,  863,  804,  490, 1059,   34,   33,   32,
			 1764,  812,  996, 1695, 1705,  814, -184, -217,   39, 1464,
			 -184, -217, 1102, 1001, -184, 1736, 1614, 1207, 1206,  769,
			  923,  923, 1464,  995, 1492,  182,  928, 1052, 1749,  487,
			 1714, 1072, 1177,  487, -268, 1072, 1071,  489,   34,   33,
			   32,  472, -268, 1532,  659, -268,  941, 1475,  472, 1768,
			 -268, 1570,  488, 1569,  487, 1735,  953,  129, 1079,  962,
			  788, 1762,  788, 1457,  788, 1456,  935,  484, 1748, 1399,
			  124, 1474,  122,  972, 1153,  974, 1606,  378, 1753,  377,
			  376,  375, 1535,  442, 1751,   34,   33,   32, 1639, 1767, yyDummy>>,
			1, 200, 600)
		end

	yytable_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  254,  254,  254, 1747, 1660, 1363,  976,  484,  978,  979,
			 1734,  129,  124,  374,  122,  984,  147,  146,  165,  165,
			 1166,  165,  165,  165,  994, -592, -592, -592,  877, 1732,
			 1030,  128, 1029,  127,  126,  125, 1000, 1411, 1730,  541,
			  325,   34,   33,   32,  484,  295, 1152,  831, 1688,  472,
			  441,  855,  854, -592, 1275,  381,  124,  123,  122,  753,
			  928,  927,  405, 1022,   34,   33,   32,  373, 1015, 1713,
			  484, 1610, 1019, 1006,  753, 1005,  372, 1712,  477,  105,
			 1535,  261,  536,  535, 1708,  967,  998, 1725,  530,  529,
			  528,   78,  177, 1707,   34,   33,   32,   77,  371,  945,

			  397,  944,   34,   33,   32, 1706,  256,  256,  256, 1694,
			  525,  524,  523, 1680, 1472, 1746,  433,  432,  431,  404,
			  121,  868,  472,  867, 1028,  941,  124, 1554,  122, 1364,
			 1669,  541,  256,  256,  256,  953,  953,  124, 1471,  122,
			  388,  387,  120,  953,  962,  962,   45, 1654, 1080, 1133,
			  485, 1380,  484, 1529,  554,  556, 1098,  396, 1099,  114,
			 1100,  115, 1101,  207,  206, 1132, 1131, 1522, 1522,  294,
			 1665,  296,  969,  970,  536,  535,  877, 1022, 1107,  -25,
			  530,  529,  528,  -25,  111,  112,  -25,  165,  477,  -25,
			  165, 1661,  -25, 1683,  165, 1139,   85,  165, 1693, 1646, yyDummy>>,
			1, 200, 800)
		end

	yytable_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  -25, 1148,  525,  -25,  -25, 1645,   93, 1642,  -25, 1084,
			 1086,  281,  231,   34,   33,   32, 1643,   84,  -25,  -25,
			 1636,  -25, -592,  869,  -25, 1488,  381, 1632, 1326, 1326,
			  935, 1326, 1721, -594, 1128, 1628,  753,  193,  751,  171,
			  953, 1616,  -17,  162,  769, 1005,  -17, 1598, 1597,  -17,
			 1584,  877,  -17,  953, 1595,  -17,  953,  124, 1549,  122,
			  107,  108,  109,  -17,  848, 1462,  -17,  -17,  280, 1605,
			  275,  -17,   34,   33,   32,  265, 1592,   34,   33,   32,
			 1587,  -17,  -17, 1203,  -17,  681, 1582,  -17,  124, 1461,
			  122, 1022, 1212, 1107, 1107, 1107, 1107, 1521, 1521, 1581,

			  -15, 1566, 1259, 1182, 1245, 1089,  -15, 1542,  182, 1552,
			 1541,    3, 1539, 1537, 1266, 1407, 1506,  -15, 1482,    2,
			  -15,  -15, 1139,   85, 1481,  -15,  508,  274,   37, 1404,
			  916, 1091,  264,   93, 1460,  -15,  295, 1455, 1278, 1450,
			 1186,  -15, 1290,  293,   84, 1412, 1395, 1651, 1394,  830,
			 1656,  923, 1392,  124,  915,  122, -596, -596, -596, -596,
			 1022, 1092,  953, 1388, 1267, -592, 1326,  545, 1216, -596,
			  935, 1376,  544, -596,  472,  472,  472,  472, 1263, 1091,
			 1090, -596,  220, 1089, -596, 1379,  177, 1088, -596, -596,
			 1378,   29, 1375,  235, 1347,   34,   33,   32, 1690,  847, yyDummy>>,
			1, 200, 1000)
		end

	yytable_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  849,  851,  853, 1351, 1283, 1227, 1369,  294,  913, 1593,
			 1594, 1346, 1088,  137, 1292, 1340, 1282,  168,   -4,  -96,
			  381,  224, 1280,   34,   33,   32, 1279,  124, 1545,  122,
			 1548,  124,  912,  122, 1480, -107,  -98,  129, 1345,  909,
			  877, 1406, -109,  186, -100, 1405,  129, -111, -102,  162,
			  234, 1362, -113, 1145, 1139,   85, 1276, 1358, 1269, 1357,
			 1356, 1355,  124,  908,  122,   93,  743, 1268,  742,  741,
			  740,  906, 1630, 1254,  119,  472,   84,  117,  223, 1368,
			 1265, -559,  124, 1354,  122, -596, 1534, 1403,  124, 1477,
			  122,  476,  739,  474,  124,  905,  122,  191, 1470,   34,

			   33,   32, 1214, 1092, 1382, 1196, -222, 1174, 1387, -233,
			  174, 1172,  472, -233,  -93, 1283,  472, -233,  -94,  725,
			 -233, -105,  729,  579,  -95, -233,  564, 1347, -106, 1666,
			  754, 1157, 1150,  758, 1149, 1668,  762,  182, 1467,  -97,
			 -108, 1264,  271, 1551,  -99,  753, 1353,  174, -233, 1144,
			 1674,  753,  261,  174,  190,  738, 1467,  877, -110,  572,
			 1129, 1487,  174, 1503, 1504, 1122, 1245,  174, 1352, -101,
			  877, 1022,  174, 1702, 1534, -112, 1087,  737, 1704,  177,
			 1067,  293,  124,  571,  122,   98,   98,  124, 1046,  122,
			  336, 1063,   85,   85, 1055, 1453, 1056,  124, 1042,  122, yyDummy>>,
			1, 200, 1200)
		end

	yytable_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1490,  569,   93,   93, -114, 1544,  174,  231, -126,   97,
			   97, 1017, 1016,   84,   84, 1553, 1011,  174, 1557,  100,
			  100, 1561, 1491,  549,  124,  568,  122,  168, 1517, 1517,
			  174, -655,  472,  165,  165,  983,  165,  165,  165, 1757,
			  162,  977, 1511,  975, -445, -456, -447,  174,  965,  561,
			  220, -458,  124, 1038,  122, -449, -460,  174,  779, -451,
			 -462,  295,  558,  973,  971,  591, 1467, -231,  293, 1567,
			 1568, -231,  124,  560,  122, -231,  174,  942, -231,  938,
			  926,  129, 1022, -231, 1580,  124,  557,  122,  898, 1619,
			 -103,  925,  900, 1621, 1022,  124, 1034,  122, 1624,  186,

			  874,  128, 1626,  127,  126,  125, -231,  866,  499,  861,
			 1612, 1360,  505,  506,  839,  842,  838,  930,  824,  823,
			  472,  932, -560, 1583,  822,  820,  476,  475,  474,  182,
			  821, -442,  177,  799, -443,  271, -454, 1623,  336,  261,
			 1575, -444, -455,  165,  124,  918,  122,  165, -446, -457,
			 1629,  425,  551,  165,  422, 1547,  165,  552, 1454, -448,
			 -459,  567, -450, -461, 1459, 1556,  800,  582, 1560, 1644,
			 1562, 1563,  168,  798,  124,  424,  122,  124,  421,  122,
			  124,  759,  122,  797,  124,  755,  122,  792, 1658,  783,
			  121,  776,  770,  767,  415,  765,  736,  583,  174,  162, yyDummy>>,
			1, 200, 1400)
		end

	yytable_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  718,  174, -176,  182, -176, 1512,  673, 1513,  174,  672,
			  656,  174,  120, 1667,  174,  654,  651,  124,  414,  122,
			  647,  412, -176,  643,  646,  181, -176, 1672, 1467, 1635,
			 -176,  645, 1685,  639,  638,  644,  129,  637, 1620,  634,
			 -441,  605, 1622,  602,  124,  411,  122, 1625,  124,  180,
			  122, 1627, 1208, 1209, 1210, 1211,  378, -535,  377,  376,
			  375, 1710,  174, -536,  630,  629,  628, 1033, -475,  212,
			 1037, 1723,  648,  597, 1041,  577, -711, 1045, -707, -709,
			 1049,  124,  374,  122, -708,  543,  552,  542,  507,  502,
			 1733,  482, -706, -705,  177,  462,  461,  459, 1675, 1744,

			  439,  458,  685,  686,  687,  688,  689,  690,  691,  692,
			  693,  694,  695,  696,  697, 1700,  176,  698,  699,  700,
			  701,  702,  703,  704,  705,  706,  707,  708,  710,  712,
			  713,  168,  436,  453,  162,  445,  438,  231, 1715,  124,
			  175,  122,  408, -452,  567,  372,  582,  567, 1728,  582,
			  400,  391,  384,  167, 1617,  567,  161,  582,  567,  370,
			  582,  567,  582,  582,  369,  297,  220,  371, 1740,  271,
			  287,  284,  261,  278,  268,  239,  124,  166,  122,  124,
			  160,  122,  124,  730,  122,  231,  238,  228, 1760,  209,
			  220,  202,  200,  199,  174, -537, 1158,  186,  174,  197, yyDummy>>,
			1, 200, 1600)
		end

	yytable_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1160, 1772,  157,  129, 1162,  174,  186,  196, 1164,  174,
			 1650,  124,  726,  122,  124,  622,  122,  124,  618,  122,
			 1787,  156,  155,  248,  143,  247,  246,  245,  142,  113,
			  124,  611,  122,  827,  828,  124,  607,  122,  648,  129,
			  110,  836,  124,  574,  122,   27,  103,  271,  290,  289,
			  288,  124,  427,  122, -162, -162,  261,   10,   22,  248,
			 -162,  247,  246,  245, -162, 1385, 1634,  873, -162, -162,
			  879, -162,  883,  883,  163,  169, -162,  231, 1701,  178,
			  183,  187,  189, 1012,  244,  243,  242,  991, 1402, 1065,
			  904,  198,  124,  270,  122, 1008, 1445, 1070,  886, -162,

			  887,  124,  260,  122,  599,  883,  883,  220,  897, 1069,
			  186, 1729,  241,  567,  582,  221,  141,  567,  582,  547,
			 1458,  232,  124,  230,  122, 1096,  567,  834,  255, 1341,
			  262, 1741, 1742, 1095,  240,  272, 1094, 1184,  208,  582,
			  493, 1615,  567,  582,  949, 1755,  567,  582,  241,  255,
			 1201, 1761,  124,  219,  122,  124,  185,  122, 1536,  791,
			 1671, 1371, 1274,  380, 1773,  943, 1775, 1058, 1061,  911,
			  240, 1590,  541,  929, 1524, 1631, 1505, 1782, 1373, 1638,
			 1589, 1396, 1270, 1788, 1409, 1443,    0,  987,    0,    0,
			 1032,    0,    0, 1795,  413,  416,    0,    0,    0,  423, yyDummy>>,
			1, 200, 1800)
		end

	yytable_template_11 (an_array: ARRAY [INTEGER])
			-- Fill chunk #11 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  426,  428,  429,  255, 1802,    0,    0,    0,    0,    0,
			    0,    0, -650, 1808, -650,  536,  535,  534,  533,  532,
			  531,  530,  529,  528,    0,    0,  836,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  525,  524,  523,    0,    0,    0,    0,
			    0,    0,    0,  516,  515,  514,  513, 1009,    0,    0,
			    0,    0,    0,    0,    0,    0,    0, 1021,    0, 1023,
			 1024,  541,    0,  883,    0,    0,  540,  539,  538,    0,
			  537,    0,    0,    0,  897,    0,    0,    0,    0, 1127,
			    0,    0,  567,    0,  582,  567,    0,  582,    0,  567,

			    0,  582,  567,    0,  582,  567,  582,  582,    0,    0,
			    0,    0,    0,    0,  536,  535,  534,  533,  532,  531,
			  530,  529,  528,  380,  380,  559,  562,    0,    0,  570,
			  573,  575,  576,  164,  170,    0,    0,    0,  179,  184,
			  188, 1397,  525,  524,  523,  522,  521,  520,  519,  518,
			  517,    0,  516,  515,  514,  513,  728,    0,    0,  732,
			    0,    0,    0,    0,    0,    0,  608,  757,    0,  612,
			  761,    0,  763,  764,  222,    0,  619,    0,    0,  623,
			  233, 1021,    0,    0,    0,    0,    0,    0,    0,  263,
			    0,    0,    0,    0,  273,    0,    0,    0,  541,    0, yyDummy>>,
			1, 200, 2000)
		end

	yytable_template_12 (an_array: ARRAY [INTEGER])
			-- Fill chunk #12 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1142, 1213, 1143,  540,  539,  538,    0,  537,    0,    0,
			 -242, -242, 1262,    0,    0,    0, -242,    0,    0,    0,
			 -242,  567,  582,    0, -242,  567,  582, -242,    0,  567,
			  582,    0, -242,  567,  582,    0,    0,    0,    0,  653,
			    0,  536,  535,  534,  533,  532,  531,  530,  529,  528,
			    0,    0,    0,  164,  170, -242,    0,    0,  179,  184,
			  188,    0,    0,    0,    0,    0,    0,    0,    0,  525,
			  524,  523,  522,  521,  520,  519,  518,  517,    0,  516,
			  515,  514,  513,    0, -236, -236,    0,    0,    0,    0,
			 -236,    0, 1344,    0, -236, 1021,    0,    0, -236,    0,

			    0, -236,    0, 1350,    0,    0, -236,    0,    0,    0,
			    0,    0,  727,    0, -670,  731, -670,  380,    0,    0,
			    0,  752,    0,  756,  899,    0,  760,    0,  901, -236,
			    0,    0,    0, 1272, 1273,    0,  752,    0,    0,    0,
			    0,    0, 1277,    0,    0,    0,    0,    0, 1391,    0,
			 1393,    0,  793,  931,    0,    0,    0,  933,    0,    0,
			    0,    0,    0,    0, 1021,    0,    0,    0,  255,  255,
			  255,    0,    0,  541,    0,    0,    0,    0,  540,  539,
			  538,    0,  537,    0,  164,  170,    0,    0,  179,  184,
			  188,    0,    0,    0,  255,  255,  255,    0,    0,    0, yyDummy>>,
			1, 200, 2200)
		end

	yytable_template_13 (an_array: ARRAY [INTEGER])
			-- Fill chunk #13 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0, 1365, 1366, 1367,  536,  535,  534,  533,
			  532,  531,  530,  529,  528,  222,    0,    0,  233, 1452,
			    0,    0,    0,    0,    0,  263,    0,    0,  273,    0,
			    0,    0,    0,    0,  525,  524,  523,  522,  521,  520,
			  519,  518,  517,    0,  516,  515,  514,  513, -335,    0,
			    0, -335,    0, -335, -335,    0,    0, -335,    0, -335,
			    0,    0,    0, -335,    0, -335, 1510, -335, -335, -335,
			    0, -335,    0, -335,    0, -335,    0,    0,  380, -335,
			    0,  907,  910, -335,  914,  917,  919,  920,  752,    0,

			    0,    0,    0,    0, 1036,   -9,    0, 1040,    0,   -9,
			    0, 1044,   -9,    0, 1048,   -9, 1050, 1051,   -9, -335,
			 -335, -335,    0,    0,    0,    0,   -9,    0,    0,   -9,
			   -9,    0,    0,    0,   -9,    0,    0,    0,    0,    0,
			 1540,  174,    0,    0,   -9,   -9,    0,   -9,  793,  793,
			   -9,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0, 1499, 1500,    0,    0,    0,    0,
			    0,  222, 1507, 1508,  233, 1021, -335,    0, -335, -335,
			 -159, -159,  263,    0,    0,  273, -159, 1514, 1515,    0,
			 -159,    0,    0,    0, -159,    0,    0, -159, 1596,    0, yyDummy>>,
			1, 200, 2400)
		end

	yytable_template_14 (an_array: ARRAY [INTEGER])
			-- Fill chunk #14 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0, -159,    0,    0,    0, -157, -157,    0,    0,
			 1601,    0, -157,    0, 1602, 1603, -157, 1611,    0,    0,
			 -157,    0,    0, -157,    0, -159,    0,    0, -157,    0,
			    0,    0, 1159,    0,    0,    0, 1161,    0,    0,    0,
			 1163,    0,    0,    0, 1165,    0,    0,    0,  174, 1543,
			    0, -157,  174,    0,    0,    0,    0,    0,  174,    0,
			 1035,  174,    0, 1039,  174,    0,    0, 1043,    0,    0,
			 1047,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  380,    0,    0,    0, 1021,    0,    0,    0,
			 1591,    0,    0,    0,    0, 1657,    0,    0, 1021, -332,

			    0, 1664, -332,    0, -332, -332,    0,    0, -332,    0,
			 -332,    0,    0,    0, -332,    0, -332,    0, -332, -332,
			 -332,    0, -332,    0, -332,    0, -332,    0,    0,    0,
			 -332,    0,  174,    0, -332,    0,  174,    0,    0, 1684,
			    0,  174,    0,    0,    0,  174,    0, 1697,    0, 1699,
			  164,  170, 1698,  179,  184,  188,    0,    0,    0,    0,
			 -332, -332, -332,    0,    0,    0,    0,    0, 1709,    0,
			    0,    0,    0,    0,    0, 1717, 1718,    0, 1722,    0,
			    0, 1649, 1727,    0,    0, 1726,    0, 1731,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0, 1737, yyDummy>>,
			1, 200, 2600)
		end

	yytable_template_15 (an_array: ARRAY [INTEGER])
			-- Fill chunk #15 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0, 1739,    0,    0, 1738,    0, 1743,  752,    0,    0,
			    0,    0, 1750,  752,    0, 1752,    0, -332,    0, -332,
			 -332, 1754, 1759, 1756,    0, 1758,    0, 1763, 1670,    0,
			    0,    0,    0, 1769,    0, 1771,    0,    0, 1770,    0,
			    0,    0, 1774,    0, 1776,    0,    0, 1779,    0,    0,
			    0,    0,    0, 1781, 1786, 1783, 1784, 1785,    0, 1790,
			    0,    0,    0,    0,    0,    0,    0,    0, 1793, 1794,
			    0, 1796,    0,    0, 1799,    0,    0,    0,    0,    0,
			 1801,    0, 1803, 1804,    0,    0,    0,    0, 1806, 1807,
			    0, 1809,    0,    0,    0,    0, 1811,    0,    0,    0,

			    0, 1813,    0, 1814,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  222,
			    0,    0,  233,    0,    0,    0,  263,    0,    0,  273,
			 -696, -696, -696, -696, -696,    0, -696, -696, -696, -696,
			 -696, -696,    0, -696, -696, -696,    0, -696, -696,    0,
			 -696, -696, -696,    0, -696, -696, -696,    0, -696, -696,
			    0,    0,    0, -696,    0, -696, -696, -696,    0,    0,
			 -696, -696, -696, 1359,    0,    0, -696,    0, -696,    0,
			    0, -696, -696, -696, -696,    0,    0, -696, -696,    0,
			    0,    0, -696, -696,    0, -696, -696, -696, -696, -696, yyDummy>>,
			1, 200, 2800)
		end

	yytable_template_16 (an_array: ARRAY [INTEGER])
			-- Fill chunk #16 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,
			 -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,
			 -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,
			 -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,
			 -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,
			 -696, -696, -696, -696, 1646, -696, -696,    0, -696, -696,
			 -696,    0, -696, -696, -696, -696, -696, -696, -696, -696,
			 -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,
			 -696, -696, -696, -696,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  541,    0,    0,    0,

			    0,  540,  539,  538,    0,  537, 1463, 1468,    0, 1473,
			 1476, 1478, 1479,    0,    0,    0,    0, 1483,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  536,
			  535,  534,  533,  532,  531,  530,  529,  528,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  525,  524,  523,
			  522,  521,  520,  519,  518,  517,    0,  516,  515,  514,
			  513,    0, -697, -697, -697, -697, -697,    0, -697, -697,
			 -697, -697, -697, -697,    0, -697, -697, -697,    0, -697, yyDummy>>,
			1, 200, 3000)
		end

	yytable_template_17 (an_array: ARRAY [INTEGER])
			-- Fill chunk #17 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -697,    0, -697, -697, -697,    0, -697, -697, -697,    0,
			 -697, -697,    0,    0,    0, -697, 1546, -697, -697, -697,
			 1550,    0, -697, -697, -697,    0, 1555,    0, -697, 1559,
			 -697,    0,    0, -697, -697, -697, -697,    0,    0, -697,
			 -697,    0,    0,    0, -697, -697,    0, -697, -697, -697,
			 -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,
			 -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,
			 -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,
			 -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,
			 -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,

			 -697, -697, -697, -697, -697, -697, 1488, -697, -697,    0,
			 -697, -697, -697,    0, -697, -697, -697, -697, -697, -697,
			 -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,
			 -697, -697, -697, -697, -697, -697,  541,    0,    0,    0,
			    0,  540,  539,  538,    0,  537,  832,    0,    0,    0,
			    0,    0,    0,    0,    0,  541,    0,    0,    0,    0,
			  540,  539,  538,    0,  537,  164,  170,    0,  179,  184,
			  188,    0,    0,    0,    0,    0,    0,    0,    0,  536,
			  535,  534,  533,  532,  531,  530,  529,  528,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  536,  535, yyDummy>>,
			1, 200, 3200)
		end

	yytable_template_18 (an_array: ARRAY [INTEGER])
			-- Fill chunk #18 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  534,  533,  532,  531,  530,  529,  528,  525,  524,  523,
			  522,  521,  520,  519,  518,  517,  527,  516,  515,  514,
			  513,    0,    0,    0,    0,    0,  525,  524,  523,  522,
			  521,  520,  519,  518,  517,    0,  516,  515,  514,  513,
			    0, -695, -695, -695, -695, -695,    0, -695, -695, -695,
			 -695, -695, -695,    0, -695, -695, -695,    0, -695, -695,
			    0, -695, -695, -695,    0, -695, -695, -695,    0, -695,
			 -695,    0,    0,    0, -695,  222, -695, -695, -695,  233,
			    0, -695, -695, -695,    0,  263,    0, -695,  273, -695,
			    0,    0, -695, -695, -695, -695,    0,    0, -695, -695,

			    0,    0,    0, -695, -695,    0, -695, -695, -695, -695,
			 -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
			 -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
			 -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
			 -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
			 -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
			 -695, -695, -695, -695, -695,    0, -695, -695,    0, -695,
			 -695, -695,    0, -695, -695, -695, -695, -695, -695, -695,
			 -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
			 -695, -695, -695, -695, -695, -332, -332, -332, -332, -332, yyDummy>>,
			1, 200, 3400)
		end

	yytable_template_19 (an_array: ARRAY [INTEGER])
			-- Fill chunk #19 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0, -332, -332, -332, -332, -332, -332,    0, -332, -332,
			 -332,    0, -332, -332,    0, -332, -332, -332,    0, -332,
			 -332, -332,    0, -332, -332,    0,    0,    0, -332,    0,
			 -332, -332, -332,    0,    0, -332, -332, -332,    0,    0,
			    0, -332,    0, -332,    0,    0, -332, -332, -332, -332,
			    0,    0, -332, -332,    0,    0,    0, -332, -332,    0,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,

			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332,    0,
			 -332, -332,    0, -332, -332, -332,    0, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -690,
			    0, -690,    0, -690,    0, -690, -690, -690, -690,    0,
			    0, -690, -690,    0, -690,    0,    0, -690, -690,    0,
			    0,    0, -690,    0,    0,    0, -690,    0,    0,    0,
			 -690,    0, -690, -690,    0,    0,    0, -690, -690,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, -690,    0, yyDummy>>,
			1, 200, 3600)
		end

	yytable_template_20 (an_array: ARRAY [INTEGER])
			-- Fill chunk #20 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -690, -690,    0,    0, -690,    0, -699,    0,    0, -690,
			 -690,    0, -690, -690,    0, -690, -690, -690,    0,    0,
			    0,    0,    0,    0, -690, -690, -690, -690, -690, -690,
			 -690, -690, -690, -690, -690, -690, -690, -690, -690, -690,
			 -690, -690, -690, -690, -690, -690, -690, -690, -690, -690,
			 -690, -690, -690, -690,    0, -690, -690,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -690, -690, -690,    0,
			 -690,    0, -690,    0,    0,    0,    0, -690,    0, -690,
			    0,    0,    0, -690, -690, -690,    0,    0,    0, -689,
			    0, -689,    0, -689,    0, -689, -689, -689, -689, -690,

			 -696, -689, -689,    0, -689,    0,    0, -689, -689,    0,
			    0,    0, -689,    0,    0,    0, -689,    0,    0,    0,
			 -689,    0, -689, -689,    0,    0,    0, -689, -689,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, -689,    0,
			 -689, -689,    0,    0, -689,    0, -698,    0,    0, -689,
			 -689,    0, -689, -689,    0, -689, -689, -689,    0,    0,
			    0,    0,    0,    0, -689, -689, -689, -689, -689, -689,
			 -689, -689, -689, -689, -689, -689, -689, -689, -689, -689,
			 -689, -689, -689, -689, -689, -689, -689, -689, -689, -689,
			 -689, -689, -689, -689,    0, -689, -689,    0,    0,    0, yyDummy>>,
			1, 200, 3800)
		end

	yytable_template_21 (an_array: ARRAY [INTEGER])
			-- Fill chunk #21 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,    0,    0, -689, -689, -689,    0,
			 -689,    0, -689,    0,    0,    0,    0, -689,    0, -689,
			    0,    0,    0, -689, -689, -689,    0,    0,    0, -715,
			    0, -715,    0, -715,    0, -715, -715, -715, -715, -689,
			 -697, -715, -715,    0, -715,    0,    0, -715, -715,    0,
			    0,    0, -715,    0,    0,    0, -715,    0,    0,    0,
			 -715,    0, -715, -715,    0,    0,    0, -715, -715,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, -715,    0,
			 -715, -715,    0,    0, -715,    0,    0,    0,    0, -715,
			 -715,    0, -715, -715,    0, -715, -715, -715,    0,    0,

			    0,    0,    0,    0, -715, -715, -715, -715, -715, -715,
			 -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
			 -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
			 -715, -715, -715, -715,    0, -715, -715,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -715, -715, -715,    0,
			 -715,    0,  484,    0,    0,    0,    0, -715, -715, -715,
			    0,    0,    0, -715, -715, -715,    0,    0,    0, -688,
			    0, -688,    0, -688,    0, -688, -688, -688, -688, -715,
			 -715, -688, -688,    0, -688,    0,    0, -688, -688,    0,
			    0,    0, -688,    0,    0,    0, -688,    0,    0,    0, yyDummy>>,
			1, 200, 4000)
		end

	yytable_template_22 (an_array: ARRAY [INTEGER])
			-- Fill chunk #22 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -688,    0, -688, -688,    0,    0,    0, -688, -688,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, -688,    0,
			 -688, -688,    0,    0, -688,    0,    0,    0,    0, -688,
			 -688,    0, -688, -688,    0, -688, -688, -688,    0,    0,
			    0,    0,    0,    0, -688, -688, -688, -688, -688, -688,
			 -688, -688, -688, -688, -688, -688, -688, -688, -688, -688,
			 -688, -688, -688, -688, -688, -688, -688, -688, -688, -688,
			 -688, -688, -688, -688,    0, -688, -688,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -688, -688, -688,    0,
			 -688,    0, -688,    0,    0,    0,    0, -688,    0, -688,

			    0,    0,    0, -688, -688, -688,    0,    0,    0, -693,
			    0, -693,    0, -693,    0, -693, -693, -693, -693, -688,
			 -695, -693, -693,    0, -693,    0,    0, -693, -693,    0,
			    0,    0, -693,    0,    0,    0, -693,    0,    0,    0,
			 -693,    0, -693, -693,    0,    0,    0, -693, -693,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, -693,    0,
			 -693, -693,    0,    0, -693,    0,    0,    0,    0, -693,
			 -693,    0, -693, -693,    0, -693, -693, -693,    0,    0,
			    0,    0,    0,    0, -693, -693, -693, -693, -693, -693,
			 -693, -693, -693, -693, -693, -693, -693, -693, -693, -693, yyDummy>>,
			1, 200, 4200)
		end

	yytable_template_23 (an_array: ARRAY [INTEGER])
			-- Fill chunk #23 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -693, -693, -693, -693, -693, -693, -693, -693, -693, -693,
			 -693, -693, -693, -693,    0, -693, -693,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -693, -693, -693,    0,
			 -693,    0, -693,    0,    0,    0,    0, -693,    0, -693,
			    0,    0,    0, -693, -693, -693,    0,    0, -694,    0,
			 -694,    0, -694,    0, -694, -694, -694, -694,    0, -693,
			 -694, -694,    0, -694,    0,    0, -694, -694,    0,    0,
			    0, -694,    0,    0,    0, -694,    0,    0,    0, -694,
			    0, -694, -694,    0,    0,    0, -694, -694,    0,    0,
			    0,    0,    0,    0,    0,    0,    0, -694,    0, -694,

			 -694,    0,    0, -694,    0,    0,    0,    0, -694, -694,
			    0, -694, -694,    0, -694, -694, -694,    0,    0,    0,
			    0,    0,    0, -694, -694, -694, -694, -694, -694, -694,
			 -694, -694, -694, -694, -694, -694, -694, -694, -694, -694,
			 -694, -694, -694, -694, -694, -694, -694, -694, -694, -694,
			 -694, -694, -694,    0, -694, -694,    0,    0,    0,    0,
			    0,    0,    0,    0,    0, -694, -694, -694,    0, -694,
			    0, -694,    0,    0,    0,    0, -694,    0, -694,    0,
			    0,    0, -694, -694, -694,    0,    0, -692,    0, -692,
			    0, -692,    0, -692, -692, -692, -692,    0, -694, -692, yyDummy>>,
			1, 200, 4400)
		end

	yytable_template_24 (an_array: ARRAY [INTEGER])
			-- Fill chunk #24 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -692,    0, -692,    0,    0, -692, -692,    0,    0,    0,
			 -692,    0,    0,    0, -692,    0,    0,    0, -692,    0,
			 -692, -692,    0,    0,    0, -692, -692,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -692,    0, -692, -692,
			    0,    0, -692,    0,    0,    0,    0, -692, -692,    0,
			 -692, -692,    0, -692, -692, -692,    0,    0,    0,    0,
			    0,    0, -692, -692, -692, -692, -692, -692, -692, -692,
			 -692, -692, -692, -692, -692, -692, -692, -692, -692, -692,
			 -692, -692, -692, -692, -692, -692, -692, -692, -692, -692,
			 -692, -692,    0, -692, -692,    0,    0,    0,    0,    0,

			    0,    0,    0,    0, -692, -692, -692,    0, -692,    0,
			 -692,    0,    0,    0,    0, -692,    0, -692,    0,    0,
			    0, -692, -692, -692,    0,    0, -691,    0, -691,    0,
			 -691,    0, -691, -691, -691, -691,    0, -692, -691, -691,
			    0, -691,    0,    0, -691, -691,    0,    0,    0, -691,
			    0,    0,    0, -691,    0,    0,    0, -691,    0, -691,
			 -691,    0,    0,    0, -691, -691,    0,    0,    0,    0,
			    0,    0,    0,    0,    0, -691,    0, -691, -691,    0,
			    0, -691,    0,    0,    0,    0, -691, -691,    0, -691,
			 -691,    0, -691, -691, -691,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 4600)
		end

	yytable_template_25 (an_array: ARRAY [INTEGER])
			-- Fill chunk #25 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0, -691, -691, -691, -691, -691, -691, -691, -691, -691,
			 -691, -691, -691, -691, -691, -691, -691, -691, -691, -691,
			 -691, -691, -691, -691, -691, -691, -691, -691, -691, -691,
			 -691,    0, -691, -691,    0,    0,    0,    0,    0,    0,
			    0, 1020,   81, -691, -691, -691,    0, -691, 1588, -691,
			    0,    0,  325,    0, -691,  324, -691,    0,  323,    0,
			 -691, -691, -691,    0,    0,    0,    0,  322,    0,    0,
			    0,    0,    0,  321,    0, 1494, -691,    0,    0,    0,
			    0,    0,    0,    0,  320,    0,    0,    0,    0,  319,
			    0,  318,  317,    0,    0,  316,    0,    0,    0,    0,

			   80,   79,    0,   78,  315,  314,   34,   33,   32,  313,
			    0,    0,    0,  312,    0,   76,   75,   74,   73,   72,
			   71,   70,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,
			   51,   50,   49,   48,   47,  311,  310,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  309,   45,   44,
			  308,  307,    0,  306,    0,    0,    0,    0,  305,    0,
			    0,  304,  303,  875,   81,    0,  302,  301,  300,    0,
			 1495,    0,    0,    0,  325,  299,    0,  324,    0,    0,
			  323,  139,    0,    0,    0,    0,    0,    0,    0,  322, yyDummy>>,
			1, 200, 4800)
		end

	yytable_template_26 (an_array: ARRAY [INTEGER])
			-- Fill chunk #26 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,    0,  321,    0, 1494,    0,    0,
			    0,    0,    0,    0,    0,    0,  320,    0,    0,    0,
			    0,  319,    0,  318,  317,    0,    0,  316,    0,    0,
			    0,    0,   80,   79,    0,   78,  315,  314,   34,   33,
			   32,  313,    0,    0,    0,  312,    0,   76,   75,   74,
			   73,   72,   71,   70,   69,   68,   67,   66,   65,   64,
			   63,   62,   61,   60,   59,   58,   57,   56,   55,   54,
			   53,   52,   51,   50,   49,   48,   47,  311,  310,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  309,
			   45,   44,  308,  307,    0,  306,    0,    0,    0,    0,

			  305,    0,   81,  304,  303,    0,    0,    0,  302,  301,
			  300,    0,  325,    0,    0,  324,    0,  299,  323,    0,
			    0,    0,    0,  139,    0,    0,    0,  322,    0,    0,
			    0,    0,    0,  321,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  320,    0,    0,    0,    0,  319,
			    0,  318,  317,    0,    0,  316,    0,    0,    0,    0,
			   80,   79,    0,   78,  315,  314,   34,   33,   32,  313,
			    0,    0,    0,  312,    0,   76,   75,   74,   73,   72,
			   71,   70,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52, yyDummy>>,
			1, 200, 5000)
		end

	yytable_template_27 (an_array: ARRAY [INTEGER])
			-- Fill chunk #27 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   51,   50,   49,   48,   47,  311,  310,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  309,   45,   44,
			  308,  893,    0,  306, 1031,    0,    0,    0,  305, 1020,
			   81,  304,  303,    0,    0,    0,  302,  301,  300,    0,
			  325,    0,    0,  324,    0,  299,  323,    0,    0,    0,
			    0,  139,  892,    0,    0,  322,    0,    0,    0,    0,
			    0,  321,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  320,    0,    0,    0,    0,  319,    0,  318,
			  317,    0,    0,  316,    0,    0,    0,    0,   80,   79,
			    0,   78,  315,  314,   34,   33,   32,  313,    0,    0,

			    0,  312,    0,   76,   75,   74,   73,   72,   71,   70,
			   69,   68,   67,   66,   65,   64,   63,   62,   61,   60,
			   59,   58,   57,   56,   55,   54,   53,   52,   51,   50,
			   49,   48,   47,  311,  310,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  309,   45,   44,  308,  307,
			    0,  306,    0,    0,    0,    0,  305,  875,   81,  304,
			  303,    0,    0,    0,  302,  301,  300,    0,  325,    0,
			    0,  324,    0,  299,  323,    0,    0,    0,    0,  139,
			    0,    0,    0,  322,    0,    0,    0,    0,    0,  321,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 5200)
		end

	yytable_template_28 (an_array: ARRAY [INTEGER])
			-- Fill chunk #28 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  320,    0,    0,    0,    0,  319,    0,  318,  317,    0,
			    0,  316,    0,    0,    0,    0,   80,   79,    0,   78,
			  315,  314,   34,   33,   32,  313,    0,    0,    0,  312,
			    0,   76,   75,   74,   73,   72,   71,   70,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,  311,  310,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  309,   45,   44,  308,  307,    0,  306,
			    0,    0,    0,    0,  305,    0,   81,  304,  303,    0,
			    0,    0,  302,  301,  300,    0,  325,    0,    0,  324,

			    0,  299,  323,    0,    0,    0,    0,  139,    0,    0,
			    0,  322,    0,    0,    0,    0,    0,  321,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  320,    0,
			    0,    0,    0,  319,    0,  318,  317,    0,    0,  316,
			    0,    0,    0,    0,   80,   79,    0,   78,  315,  314,
			   34,   33,   32,  313,    0,    0,    0,  312,    0,   76,
			   75,   74,   73,   72,   71,   70,   69,   68,   67,   66,
			   65,   64,   63,   62,   61,   60,   59,   58,   57,   56,
			   55,   54,   53,   52,   51,   50,   49,   48,   47,  311,
			  310,    0,    0,    0,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 5400)
		end

	yytable_template_29 (an_array: ARRAY [INTEGER])
			-- Fill chunk #29 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,  309,   45,   44,  308,  893,    0,  306,    0,    0,
			    0,    0,  305,    0,    0,  304,  303,    0,    0,    0,
			  302,  301,  300,    0,    0,    0, 1231,    0, 1230,  299,
			 1229,    0,    0,    0,    0,  139,  892,    0, 1228, 1227,
			    0, 1226,    0,    0, 1225,    0,    0,    0,    0,    0,
			    0,    0,    0,  322,    0,    0,    0,    0,    0,  321,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0, 1224,    0,  318, 1223,    0,
			    0,  316,    0,    0,    0,    0,   80,   79,    0,   78,
			  315,    0,   34,   33,   32,    0,    0,    0,    0,    0,

			    0,   76,   75,   74,   73,   72,   71,   70,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47, 1485, 1222, 1221,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  309,   45,   44,  670, 1220,    0,  306,
			    0,    0, 1484,    0,  305,    0, 1219,    0,    0,    0,
			 1218,    0,  302,    0,    0,    0,    0,  669,    0,    0,
			    0,  -12,    0,    0,    0,  -12, 1217,    0,  -12,    0,
			    0,  -12,    0,    0,  -12,    0,    0,    0,    0,    0,
			    0,    0,  -12,    0,    0,  -12,  -12,  541,    0,    0, yyDummy>>,
			1, 200, 5600)
		end

	yytable_template_30 (an_array: ARRAY [INTEGER])
			-- Fill chunk #30 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  -12,    0,  540,  539,  538,    0,  537,    0,    0,    0,
			  -12,  -12,  541,  -12,    0,    0,  -12,  540,  539,  538,
			    0,  537,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  536,  535,  534,  533,  532,  531,  530,  529,  528,    0,
			    0,    0,    0,    0,    0,  536,  535,  534,  533,  532,
			  531,  530,  529,  528,    0,    0,    0,    0,  525,  524,
			  523,  522,  521,  520,  519,  518,  517,    0,  516,  515,
			  514,  513,    0,  525,  524,  523,  522,  521,  520,  519,
			  518,  517,   81,  516,  515,  514,  513,    0,    0,    0,

			    0,    0,  325,    0,    0,  324,    0,    0,  323,    0,
			    0,    0,    0,    0,    0,    0,    0,  322,    0,    0,
			    0,    0,    0,  321,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  320,    0,    0,    0,    0,  319,
			    0,  318,  317,    0,    0,  316,    0,    0,    0,    0,
			   80,   79,    0,   78,  315,  314,   34,   33,   32,  313,
			    0,    0,    0,  312,    0,   76,   75,   74,   73,   72,
			   71,   70,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,
			   51,   50,   49,   48,   47,  311,  310,    0,    0,    0, yyDummy>>,
			1, 200, 5800)
		end

	yytable_template_31 (an_array: ARRAY [INTEGER])
			-- Fill chunk #31 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,    0,    0,    0,  309,   45,   44,
			  308,  307,    0,  306,    0,    0,    0, 1026,  305,    0,
			   81,  304,  303,    0,    0,    0,  302,  301,  300,    0,
			  325,    0,    0,  324,    0,  299,  323,    0,    0,    0,
			    0,  139,    0,    0,    0,  322,    0,    0,    0,    0,
			    0,  321,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  320,    0,    0,    0,    0,  319,    0,  318,
			  317,    0,    0,  316,    0,    0,    0,    0,   80,   79,
			    0,   78,  315,  314,   34,   33,   32,  313,    0,    0,
			    0,  312,    0,   76,   75,   74,   73,   72,   71,   70,

			   69,   68,   67,   66,   65,   64,   63,   62,   61,   60,
			   59,   58,   57,   56,   55,   54,   53,   52,   51,   50,
			   49,   48,   47,  311,  310,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  309,   45,   44,  308, 1003,
			    0,  306,    0,    0,    0,    0,  305,  830,   81,  304,
			  303,    0,    0,    0,  302,  301,  300,    0,  325,    0,
			    0,  324,    0,  299,  323,    0,    0,    0,    0,  139,
			    0,    0,    0,  322,    0,    0,    0,    0,    0,  321,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  320,    0,    0,    0,    0,  319,    0,  318,  317,    0, yyDummy>>,
			1, 200, 6000)
		end

	yytable_template_32 (an_array: ARRAY [INTEGER])
			-- Fill chunk #32 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,  316,    0,    0,    0,    0,   80,   79,    0,   78,
			  315,  314,   34,   33,   32,  313,    0,    0,    0,  312,
			    0,   76,   75,   74,   73,   72,   71,   70,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,  311,  310,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  309,   45,   44,  308,  307,    0,  306,
			  986,    0,    0,    0,  305,    0,   81,  304,  303,    0,
			    0,    0,  302,  301,  300,    0,  325,    0,    0,  324,
			    0,  299,  323,    0,    0,    0,    0,  139,    0,    0,

			    0,  322,    0,    0,    0,    0,    0,  321,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  320,    0,
			    0,    0,    0,  319,    0,  318,  317,    0,    0,  316,
			  833,    0,    0,    0,   80,   79,    0,   78,  315,  314,
			   34,   33,   32,  313,    0,    0,    0,  312,    0,   76,
			   75,   74,   73,   72,   71,   70,   69,   68,   67,   66,
			   65,   64,   63,   62,   61,   60,   59,   58,   57,   56,
			   55,   54,   53,   52,   51,   50,   49,   48,   47,  311,
			  310,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  309,   45,   44,  308,  307,    0,  306,    0,    0, yyDummy>>,
			1, 200, 6200)
		end

	yytable_template_33 (an_array: ARRAY [INTEGER])
			-- Fill chunk #33 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,  305,    0,   81,  304,  303,    0,    0,    0,
			  302,  301,  300,    0,  325,    0,    0,  324,    0,  299,
			  323,    0,    0,    0,    0,  139,    0,    0,    0,  322,
			    0,    0,    0,    0,    0,  321,    0,  711,    0,    0,
			    0,    0,    0,    0,    0,    0,  320,    0,    0,    0,
			    0,  319,    0,  318,  317,    0,    0,  316,    0,    0,
			    0,    0,   80,   79,    0,   78,  315,  314,   34,   33,
			   32,  313,    0,    0,    0,  312,    0,   76,   75,   74,
			   73,   72,   71,   70,   69,   68,   67,   66,   65,   64,
			   63,   62,   61,   60,   59,   58,   57,   56,   55,   54,

			   53,   52,   51,   50,   49,   48,   47,  311,  310,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  309,
			   45,   44,  308,  307,    0,  306,    0,    0,    0,    0,
			  305,    0,   81,  304,  303,    0,  709,    0,  302,  301,
			  300,    0,  325,    0,    0,  324,    0,  299,  323,    0,
			    0,    0,    0,  139,    0,    0,    0,  322,    0,    0,
			    0,    0,    0,  321,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  320,    0,    0,    0,    0,  319,
			    0,  318,  317,    0,    0,  316,    0,    0,    0,    0,
			   80,   79,    0,   78,  315,  314,   34,   33,   32,  313, yyDummy>>,
			1, 200, 6400)
		end

	yytable_template_34 (an_array: ARRAY [INTEGER])
			-- Fill chunk #34 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,  312,    0,   76,   75,   74,   73,   72,
			   71,   70,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,
			   51,   50,   49,   48,   47,  311,  310,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  309,   45,   44,
			  308,  307,    0,  306,    0,    0,    0,    0,  305,    0,
			   81,  304,  303,    0,    0,    0,  302,  301,  300,    0,
			  325,    0,    0,  324,    0,  299,  323,    0,    0,    0,
			    0,  139,    0,    0,    0,  322,    0,    0,    0,    0,
			    0,  321,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,  320,    0,    0,    0,    0,  319,    0,  318,
			  317,    0,    0,  316,    0,    0,    0,    0,   80,   79,
			    0,   78,  315,  314,   34,   33,   32,  313,    0,    0,
			    0,  312,    0,   76,   75,   74,   73,   72,   71,   70,
			   69,   68,   67,   66,   65,   64,   63,   62,   61,   60,
			   59,   58,   57,   56,   55,   54,   53,   52,   51,   50,
			   49,   48,   47,  311,  310,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  309,   45,   44,  308,  307,
			    0,  306,    0,    0,    0,  546,  305,    0,   81,  304,
			  303,    0,    0,    0,  302,  301,  300,    0,  325,    0, yyDummy>>,
			1, 200, 6600)
		end

	yytable_template_35 (an_array: ARRAY [INTEGER])
			-- Fill chunk #35 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,  324,    0,  299,  323,    0,    0,    0,    0,  139,
			    0,    0,    0,  322,    0,    0,    0,    0,    0,  321,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  320,    0,    0,    0,    0,  319,    0,  318,  317,    0,
			    0,  316,    0,    0,    0,    0,   80,   79,    0,   78,
			  315,  314,   34,   33,   32,  313,    0,    0,    0,  312,
			    0,   76,   75,   74,   73,   72,   71,   70,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,  311,  310,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,  309,   45,   44,  308,  307,    0,  306,
			    0,    0,    0,    0,  305,    0,   81,  304,  303,    0,
			    0,    0,  302,  301,  300,    0,  325,    0,    0,  324,
			    0,  299,  323,    0,    0,    0,    0,  139,    0,    0,
			    0,  322,    0,    0,    0,    0,    0,  321,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  320,    0,
			    0,    0,    0,  319,    0,  318,  317,    0,    0,  316,
			    0,    0,    0,    0,   80,   79,    0,   78,  315,  314,
			   34,   33,   32,  313,    0,    0,    0,  312,    0,   76,
			   75,   74,   73,   72,   71,   70,   69,   68,   67,   66, yyDummy>>,
			1, 200, 6800)
		end

	yytable_template_36 (an_array: ARRAY [INTEGER])
			-- Fill chunk #36 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   65,   64,   63,   62,   61,   60,   59,   58,   57,   56,
			   55,   54,   53,   52,   51,   50,   49,   48,   47,  311,
			  310, 1013,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  309,   45,   44,  308,  500,    0,  306, 1271,    0,
			    0,    0,  305,    0,    0,  304,  303,    0,    0,    0,
			  302,  301,  300,    0,    0,    0,    0,    0,    0,  299,
			    0,    0,    0,    0,    0,  139,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  541,    0,    0,    0,    0,  540,  539,  538,    0,  537,
			    0,    0,    0,    0,    0,  541,    0,    0,    0,    0,

			  540,  539,  538,    0,  537,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, 1130,    0,
			    0,    0,    0,  536,  535,  534,  533,  532,  531,  530,
			  529,  528,    0,    0,    0,    0,    0,    0,  536,  535,
			  534,  533,  532,  531,  530,  529,  528,    0,    0,    0,
			    0,  525,  524,  523,  522,  521,  520,  519,  518,  517,
			  541,  516,  515,  514,  513,  540,  525,  524,  523,  522,
			  521,  520,  519,  518,  517,  541,  516,  515,  514,  513,
			  540,  539,  538,    0,  537,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 7000)
		end

	yytable_template_37 (an_array: ARRAY [INTEGER])
			-- Fill chunk #37 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,   81,  536,  535,  534,  533,  532,  531,  530,
			  529,  528,    0,    0,    0,    0,    0,    0,  536,  535,
			  534,  533,  532,  531,  530,  529,  528,    0,    0,    0,
			    0,  525,  524,  523,    0,    0,    0,    0,  518,  517,
			    0,  516,  515,  514,  513,    0,  525,  524,  523,  522,
			  521,  520,  519,  518,  517,    0,  516,  515,  514,  513,
			   80,   79,    0,   78,    0,    0,   34,   33,   32,   77,
			    0,    0,    0,    0,    0,   76,   75,   74,   73,   72,
			   71,   70,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,

			   51,   50,   49,   48,   47,   46,    3,    0,    0,    0,
			    0,    0,    0,    0,    2,    0,    0,    0,   45,   44,
			    0,   43,    0,    0,    0,    0,    0, 1523,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   42,   41,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			   80,   79,    0,   78,    0,    0,    0,    0,    0,   77,
			    0,    0,    0,    0,    0,   76,   75,   74,   73,   72,
			   71,   70,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,
			   51,   50,   49,   48,   47,   46, 1398,    0,    0,    0, yyDummy>>,
			1, 200, 7200)
		end

	yytable_template_38 (an_array: ARRAY [INTEGER])
			-- Fill chunk #38 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,    0,    0,    0,    0,   45,   44,
			  678,   43,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  541,   42,   41,    0,
			    0,  540,  539,  538,    0,  537,    0,    0,    0,    0,
			  541,    0,    0,    0,    0,  540,  539,  538,    0,  537,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  536,
			  535,  534,  533,  532,  531,  530,  529,  528,    0,    0,
			    0,    0,    0,  536,  535,  534,  533,  532,  531,  530,
			  529,  528,    0,    0, 1153,    0,    0,  525,  524,  523,

			  522,  521,  520,  519,  518,  517,    0,  516,  515,  514,
			  513,  525,  524,  523,  522,  521,  520,  519,  518,  517,
			  541,  516,  515,  514,  513,  540,  539,  538,    0,  537,
			    0,   76,   75,   74,   73,   72,   71,   70,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,    0,    0,  536,  535,  534,  533,  532,  531,  530,
			  529,  528,    0,    0,    0,   44,    0,  503,    0,    0,
			    0,    0, 1516,    0,    0,    0,    0,    0,    0,    0,
			    0,  525,  524,  523,  522,  521,  520,  519,  518,  517, yyDummy>>,
			1, 200, 7400)
		end

	yytable_template_39 (an_array: ARRAY [INTEGER])
			-- Fill chunk #39 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,  516,  515,  514,  513,   80,   79,    0,   78,    0,
			    0,    0,    0,    0,   77,    0,    0,    0,    0,    0,
			   76,   75,   74,   73,   72,   71,   70,   69,   68,   67,
			   66,   65,   64,   63,   62,   61,   60,   59,   58,   57,
			   56,   55,   54,   53,   52,   51,   50,   49,   48,   47,
			   46,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,   45,   44,  316,   43,    0,    0,    0,
			    0,    0,    0,   78,    0,    0,    0,    0,    0,   77,
			    0,    0,   42,   41,    0,   76,   75,   74,   73,   72,
			   71,   70,   69,   68,   67,   66,   65,   64,   63,   62,

			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,
			   51,   50,   49,   48,   47,   46,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  541,    0,    0,   45,   44,
			  540,  539,  538,    0,  537,    0,    0,    0,    0,  830,
			    0,    0,    0,    0,  541,    0,    0,   42,   41,  540,
			  539,  538,    0,  537,    0,    0,    0,    0,    0,    0,
			    0,    0, 1281,    0,    0,    0,    0,    0,  536,  535,
			  534,  533,  532,  531,  530,  529,  528,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  536,  535,  534,
			  533,  532,  531,  530,  529,  528,  525,  524,  523,  522, yyDummy>>,
			1, 200, 7600)
		end

	yytable_template_40 (an_array: ARRAY [INTEGER])
			-- Fill chunk #40 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  521,  520,  519,  518,  517,    0,  516,  515,  514,  513,
			 1151,    0,    0,    0,    0,  525,  524,  523,  522,  521,
			  520,  519,  518,  517,    0,  516,  515,  514,  513, 1018,
			  541,    0,    0,    0,    0,  540,  539,  538,    0,  537,
			    0,   76,   75,   74,   73,   72,   71,   70,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,    0,    0,  536,  535,  534,  533,  532,  531,  530,
			  529,  528,    0,    0,    0,   44,    0,    0,  541,    0,
			    0,  527, 1025,  540,  539,  538,    0,  537,    0,    0,

			    0,  525,  524,  523,  522,  521,  520,  519,  518,  517,
			    0,  516,  515,  514,  513,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  536,  535,  534,  533,  532,  531,  530,  529,  528,
			    0,    0,    0,    0,    0,  541,    0,  985,    0,  527,
			  540,  539,  538,    0,  537,    0,    0,    0,    0,  525,
			  524,  523,  522,  521,  520,  519,  518,  517,    0,  516,
			  515,  514,  513,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  536,  535,
			  534,  533,  532,  531,  530,  529,  528,    0,    0,    0, yyDummy>>,
			1, 200, 7800)
		end

	yytable_template_41 (an_array: ARRAY [INTEGER])
			-- Fill chunk #41 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,  541,    0,    0,  527,  526,  540,  539,
			  538,    0,  537,    0,    0,    0,  525,  524,  523,  522,
			  521,  520,  519,  518,  517,    0,  516,  515,  514,  513,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  536,  535,  534,  533,
			  532,  531,  530,  529,  528,  541,    0,    0,    0,    0,
			  540,  539,  538,    0,  537,    0,    0,    0,    0,    0,
			    0, 1618,    0,    0,  525,  524,  523,  522,  521,  520,
			  519,  518,  517,    0,  516,  515,  514,  513,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  536,  535,

			  534,  533,  532,  531,  530,  529,  528,  541,    0,    0,
			    0,    0,  540,  539,  538,    0,  537,    0,    0,    0,
			    0,    0,    0,  982,    0,    0,  525,  524,  523,  522,
			  521,  520,  519,  518,  517,    0,  516,  515,  514,  513,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  536,  535,  534,  533,  532,  531,  530,  529,  528,  541,
			    0,    0,    0,    0,  540,  539,  538,    0,  537,    0,
			    0,    0,    0,    0,    0,  981,    0,    0,  525,  524,
			  523,  522,  521,  520,  519,  518,  517,    0,  516,  515,
			  514,  513,    0,    0,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 8000)
		end

	yytable_template_42 (an_array: ARRAY [INTEGER])
			-- Fill chunk #42 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,  536,  535,  534,  533,  532,  531,  530,  529,
			  528,    0,    0,    0,  541,    0,    0,    0,  720,  540,
			  539,  538,    0,  537,    0,    0,    0,    0,    0,    0,
			  525,  524,  523,  522,  521,  520,  519,  518,  517,    0,
			  516,  515,  514,  513,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  536,  535,  534,
			  533,  532,  531,  530,  529,  528,  541,    0,    0,    0,
			    0,  540,  539,  538,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  525,  524,  523,  522,  521,
			  520,  519,  518,  517,    0,  516,  515,  514,  513,    0,

			    0,    0,    0,    0,    0,    0,    0,    0,    0,  536,
			  535,  534,  533,  532,  531,  530,  529,  528,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  316,    0,    0,    0,    0,  525,  524,  523,
			   78,  521,  520,  519,  518,  517,   77,  516,  515,  514,
			  513,    0,   76,   75,   74,   73,   72,   71,   70,   69,
			   68,   67,   66,   65,   64,   63,   62,   61,   60,   59,
			   58,   57,   56,   55,   54,   53,   52,   51,   50,   49,
			   48,   47,   46,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,   45,   44,    0,    0,    0, yyDummy>>,
			1, 200, 8200)
		end

	yytable_template_43 (an_array: ARRAY [INTEGER])
			-- Fill chunk #43 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,   78,    0,  830,    0,    0,    0,
			   77,    0,    0,    0,   42,   41,   76,   75,   74,   73,
			   72,   71,   70,   69,   68,   67,   66,   65,   64,   63,
			   62,   61,   60,   59,   58,   57,   56,   55,   54,   53,
			   52,   51,   50,   49,   48,   47,   46,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,   45,
			   44,  316,    0,    0,    0,    0,    0,    0,    0,   78,
			    0,    0,    0,    0,    0,    0,    0,    0,   42,   41,
			    0,   76,   75,   74,   73,   72,   71,   70,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,

			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,   45,   44,    0,    0,    0,    0,
			    0,    0,    0,    0,    0, 1565, 1324, 1323, 1322, 1321,
			 1320, 1319, 1318, 1317, 1316, 1315, 1314, 1313, 1312, 1311,
			 1310, 1309, 1308, 1307, 1306, 1305, 1304, 1303, 1302, 1301,
			 1300, 1299, 1298, 1297, 1296, 1295, 1414, 1415, 1416, 1417,
			 1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427,
			 1428, 1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437,
			 1438, 1439, 1440, 1441, 1442, yyDummy>>,
			1, 195, 8400)
		end

	yycheck_template: SPECIAL [INTEGER]
			-- Template for `yycheck'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 8594)
			yycheck_template_1 (an_array)
			yycheck_template_2 (an_array)
			yycheck_template_3 (an_array)
			yycheck_template_4 (an_array)
			yycheck_template_5 (an_array)
			yycheck_template_6 (an_array)
			yycheck_template_7 (an_array)
			yycheck_template_8 (an_array)
			yycheck_template_9 (an_array)
			yycheck_template_10 (an_array)
			yycheck_template_11 (an_array)
			yycheck_template_12 (an_array)
			yycheck_template_13 (an_array)
			yycheck_template_14 (an_array)
			yycheck_template_15 (an_array)
			yycheck_template_16 (an_array)
			yycheck_template_17 (an_array)
			yycheck_template_18 (an_array)
			yycheck_template_19 (an_array)
			yycheck_template_20 (an_array)
			yycheck_template_21 (an_array)
			yycheck_template_22 (an_array)
			yycheck_template_23 (an_array)
			yycheck_template_24 (an_array)
			yycheck_template_25 (an_array)
			yycheck_template_26 (an_array)
			yycheck_template_27 (an_array)
			yycheck_template_28 (an_array)
			yycheck_template_29 (an_array)
			yycheck_template_30 (an_array)
			yycheck_template_31 (an_array)
			yycheck_template_32 (an_array)
			yycheck_template_33 (an_array)
			yycheck_template_34 (an_array)
			yycheck_template_35 (an_array)
			yycheck_template_36 (an_array)
			yycheck_template_37 (an_array)
			yycheck_template_38 (an_array)
			yycheck_template_39 (an_array)
			yycheck_template_40 (an_array)
			yycheck_template_41 (an_array)
			yycheck_template_42 (an_array)
			yycheck_template_43 (an_array)
			Result := yyfixed_array (an_array)
		end

	yycheck_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   21,    1,   17,    8,    9,  130,   21,   21,  243,  197,
			  668,  197,  647,  322, 1024, 1001,  320,   21,  318,  674,
			 1377,  174,  492,  317,   21,   30,   31,  201,   21,  174,
			  387,  388,  843,   38,   21,   40, 1119,  778,  299,  300,
			  301,  498,  195,   21, 1119, 1010, 1119,  308, 1185, 1353,
			 1119,  312,  858,  314,  289, 1000,  567, 1119, 1010,  567,
			 1238, 1119,  567, 1198, 1195,  771,   36, 1371,   14,   90,
			 1010,  582, 1191,   14,   43,   90,   90,  582, 1494, 1191,
			  209, 1572,   26, 1487,  105,  684,   90,   36,  595,  104,
			  950,   14,  113,   90, 1591,  110,  249,   90,  113,  113,

			   72,  106,   74,   90,  160,  250,  251,   75,   14,  113,
			  166,  135,   90, 1190,  129, 1192,  113,  716,  717,  175,
			  113,  142,   45,   21,  180,   17,  113,  142,  142,  185,
			  255,  146,  147,  157,  149,  113,   28,   90,  142,   45,
			  155,  156,  157,  111,  305,  142,   20,  162,  153,  142,
			   63,   64, 1649,  168, 1570,  142, 1293,  318,   75,  174,
			  113,  131,  177,  219,  142,    4,  951,  182,  132, 1573,
			    0,  186, 1137,  958,  230,  349,  197, 1481,  383, 1670,
			  991,  196,  131,  197,  156, 1137,  418,  131,  420,  142,
			    0,  132,   90,  157,  111, 1055, 1374, 1137,   72,   73, yyDummy>>,
			1, 200, 0)
		end

	yycheck_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   74,  120,  121, 1338,  260,  220,  125,  126,  127,  864,
			 1341,  157, 1331,  228,  270,  113,  231,   56, 1204, 1331,
			   17,  190,  135,  238,  133,  951,   71,  459,  460,  461,
			  199,   28,  958,  744,  940,  250,  251,  745,  746,  744,
			  369,  370,  161, 1229,  142,  133,  261,  156,  167,   46,
			 1327,  156,   11,  268,  223, 1066,  271,  176, 1203,  132,
			  133,  169,  181,  278,   22,  234,   14,  127,  156,  284,
			  178, 1408,   30,   32, 1260,  183,  121,   14,  785,  187,
			  787,  189,  789, 1068,  157,  884, 1071,  302,  303,  304,
			  305, 1648,  307,   52,  305,  264,  156,  142, 1381, 1105,

			   72,  322,   74,  318, 1269,  274, 1381,  318, 1381,  483,
			   68,  280, 1381,  221, 1259,   27, 1451, 1269, 1124, 1381,
			   37,  240,  241, 1381,  232,  322,  245,  246,  247, 1269,
			    8,    9,  990,   14,  128, 1076,   14,   49,  307, 1643,
			   18,  999, 1068,   14,   22, 1071,   14,   25,  553,  554,
			  555,  556,   30,   14,  262,  411,   15,   38,  414,   14,
			   72,   73,   74,  157,  272,  421,   14,   15,  424,   27,
			  840,  427,   14,    8,    9,   53,   72,   73,   74,   14,
			  385,  128,  133,   18,  841,  400,  133,   22, 1525,   37,
			   25, 1528, 1177,  408,    4,   30,  628,  629,  630,  856, yyDummy>>,
			1, 200, 200)
		end

	yycheck_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  112,   72,   73,   74,   14,   70,  157,   72,   73,   74,
			  157,   72,   73,   74,   72,   73,   74,  928,   53,   11,
			  714,  715,  779,   22,   34,   22,  587,  396,   38,   26,
			  445,   30,   42,   30,  130,  404,  129,   17,  453,   17,
			   32, 1406, 1407, 1184, 1255,   63,   64,  112,   28,  127,
			   28, 1177,  371,  372, 1406, 1407,  375,  376,  377,  647,
			   52,  647,  615,  616,  129,   17,  174,  436,   46, 1606,
			  615,  616,  441,   17,    3,  649,   28,  128,  652,   17,
			  449,  132,  497,   14,   28,  500,   14,  195,  641,  642,
			   28,   14,  127,  412,   46,  656,  415,   72,   73,   74,

			  505,  209,   46,  422,  128,  413,  425,   17,  416,  133,
			   72,   73,   74,  674,   12,  423,   14,  127,  426,  488,
			  428,  429, 1157,   72,   73,   74,  128,  542,  543,   69,
			  132,  500,  826,  157,  503,   75,   46,   47,  507,   49,
			   14,  249, 1053,   11,  838,   12,  156,   14, 1059,  135,
			 1291,  607,  567,  128,   17,  611,   11,  861,   72,   73,
			   74, 1372,  618,  129,   32,   28,  622,  582,  130,    7,
			   14,  157,  587,   11, 1385,   11,   14,   32,  593,   17,
			  595,  130,   20,   46,  124,  132,  133,   72,   73,   74,
			   28,   17,   11,   31,   32,  135,   32,   14,   36,  614, yyDummy>>,
			1, 200, 400)
		end

	yycheck_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  615,  616,   28,  143,  144,  766,  132,  133,   46,   47,
			  157,   49,  773,   32,   52,  129,   14,  131,  132,   70,
			   46,   72,   73,   74,  639,   25,  647, 1613,  643,   29,
			   20,  157,   14,  647,   20,   14,   26, 1647,   14,  558,
			   26,  656,  561,  128,   44,   45,  661,  662,  663,  664,
			  569,  951,   34,  572,  669,  670,   38,  672,   17,  674,
			   42,  369,  370,  837,   11,  680, 1407, 1612, 1409,   28,
			   11,  816,  817, 1659,   44,   45,  127,  646,   11,   72,
			   73,   74,   72,   73,   74,   32,   72,   73,   74,  658,
			  984,   32,   72,   73,   74,  927,   14,   14,  667,   32,

			  608, 1687,   11,  864,  612,   70,  938,   72,   73,   74,
			   14,  619,   11, 1658,  135,  623,   34,   34,  156,  112,
			   38,   38,  983,   32,   42, 1711, 1532,  131,  132,  744,
			  745,  746,  112,   32,  127,   27,  131,  132, 1724,  129,
			 1685,  131,  132,  129,   14,  131,  132,  112,   72,   73,
			   74,  766,   22, 1411,   36,   25,  771,   49,  773, 1745,
			   30,   12,  127,   14,  129, 1710,  781,   27, 1068,  784,
			  785,   14,  787,  130,  789,  132,  937,  129, 1723,  131,
			   72,   73,   74,  798,   45,  800, 1527,   47,   14,   49,
			   50,   51, 1447,   70,   14,   72,   73,   74,   13, 1744, yyDummy>>,
			1, 200, 600)
		end

	yycheck_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  815,  816,  817,   14, 1610,  127,  821,  129,  823,  824,
			   14,   27,   72,   73,   74,  830,   47,   48,  737,  738,
			 1052,  740,  741,  742,  845,   12,   13,   14,  843,   14,
			  130,   47,  132,   49,   50,   51,  857, 1294,   14,   71,
			   18,   72,   73,   74,  129,  866,  131, 1482, 1654,  864,
			  127,  131,  132,   40, 1148,  563,   72,   73,   74,  567,
			  131,  132,   70,  878,   72,   73,   74,  127,  873,   14,
			  129, 1529,  131,  130,  582,  132,  136, 1683,  893,   31,
			 1535,   27,  114,  115,   14,  793,  855, 1693,  120,  121,
			  122,   69,   27,   14,   72,   73,   74,   75,  158,  129,

			   70,  131,   72,   73,   74,   14,  614,  615,  616,   14,
			  142,  143,  144,   14,   49, 1721,   72,   73,   74,  127,
			  136,   12,  937,   14,  893,  940,   72,   73,   74, 1223,
			   14,   71,  640,  641,  642,  950,  951,   72,   73,   74,
			    8,    9,  158,  958,  959,  960,  124, 1605,  953,  127,
			  127, 1245,  129, 1410,  369,  370,  971,  127,  973,   38,
			  975,   40,  977,  132,  133,  143,  144, 1406, 1407, 1157,
			   14, 1157,  794,  795,  114,  115,  991,  992,  993,    7,
			  120,  121,  122,   11,   30,   31,   14,  906, 1003,   17,
			  909,   14,   20, 1651,  913, 1010, 1010,  916, 1656,   29, yyDummy>>,
			1, 200, 800)
		end

	yycheck_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   28, 1016,  142,   31,   32,   14, 1010,  135,   36,  959,
			  960,   70,   27,   72,   73,   74,  128, 1010,   46,   47,
			   14,   49,   14,   40,   52,   41,  734,   14, 1189, 1190,
			 1191, 1192, 1690,   14, 1003,  135,  744,  157, 1053,  157,
			 1055,   14,    7,   27, 1059,  132,   11,   14,   14,   14,
			  135, 1066,   17, 1068,   14,   20, 1071,   72,   73,   74,
			   24,   25,   26,   28, 1079,   49,   31,   32,  127, 1526,
			   70,   36,   72,   73,   74,   70,   44,   72,   73,   74,
			   14,   46,   47, 1104,   49,   44,   14,   52,   72,   73,
			   74, 1106, 1113, 1108, 1109, 1110, 1111, 1406, 1407,  128,

			   11,  128, 1123, 1072, 1119,   38,   17,   14,   27,  135,
			   14,   22,   14,   14, 1129,   26,  141,   28,  128,   30,
			   31,   32, 1137, 1137,  136,   36,   25,  127,  156, 1290,
			   49,   34,  127, 1137,  131,   46, 1157,  156, 1153,   14,
			    3,   52,   54, 1157, 1137,   53,  128, 1604,   14,  135,
			 1607, 1166,   14,   72,   73,   74,   12,   13,   14,   15,
			 1175,   16, 1177,   14, 1133,  141, 1327,  157, 1116,   25,
			 1331,   63,  157,   29, 1189, 1190, 1191, 1192, 1126,   34,
			   35,   37,   27,   38,   40,  135,   27,   42,   44,   45,
			  135,  156,   63,   70, 1215,   72,   73,   74, 1655,  661, yyDummy>>,
			1, 200, 1000)
		end

	yycheck_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  662,  663,  664, 1218, 1173,   19,  127, 1395,   49, 1503,
			 1504,   14,   42,  119, 1183,   14,  132,   27,    0,  133,
			  928,   70,   14,   72,   73,   74,   14,   72,   73,   74,
			 1465,   72,   73,   74, 1359,  133,  133,   27, 1207,   49,
			 1255,  152,  133,   27,  133,  156,   27,  133,  133,   27,
			  127, 1220,  133,   13, 1269, 1269,  156,   47,   60,   49,
			   50,   51,   72,   73,   74, 1269,   47,  132,   49,   50,
			   51,   49, 1566,   41,   75, 1290, 1269,   75,  127, 1227,
			  128,  135,   72,   73,   74,  141, 1447, 1287,   72,   73,
			   74,   72,   73,   74,   72,   73,   74,   70, 1354,   72,

			   73,   74,  130,   16, 1252,   14,   14,  130, 1256,   14,
			  123,  128, 1327,   18,  133, 1284, 1331,   22,  133,  557,
			   25,  133,  560,  157,  133,   30,  157, 1348,  133, 1623,
			  568,  128,  156,  571,  156, 1629,  574,   27, 1353,  133,
			  133, 1127,   27, 1468,  133, 1053,  136,  160,   53,   12,
			 1644, 1059,   27,  166,  127,  136, 1371, 1372,  133,   49,
			    5, 1366,  175, 1378, 1379,  156, 1381,  180,  158,  133,
			 1385, 1386,  185, 1667, 1535,  133,  132,  158, 1672,   27,
			   14, 1395,   72,   73,   74, 1406, 1407,   72,   73,   74,
			  201,  127, 1406, 1407,    5, 1343,   14,   72,   73,   74, yyDummy>>,
			1, 200, 1200)
		end

	yycheck_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			 1369,   49, 1406, 1407,  132, 1461,  219,   27,  132, 1406,
			 1407,  156,  135, 1406, 1407, 1471,   41,  230, 1474, 1406,
			 1407, 1477, 1370,  129,   72,   73,   74,   27, 1406, 1407,
			  243,   41, 1447, 1352, 1353,  128, 1355, 1356, 1357, 1733,
			   27,  135, 1390,  135,  133,  133,  133,  260,  132,   49,
			   27,  133,   72,   73,   74,  133,  133,  270,   18,  133,
			  133, 1482,   49,  135,  135,  127, 1481,   14, 1482, 1484,
			 1485,   18,   72,   73,   74,   22,  289,  132,   25,  132,
			  132,   27, 1497,   30, 1489,   72,   73,   74,  726, 1545,
			  133,  133,  730, 1549, 1509,   72,   73,   74, 1554,   27,

			  128,   47, 1558,   49,   50,   51,   53,  128,  319,  128,
			 1531, 1219,  323,  324,  128,   12,  128,  755,  135,  135,
			 1535,  759,  135, 1492,  128,  128,   72,   73,   74,   27,
			  135,  133,   27,  128,  133,   27,  133, 1552,  349,   27,
			 1488,  133,  133, 1462,   72,   73,   74, 1466,  133,  133,
			 1565,   49,  363, 1472,   49, 1463, 1475,  368, 1344,  133,
			  133,  374,  133,  133, 1350, 1473,  135,  380, 1476, 1584,
			 1478, 1479,   27,  135,   72,   73,   74,   72,   73,   74,
			   72,   73,   74,  128,   72,   73,   74,  128, 1609,  128,
			  136,   25,   14,  133,   49,   14,  133,    8,  411,   27, yyDummy>>,
			1, 200, 1400)
		end

	yycheck_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  130,  414,   14,   27,   16, 1391,  130, 1393,  421,    5,
			  135,  424,  158, 1628,  427,  130,  130,   72,   73,   74,
			  128,   49,   34,  135,  131,   49,   38, 1642, 1643, 1577,
			   42,  131, 1653,  135,  128,  131,   27,  128, 1546,  128,
			  133,  128, 1550,  128,   72,   73,   74, 1555,   72,   73,
			   74, 1559, 1108, 1109, 1110, 1111,   47,  135,   49,   50,
			   51, 1682,  475,  135,  132,  132,  132,  905,  132,   23,
			  908, 1692,  483,   74,  912,   35,  135,  915,  135,  135,
			  918,   72,   73,   74,  135,  135,  497,  135,  127,  129,
			 1705,   62,  135,  135,   27,  128,  132,  132, 1646, 1720,

			  132,  128,  513,  514,  515,  516,  517,  518,  519,  520,
			  521,  522,  523,  524,  525, 1663,   49,  528,  529,  530,
			  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
			  541,   27,  131,  135,   27,  135,  133,   27, 1686,   72,
			   73,   74,  135,  133,  557,  136,  559,  560, 1696,  562,
			  135,  127,   53,   49, 1540,  568,   49,  570,  571,   59,
			  573,  574,  575,  576,   59,  117,   27,  158, 1716,   27,
			  133,  135,   27,  135,  135,  133,   72,   73,   74,   72,
			   73,   74,   72,   73,   74,   27,  135,  135, 1736,   59,
			   27,   14,  133,  127,  607,  135, 1034,   27,  611,  128, yyDummy>>,
			1, 200, 1600)
		end

	yycheck_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			 1038, 1749,    7,   27, 1042,  618,   27,  135, 1046,  622,
			 1596,   72,   73,   74,   72,   73,   74,   72,   73,   74,
			 1768,    7,    7,   47,  132,   49,   50,   51,  131,  131,
			   72,   73,   74,  644,  645,   72,   73,   74,  649,   27,
			    7,  652,   72,   73,   74,   17,  133,   27,   72,   73,
			   74,   72,   73,   74,    8,    9,   27,   20,  157,   47,
			   14,   49,   50,   51,   18, 1254, 1573,  678,   22,   23,
			  681,   25,  683,  684,  120,  121,   30,   27, 1664,  125,
			  126,  127,  128,  871,   72,   73,   74,  842, 1284,  945,
			  734,  137,   72,   73,   74,  864, 1331,  950,  709,   53,

			  711,   72,   73,   74,  394,  716,  717,   27,  719,  950,
			   27, 1697,  136,  726,  727,  161,   86,  730,  731,  349,
			 1348,  167,   72,   73,   74,  967,  739,  649,  174, 1202,
			  176, 1717, 1718,  967,  158,  181,  967, 1075,  149,  752,
			  318, 1535,  755,  756,  780, 1731,  759,  760,  136,  195,
			 1097, 1737,   72,   73,   74,   72,   73,   74, 1448,  596,
			 1640, 1230, 1146,  209, 1750,  773, 1752,  937,  940,  739,
			  158, 1498,   71,  752, 1407, 1570, 1381, 1763, 1232, 1579,
			 1497, 1269, 1137, 1769, 1292, 1325,   -1,  837,   -1,   -1,
			  895,   -1,   -1, 1779,  240,  241,   -1,   -1,   -1,  245, yyDummy>>,
			1, 200, 1800)
		end

	yycheck_template_11 (an_array: ARRAY [INTEGER])
			-- Fill chunk #11 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  246,  247,  248,  249, 1790,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   12, 1799,   14,  114,  115,  116,  117,  118,
			  119,  120,  121,  122,   -1,   -1,  837,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  142,  143,  144,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  152,  153,  154,  155,  868,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  878,   -1,  880,
			  881,   71,   -1,  884,   -1,   -1,   76,   77,   78,   -1,
			   80,   -1,   -1,   -1,  895,   -1,   -1,   -1,   -1, 1002,
			   -1,   -1,  905,   -1,  907,  908,   -1,  910,   -1,  912,

			   -1,  914,  915,   -1,  917,  918,  919,  920,   -1,   -1,
			   -1,   -1,   -1,   -1,  114,  115,  116,  117,  118,  119,
			  120,  121,  122,  369,  370,  371,  372,   -1,   -1,  375,
			  376,  377,  378,  120,  121,   -1,   -1,   -1,  125,  126,
			  127,   14,  142,  143,  144,  145,  146,  147,  148,  149,
			  150,   -1,  152,  153,  154,  155,  559,   -1,   -1,  562,
			   -1,   -1,   -1,   -1,   -1,   -1,  412,  570,   -1,  415,
			  573,   -1,  575,  576,  161,   -1,  422,   -1,   -1,  425,
			  167,  992,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  176,
			   -1,   -1,   -1,   -1,  181,   -1,   -1,   -1,   71,   -1, yyDummy>>,
			1, 200, 2000)
		end

	yycheck_template_12 (an_array: ARRAY [INTEGER])
			-- Fill chunk #12 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			 1011, 1114, 1013,   76,   77,   78,   -1,   80,   -1,   -1,
			    8,    9, 1125,   -1,   -1,   -1,   14,   -1,   -1,   -1,
			   18, 1034, 1035,   -1,   22, 1038, 1039,   25,   -1, 1042,
			 1043,   -1,   30, 1046, 1047,   -1,   -1,   -1,   -1,  485,
			   -1,  114,  115,  116,  117,  118,  119,  120,  121,  122,
			   -1,   -1,   -1,  240,  241,   53,   -1,   -1,  245,  246,
			  247,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  142,
			  143,  144,  145,  146,  147,  148,  149,  150,   -1,  152,
			  153,  154,  155,   -1,    8,    9,   -1,   -1,   -1,   -1,
			   14,   -1, 1205,   -1,   18, 1106,   -1,   -1,   22,   -1,

			   -1,   25,   -1, 1216,   -1,   -1,   30,   -1,   -1,   -1,
			   -1,   -1,  558,   -1,   12,  561,   14,  563,   -1,   -1,
			   -1,  567,   -1,  569,  727,   -1,  572,   -1,  731,   53,
			   -1,   -1,   -1, 1144, 1145,   -1,  582,   -1,   -1,   -1,
			   -1,   -1, 1153,   -1,   -1,   -1,   -1,   -1, 1261,   -1,
			 1263,   -1,  598,  756,   -1,   -1,   -1,  760,   -1,   -1,
			   -1,   -1,   -1,   -1, 1175,   -1,   -1,   -1,  614,  615,
			  616,   -1,   -1,   71,   -1,   -1,   -1,   -1,   76,   77,
			   78,   -1,   80,   -1,  371,  372,   -1,   -1,  375,  376,
			  377,   -1,   -1,   -1,  640,  641,  642,   -1,   -1,   -1, yyDummy>>,
			1, 200, 2200)
		end

	yycheck_template_13 (an_array: ARRAY [INTEGER])
			-- Fill chunk #13 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1, 1224, 1225, 1226,  114,  115,  116,  117,
			  118,  119,  120,  121,  122,  412,   -1,   -1,  415, 1342,
			   -1,   -1,   -1,   -1,   -1,  422,   -1,   -1,  425,   -1,
			   -1,   -1,   -1,   -1,  142,  143,  144,  145,  146,  147,
			  148,  149,  150,   -1,  152,  153,  154,  155,   11,   -1,
			   -1,   14,   -1,   16,   17,   -1,   -1,   20,   -1,   22,
			   -1,   -1,   -1,   26,   -1,   28, 1389,   30,   31,   32,
			   -1,   34,   -1,   36,   -1,   38,   -1,   -1,  734,   42,
			   -1,  737,  738,   46,  740,  741,  742,  743,  744,   -1,

			   -1,   -1,   -1,   -1,  907,    7,   -1,  910,   -1,   11,
			   -1,  914,   14,   -1,  917,   17,  919,  920,   20,   72,
			   73,   74,   -1,   -1,   -1,   -1,   28,   -1,   -1,   31,
			   32,   -1,   -1,   -1,   36,   -1,   -1,   -1,   -1,   -1,
			 1453, 1354,   -1,   -1,   46,   47,   -1,   49,  794,  795,
			   52,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1, 1375, 1376,   -1,   -1,   -1,   -1,
			   -1,  558, 1383, 1384,  561, 1386,  129,   -1,  131,  132,
			    8,    9,  569,   -1,   -1,  572,   14, 1398, 1399,   -1,
			   18,   -1,   -1,   -1,   22,   -1,   -1,   25, 1511,   -1, yyDummy>>,
			1, 200, 2400)
		end

	yycheck_template_14 (an_array: ARRAY [INTEGER])
			-- Fill chunk #14 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   30,   -1,   -1,   -1,    8,    9,   -1,   -1,
			 1519,   -1,   14,   -1, 1523, 1524,   18, 1530,   -1,   -1,
			   22,   -1,   -1,   25,   -1,   53,   -1,   -1,   30,   -1,
			   -1,   -1, 1035,   -1,   -1,   -1, 1039,   -1,   -1,   -1,
			 1043,   -1,   -1,   -1, 1047,   -1,   -1,   -1, 1461, 1460,
			   -1,   53, 1465,   -1,   -1,   -1,   -1,   -1, 1471,   -1,
			  906, 1474,   -1,  909, 1477,   -1,   -1,  913,   -1,   -1,
			  916,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  928,   -1,   -1,   -1, 1497,   -1,   -1,   -1,
			 1501,   -1,   -1,   -1,   -1, 1608,   -1,   -1, 1509,   11,

			   -1, 1614,   14,   -1,   16,   17,   -1,   -1,   20,   -1,
			   22,   -1,   -1,   -1,   26,   -1,   28,   -1,   30,   31,
			   32,   -1,   34,   -1,   36,   -1,   38,   -1,   -1,   -1,
			   42,   -1, 1545,   -1,   46,   -1, 1549,   -1,   -1, 1652,
			   -1, 1554,   -1,   -1,   -1, 1558,   -1, 1660,   -1, 1662,
			  737,  738, 1661,  740,  741,  742,   -1,   -1,   -1,   -1,
			   72,   73,   74,   -1,   -1,   -1,   -1,   -1, 1681,   -1,
			   -1,   -1,   -1,   -1,   -1, 1688, 1689,   -1, 1691,   -1,
			   -1, 1592, 1695,   -1,   -1, 1694,   -1, 1700,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1712, yyDummy>>,
			1, 200, 2600)
		end

	yycheck_template_15 (an_array: ARRAY [INTEGER])
			-- Fill chunk #15 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1, 1714,   -1,   -1, 1713,   -1, 1719, 1053,   -1,   -1,
			   -1,   -1, 1725, 1059,   -1, 1728,   -1,  129,   -1,  131,
			  132, 1730, 1735, 1732,   -1, 1734,   -1, 1740, 1639,   -1,
			   -1,   -1,   -1, 1746,   -1, 1748,   -1,   -1, 1747,   -1,
			   -1,   -1, 1751,   -1, 1753,   -1,   -1, 1760,   -1,   -1,
			   -1,   -1,   -1, 1762, 1767, 1764, 1765, 1766,   -1, 1772,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1777, 1778,
			   -1, 1780,   -1,   -1, 1787,   -1,   -1,   -1,   -1,   -1,
			 1789,   -1, 1791, 1792,   -1,   -1,   -1,   -1, 1797, 1798,
			   -1, 1800,   -1,   -1,   -1,   -1, 1805,   -1,   -1,   -1,

			   -1, 1810,   -1, 1812,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  906,
			   -1,   -1,  909,   -1,   -1,   -1,  913,   -1,   -1,  916,
			    4,    5,    6,    7,    8,   -1,   10,   11,   12,   13,
			   14,   15,   -1,   17,   18,   19,   -1,   21,   22,   -1,
			   24,   25,   26,   -1,   28,   29,   30,   -1,   32,   33,
			   -1,   -1,   -1,   37,   -1,   39,   40,   41,   -1,   -1,
			   44,   45,   46, 1219,   -1,   -1,   50,   -1,   52,   -1,
			   -1,   55,   56,   57,   58,   -1,   -1,   61,   62,   -1,
			   -1,   -1,   66,   67,   -1,   69,   70,   71,   72,   73, yyDummy>>,
			1, 200, 2800)
		end

	yycheck_template_16 (an_array: ARRAY [INTEGER])
			-- Fill chunk #16 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
			  104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
			  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
			  124,  125,  126,  127,   29,  129,  130,   -1,  132,  133,
			  134,   -1,  136,  137,  138,  139,  140,  141,  142,  143,
			  144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
			  154,  155,  156,  157,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   71,   -1,   -1,   -1,

			   -1,   76,   77,   78,   -1,   80, 1352, 1353,   -1, 1355,
			 1356, 1357, 1358,   -1,   -1,   -1,   -1, 1363,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,
			  115,  116,  117,  118,  119,  120,  121,  122,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  142,  143,  144,
			  145,  146,  147,  148,  149,  150,   -1,  152,  153,  154,
			  155,   -1,    4,    5,    6,    7,    8,   -1,   10,   11,
			   12,   13,   14,   15,   -1,   17,   18,   19,   -1,   21, yyDummy>>,
			1, 200, 3000)
		end

	yycheck_template_17 (an_array: ARRAY [INTEGER])
			-- Fill chunk #17 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   22,   -1,   24,   25,   26,   -1,   28,   29,   30,   -1,
			   32,   33,   -1,   -1,   -1,   37, 1462,   39,   40,   41,
			 1466,   -1,   44,   45,   46,   -1, 1472,   -1,   50, 1475,
			   52,   -1,   -1,   55,   56,   57,   58,   -1,   -1,   61,
			   62,   -1,   -1,   -1,   66,   67,   -1,   69,   70,   71,
			   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
			   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
			  102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
			  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,

			  122,  123,  124,  125,  126,  127,   41,  129,  130,   -1,
			  132,  133,  134,   -1,  136,  137,  138,  139,  140,  141,
			  142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
			  152,  153,  154,  155,  156,  157,   71,   -1,   -1,   -1,
			   -1,   76,   77,   78,   -1,   80,   62,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   71,   -1,   -1,   -1,   -1,
			   76,   77,   78,   -1,   80, 1352, 1353,   -1, 1355, 1356,
			 1357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,
			  115,  116,  117,  118,  119,  120,  121,  122,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,  115, yyDummy>>,
			1, 200, 3200)
		end

	yycheck_template_18 (an_array: ARRAY [INTEGER])
			-- Fill chunk #18 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  116,  117,  118,  119,  120,  121,  122,  142,  143,  144,
			  145,  146,  147,  148,  149,  150,  132,  152,  153,  154,
			  155,   -1,   -1,   -1,   -1,   -1,  142,  143,  144,  145,
			  146,  147,  148,  149,  150,   -1,  152,  153,  154,  155,
			   -1,    4,    5,    6,    7,    8,   -1,   10,   11,   12,
			   13,   14,   15,   -1,   17,   18,   19,   -1,   21,   22,
			   -1,   24,   25,   26,   -1,   28,   29,   30,   -1,   32,
			   33,   -1,   -1,   -1,   37, 1462,   39,   40,   41, 1466,
			   -1,   44,   45,   46,   -1, 1472,   -1,   50, 1475,   52,
			   -1,   -1,   55,   56,   57,   58,   -1,   -1,   61,   62,

			   -1,   -1,   -1,   66,   67,   -1,   69,   70,   71,   72,
			   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
			   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
			   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
			  103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
			  113,  114,  115,  116,  117,  118,  119,  120,  121,  122,
			  123,  124,  125,  126,  127,   -1,  129,  130,   -1,  132,
			  133,  134,   -1,  136,  137,  138,  139,  140,  141,  142,
			  143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
			  153,  154,  155,  156,  157,    4,    5,    6,    7,    8, yyDummy>>,
			1, 200, 3400)
		end

	yycheck_template_19 (an_array: ARRAY [INTEGER])
			-- Fill chunk #19 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   10,   11,   12,   13,   14,   15,   -1,   17,   18,
			   19,   -1,   21,   22,   -1,   24,   25,   26,   -1,   28,
			   29,   30,   -1,   32,   33,   -1,   -1,   -1,   37,   -1,
			   39,   40,   41,   -1,   -1,   44,   45,   46,   -1,   -1,
			   -1,   50,   -1,   52,   -1,   -1,   55,   56,   57,   58,
			   -1,   -1,   61,   62,   -1,   -1,   -1,   66,   67,   -1,
			   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,
			   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
			   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
			   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,

			  109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
			  119,  120,  121,  122,  123,  124,  125,  126,  127,   -1,
			  129,  130,   -1,  132,  133,  134,   -1,  136,  137,  138,
			  139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
			  149,  150,  151,  152,  153,  154,  155,  156,  157,    6,
			   -1,    8,   -1,   10,   -1,   12,   13,   14,   15,   -1,
			   -1,   18,   19,   -1,   21,   -1,   -1,   24,   25,   -1,
			   -1,   -1,   29,   -1,   -1,   -1,   33,   -1,   -1,   -1,
			   37,   -1,   39,   40,   -1,   -1,   -1,   44,   45,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1, yyDummy>>,
			1, 200, 3600)
		end

	yycheck_template_20 (an_array: ARRAY [INTEGER])
			-- Fill chunk #20 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   57,   58,   -1,   -1,   61,   -1,   63,   -1,   -1,   66,
			   67,   -1,   69,   70,   -1,   72,   73,   74,   -1,   -1,
			   -1,   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
			  107,  108,  109,  110,   -1,  112,  113,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,   -1,
			  127,   -1,  129,   -1,   -1,   -1,   -1,  134,   -1,  136,
			   -1,   -1,   -1,  140,  141,  142,   -1,   -1,   -1,    6,
			   -1,    8,   -1,   10,   -1,   12,   13,   14,   15,  156,

			  157,   18,   19,   -1,   21,   -1,   -1,   24,   25,   -1,
			   -1,   -1,   29,   -1,   -1,   -1,   33,   -1,   -1,   -1,
			   37,   -1,   39,   40,   -1,   -1,   -1,   44,   45,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,
			   57,   58,   -1,   -1,   61,   -1,   63,   -1,   -1,   66,
			   67,   -1,   69,   70,   -1,   72,   73,   74,   -1,   -1,
			   -1,   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
			  107,  108,  109,  110,   -1,  112,  113,   -1,   -1,   -1, yyDummy>>,
			1, 200, 3800)
		end

	yycheck_template_21 (an_array: ARRAY [INTEGER])
			-- Fill chunk #21 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,   -1,
			  127,   -1,  129,   -1,   -1,   -1,   -1,  134,   -1,  136,
			   -1,   -1,   -1,  140,  141,  142,   -1,   -1,   -1,    6,
			   -1,    8,   -1,   10,   -1,   12,   13,   14,   15,  156,
			  157,   18,   19,   -1,   21,   -1,   -1,   24,   25,   -1,
			   -1,   -1,   29,   -1,   -1,   -1,   33,   -1,   -1,   -1,
			   37,   -1,   39,   40,   -1,   -1,   -1,   44,   45,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,
			   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,
			   67,   -1,   69,   70,   -1,   72,   73,   74,   -1,   -1,

			   -1,   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
			  107,  108,  109,  110,   -1,  112,  113,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,   -1,
			  127,   -1,  129,   -1,   -1,   -1,   -1,  134,  135,  136,
			   -1,   -1,   -1,  140,  141,  142,   -1,   -1,   -1,    6,
			   -1,    8,   -1,   10,   -1,   12,   13,   14,   15,  156,
			  157,   18,   19,   -1,   21,   -1,   -1,   24,   25,   -1,
			   -1,   -1,   29,   -1,   -1,   -1,   33,   -1,   -1,   -1, yyDummy>>,
			1, 200, 4000)
		end

	yycheck_template_22 (an_array: ARRAY [INTEGER])
			-- Fill chunk #22 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   37,   -1,   39,   40,   -1,   -1,   -1,   44,   45,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,
			   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,
			   67,   -1,   69,   70,   -1,   72,   73,   74,   -1,   -1,
			   -1,   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
			  107,  108,  109,  110,   -1,  112,  113,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,   -1,
			  127,   -1,  129,   -1,   -1,   -1,   -1,  134,   -1,  136,

			   -1,   -1,   -1,  140,  141,  142,   -1,   -1,   -1,    6,
			   -1,    8,   -1,   10,   -1,   12,   13,   14,   15,  156,
			  157,   18,   19,   -1,   21,   -1,   -1,   24,   25,   -1,
			   -1,   -1,   29,   -1,   -1,   -1,   33,   -1,   -1,   -1,
			   37,   -1,   39,   40,   -1,   -1,   -1,   44,   45,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,
			   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,
			   67,   -1,   69,   70,   -1,   72,   73,   74,   -1,   -1,
			   -1,   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96, yyDummy>>,
			1, 200, 4200)
		end

	yycheck_template_23 (an_array: ARRAY [INTEGER])
			-- Fill chunk #23 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
			  107,  108,  109,  110,   -1,  112,  113,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,   -1,
			  127,   -1,  129,   -1,   -1,   -1,   -1,  134,   -1,  136,
			   -1,   -1,   -1,  140,  141,  142,   -1,   -1,    6,   -1,
			    8,   -1,   10,   -1,   12,   13,   14,   15,   -1,  156,
			   18,   19,   -1,   21,   -1,   -1,   24,   25,   -1,   -1,
			   -1,   29,   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,
			   -1,   39,   40,   -1,   -1,   -1,   44,   45,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,   57,

			   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,   67,
			   -1,   69,   70,   -1,   72,   73,   74,   -1,   -1,   -1,
			   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
			  108,  109,  110,   -1,  112,  113,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  123,  124,  125,   -1,  127,
			   -1,  129,   -1,   -1,   -1,   -1,  134,   -1,  136,   -1,
			   -1,   -1,  140,  141,  142,   -1,   -1,    6,   -1,    8,
			   -1,   10,   -1,   12,   13,   14,   15,   -1,  156,   18, yyDummy>>,
			1, 200, 4400)
		end

	yycheck_template_24 (an_array: ARRAY [INTEGER])
			-- Fill chunk #24 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   19,   -1,   21,   -1,   -1,   24,   25,   -1,   -1,   -1,
			   29,   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,   -1,
			   39,   40,   -1,   -1,   -1,   44,   45,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,
			   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,
			   69,   70,   -1,   72,   73,   74,   -1,   -1,   -1,   -1,
			   -1,   -1,   81,   82,   83,   84,   85,   86,   87,   88,
			   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
			   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
			  109,  110,   -1,  112,  113,   -1,   -1,   -1,   -1,   -1,

			   -1,   -1,   -1,   -1,  123,  124,  125,   -1,  127,   -1,
			  129,   -1,   -1,   -1,   -1,  134,   -1,  136,   -1,   -1,
			   -1,  140,  141,  142,   -1,   -1,    6,   -1,    8,   -1,
			   10,   -1,   12,   13,   14,   15,   -1,  156,   18,   19,
			   -1,   21,   -1,   -1,   24,   25,   -1,   -1,   -1,   29,
			   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,   -1,   39,
			   40,   -1,   -1,   -1,   44,   45,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,
			   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,
			   70,   -1,   72,   73,   74,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 4600)
		end

	yycheck_template_25 (an_array: ARRAY [INTEGER])
			-- Fill chunk #25 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
			  110,   -1,  112,  113,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,    7,    8,  123,  124,  125,   -1,  127,   14,  129,
			   -1,   -1,   18,   -1,  134,   21,  136,   -1,   24,   -1,
			  140,  141,  142,   -1,   -1,   -1,   -1,   33,   -1,   -1,
			   -1,   -1,   -1,   39,   -1,   41,  156,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,
			   -1,   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,

			   66,   67,   -1,   69,   70,   71,   72,   73,   74,   75,
			   -1,   -1,   -1,   79,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,  107,  108,  109,  110,  111,  112,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
			  126,  127,   -1,  129,   -1,   -1,   -1,   -1,  134,   -1,
			   -1,  137,  138,    7,    8,   -1,  142,  143,  144,   -1,
			   14,   -1,   -1,   -1,   18,  151,   -1,   21,   -1,   -1,
			   24,  157,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33, yyDummy>>,
			1, 200, 4800)
		end

	yycheck_template_26 (an_array: ARRAY [INTEGER])
			-- Fill chunk #26 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   -1,   39,   -1,   41,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,
			   -1,   55,   -1,   57,   58,   -1,   -1,   61,   -1,   -1,
			   -1,   -1,   66,   67,   -1,   69,   70,   71,   72,   73,
			   74,   75,   -1,   -1,   -1,   79,   -1,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
			  104,  105,  106,  107,  108,  109,  110,  111,  112,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
			  124,  125,  126,  127,   -1,  129,   -1,   -1,   -1,   -1,

			  134,   -1,    8,  137,  138,   -1,   -1,   -1,  142,  143,
			  144,   -1,   18,   -1,   -1,   21,   -1,  151,   24,   -1,
			   -1,   -1,   -1,  157,   -1,   -1,   -1,   33,   -1,   -1,
			   -1,   -1,   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,
			   -1,   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,
			   66,   67,   -1,   69,   70,   71,   72,   73,   74,   75,
			   -1,   -1,   -1,   79,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105, yyDummy>>,
			1, 200, 5000)
		end

	yycheck_template_27 (an_array: ARRAY [INTEGER])
			-- Fill chunk #27 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  106,  107,  108,  109,  110,  111,  112,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
			  126,  127,   -1,  129,  130,   -1,   -1,   -1,  134,    7,
			    8,  137,  138,   -1,   -1,   -1,  142,  143,  144,   -1,
			   18,   -1,   -1,   21,   -1,  151,   24,   -1,   -1,   -1,
			   -1,  157,  158,   -1,   -1,   33,   -1,   -1,   -1,   -1,
			   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,   -1,   57,
			   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,   67,
			   -1,   69,   70,   71,   72,   73,   74,   75,   -1,   -1,

			   -1,   79,   -1,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
			  108,  109,  110,  111,  112,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  123,  124,  125,  126,  127,
			   -1,  129,   -1,   -1,   -1,   -1,  134,    7,    8,  137,
			  138,   -1,   -1,   -1,  142,  143,  144,   -1,   18,   -1,
			   -1,   21,   -1,  151,   24,   -1,   -1,   -1,   -1,  157,
			   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   39,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 5200)
		end

	yycheck_template_28 (an_array: ARRAY [INTEGER])
			-- Fill chunk #28 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   50,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,
			   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,
			   70,   71,   72,   73,   74,   75,   -1,   -1,   -1,   79,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
			  110,  111,  112,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  123,  124,  125,  126,  127,   -1,  129,
			   -1,   -1,   -1,   -1,  134,   -1,    8,  137,  138,   -1,
			   -1,   -1,  142,  143,  144,   -1,   18,   -1,   -1,   21,

			   -1,  151,   24,   -1,   -1,   -1,   -1,  157,   -1,   -1,
			   -1,   33,   -1,   -1,   -1,   -1,   -1,   39,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,
			   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,   61,
			   -1,   -1,   -1,   -1,   66,   67,   -1,   69,   70,   71,
			   72,   73,   74,   75,   -1,   -1,   -1,   79,   -1,   81,
			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
			   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
			  102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
			  112,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 5400)
		end

	yycheck_template_29 (an_array: ARRAY [INTEGER])
			-- Fill chunk #29 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,  123,  124,  125,  126,  127,   -1,  129,   -1,   -1,
			   -1,   -1,  134,   -1,   -1,  137,  138,   -1,   -1,   -1,
			  142,  143,  144,   -1,   -1,   -1,    6,   -1,    8,  151,
			   10,   -1,   -1,   -1,   -1,  157,  158,   -1,   18,   19,
			   -1,   21,   -1,   -1,   24,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   39,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,
			   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,
			   70,   -1,   72,   73,   74,   -1,   -1,   -1,   -1,   -1,

			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
			  110,    5,  112,  113,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  123,  124,  125,    5,  127,   -1,  129,
			   -1,   -1,   26,   -1,  134,   -1,  136,   -1,   -1,   -1,
			  140,   -1,  142,   -1,   -1,   -1,   -1,   26,   -1,   -1,
			   -1,    7,   -1,   -1,   -1,   11,  156,   -1,   14,   -1,
			   -1,   17,   -1,   -1,   20,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   28,   -1,   -1,   31,   32,   71,   -1,   -1, yyDummy>>,
			1, 200, 5600)
		end

	yycheck_template_30 (an_array: ARRAY [INTEGER])
			-- Fill chunk #30 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   36,   -1,   76,   77,   78,   -1,   80,   -1,   -1,   -1,
			   46,   47,   71,   49,   -1,   -1,   52,   76,   77,   78,
			   -1,   80,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  114,  115,  116,  117,  118,  119,  120,  121,  122,   -1,
			   -1,   -1,   -1,   -1,   -1,  114,  115,  116,  117,  118,
			  119,  120,  121,  122,   -1,   -1,   -1,   -1,  142,  143,
			  144,  145,  146,  147,  148,  149,  150,   -1,  152,  153,
			  154,  155,   -1,  142,  143,  144,  145,  146,  147,  148,
			  149,  150,    8,  152,  153,  154,  155,   -1,   -1,   -1,

			   -1,   -1,   18,   -1,   -1,   21,   -1,   -1,   24,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
			   -1,   -1,   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,
			   -1,   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,
			   66,   67,   -1,   69,   70,   71,   72,   73,   74,   75,
			   -1,   -1,   -1,   79,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,  107,  108,  109,  110,  111,  112,   -1,   -1,   -1, yyDummy>>,
			1, 200, 5800)
		end

	yycheck_template_31 (an_array: ARRAY [INTEGER])
			-- Fill chunk #31 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
			  126,  127,   -1,  129,   -1,   -1,   -1,  133,  134,   -1,
			    8,  137,  138,   -1,   -1,   -1,  142,  143,  144,   -1,
			   18,   -1,   -1,   21,   -1,  151,   24,   -1,   -1,   -1,
			   -1,  157,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,
			   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,   -1,   57,
			   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,   67,
			   -1,   69,   70,   71,   72,   73,   74,   75,   -1,   -1,
			   -1,   79,   -1,   81,   82,   83,   84,   85,   86,   87,

			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
			  108,  109,  110,  111,  112,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  123,  124,  125,  126,  127,
			   -1,  129,   -1,   -1,   -1,   -1,  134,  135,    8,  137,
			  138,   -1,   -1,   -1,  142,  143,  144,   -1,   18,   -1,
			   -1,   21,   -1,  151,   24,   -1,   -1,   -1,   -1,  157,
			   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   39,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   50,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1, yyDummy>>,
			1, 200, 6000)
		end

	yycheck_template_32 (an_array: ARRAY [INTEGER])
			-- Fill chunk #32 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,
			   70,   71,   72,   73,   74,   75,   -1,   -1,   -1,   79,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
			  110,  111,  112,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  123,  124,  125,  126,  127,   -1,  129,
			  130,   -1,   -1,   -1,  134,   -1,    8,  137,  138,   -1,
			   -1,   -1,  142,  143,  144,   -1,   18,   -1,   -1,   21,
			   -1,  151,   24,   -1,   -1,   -1,   -1,  157,   -1,   -1,

			   -1,   33,   -1,   -1,   -1,   -1,   -1,   39,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,
			   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,   61,
			   62,   -1,   -1,   -1,   66,   67,   -1,   69,   70,   71,
			   72,   73,   74,   75,   -1,   -1,   -1,   79,   -1,   81,
			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
			   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
			  102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
			  112,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,  123,  124,  125,  126,  127,   -1,  129,   -1,   -1, yyDummy>>,
			1, 200, 6200)
		end

	yycheck_template_33 (an_array: ARRAY [INTEGER])
			-- Fill chunk #33 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,  134,   -1,    8,  137,  138,   -1,   -1,   -1,
			  142,  143,  144,   -1,   18,   -1,   -1,   21,   -1,  151,
			   24,   -1,   -1,   -1,   -1,  157,   -1,   -1,   -1,   33,
			   -1,   -1,   -1,   -1,   -1,   39,   -1,   41,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,
			   -1,   55,   -1,   57,   58,   -1,   -1,   61,   -1,   -1,
			   -1,   -1,   66,   67,   -1,   69,   70,   71,   72,   73,
			   74,   75,   -1,   -1,   -1,   79,   -1,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,

			  104,  105,  106,  107,  108,  109,  110,  111,  112,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
			  124,  125,  126,  127,   -1,  129,   -1,   -1,   -1,   -1,
			  134,   -1,    8,  137,  138,   -1,   12,   -1,  142,  143,
			  144,   -1,   18,   -1,   -1,   21,   -1,  151,   24,   -1,
			   -1,   -1,   -1,  157,   -1,   -1,   -1,   33,   -1,   -1,
			   -1,   -1,   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,
			   -1,   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,
			   66,   67,   -1,   69,   70,   71,   72,   73,   74,   75, yyDummy>>,
			1, 200, 6400)
		end

	yycheck_template_34 (an_array: ARRAY [INTEGER])
			-- Fill chunk #34 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   79,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,  107,  108,  109,  110,  111,  112,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
			  126,  127,   -1,  129,   -1,   -1,   -1,   -1,  134,   -1,
			    8,  137,  138,   -1,   -1,   -1,  142,  143,  144,   -1,
			   18,   -1,   -1,   21,   -1,  151,   24,   -1,   -1,   -1,
			   -1,  157,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,
			   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,   -1,   57,
			   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,   67,
			   -1,   69,   70,   71,   72,   73,   74,   75,   -1,   -1,
			   -1,   79,   -1,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
			  108,  109,  110,  111,  112,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  123,  124,  125,  126,  127,
			   -1,  129,   -1,   -1,   -1,  133,  134,   -1,    8,  137,
			  138,   -1,   -1,   -1,  142,  143,  144,   -1,   18,   -1, yyDummy>>,
			1, 200, 6600)
		end

	yycheck_template_35 (an_array: ARRAY [INTEGER])
			-- Fill chunk #35 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   21,   -1,  151,   24,   -1,   -1,   -1,   -1,  157,
			   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   39,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   50,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,
			   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,
			   70,   71,   72,   73,   74,   75,   -1,   -1,   -1,   79,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
			  110,  111,  112,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   -1,   -1,   -1,  123,  124,  125,  126,  127,   -1,  129,
			   -1,   -1,   -1,   -1,  134,   -1,    8,  137,  138,   -1,
			   -1,   -1,  142,  143,  144,   -1,   18,   -1,   -1,   21,
			   -1,  151,   24,   -1,   -1,   -1,   -1,  157,   -1,   -1,
			   -1,   33,   -1,   -1,   -1,   -1,   -1,   39,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,
			   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,   61,
			   -1,   -1,   -1,   -1,   66,   67,   -1,   69,   70,   71,
			   72,   73,   74,   75,   -1,   -1,   -1,   79,   -1,   81,
			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91, yyDummy>>,
			1, 200, 6800)
		end

	yycheck_template_36 (an_array: ARRAY [INTEGER])
			-- Fill chunk #36 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
			  102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
			  112,   12,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,  123,  124,  125,  126,  127,   -1,  129,   14,   -1,
			   -1,   -1,  134,   -1,   -1,  137,  138,   -1,   -1,   -1,
			  142,  143,  144,   -1,   -1,   -1,   -1,   -1,   -1,  151,
			   -1,   -1,   -1,   -1,   -1,  157,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   71,   -1,   -1,   -1,   -1,   76,   77,   78,   -1,   80,
			   -1,   -1,   -1,   -1,   -1,   71,   -1,   -1,   -1,   -1,

			   76,   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   14,   -1,
			   -1,   -1,   -1,  114,  115,  116,  117,  118,  119,  120,
			  121,  122,   -1,   -1,   -1,   -1,   -1,   -1,  114,  115,
			  116,  117,  118,  119,  120,  121,  122,   -1,   -1,   -1,
			   -1,  142,  143,  144,  145,  146,  147,  148,  149,  150,
			   71,  152,  153,  154,  155,   76,  142,  143,  144,  145,
			  146,  147,  148,  149,  150,   71,  152,  153,  154,  155,
			   76,   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 7000)
		end

	yycheck_template_37 (an_array: ARRAY [INTEGER])
			-- Fill chunk #37 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,    8,  114,  115,  116,  117,  118,  119,  120,
			  121,  122,   -1,   -1,   -1,   -1,   -1,   -1,  114,  115,
			  116,  117,  118,  119,  120,  121,  122,   -1,   -1,   -1,
			   -1,  142,  143,  144,   -1,   -1,   -1,   -1,  149,  150,
			   -1,  152,  153,  154,  155,   -1,  142,  143,  144,  145,
			  146,  147,  148,  149,  150,   -1,  152,  153,  154,  155,
			   66,   67,   -1,   69,   -1,   -1,   72,   73,   74,   75,
			   -1,   -1,   -1,   -1,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,

			  106,  107,  108,  109,  110,  111,   22,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   30,   -1,   -1,   -1,  124,  125,
			   -1,  127,   -1,   -1,   -1,   -1,   -1,   43,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  143,  144,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   66,   67,   -1,   69,   -1,   -1,   -1,   -1,   -1,   75,
			   -1,   -1,   -1,   -1,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,  107,  108,  109,  110,  111,   41,   -1,   -1,   -1, yyDummy>>,
			1, 200, 7200)
		end

	yycheck_template_38 (an_array: ARRAY [INTEGER])
			-- Fill chunk #38 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,
			   41,  127,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   71,  143,  144,   -1,
			   -1,   76,   77,   78,   -1,   80,   -1,   -1,   -1,   -1,
			   71,   -1,   -1,   -1,   -1,   76,   77,   78,   -1,   80,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,
			  115,  116,  117,  118,  119,  120,  121,  122,   -1,   -1,
			   -1,   -1,   -1,  114,  115,  116,  117,  118,  119,  120,
			  121,  122,   -1,   -1,   45,   -1,   -1,  142,  143,  144,

			  145,  146,  147,  148,  149,  150,   -1,  152,  153,  154,
			  155,  142,  143,  144,  145,  146,  147,  148,  149,  150,
			   71,  152,  153,  154,  155,   76,   77,   78,   -1,   80,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
			  110,   -1,   -1,  114,  115,  116,  117,  118,  119,  120,
			  121,  122,   -1,   -1,   -1,  125,   -1,  127,   -1,   -1,
			   -1,   -1,   43,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,  142,  143,  144,  145,  146,  147,  148,  149,  150, yyDummy>>,
			1, 200, 7400)
		end

	yycheck_template_39 (an_array: ARRAY [INTEGER])
			-- Fill chunk #39 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,  152,  153,  154,  155,   66,   67,   -1,   69,   -1,
			   -1,   -1,   -1,   -1,   75,   -1,   -1,   -1,   -1,   -1,
			   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
			   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
			  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
			  111,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  124,  125,   61,  127,   -1,   -1,   -1,
			   -1,   -1,   -1,   69,   -1,   -1,   -1,   -1,   -1,   75,
			   -1,   -1,  143,  144,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,

			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,  107,  108,  109,  110,  111,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   71,   -1,   -1,  124,  125,
			   76,   77,   78,   -1,   80,   -1,   -1,   -1,   -1,  135,
			   -1,   -1,   -1,   -1,   71,   -1,   -1,  143,  144,   76,
			   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  158,   -1,   -1,   -1,   -1,   -1,  114,  115,
			  116,  117,  118,  119,  120,  121,  122,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,  115,  116,
			  117,  118,  119,  120,  121,  122,  142,  143,  144,  145, yyDummy>>,
			1, 200, 7600)
		end

	yycheck_template_40 (an_array: ARRAY [INTEGER])
			-- Fill chunk #40 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  146,  147,  148,  149,  150,   -1,  152,  153,  154,  155,
			  156,   -1,   -1,   -1,   -1,  142,  143,  144,  145,  146,
			  147,  148,  149,  150,   -1,  152,  153,  154,  155,  156,
			   71,   -1,   -1,   -1,   -1,   76,   77,   78,   -1,   80,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
			  110,   -1,   -1,  114,  115,  116,  117,  118,  119,  120,
			  121,  122,   -1,   -1,   -1,  125,   -1,   -1,   71,   -1,
			   -1,  132,  133,   76,   77,   78,   -1,   80,   -1,   -1,

			   -1,  142,  143,  144,  145,  146,  147,  148,  149,  150,
			   -1,  152,  153,  154,  155,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,  114,  115,  116,  117,  118,  119,  120,  121,  122,
			   -1,   -1,   -1,   -1,   -1,   71,   -1,  130,   -1,  132,
			   76,   77,   78,   -1,   80,   -1,   -1,   -1,   -1,  142,
			  143,  144,  145,  146,  147,  148,  149,  150,   -1,  152,
			  153,  154,  155,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,  115,
			  116,  117,  118,  119,  120,  121,  122,   -1,   -1,   -1, yyDummy>>,
			1, 200, 7800)
		end

	yycheck_template_41 (an_array: ARRAY [INTEGER])
			-- Fill chunk #41 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   71,   -1,   -1,  132,  133,   76,   77,
			   78,   -1,   80,   -1,   -1,   -1,  142,  143,  144,  145,
			  146,  147,  148,  149,  150,   -1,  152,  153,  154,  155,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  114,  115,  116,  117,
			  118,  119,  120,  121,  122,   71,   -1,   -1,   -1,   -1,
			   76,   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,
			   -1,  139,   -1,   -1,  142,  143,  144,  145,  146,  147,
			  148,  149,  150,   -1,  152,  153,  154,  155,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,  115,

			  116,  117,  118,  119,  120,  121,  122,   71,   -1,   -1,
			   -1,   -1,   76,   77,   78,   -1,   80,   -1,   -1,   -1,
			   -1,   -1,   -1,  139,   -1,   -1,  142,  143,  144,  145,
			  146,  147,  148,  149,  150,   -1,  152,  153,  154,  155,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  114,  115,  116,  117,  118,  119,  120,  121,  122,   71,
			   -1,   -1,   -1,   -1,   76,   77,   78,   -1,   80,   -1,
			   -1,   -1,   -1,   -1,   -1,  139,   -1,   -1,  142,  143,
			  144,  145,  146,  147,  148,  149,  150,   -1,  152,  153,
			  154,  155,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 8000)
		end

	yycheck_template_42 (an_array: ARRAY [INTEGER])
			-- Fill chunk #42 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,  114,  115,  116,  117,  118,  119,  120,  121,
			  122,   -1,   -1,   -1,   71,   -1,   -1,   -1,  130,   76,
			   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,   -1,
			  142,  143,  144,  145,  146,  147,  148,  149,  150,   -1,
			  152,  153,  154,  155,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,  115,  116,
			  117,  118,  119,  120,  121,  122,   71,   -1,   -1,   -1,
			   -1,   76,   77,   78,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  142,  143,  144,  145,  146,
			  147,  148,  149,  150,   -1,  152,  153,  154,  155,   -1,

			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,
			  115,  116,  117,  118,  119,  120,  121,  122,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   61,   -1,   -1,   -1,   -1,  142,  143,  144,
			   69,  146,  147,  148,  149,  150,   75,  152,  153,  154,
			  155,   -1,   81,   82,   83,   84,   85,   86,   87,   88,
			   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
			   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
			  109,  110,  111,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,   -1,   -1, yyDummy>>,
			1, 200, 8200)
		end

	yycheck_template_43 (an_array: ARRAY [INTEGER])
			-- Fill chunk #43 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   69,   -1,  135,   -1,   -1,   -1,
			   75,   -1,   -1,   -1,  143,  144,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,  107,  108,  109,  110,  111,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
			  125,   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   69,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  143,  144,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,

			  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
			  110,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  135,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,  107,  108,  109,  110, 1296, 1297, 1298, 1299,
			 1300, 1301, 1302, 1303, 1304, 1305, 1306, 1307, 1308, 1309,
			 1310, 1311, 1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319,
			 1320, 1321, 1322, 1323, 1324, yyDummy>>,
			1, 195, 8400)
		end

feature {NONE} -- Semantic value stacks

	yyvs1: SPECIAL [detachable ANY]
			-- Stack for semantic values of type detachable ANY

	yyvsc1: INTEGER
			-- Capacity of semantic value stack `yyvs1'

	yyvsp1: INTEGER
			-- Top of semantic value stack `yyvs1'

	yyspecial_routines1: KL_SPECIAL_ROUTINES [detachable ANY]
			-- Routines that ought to be in SPECIAL [detachable ANY]

	yyvs2: SPECIAL [detachable ET_KEYWORD]
			-- Stack for semantic values of type detachable ET_KEYWORD

	yyvsc2: INTEGER
			-- Capacity of semantic value stack `yyvs2'

	yyvsp2: INTEGER
			-- Top of semantic value stack `yyvs2'

	yyspecial_routines2: KL_SPECIAL_ROUTINES [detachable ET_KEYWORD]
			-- Routines that ought to be in SPECIAL [detachable ET_KEYWORD]

	yyvs3: SPECIAL [detachable ET_AGENT_KEYWORD]
			-- Stack for semantic values of type detachable ET_AGENT_KEYWORD

	yyvsc3: INTEGER
			-- Capacity of semantic value stack `yyvs3'

	yyvsp3: INTEGER
			-- Top of semantic value stack `yyvs3'

	yyspecial_routines3: KL_SPECIAL_ROUTINES [detachable ET_AGENT_KEYWORD]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_KEYWORD]

	yyvs4: SPECIAL [detachable ET_PRECURSOR_KEYWORD]
			-- Stack for semantic values of type detachable ET_PRECURSOR_KEYWORD

	yyvsc4: INTEGER
			-- Capacity of semantic value stack `yyvs4'

	yyvsp4: INTEGER
			-- Top of semantic value stack `yyvs4'

	yyspecial_routines4: KL_SPECIAL_ROUTINES [detachable ET_PRECURSOR_KEYWORD]
			-- Routines that ought to be in SPECIAL [detachable ET_PRECURSOR_KEYWORD]

	yyvs5: SPECIAL [detachable ET_SYMBOL]
			-- Stack for semantic values of type detachable ET_SYMBOL

	yyvsc5: INTEGER
			-- Capacity of semantic value stack `yyvs5'

	yyvsp5: INTEGER
			-- Top of semantic value stack `yyvs5'

	yyspecial_routines5: KL_SPECIAL_ROUTINES [detachable ET_SYMBOL]
			-- Routines that ought to be in SPECIAL [detachable ET_SYMBOL]

	yyvs6: SPECIAL [detachable ET_POSITION]
			-- Stack for semantic values of type detachable ET_POSITION

	yyvsc6: INTEGER
			-- Capacity of semantic value stack `yyvs6'

	yyvsp6: INTEGER
			-- Top of semantic value stack `yyvs6'

	yyspecial_routines6: KL_SPECIAL_ROUTINES [detachable ET_POSITION]
			-- Routines that ought to be in SPECIAL [detachable ET_POSITION]

	yyvs7: SPECIAL [detachable ET_BOOLEAN_CONSTANT]
			-- Stack for semantic values of type detachable ET_BOOLEAN_CONSTANT

	yyvsc7: INTEGER
			-- Capacity of semantic value stack `yyvs7'

	yyvsp7: INTEGER
			-- Top of semantic value stack `yyvs7'

	yyspecial_routines7: KL_SPECIAL_ROUTINES [detachable ET_BOOLEAN_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_BOOLEAN_CONSTANT]

	yyvs8: SPECIAL [detachable ET_BREAK]
			-- Stack for semantic values of type detachable ET_BREAK

	yyvsc8: INTEGER
			-- Capacity of semantic value stack `yyvs8'

	yyvsp8: INTEGER
			-- Top of semantic value stack `yyvs8'

	yyspecial_routines8: KL_SPECIAL_ROUTINES [detachable ET_BREAK]
			-- Routines that ought to be in SPECIAL [detachable ET_BREAK]

	yyvs9: SPECIAL [detachable ET_CHARACTER_CONSTANT]
			-- Stack for semantic values of type detachable ET_CHARACTER_CONSTANT

	yyvsc9: INTEGER
			-- Capacity of semantic value stack `yyvs9'

	yyvsp9: INTEGER
			-- Top of semantic value stack `yyvs9'

	yyspecial_routines9: KL_SPECIAL_ROUTINES [detachable ET_CHARACTER_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_CHARACTER_CONSTANT]

	yyvs10: SPECIAL [detachable ET_CURRENT]
			-- Stack for semantic values of type detachable ET_CURRENT

	yyvsc10: INTEGER
			-- Capacity of semantic value stack `yyvs10'

	yyvsp10: INTEGER
			-- Top of semantic value stack `yyvs10'

	yyspecial_routines10: KL_SPECIAL_ROUTINES [detachable ET_CURRENT]
			-- Routines that ought to be in SPECIAL [detachable ET_CURRENT]

	yyvs11: SPECIAL [detachable ET_FREE_OPERATOR]
			-- Stack for semantic values of type detachable ET_FREE_OPERATOR

	yyvsc11: INTEGER
			-- Capacity of semantic value stack `yyvs11'

	yyvsp11: INTEGER
			-- Top of semantic value stack `yyvs11'

	yyspecial_routines11: KL_SPECIAL_ROUTINES [detachable ET_FREE_OPERATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_FREE_OPERATOR]

	yyvs12: SPECIAL [detachable ET_IDENTIFIER]
			-- Stack for semantic values of type detachable ET_IDENTIFIER

	yyvsc12: INTEGER
			-- Capacity of semantic value stack `yyvs12'

	yyvsp12: INTEGER
			-- Top of semantic value stack `yyvs12'

	yyspecial_routines12: KL_SPECIAL_ROUTINES [detachable ET_IDENTIFIER]
			-- Routines that ought to be in SPECIAL [detachable ET_IDENTIFIER]

	yyvs13: SPECIAL [detachable ET_INTEGER_CONSTANT]
			-- Stack for semantic values of type detachable ET_INTEGER_CONSTANT

	yyvsc13: INTEGER
			-- Capacity of semantic value stack `yyvs13'

	yyvsp13: INTEGER
			-- Top of semantic value stack `yyvs13'

	yyspecial_routines13: KL_SPECIAL_ROUTINES [detachable ET_INTEGER_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_INTEGER_CONSTANT]

	yyvs14: SPECIAL [detachable ET_KEYWORD_OPERATOR]
			-- Stack for semantic values of type detachable ET_KEYWORD_OPERATOR

	yyvsc14: INTEGER
			-- Capacity of semantic value stack `yyvs14'

	yyvsp14: INTEGER
			-- Top of semantic value stack `yyvs14'

	yyspecial_routines14: KL_SPECIAL_ROUTINES [detachable ET_KEYWORD_OPERATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_KEYWORD_OPERATOR]

	yyvs15: SPECIAL [detachable ET_MANIFEST_STRING]
			-- Stack for semantic values of type detachable ET_MANIFEST_STRING

	yyvsc15: INTEGER
			-- Capacity of semantic value stack `yyvs15'

	yyvsp15: INTEGER
			-- Top of semantic value stack `yyvs15'

	yyspecial_routines15: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_STRING]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_STRING]

	yyvs16: SPECIAL [detachable ET_REAL_CONSTANT]
			-- Stack for semantic values of type detachable ET_REAL_CONSTANT

	yyvsc16: INTEGER
			-- Capacity of semantic value stack `yyvs16'

	yyvsp16: INTEGER
			-- Top of semantic value stack `yyvs16'

	yyspecial_routines16: KL_SPECIAL_ROUTINES [detachable ET_REAL_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_REAL_CONSTANT]

	yyvs17: SPECIAL [detachable ET_RESULT]
			-- Stack for semantic values of type detachable ET_RESULT

	yyvsc17: INTEGER
			-- Capacity of semantic value stack `yyvs17'

	yyvsp17: INTEGER
			-- Top of semantic value stack `yyvs17'

	yyspecial_routines17: KL_SPECIAL_ROUTINES [detachable ET_RESULT]
			-- Routines that ought to be in SPECIAL [detachable ET_RESULT]

	yyvs18: SPECIAL [detachable ET_RETRY_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_RETRY_INSTRUCTION

	yyvsc18: INTEGER
			-- Capacity of semantic value stack `yyvs18'

	yyvsp18: INTEGER
			-- Top of semantic value stack `yyvs18'

	yyspecial_routines18: KL_SPECIAL_ROUTINES [detachable ET_RETRY_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_RETRY_INSTRUCTION]

	yyvs19: SPECIAL [detachable ET_SYMBOL_OPERATOR]
			-- Stack for semantic values of type detachable ET_SYMBOL_OPERATOR

	yyvsc19: INTEGER
			-- Capacity of semantic value stack `yyvs19'

	yyvsp19: INTEGER
			-- Top of semantic value stack `yyvs19'

	yyspecial_routines19: KL_SPECIAL_ROUTINES [detachable ET_SYMBOL_OPERATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_SYMBOL_OPERATOR]

	yyvs20: SPECIAL [detachable ET_VOID]
			-- Stack for semantic values of type detachable ET_VOID

	yyvsc20: INTEGER
			-- Capacity of semantic value stack `yyvs20'

	yyvsp20: INTEGER
			-- Top of semantic value stack `yyvs20'

	yyspecial_routines20: KL_SPECIAL_ROUTINES [detachable ET_VOID]
			-- Routines that ought to be in SPECIAL [detachable ET_VOID]

	yyvs21: SPECIAL [detachable ET_SEMICOLON_SYMBOL]
			-- Stack for semantic values of type detachable ET_SEMICOLON_SYMBOL

	yyvsc21: INTEGER
			-- Capacity of semantic value stack `yyvs21'

	yyvsp21: INTEGER
			-- Top of semantic value stack `yyvs21'

	yyspecial_routines21: KL_SPECIAL_ROUTINES [detachable ET_SEMICOLON_SYMBOL]
			-- Routines that ought to be in SPECIAL [detachable ET_SEMICOLON_SYMBOL]

	yyvs22: SPECIAL [detachable ET_BRACKET_SYMBOL]
			-- Stack for semantic values of type detachable ET_BRACKET_SYMBOL

	yyvsc22: INTEGER
			-- Capacity of semantic value stack `yyvs22'

	yyvsp22: INTEGER
			-- Top of semantic value stack `yyvs22'

	yyspecial_routines22: KL_SPECIAL_ROUTINES [detachable ET_BRACKET_SYMBOL]
			-- Routines that ought to be in SPECIAL [detachable ET_BRACKET_SYMBOL]

	yyvs23: SPECIAL [detachable ET_QUESTION_MARK_SYMBOL]
			-- Stack for semantic values of type detachable ET_QUESTION_MARK_SYMBOL

	yyvsc23: INTEGER
			-- Capacity of semantic value stack `yyvs23'

	yyvsp23: INTEGER
			-- Top of semantic value stack `yyvs23'

	yyspecial_routines23: KL_SPECIAL_ROUTINES [detachable ET_QUESTION_MARK_SYMBOL]
			-- Routines that ought to be in SPECIAL [detachable ET_QUESTION_MARK_SYMBOL]

	yyvs24: SPECIAL [detachable ET_ACROSS_EXPRESSION]
			-- Stack for semantic values of type detachable ET_ACROSS_EXPRESSION

	yyvsc24: INTEGER
			-- Capacity of semantic value stack `yyvs24'

	yyvsp24: INTEGER
			-- Top of semantic value stack `yyvs24'

	yyspecial_routines24: KL_SPECIAL_ROUTINES [detachable ET_ACROSS_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_ACROSS_EXPRESSION]

	yyvs25: SPECIAL [detachable ET_ACROSS_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_ACROSS_INSTRUCTION

	yyvsc25: INTEGER
			-- Capacity of semantic value stack `yyvs25'

	yyvsp25: INTEGER
			-- Top of semantic value stack `yyvs25'

	yyspecial_routines25: KL_SPECIAL_ROUTINES [detachable ET_ACROSS_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_ACROSS_INSTRUCTION]

	yyvs26: SPECIAL [detachable ET_ACTUAL_ARGUMENT_LIST]
			-- Stack for semantic values of type detachable ET_ACTUAL_ARGUMENT_LIST

	yyvsc26: INTEGER
			-- Capacity of semantic value stack `yyvs26'

	yyvsp26: INTEGER
			-- Top of semantic value stack `yyvs26'

	yyspecial_routines26: KL_SPECIAL_ROUTINES [detachable ET_ACTUAL_ARGUMENT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ACTUAL_ARGUMENT_LIST]

	yyvs27: SPECIAL [detachable ET_ACTUAL_PARAMETER_ITEM]
			-- Stack for semantic values of type detachable ET_ACTUAL_PARAMETER_ITEM

	yyvsc27: INTEGER
			-- Capacity of semantic value stack `yyvs27'

	yyvsp27: INTEGER
			-- Top of semantic value stack `yyvs27'

	yyspecial_routines27: KL_SPECIAL_ROUTINES [detachable ET_ACTUAL_PARAMETER_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_ACTUAL_PARAMETER_ITEM]

	yyvs28: SPECIAL [detachable ET_ACTUAL_PARAMETER_LIST]
			-- Stack for semantic values of type detachable ET_ACTUAL_PARAMETER_LIST

	yyvsc28: INTEGER
			-- Capacity of semantic value stack `yyvs28'

	yyvsp28: INTEGER
			-- Top of semantic value stack `yyvs28'

	yyspecial_routines28: KL_SPECIAL_ROUTINES [detachable ET_ACTUAL_PARAMETER_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ACTUAL_PARAMETER_LIST]

	yyvs29: SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND]
			-- Stack for semantic values of type detachable ET_AGENT_ARGUMENT_OPERAND

	yyvsc29: INTEGER
			-- Capacity of semantic value stack `yyvs29'

	yyvsp29: INTEGER
			-- Top of semantic value stack `yyvs29'

	yyspecial_routines29: KL_SPECIAL_ROUTINES [detachable ET_AGENT_ARGUMENT_OPERAND]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND]

	yyvs30: SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND_ITEM]
			-- Stack for semantic values of type detachable ET_AGENT_ARGUMENT_OPERAND_ITEM

	yyvsc30: INTEGER
			-- Capacity of semantic value stack `yyvs30'

	yyvsp30: INTEGER
			-- Top of semantic value stack `yyvs30'

	yyspecial_routines30: KL_SPECIAL_ROUTINES [detachable ET_AGENT_ARGUMENT_OPERAND_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND_ITEM]

	yyvs31: SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND_LIST]
			-- Stack for semantic values of type detachable ET_AGENT_ARGUMENT_OPERAND_LIST

	yyvsc31: INTEGER
			-- Capacity of semantic value stack `yyvs31'

	yyvsp31: INTEGER
			-- Top of semantic value stack `yyvs31'

	yyspecial_routines31: KL_SPECIAL_ROUTINES [detachable ET_AGENT_ARGUMENT_OPERAND_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND_LIST]

	yyvs32: SPECIAL [detachable ET_AGENT_TARGET]
			-- Stack for semantic values of type detachable ET_AGENT_TARGET

	yyvsc32: INTEGER
			-- Capacity of semantic value stack `yyvs32'

	yyvsp32: INTEGER
			-- Top of semantic value stack `yyvs32'

	yyspecial_routines32: KL_SPECIAL_ROUTINES [detachable ET_AGENT_TARGET]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_TARGET]

	yyvs33: SPECIAL [detachable ET_ALIAS_NAME]
			-- Stack for semantic values of type detachable ET_ALIAS_NAME

	yyvsc33: INTEGER
			-- Capacity of semantic value stack `yyvs33'

	yyvsp33: INTEGER
			-- Top of semantic value stack `yyvs33'

	yyspecial_routines33: KL_SPECIAL_ROUTINES [detachable ET_ALIAS_NAME]
			-- Routines that ought to be in SPECIAL [detachable ET_ALIAS_NAME]

	yyvs34: SPECIAL [detachable ET_ALIAS_NAME_LIST]
			-- Stack for semantic values of type detachable ET_ALIAS_NAME_LIST

	yyvsc34: INTEGER
			-- Capacity of semantic value stack `yyvs34'

	yyvsp34: INTEGER
			-- Top of semantic value stack `yyvs34'

	yyspecial_routines34: KL_SPECIAL_ROUTINES [detachable ET_ALIAS_NAME_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ALIAS_NAME_LIST]

	yyvs35: SPECIAL [detachable ET_ASSIGNER]
			-- Stack for semantic values of type detachable ET_ASSIGNER

	yyvsc35: INTEGER
			-- Capacity of semantic value stack `yyvs35'

	yyvsp35: INTEGER
			-- Top of semantic value stack `yyvs35'

	yyspecial_routines35: KL_SPECIAL_ROUTINES [detachable ET_ASSIGNER]
			-- Routines that ought to be in SPECIAL [detachable ET_ASSIGNER]

	yyvs36: SPECIAL [detachable ET_BRACKET_EXPRESSION]
			-- Stack for semantic values of type detachable ET_BRACKET_EXPRESSION

	yyvsc36: INTEGER
			-- Capacity of semantic value stack `yyvs36'

	yyvsp36: INTEGER
			-- Top of semantic value stack `yyvs36'

	yyspecial_routines36: KL_SPECIAL_ROUTINES [detachable ET_BRACKET_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_BRACKET_EXPRESSION]

	yyvs37: SPECIAL [detachable ET_CALL_AGENT]
			-- Stack for semantic values of type detachable ET_CALL_AGENT

	yyvsc37: INTEGER
			-- Capacity of semantic value stack `yyvs37'

	yyvsp37: INTEGER
			-- Top of semantic value stack `yyvs37'

	yyspecial_routines37: KL_SPECIAL_ROUTINES [detachable ET_CALL_AGENT]
			-- Routines that ought to be in SPECIAL [detachable ET_CALL_AGENT]

	yyvs38: SPECIAL [detachable ET_QUALIFIED_CALL_EXPRESSION]
			-- Stack for semantic values of type detachable ET_QUALIFIED_CALL_EXPRESSION

	yyvsc38: INTEGER
			-- Capacity of semantic value stack `yyvs38'

	yyvsp38: INTEGER
			-- Top of semantic value stack `yyvs38'

	yyspecial_routines38: KL_SPECIAL_ROUTINES [detachable ET_QUALIFIED_CALL_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_QUALIFIED_CALL_EXPRESSION]

	yyvs39: SPECIAL [detachable ET_CHECK_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_CHECK_INSTRUCTION

	yyvsc39: INTEGER
			-- Capacity of semantic value stack `yyvs39'

	yyvsp39: INTEGER
			-- Top of semantic value stack `yyvs39'

	yyspecial_routines39: KL_SPECIAL_ROUTINES [detachable ET_CHECK_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_CHECK_INSTRUCTION]

	yyvs40: SPECIAL [detachable ET_CHOICE]
			-- Stack for semantic values of type detachable ET_CHOICE

	yyvsc40: INTEGER
			-- Capacity of semantic value stack `yyvs40'

	yyvsp40: INTEGER
			-- Top of semantic value stack `yyvs40'

	yyspecial_routines40: KL_SPECIAL_ROUTINES [detachable ET_CHOICE]
			-- Routines that ought to be in SPECIAL [detachable ET_CHOICE]

	yyvs41: SPECIAL [detachable ET_CHOICE_CONSTANT]
			-- Stack for semantic values of type detachable ET_CHOICE_CONSTANT

	yyvsc41: INTEGER
			-- Capacity of semantic value stack `yyvs41'

	yyvsp41: INTEGER
			-- Top of semantic value stack `yyvs41'

	yyspecial_routines41: KL_SPECIAL_ROUTINES [detachable ET_CHOICE_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_CHOICE_CONSTANT]

	yyvs42: SPECIAL [detachable ET_CHOICE_ITEM]
			-- Stack for semantic values of type detachable ET_CHOICE_ITEM

	yyvsc42: INTEGER
			-- Capacity of semantic value stack `yyvs42'

	yyvsp42: INTEGER
			-- Top of semantic value stack `yyvs42'

	yyspecial_routines42: KL_SPECIAL_ROUTINES [detachable ET_CHOICE_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_CHOICE_ITEM]

	yyvs43: SPECIAL [detachable ET_CHOICE_LIST]
			-- Stack for semantic values of type detachable ET_CHOICE_LIST

	yyvsc43: INTEGER
			-- Capacity of semantic value stack `yyvs43'

	yyvsp43: INTEGER
			-- Top of semantic value stack `yyvs43'

	yyspecial_routines43: KL_SPECIAL_ROUTINES [detachable ET_CHOICE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CHOICE_LIST]

	yyvs44: SPECIAL [detachable ET_CLASS]
			-- Stack for semantic values of type detachable ET_CLASS

	yyvsc44: INTEGER
			-- Capacity of semantic value stack `yyvs44'

	yyvsp44: INTEGER
			-- Top of semantic value stack `yyvs44'

	yyspecial_routines44: KL_SPECIAL_ROUTINES [detachable ET_CLASS]
			-- Routines that ought to be in SPECIAL [detachable ET_CLASS]

	yyvs45: SPECIAL [detachable ET_CLIENT_ITEM]
			-- Stack for semantic values of type detachable ET_CLIENT_ITEM

	yyvsc45: INTEGER
			-- Capacity of semantic value stack `yyvs45'

	yyvsp45: INTEGER
			-- Top of semantic value stack `yyvs45'

	yyspecial_routines45: KL_SPECIAL_ROUTINES [detachable ET_CLIENT_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_CLIENT_ITEM]

	yyvs46: SPECIAL [detachable ET_CLIENTS]
			-- Stack for semantic values of type detachable ET_CLIENTS

	yyvsc46: INTEGER
			-- Capacity of semantic value stack `yyvs46'

	yyvsp46: INTEGER
			-- Top of semantic value stack `yyvs46'

	yyspecial_routines46: KL_SPECIAL_ROUTINES [detachable ET_CLIENTS]
			-- Routines that ought to be in SPECIAL [detachable ET_CLIENTS]

	yyvs47: SPECIAL [detachable ET_COMPOUND]
			-- Stack for semantic values of type detachable ET_COMPOUND

	yyvsc47: INTEGER
			-- Capacity of semantic value stack `yyvs47'

	yyvsp47: INTEGER
			-- Top of semantic value stack `yyvs47'

	yyspecial_routines47: KL_SPECIAL_ROUTINES [detachable ET_COMPOUND]
			-- Routines that ought to be in SPECIAL [detachable ET_COMPOUND]

	yyvs48: SPECIAL [detachable ET_CONDITIONAL]
			-- Stack for semantic values of type detachable ET_CONDITIONAL

	yyvsc48: INTEGER
			-- Capacity of semantic value stack `yyvs48'

	yyvsp48: INTEGER
			-- Top of semantic value stack `yyvs48'

	yyspecial_routines48: KL_SPECIAL_ROUTINES [detachable ET_CONDITIONAL]
			-- Routines that ought to be in SPECIAL [detachable ET_CONDITIONAL]

	yyvs49: SPECIAL [detachable ET_CONSTANT]
			-- Stack for semantic values of type detachable ET_CONSTANT

	yyvsc49: INTEGER
			-- Capacity of semantic value stack `yyvs49'

	yyvsp49: INTEGER
			-- Top of semantic value stack `yyvs49'

	yyspecial_routines49: KL_SPECIAL_ROUTINES [detachable ET_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTANT]

	yyvs50: SPECIAL [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM

	yyvsc50: INTEGER
			-- Capacity of semantic value stack `yyvs50'

	yyvsp50: INTEGER
			-- Top of semantic value stack `yyvs50'

	yyspecial_routines50: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM]

	yyvs51: SPECIAL [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST

	yyvsc51: INTEGER
			-- Capacity of semantic value stack `yyvs51'

	yyvsp51: INTEGER
			-- Top of semantic value stack `yyvs51'

	yyspecial_routines51: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST]

	yyvs52: SPECIAL [detachable ET_CONSTRAINT_CREATOR]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_CREATOR

	yyvsc52: INTEGER
			-- Capacity of semantic value stack `yyvs52'

	yyvsp52: INTEGER
			-- Top of semantic value stack `yyvs52'

	yyspecial_routines52: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_CREATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_CREATOR]

	yyvs53: SPECIAL [detachable ET_CONSTRAINT_RENAME_LIST]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_RENAME_LIST

	yyvsc53: INTEGER
			-- Capacity of semantic value stack `yyvs53'

	yyvsp53: INTEGER
			-- Top of semantic value stack `yyvs53'

	yyspecial_routines53: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_RENAME_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_RENAME_LIST]

	yyvs54: SPECIAL [detachable ET_CONSTRAINT_TYPE]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_TYPE

	yyvsc54: INTEGER
			-- Capacity of semantic value stack `yyvs54'

	yyvsp54: INTEGER
			-- Top of semantic value stack `yyvs54'

	yyspecial_routines54: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_TYPE]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_TYPE]

	yyvs55: SPECIAL [detachable ET_CONVERT_FEATURE]
			-- Stack for semantic values of type detachable ET_CONVERT_FEATURE

	yyvsc55: INTEGER
			-- Capacity of semantic value stack `yyvs55'

	yyvsp55: INTEGER
			-- Top of semantic value stack `yyvs55'

	yyspecial_routines55: KL_SPECIAL_ROUTINES [detachable ET_CONVERT_FEATURE]
			-- Routines that ought to be in SPECIAL [detachable ET_CONVERT_FEATURE]

	yyvs56: SPECIAL [detachable ET_CONVERT_FEATURE_ITEM]
			-- Stack for semantic values of type detachable ET_CONVERT_FEATURE_ITEM

	yyvsc56: INTEGER
			-- Capacity of semantic value stack `yyvs56'

	yyvsp56: INTEGER
			-- Top of semantic value stack `yyvs56'

	yyspecial_routines56: KL_SPECIAL_ROUTINES [detachable ET_CONVERT_FEATURE_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_CONVERT_FEATURE_ITEM]

	yyvs57: SPECIAL [detachable ET_CONVERT_FEATURE_LIST]
			-- Stack for semantic values of type detachable ET_CONVERT_FEATURE_LIST

	yyvsc57: INTEGER
			-- Capacity of semantic value stack `yyvs57'

	yyvsp57: INTEGER
			-- Top of semantic value stack `yyvs57'

	yyspecial_routines57: KL_SPECIAL_ROUTINES [detachable ET_CONVERT_FEATURE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CONVERT_FEATURE_LIST]

	yyvs58: SPECIAL [detachable ET_CREATE_EXPRESSION]
			-- Stack for semantic values of type detachable ET_CREATE_EXPRESSION

	yyvsc58: INTEGER
			-- Capacity of semantic value stack `yyvs58'

	yyvsp58: INTEGER
			-- Top of semantic value stack `yyvs58'

	yyspecial_routines58: KL_SPECIAL_ROUTINES [detachable ET_CREATE_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_CREATE_EXPRESSION]

	yyvs59: SPECIAL [detachable ET_CREATION_REGION]
			-- Stack for semantic values of type detachable ET_CREATION_REGION

	yyvsc59: INTEGER
			-- Capacity of semantic value stack `yyvs59'

	yyvsp59: INTEGER
			-- Top of semantic value stack `yyvs59'

	yyspecial_routines59: KL_SPECIAL_ROUTINES [detachable ET_CREATION_REGION]
			-- Routines that ought to be in SPECIAL [detachable ET_CREATION_REGION]

	yyvs60: SPECIAL [detachable ET_CREATOR]
			-- Stack for semantic values of type detachable ET_CREATOR

	yyvsc60: INTEGER
			-- Capacity of semantic value stack `yyvs60'

	yyvsp60: INTEGER
			-- Top of semantic value stack `yyvs60'

	yyspecial_routines60: KL_SPECIAL_ROUTINES [detachable ET_CREATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_CREATOR]

	yyvs61: SPECIAL [detachable ET_CREATOR_LIST]
			-- Stack for semantic values of type detachable ET_CREATOR_LIST

	yyvsc61: INTEGER
			-- Capacity of semantic value stack `yyvs61'

	yyvsp61: INTEGER
			-- Top of semantic value stack `yyvs61'

	yyspecial_routines61: KL_SPECIAL_ROUTINES [detachable ET_CREATOR_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CREATOR_LIST]

	yyvs62: SPECIAL [detachable ET_DEBUG_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_DEBUG_INSTRUCTION

	yyvsc62: INTEGER
			-- Capacity of semantic value stack `yyvs62'

	yyvsp62: INTEGER
			-- Top of semantic value stack `yyvs62'

	yyspecial_routines62: KL_SPECIAL_ROUTINES [detachable ET_DEBUG_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_DEBUG_INSTRUCTION]

	yyvs63: SPECIAL [detachable ET_ELSEIF_EXPRESSION]
			-- Stack for semantic values of type detachable ET_ELSEIF_EXPRESSION

	yyvsc63: INTEGER
			-- Capacity of semantic value stack `yyvs63'

	yyvsp63: INTEGER
			-- Top of semantic value stack `yyvs63'

	yyspecial_routines63: KL_SPECIAL_ROUTINES [detachable ET_ELSEIF_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_ELSEIF_EXPRESSION]

	yyvs64: SPECIAL [detachable ET_ELSEIF_EXPRESSION_LIST]
			-- Stack for semantic values of type detachable ET_ELSEIF_EXPRESSION_LIST

	yyvsc64: INTEGER
			-- Capacity of semantic value stack `yyvs64'

	yyvsp64: INTEGER
			-- Top of semantic value stack `yyvs64'

	yyspecial_routines64: KL_SPECIAL_ROUTINES [detachable ET_ELSEIF_EXPRESSION_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ELSEIF_EXPRESSION_LIST]

	yyvs65: SPECIAL [detachable ET_ELSEIF_PART]
			-- Stack for semantic values of type detachable ET_ELSEIF_PART

	yyvsc65: INTEGER
			-- Capacity of semantic value stack `yyvs65'

	yyvsp65: INTEGER
			-- Top of semantic value stack `yyvs65'

	yyspecial_routines65: KL_SPECIAL_ROUTINES [detachable ET_ELSEIF_PART]
			-- Routines that ought to be in SPECIAL [detachable ET_ELSEIF_PART]

	yyvs66: SPECIAL [detachable ET_ELSEIF_PART_LIST]
			-- Stack for semantic values of type detachable ET_ELSEIF_PART_LIST

	yyvsc66: INTEGER
			-- Capacity of semantic value stack `yyvs66'

	yyvsp66: INTEGER
			-- Top of semantic value stack `yyvs66'

	yyspecial_routines66: KL_SPECIAL_ROUTINES [detachable ET_ELSEIF_PART_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ELSEIF_PART_LIST]

	yyvs67: SPECIAL [detachable ET_EXPORT]
			-- Stack for semantic values of type detachable ET_EXPORT

	yyvsc67: INTEGER
			-- Capacity of semantic value stack `yyvs67'

	yyvsp67: INTEGER
			-- Top of semantic value stack `yyvs67'

	yyspecial_routines67: KL_SPECIAL_ROUTINES [detachable ET_EXPORT]
			-- Routines that ought to be in SPECIAL [detachable ET_EXPORT]

	yyvs68: SPECIAL [detachable ET_EXPORT_LIST]
			-- Stack for semantic values of type detachable ET_EXPORT_LIST

	yyvsc68: INTEGER
			-- Capacity of semantic value stack `yyvs68'

	yyvsp68: INTEGER
			-- Top of semantic value stack `yyvs68'

	yyspecial_routines68: KL_SPECIAL_ROUTINES [detachable ET_EXPORT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_EXPORT_LIST]

	yyvs69: SPECIAL [detachable ET_EXPRESSION]
			-- Stack for semantic values of type detachable ET_EXPRESSION

	yyvsc69: INTEGER
			-- Capacity of semantic value stack `yyvs69'

	yyvsp69: INTEGER
			-- Top of semantic value stack `yyvs69'

	yyspecial_routines69: KL_SPECIAL_ROUTINES [detachable ET_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_EXPRESSION]

	yyvs70: SPECIAL [detachable ET_EXPRESSION_ITEM]
			-- Stack for semantic values of type detachable ET_EXPRESSION_ITEM

	yyvsc70: INTEGER
			-- Capacity of semantic value stack `yyvs70'

	yyvsp70: INTEGER
			-- Top of semantic value stack `yyvs70'

	yyspecial_routines70: KL_SPECIAL_ROUTINES [detachable ET_EXPRESSION_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_EXPRESSION_ITEM]

	yyvs71: SPECIAL [detachable ET_EXTENDED_FEATURE_NAME]
			-- Stack for semantic values of type detachable ET_EXTENDED_FEATURE_NAME

	yyvsc71: INTEGER
			-- Capacity of semantic value stack `yyvs71'

	yyvsp71: INTEGER
			-- Top of semantic value stack `yyvs71'

	yyspecial_routines71: KL_SPECIAL_ROUTINES [detachable ET_EXTENDED_FEATURE_NAME]
			-- Routines that ought to be in SPECIAL [detachable ET_EXTENDED_FEATURE_NAME]

	yyvs72: SPECIAL [detachable ET_EXTERNAL_ALIAS]
			-- Stack for semantic values of type detachable ET_EXTERNAL_ALIAS

	yyvsc72: INTEGER
			-- Capacity of semantic value stack `yyvs72'

	yyvsp72: INTEGER
			-- Top of semantic value stack `yyvs72'

	yyspecial_routines72: KL_SPECIAL_ROUTINES [detachable ET_EXTERNAL_ALIAS]
			-- Routines that ought to be in SPECIAL [detachable ET_EXTERNAL_ALIAS]

	yyvs73: SPECIAL [detachable ET_FEATURE_CLAUSE]
			-- Stack for semantic values of type detachable ET_FEATURE_CLAUSE

	yyvsc73: INTEGER
			-- Capacity of semantic value stack `yyvs73'

	yyvsp73: INTEGER
			-- Top of semantic value stack `yyvs73'

	yyspecial_routines73: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_CLAUSE]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_CLAUSE]

	yyvs74: SPECIAL [detachable ET_FEATURE_CLAUSE_LIST]
			-- Stack for semantic values of type detachable ET_FEATURE_CLAUSE_LIST

	yyvsc74: INTEGER
			-- Capacity of semantic value stack `yyvs74'

	yyvsp74: INTEGER
			-- Top of semantic value stack `yyvs74'

	yyspecial_routines74: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_CLAUSE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_CLAUSE_LIST]

	yyvs75: SPECIAL [detachable ET_FEATURE_EXPORT]
			-- Stack for semantic values of type detachable ET_FEATURE_EXPORT

	yyvsc75: INTEGER
			-- Capacity of semantic value stack `yyvs75'

	yyvsp75: INTEGER
			-- Top of semantic value stack `yyvs75'

	yyspecial_routines75: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_EXPORT]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_EXPORT]

	yyvs76: SPECIAL [detachable ET_FEATURE_NAME]
			-- Stack for semantic values of type detachable ET_FEATURE_NAME

	yyvsc76: INTEGER
			-- Capacity of semantic value stack `yyvs76'

	yyvsp76: INTEGER
			-- Top of semantic value stack `yyvs76'

	yyspecial_routines76: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_NAME]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_NAME]

	yyvs77: SPECIAL [detachable ET_FEATURE_NAME_ITEM]
			-- Stack for semantic values of type detachable ET_FEATURE_NAME_ITEM

	yyvsc77: INTEGER
			-- Capacity of semantic value stack `yyvs77'

	yyvsp77: INTEGER
			-- Top of semantic value stack `yyvs77'

	yyspecial_routines77: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_NAME_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_NAME_ITEM]

	yyvs78: SPECIAL [detachable ET_FORMAL_ARGUMENT]
			-- Stack for semantic values of type detachable ET_FORMAL_ARGUMENT

	yyvsc78: INTEGER
			-- Capacity of semantic value stack `yyvs78'

	yyvsp78: INTEGER
			-- Top of semantic value stack `yyvs78'

	yyspecial_routines78: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_ARGUMENT]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_ARGUMENT]

	yyvs79: SPECIAL [detachable ET_FORMAL_ARGUMENT_ITEM]
			-- Stack for semantic values of type detachable ET_FORMAL_ARGUMENT_ITEM

	yyvsc79: INTEGER
			-- Capacity of semantic value stack `yyvs79'

	yyvsp79: INTEGER
			-- Top of semantic value stack `yyvs79'

	yyspecial_routines79: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_ARGUMENT_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_ARGUMENT_ITEM]

	yyvs80: SPECIAL [detachable ET_FORMAL_ARGUMENT_LIST]
			-- Stack for semantic values of type detachable ET_FORMAL_ARGUMENT_LIST

	yyvsc80: INTEGER
			-- Capacity of semantic value stack `yyvs80'

	yyvsp80: INTEGER
			-- Top of semantic value stack `yyvs80'

	yyspecial_routines80: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_ARGUMENT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_ARGUMENT_LIST]

	yyvs81: SPECIAL [detachable ET_FORMAL_PARAMETER]
			-- Stack for semantic values of type detachable ET_FORMAL_PARAMETER

	yyvsc81: INTEGER
			-- Capacity of semantic value stack `yyvs81'

	yyvsp81: INTEGER
			-- Top of semantic value stack `yyvs81'

	yyspecial_routines81: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_PARAMETER]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_PARAMETER]

	yyvs82: SPECIAL [detachable ET_FORMAL_PARAMETER_ITEM]
			-- Stack for semantic values of type detachable ET_FORMAL_PARAMETER_ITEM

	yyvsc82: INTEGER
			-- Capacity of semantic value stack `yyvs82'

	yyvsp82: INTEGER
			-- Top of semantic value stack `yyvs82'

	yyspecial_routines82: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_PARAMETER_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_PARAMETER_ITEM]

	yyvs83: SPECIAL [detachable ET_FORMAL_PARAMETER_LIST]
			-- Stack for semantic values of type detachable ET_FORMAL_PARAMETER_LIST

	yyvsc83: INTEGER
			-- Capacity of semantic value stack `yyvs83'

	yyvsp83: INTEGER
			-- Top of semantic value stack `yyvs83'

	yyspecial_routines83: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_PARAMETER_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_PARAMETER_LIST]

	yyvs84: SPECIAL [detachable ET_IF_EXPRESSION]
			-- Stack for semantic values of type detachable ET_IF_EXPRESSION

	yyvsc84: INTEGER
			-- Capacity of semantic value stack `yyvs84'

	yyvsp84: INTEGER
			-- Top of semantic value stack `yyvs84'

	yyspecial_routines84: KL_SPECIAL_ROUTINES [detachable ET_IF_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_IF_EXPRESSION]

	yyvs85: SPECIAL [detachable ET_IF_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_IF_INSTRUCTION

	yyvsc85: INTEGER
			-- Capacity of semantic value stack `yyvs85'

	yyvsp85: INTEGER
			-- Top of semantic value stack `yyvs85'

	yyspecial_routines85: KL_SPECIAL_ROUTINES [detachable ET_IF_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_IF_INSTRUCTION]

	yyvs86: SPECIAL [detachable ET_INDEXING_LIST]
			-- Stack for semantic values of type detachable ET_INDEXING_LIST

	yyvsc86: INTEGER
			-- Capacity of semantic value stack `yyvs86'

	yyvsp86: INTEGER
			-- Top of semantic value stack `yyvs86'

	yyspecial_routines86: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_LIST]

	yyvs87: SPECIAL [detachable ET_INDEXING_ITEM]
			-- Stack for semantic values of type detachable ET_INDEXING_ITEM

	yyvsc87: INTEGER
			-- Capacity of semantic value stack `yyvs87'

	yyvsp87: INTEGER
			-- Top of semantic value stack `yyvs87'

	yyspecial_routines87: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_ITEM]

	yyvs88: SPECIAL [detachable ET_INDEXING_TERM]
			-- Stack for semantic values of type detachable ET_INDEXING_TERM

	yyvsc88: INTEGER
			-- Capacity of semantic value stack `yyvs88'

	yyvsp88: INTEGER
			-- Top of semantic value stack `yyvs88'

	yyspecial_routines88: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_TERM]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_TERM]

	yyvs89: SPECIAL [detachable ET_INDEXING_TERM_ITEM]
			-- Stack for semantic values of type detachable ET_INDEXING_TERM_ITEM

	yyvsc89: INTEGER
			-- Capacity of semantic value stack `yyvs89'

	yyvsp89: INTEGER
			-- Top of semantic value stack `yyvs89'

	yyspecial_routines89: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_TERM_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_TERM_ITEM]

	yyvs90: SPECIAL [detachable ET_INDEXING_TERM_LIST]
			-- Stack for semantic values of type detachable ET_INDEXING_TERM_LIST

	yyvsc90: INTEGER
			-- Capacity of semantic value stack `yyvs90'

	yyvsp90: INTEGER
			-- Top of semantic value stack `yyvs90'

	yyspecial_routines90: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_TERM_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_TERM_LIST]

	yyvs91: SPECIAL [detachable ET_INLINE_AGENT]
			-- Stack for semantic values of type detachable ET_INLINE_AGENT

	yyvsc91: INTEGER
			-- Capacity of semantic value stack `yyvs91'

	yyvsp91: INTEGER
			-- Top of semantic value stack `yyvs91'

	yyspecial_routines91: KL_SPECIAL_ROUTINES [detachable ET_INLINE_AGENT]
			-- Routines that ought to be in SPECIAL [detachable ET_INLINE_AGENT]

	yyvs92: SPECIAL [detachable ET_INSPECT_EXPRESSION]
			-- Stack for semantic values of type detachable ET_INSPECT_EXPRESSION

	yyvsc92: INTEGER
			-- Capacity of semantic value stack `yyvs92'

	yyvsp92: INTEGER
			-- Top of semantic value stack `yyvs92'

	yyspecial_routines92: KL_SPECIAL_ROUTINES [detachable ET_INSPECT_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_INSPECT_EXPRESSION]

	yyvs93: SPECIAL [detachable ET_INSPECT_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_INSPECT_INSTRUCTION

	yyvsc93: INTEGER
			-- Capacity of semantic value stack `yyvs93'

	yyvsp93: INTEGER
			-- Top of semantic value stack `yyvs93'

	yyspecial_routines93: KL_SPECIAL_ROUTINES [detachable ET_INSPECT_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_INSPECT_INSTRUCTION]

	yyvs94: SPECIAL [detachable ET_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_INSTRUCTION

	yyvsc94: INTEGER
			-- Capacity of semantic value stack `yyvs94'

	yyvsp94: INTEGER
			-- Top of semantic value stack `yyvs94'

	yyspecial_routines94: KL_SPECIAL_ROUTINES [detachable ET_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_INSTRUCTION]

	yyvs95: SPECIAL [detachable ET_INVARIANTS]
			-- Stack for semantic values of type detachable ET_INVARIANTS

	yyvsc95: INTEGER
			-- Capacity of semantic value stack `yyvs95'

	yyvsp95: INTEGER
			-- Top of semantic value stack `yyvs95'

	yyspecial_routines95: KL_SPECIAL_ROUTINES [detachable ET_INVARIANTS]
			-- Routines that ought to be in SPECIAL [detachable ET_INVARIANTS]

	yyvs96: SPECIAL [detachable ET_KEYWORD_FEATURE_NAME_LIST]
			-- Stack for semantic values of type detachable ET_KEYWORD_FEATURE_NAME_LIST

	yyvsc96: INTEGER
			-- Capacity of semantic value stack `yyvs96'

	yyvsp96: INTEGER
			-- Top of semantic value stack `yyvs96'

	yyspecial_routines96: KL_SPECIAL_ROUTINES [detachable ET_KEYWORD_FEATURE_NAME_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_KEYWORD_FEATURE_NAME_LIST]

	yyvs97: SPECIAL [detachable ET_LIKE_TYPE]
			-- Stack for semantic values of type detachable ET_LIKE_TYPE

	yyvsc97: INTEGER
			-- Capacity of semantic value stack `yyvs97'

	yyvsp97: INTEGER
			-- Top of semantic value stack `yyvs97'

	yyspecial_routines97: KL_SPECIAL_ROUTINES [detachable ET_LIKE_TYPE]
			-- Routines that ought to be in SPECIAL [detachable ET_LIKE_TYPE]

	yyvs98: SPECIAL [detachable ET_LOCAL_VARIABLE]
			-- Stack for semantic values of type detachable ET_LOCAL_VARIABLE

	yyvsc98: INTEGER
			-- Capacity of semantic value stack `yyvs98'

	yyvsp98: INTEGER
			-- Top of semantic value stack `yyvs98'

	yyspecial_routines98: KL_SPECIAL_ROUTINES [detachable ET_LOCAL_VARIABLE]
			-- Routines that ought to be in SPECIAL [detachable ET_LOCAL_VARIABLE]

	yyvs99: SPECIAL [detachable ET_LOCAL_VARIABLE_ITEM]
			-- Stack for semantic values of type detachable ET_LOCAL_VARIABLE_ITEM

	yyvsc99: INTEGER
			-- Capacity of semantic value stack `yyvs99'

	yyvsp99: INTEGER
			-- Top of semantic value stack `yyvs99'

	yyspecial_routines99: KL_SPECIAL_ROUTINES [detachable ET_LOCAL_VARIABLE_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_LOCAL_VARIABLE_ITEM]

	yyvs100: SPECIAL [detachable ET_LOCAL_VARIABLE_LIST]
			-- Stack for semantic values of type detachable ET_LOCAL_VARIABLE_LIST

	yyvsc100: INTEGER
			-- Capacity of semantic value stack `yyvs100'

	yyvsp100: INTEGER
			-- Top of semantic value stack `yyvs100'

	yyspecial_routines100: KL_SPECIAL_ROUTINES [detachable ET_LOCAL_VARIABLE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_LOCAL_VARIABLE_LIST]

	yyvs101: SPECIAL [detachable ET_LOOP_INVARIANTS]
			-- Stack for semantic values of type detachable ET_LOOP_INVARIANTS

	yyvsc101: INTEGER
			-- Capacity of semantic value stack `yyvs101'

	yyvsp101: INTEGER
			-- Top of semantic value stack `yyvs101'

	yyspecial_routines101: KL_SPECIAL_ROUTINES [detachable ET_LOOP_INVARIANTS]
			-- Routines that ought to be in SPECIAL [detachable ET_LOOP_INVARIANTS]

	yyvs102: SPECIAL [detachable ET_MANIFEST_ARRAY]
			-- Stack for semantic values of type detachable ET_MANIFEST_ARRAY

	yyvsc102: INTEGER
			-- Capacity of semantic value stack `yyvs102'

	yyvsp102: INTEGER
			-- Top of semantic value stack `yyvs102'

	yyspecial_routines102: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_ARRAY]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_ARRAY]

	yyvs103: SPECIAL [detachable ET_MANIFEST_STRING_ITEM]
			-- Stack for semantic values of type detachable ET_MANIFEST_STRING_ITEM

	yyvsc103: INTEGER
			-- Capacity of semantic value stack `yyvs103'

	yyvsp103: INTEGER
			-- Top of semantic value stack `yyvs103'

	yyspecial_routines103: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_STRING_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_STRING_ITEM]

	yyvs104: SPECIAL [detachable ET_MANIFEST_STRING_LIST]
			-- Stack for semantic values of type detachable ET_MANIFEST_STRING_LIST

	yyvsc104: INTEGER
			-- Capacity of semantic value stack `yyvs104'

	yyvsp104: INTEGER
			-- Top of semantic value stack `yyvs104'

	yyspecial_routines104: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_STRING_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_STRING_LIST]

	yyvs105: SPECIAL [detachable ET_MANIFEST_TUPLE]
			-- Stack for semantic values of type detachable ET_MANIFEST_TUPLE

	yyvsc105: INTEGER
			-- Capacity of semantic value stack `yyvs105'

	yyvsp105: INTEGER
			-- Top of semantic value stack `yyvs105'

	yyspecial_routines105: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_TUPLE]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_TUPLE]

	yyvs106: SPECIAL [detachable ET_OBSOLETE]
			-- Stack for semantic values of type detachable ET_OBSOLETE

	yyvsc106: INTEGER
			-- Capacity of semantic value stack `yyvs106'

	yyvsp106: INTEGER
			-- Top of semantic value stack `yyvs106'

	yyspecial_routines106: KL_SPECIAL_ROUTINES [detachable ET_OBSOLETE]
			-- Routines that ought to be in SPECIAL [detachable ET_OBSOLETE]

	yyvs107: SPECIAL [detachable ET_PARENTHESIZED_EXPRESSION]
			-- Stack for semantic values of type detachable ET_PARENTHESIZED_EXPRESSION

	yyvsc107: INTEGER
			-- Capacity of semantic value stack `yyvs107'

	yyvsp107: INTEGER
			-- Top of semantic value stack `yyvs107'

	yyspecial_routines107: KL_SPECIAL_ROUTINES [detachable ET_PARENTHESIZED_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENTHESIZED_EXPRESSION]

	yyvs108: SPECIAL [detachable ET_PARENT]
			-- Stack for semantic values of type detachable ET_PARENT

	yyvsc108: INTEGER
			-- Capacity of semantic value stack `yyvs108'

	yyvsp108: INTEGER
			-- Top of semantic value stack `yyvs108'

	yyspecial_routines108: KL_SPECIAL_ROUTINES [detachable ET_PARENT]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENT]

	yyvs109: SPECIAL [detachable ET_PARENT_CLAUSE_LIST]
			-- Stack for semantic values of type detachable ET_PARENT_CLAUSE_LIST

	yyvsc109: INTEGER
			-- Capacity of semantic value stack `yyvs109'

	yyvsp109: INTEGER
			-- Top of semantic value stack `yyvs109'

	yyspecial_routines109: KL_SPECIAL_ROUTINES [detachable ET_PARENT_CLAUSE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENT_CLAUSE_LIST]

	yyvs110: SPECIAL [detachable ET_PARENT_ITEM]
			-- Stack for semantic values of type detachable ET_PARENT_ITEM

	yyvsc110: INTEGER
			-- Capacity of semantic value stack `yyvs110'

	yyvsp110: INTEGER
			-- Top of semantic value stack `yyvs110'

	yyspecial_routines110: KL_SPECIAL_ROUTINES [detachable ET_PARENT_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENT_ITEM]

	yyvs111: SPECIAL [detachable ET_PARENT_LIST]
			-- Stack for semantic values of type detachable ET_PARENT_LIST

	yyvsc111: INTEGER
			-- Capacity of semantic value stack `yyvs111'

	yyvsp111: INTEGER
			-- Top of semantic value stack `yyvs111'

	yyspecial_routines111: KL_SPECIAL_ROUTINES [detachable ET_PARENT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENT_LIST]

	yyvs112: SPECIAL [detachable ET_POSTCONDITIONS]
			-- Stack for semantic values of type detachable ET_POSTCONDITIONS

	yyvsc112: INTEGER
			-- Capacity of semantic value stack `yyvs112'

	yyvsp112: INTEGER
			-- Top of semantic value stack `yyvs112'

	yyspecial_routines112: KL_SPECIAL_ROUTINES [detachable ET_POSTCONDITIONS]
			-- Routines that ought to be in SPECIAL [detachable ET_POSTCONDITIONS]

	yyvs113: SPECIAL [detachable ET_PRECONDITIONS]
			-- Stack for semantic values of type detachable ET_PRECONDITIONS

	yyvsc113: INTEGER
			-- Capacity of semantic value stack `yyvs113'

	yyvsp113: INTEGER
			-- Top of semantic value stack `yyvs113'

	yyspecial_routines113: KL_SPECIAL_ROUTINES [detachable ET_PRECONDITIONS]
			-- Routines that ought to be in SPECIAL [detachable ET_PRECONDITIONS]

	yyvs114: SPECIAL [detachable ET_PROCEDURE]
			-- Stack for semantic values of type detachable ET_PROCEDURE

	yyvsc114: INTEGER
			-- Capacity of semantic value stack `yyvs114'

	yyvsp114: INTEGER
			-- Top of semantic value stack `yyvs114'

	yyspecial_routines114: KL_SPECIAL_ROUTINES [detachable ET_PROCEDURE]
			-- Routines that ought to be in SPECIAL [detachable ET_PROCEDURE]

	yyvs115: SPECIAL [detachable ET_QUALIFIED_LIKE_IDENTIFIER]
			-- Stack for semantic values of type detachable ET_QUALIFIED_LIKE_IDENTIFIER

	yyvsc115: INTEGER
			-- Capacity of semantic value stack `yyvs115'

	yyvsp115: INTEGER
			-- Top of semantic value stack `yyvs115'

	yyspecial_routines115: KL_SPECIAL_ROUTINES [detachable ET_QUALIFIED_LIKE_IDENTIFIER]
			-- Routines that ought to be in SPECIAL [detachable ET_QUALIFIED_LIKE_IDENTIFIER]

	yyvs116: SPECIAL [detachable ET_QUANTIFIER_EXPRESSION]
			-- Stack for semantic values of type detachable ET_QUANTIFIER_EXPRESSION

	yyvsc116: INTEGER
			-- Capacity of semantic value stack `yyvs116'

	yyvsp116: INTEGER
			-- Top of semantic value stack `yyvs116'

	yyspecial_routines116: KL_SPECIAL_ROUTINES [detachable ET_QUANTIFIER_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_QUANTIFIER_EXPRESSION]

	yyvs117: SPECIAL [detachable ET_QUERY]
			-- Stack for semantic values of type detachable ET_QUERY

	yyvsc117: INTEGER
			-- Capacity of semantic value stack `yyvs117'

	yyvsp117: INTEGER
			-- Top of semantic value stack `yyvs117'

	yyspecial_routines117: KL_SPECIAL_ROUTINES [detachable ET_QUERY]
			-- Routines that ought to be in SPECIAL [detachable ET_QUERY]

	yyvs118: SPECIAL [detachable ET_RENAME_ITEM]
			-- Stack for semantic values of type detachable ET_RENAME_ITEM

	yyvsc118: INTEGER
			-- Capacity of semantic value stack `yyvs118'

	yyvsp118: INTEGER
			-- Top of semantic value stack `yyvs118'

	yyspecial_routines118: KL_SPECIAL_ROUTINES [detachable ET_RENAME_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_RENAME_ITEM]

	yyvs119: SPECIAL [detachable ET_RENAME_LIST]
			-- Stack for semantic values of type detachable ET_RENAME_LIST

	yyvsc119: INTEGER
			-- Capacity of semantic value stack `yyvs119'

	yyvsp119: INTEGER
			-- Top of semantic value stack `yyvs119'

	yyspecial_routines119: KL_SPECIAL_ROUTINES [detachable ET_RENAME_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_RENAME_LIST]

	yyvs120: SPECIAL [detachable ET_REPEAT_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_REPEAT_INSTRUCTION

	yyvsc120: INTEGER
			-- Capacity of semantic value stack `yyvs120'

	yyvsp120: INTEGER
			-- Top of semantic value stack `yyvs120'

	yyspecial_routines120: KL_SPECIAL_ROUTINES [detachable ET_REPEAT_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_REPEAT_INSTRUCTION]

	yyvs121: SPECIAL [detachable ET_STATIC_CALL_EXPRESSION]
			-- Stack for semantic values of type detachable ET_STATIC_CALL_EXPRESSION

	yyvsc121: INTEGER
			-- Capacity of semantic value stack `yyvs121'

	yyvsp121: INTEGER
			-- Top of semantic value stack `yyvs121'

	yyspecial_routines121: KL_SPECIAL_ROUTINES [detachable ET_STATIC_CALL_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_STATIC_CALL_EXPRESSION]

	yyvs122: SPECIAL [detachable ET_STRIP_EXPRESSION]
			-- Stack for semantic values of type detachable ET_STRIP_EXPRESSION

	yyvsc122: INTEGER
			-- Capacity of semantic value stack `yyvs122'

	yyvsp122: INTEGER
			-- Top of semantic value stack `yyvs122'

	yyspecial_routines122: KL_SPECIAL_ROUTINES [detachable ET_STRIP_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_STRIP_EXPRESSION]

	yyvs123: SPECIAL [detachable ET_TYPE]
			-- Stack for semantic values of type detachable ET_TYPE

	yyvsc123: INTEGER
			-- Capacity of semantic value stack `yyvs123'

	yyvsp123: INTEGER
			-- Top of semantic value stack `yyvs123'

	yyspecial_routines123: KL_SPECIAL_ROUTINES [detachable ET_TYPE]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE]

	yyvs124: SPECIAL [detachable ET_TYPE_CONSTRAINT]
			-- Stack for semantic values of type detachable ET_TYPE_CONSTRAINT

	yyvsc124: INTEGER
			-- Capacity of semantic value stack `yyvs124'

	yyvsp124: INTEGER
			-- Top of semantic value stack `yyvs124'

	yyspecial_routines124: KL_SPECIAL_ROUTINES [detachable ET_TYPE_CONSTRAINT]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_CONSTRAINT]

	yyvs125: SPECIAL [detachable ET_TYPE_CONSTRAINT_ITEM]
			-- Stack for semantic values of type detachable ET_TYPE_CONSTRAINT_ITEM

	yyvsc125: INTEGER
			-- Capacity of semantic value stack `yyvs125'

	yyvsp125: INTEGER
			-- Top of semantic value stack `yyvs125'

	yyspecial_routines125: KL_SPECIAL_ROUTINES [detachable ET_TYPE_CONSTRAINT_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_CONSTRAINT_ITEM]

	yyvs126: SPECIAL [detachable ET_TYPE_CONSTRAINT_LIST]
			-- Stack for semantic values of type detachable ET_TYPE_CONSTRAINT_LIST

	yyvsc126: INTEGER
			-- Capacity of semantic value stack `yyvs126'

	yyvsp126: INTEGER
			-- Top of semantic value stack `yyvs126'

	yyspecial_routines126: KL_SPECIAL_ROUTINES [detachable ET_TYPE_CONSTRAINT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_CONSTRAINT_LIST]

	yyvs127: SPECIAL [detachable ET_TYPE_ITEM]
			-- Stack for semantic values of type detachable ET_TYPE_ITEM

	yyvsc127: INTEGER
			-- Capacity of semantic value stack `yyvs127'

	yyvsp127: INTEGER
			-- Top of semantic value stack `yyvs127'

	yyspecial_routines127: KL_SPECIAL_ROUTINES [detachable ET_TYPE_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_ITEM]

	yyvs128: SPECIAL [detachable ET_TYPE_LIST]
			-- Stack for semantic values of type detachable ET_TYPE_LIST

	yyvsc128: INTEGER
			-- Capacity of semantic value stack `yyvs128'

	yyvsp128: INTEGER
			-- Top of semantic value stack `yyvs128'

	yyspecial_routines128: KL_SPECIAL_ROUTINES [detachable ET_TYPE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_LIST]

	yyvs129: SPECIAL [detachable ET_VARIANT]
			-- Stack for semantic values of type detachable ET_VARIANT

	yyvsc129: INTEGER
			-- Capacity of semantic value stack `yyvs129'

	yyvsp129: INTEGER
			-- Top of semantic value stack `yyvs129'

	yyspecial_routines129: KL_SPECIAL_ROUTINES [detachable ET_VARIANT]
			-- Routines that ought to be in SPECIAL [detachable ET_VARIANT]

	yyvs130: SPECIAL [detachable ET_WHEN_EXPRESSION]
			-- Stack for semantic values of type detachable ET_WHEN_EXPRESSION

	yyvsc130: INTEGER
			-- Capacity of semantic value stack `yyvs130'

	yyvsp130: INTEGER
			-- Top of semantic value stack `yyvs130'

	yyspecial_routines130: KL_SPECIAL_ROUTINES [detachable ET_WHEN_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_WHEN_EXPRESSION]

	yyvs131: SPECIAL [detachable ET_WHEN_EXPRESSION_LIST]
			-- Stack for semantic values of type detachable ET_WHEN_EXPRESSION_LIST

	yyvsc131: INTEGER
			-- Capacity of semantic value stack `yyvs131'

	yyvsp131: INTEGER
			-- Top of semantic value stack `yyvs131'

	yyspecial_routines131: KL_SPECIAL_ROUTINES [detachable ET_WHEN_EXPRESSION_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_WHEN_EXPRESSION_LIST]

	yyvs132: SPECIAL [detachable ET_WHEN_PART]
			-- Stack for semantic values of type detachable ET_WHEN_PART

	yyvsc132: INTEGER
			-- Capacity of semantic value stack `yyvs132'

	yyvsp132: INTEGER
			-- Top of semantic value stack `yyvs132'

	yyspecial_routines132: KL_SPECIAL_ROUTINES [detachable ET_WHEN_PART]
			-- Routines that ought to be in SPECIAL [detachable ET_WHEN_PART]

	yyvs133: SPECIAL [detachable ET_WHEN_PART_LIST]
			-- Stack for semantic values of type detachable ET_WHEN_PART_LIST

	yyvsc133: INTEGER
			-- Capacity of semantic value stack `yyvs133'

	yyvsp133: INTEGER
			-- Top of semantic value stack `yyvs133'

	yyspecial_routines133: KL_SPECIAL_ROUTINES [detachable ET_WHEN_PART_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_WHEN_PART_LIST]

	yyvs134: SPECIAL [detachable ET_WRITABLE]
			-- Stack for semantic values of type detachable ET_WRITABLE

	yyvsc134: INTEGER
			-- Capacity of semantic value stack `yyvs134'

	yyvsp134: INTEGER
			-- Top of semantic value stack `yyvs134'

	yyspecial_routines134: KL_SPECIAL_ROUTINES [detachable ET_WRITABLE]
			-- Routines that ought to be in SPECIAL [detachable ET_WRITABLE]

feature {NONE} -- Constants

	yyFinal: INTEGER = 1817
			-- Termination state id

	yyFlag: INTEGER = -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER = 160
			-- Number of tokens

	yyLast: INTEGER = 8594
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER = 391
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER = 472
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features



feature -- Access

	system_processor: ET_SYSTEM_PROCESSOR
			-- System processor currently used

end
